// Begin of spicy_init (from "<root>")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_ldap_hlto_scope;

namespace zeek::spicy::rt {
    extern void register_spicy_module_begin(const std::string& name, const std::string& description);
    extern void register_spicy_module_end();
}

namespace __hlt_ldap::spicy_init {
    extern void zeek_preinit();
    extern void __preinit_module();
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_ldap::spicy_init::__register_module)

extern void __hlt_ldap::spicy_init::__preinit_module() { __hlt_ldap::spicy_init::zeek_preinit(); }

extern void __hlt_ldap::spicy_init::__register_module() {
    ::hilti::rt::detail::registerModule({ "spicy_init", __hlt_ldap_hlto_scope, nullptr, nullptr, nullptr, nullptr});
    __preinit_module();
}

extern void __hlt_ldap::spicy_init::zeek_preinit() {
    ::zeek::spicy::rt::register_spicy_module_begin(std::string("Zeek::LDAP"), std::string("LDAP analyzer"));
    ::zeek::spicy::rt::register_protocol_analyzer(std::string("LDAP_TCP"), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), std::string("LDAP::Messages"), std::string("LDAP::Messages"), std::string(""), std::string(__hlt_ldap_hlto_scope));
    ::zeek::spicy::rt::register_protocol_analyzer(std::string("LDAP_UDP"), ::hilti::rt::Protocol{::hilti::rt::Protocol::UDP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), std::string("LDAP::Messages"), std::string("LDAP::Messages"), std::string(""), std::string(__hlt_ldap_hlto_scope));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::message"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::bind_request"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::search_request"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::search_result_entry"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::extended_request"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::extended_response"));
    ::zeek::spicy::rt::install_handler(std::string("LDAP::starttls"));

    // Creating Zeek type LDAP::ProtocolOpcode;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_ProtocolOpcode;
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("BIND_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("BIND_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("UNBIND_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("SEARCH_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("SEARCH_RESULT_ENTRY"), ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("SEARCH_RESULT_DONE"), ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("MODIFY_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("MODIFY_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("ADD_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("ADD_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("DEL_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("DEL_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("MOD_DN_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("MOD_DN_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("COMPARE_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{14}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("COMPARE_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{15}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("ABANDON_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("SEARCH_RESULT_REFERENCE"), ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("EXTENDED_REQUEST"), ::hilti::rt::integer::safe<std::int64_t>{23}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("EXTENDED_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{24}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("INTERMEDIATE_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{25}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_ProtocolOpcode = ::zeek::spicy::rt::create_enum_type(std::string("LDAP"), std::string("ProtocolOpcode"), __labels_LDAP_ProtocolOpcode);
    ::zeek::spicy::rt::register_type(std::string("LDAP"), std::string("ProtocolOpcode"), __type_LDAP_ProtocolOpcode);

    // Creating Zeek type LDAP::ResultCode;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_ResultCode;
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("SUCCESS"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("OPERATIONS_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("PROTOCOL_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("TIME_LIMIT_EXCEEDED"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("SIZE_LIMIT_EXCEEDED"), ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("COMPARE_FALSE"), ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("COMPARE_TRUE"), ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("AUTH_METHOD_NOT_SUPPORTED"), ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("STRONGER_AUTH_REQUIRED"), ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("PARTIAL_RESULTS"), ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("REFERRAL"), ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ADMIN_LIMIT_EXCEEDED"), ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("UNAVAILABLE_CRITICAL_EXTENSION"), ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CONFIDENTIALITY_REQUIRED"), ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("SASL_BIND_IN_PROGRESS"), ::hilti::rt::integer::safe<std::int64_t>{14}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NO_SUCH_ATTRIBUTE"), ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("UNDEFINED_ATTRIBUTE_TYPE"), ::hilti::rt::integer::safe<std::int64_t>{17}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INAPPROPRIATE_MATCHING"), ::hilti::rt::integer::safe<std::int64_t>{18}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CONSTRAINT_VIOLATION"), ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ATTRIBUTE_OR_VALUE_EXISTS"), ::hilti::rt::integer::safe<std::int64_t>{20}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INVALID_ATTRIBUTE_SYNTAX"), ::hilti::rt::integer::safe<std::int64_t>{21}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NO_SUCH_OBJECT"), ::hilti::rt::integer::safe<std::int64_t>{32}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ALIAS_PROBLEM"), ::hilti::rt::integer::safe<std::int64_t>{33}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INVALID_DNSYNTAX"), ::hilti::rt::integer::safe<std::int64_t>{34}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ALIAS_DEREFERENCING_PROBLEM"), ::hilti::rt::integer::safe<std::int64_t>{36}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INAPPROPRIATE_AUTHENTICATION"), ::hilti::rt::integer::safe<std::int64_t>{48}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INVALID_CREDENTIALS"), ::hilti::rt::integer::safe<std::int64_t>{49}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INSUFFICIENT_ACCESS_RIGHTS"), ::hilti::rt::integer::safe<std::int64_t>{50}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("BUSY"), ::hilti::rt::integer::safe<std::int64_t>{51}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("UNAVAILABLE"), ::hilti::rt::integer::safe<std::int64_t>{52}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("UNWILLING_TO_PERFORM"), ::hilti::rt::integer::safe<std::int64_t>{53}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("LOOP_DETECT"), ::hilti::rt::integer::safe<std::int64_t>{54}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("SORT_CONTROL_MISSING"), ::hilti::rt::integer::safe<std::int64_t>{60}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("OFFSET_RANGE_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{61}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NAMING_VIOLATION"), ::hilti::rt::integer::safe<std::int64_t>{64}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("OBJECT_CLASS_VIOLATION"), ::hilti::rt::integer::safe<std::int64_t>{65}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NOT_ALLOWED_ON_NON_LEAF"), ::hilti::rt::integer::safe<std::int64_t>{66}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NOT_ALLOWED_ON_RDN"), ::hilti::rt::integer::safe<std::int64_t>{67}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ENTRY_ALREADY_EXISTS"), ::hilti::rt::integer::safe<std::int64_t>{68}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("OBJECT_CLASS_MODS_PROHIBITED"), ::hilti::rt::integer::safe<std::int64_t>{69}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("RESULTS_TOO_LARGE"), ::hilti::rt::integer::safe<std::int64_t>{70}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("AFFECTS_MULTIPLE_DSAS"), ::hilti::rt::integer::safe<std::int64_t>{71}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CONTROL_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{76}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("OTHER"), ::hilti::rt::integer::safe<std::int64_t>{80}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("SERVER_DOWN"), ::hilti::rt::integer::safe<std::int64_t>{81}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("LOCAL_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{82}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ENCODING_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{83}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("DECODING_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{84}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("TIMEOUT"), ::hilti::rt::integer::safe<std::int64_t>{85}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("AUTH_UNKNOWN"), ::hilti::rt::integer::safe<std::int64_t>{86}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("FILTER_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{87}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("USER_CANCELED"), ::hilti::rt::integer::safe<std::int64_t>{88}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("PARAM_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{89}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NO_MEMORY"), ::hilti::rt::integer::safe<std::int64_t>{90}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CONNECT_ERROR"), ::hilti::rt::integer::safe<std::int64_t>{91}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NOT_SUPPORTED"), ::hilti::rt::integer::safe<std::int64_t>{92}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CONTROL_NOT_FOUND"), ::hilti::rt::integer::safe<std::int64_t>{93}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NO_RESULTS_RETURNED"), ::hilti::rt::integer::safe<std::int64_t>{94}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("MORE_RESULTS_TO_RETURN"), ::hilti::rt::integer::safe<std::int64_t>{95}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CLIENT_LOOP"), ::hilti::rt::integer::safe<std::int64_t>{96}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("REFERRAL_LIMIT_EXCEEDED"), ::hilti::rt::integer::safe<std::int64_t>{97}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INVALID_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{100}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("AMBIGUOUS_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{101}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("TLS_NOT_SUPPORTED"), ::hilti::rt::integer::safe<std::int64_t>{112}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("INTERMEDIATE_RESPONSE"), ::hilti::rt::integer::safe<std::int64_t>{113}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("UNKNOWN_TYPE"), ::hilti::rt::integer::safe<std::int64_t>{114}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("LCUP_INVALID_DATA"), ::hilti::rt::integer::safe<std::int64_t>{115}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("LCUP_UNSUPPORTED_SCHEME"), ::hilti::rt::integer::safe<std::int64_t>{116}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("LCUP_RELOAD_REQUIRED"), ::hilti::rt::integer::safe<std::int64_t>{117}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CANCELED"), ::hilti::rt::integer::safe<std::int64_t>{118}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("NO_SUCH_OPERATION"), ::hilti::rt::integer::safe<std::int64_t>{119}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("TOO_LATE"), ::hilti::rt::integer::safe<std::int64_t>{120}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("CANNOT_CANCEL"), ::hilti::rt::integer::safe<std::int64_t>{121}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("ASSERTION_FAILED"), ::hilti::rt::integer::safe<std::int64_t>{122}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("AUTHORIZATION_DENIED"), ::hilti::rt::integer::safe<std::int64_t>{123}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_ResultCode = ::zeek::spicy::rt::create_enum_type(std::string("LDAP"), std::string("ResultCode"), __labels_LDAP_ResultCode);
    ::zeek::spicy::rt::register_type(std::string("LDAP"), std::string("ResultCode"), __type_LDAP_ResultCode);

    // Creating Zeek type LDAP::BindAuthType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_BindAuthType;
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple(std::string_view("BIND_AUTH_SIMPLE"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple(std::string_view("BIND_AUTH_SASL"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_BindAuthType = ::zeek::spicy::rt::create_enum_type(std::string("LDAP"), std::string("BindAuthType"), __labels_LDAP_BindAuthType);
    ::zeek::spicy::rt::register_type(std::string("LDAP"), std::string("BindAuthType"), __type_LDAP_BindAuthType);

    // Creating Zeek type LDAP::SearchScope;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_SearchScope;
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple(std::string_view("SEARCH_BASE"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple(std::string_view("SEARCH_SINGLE"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple(std::string_view("SEARCH_TREE"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_SearchScope = ::zeek::spicy::rt::create_enum_type(std::string("LDAP"), std::string("SearchScope"), __labels_LDAP_SearchScope);
    ::zeek::spicy::rt::register_type(std::string("LDAP"), std::string("SearchScope"), __type_LDAP_SearchScope);

    // Creating Zeek type LDAP::SearchDerefAlias;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_SearchDerefAlias;
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple(std::string_view("DEREF_NEVER"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple(std::string_view("DEREF_IN_SEARCHING"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple(std::string_view("DEREF_FINDING_BASE"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple(std::string_view("DEREF_ALWAYS"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_SearchDerefAlias = ::zeek::spicy::rt::create_enum_type(std::string("LDAP"), std::string("SearchDerefAlias"), __labels_LDAP_SearchDerefAlias);
    ::zeek::spicy::rt::register_type(std::string("LDAP"), std::string("SearchDerefAlias"), __type_LDAP_SearchDerefAlias);

    // Creating Zeek type ASN1::ASN1Type;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_ASN1_ASN1Type;
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Boolean"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Integer"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("BitString"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("OctetString"), ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("NullVal"), ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("ObjectIdentifier"), ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("ObjectDescriptor"), ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("InstanceOf"), ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Real"), ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Enumerated"), ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("EmbeddedPDV"), ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("UTF8String"), ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("RelativeOID"), ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Sequence"), ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Set"), ::hilti::rt::integer::safe<std::int64_t>{17}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("NumericString"), ::hilti::rt::integer::safe<std::int64_t>{18}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("PrintableString"), ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("TeletextString"), ::hilti::rt::integer::safe<std::int64_t>{20}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("VideotextString"), ::hilti::rt::integer::safe<std::int64_t>{21}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("IA5String"), ::hilti::rt::integer::safe<std::int64_t>{22}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("UTCTime"), ::hilti::rt::integer::safe<std::int64_t>{23}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("GeneralizedTime"), ::hilti::rt::integer::safe<std::int64_t>{24}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("GraphicString"), ::hilti::rt::integer::safe<std::int64_t>{25}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("VisibleString"), ::hilti::rt::integer::safe<std::int64_t>{26}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("GeneralString"), ::hilti::rt::integer::safe<std::int64_t>{27}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("UniversalString"), ::hilti::rt::integer::safe<std::int64_t>{28}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("CharacterString"), ::hilti::rt::integer::safe<std::int64_t>{29}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("BMPString"), ::hilti::rt::integer::safe<std::int64_t>{30}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_ASN1_ASN1Type = ::zeek::spicy::rt::create_enum_type(std::string("ASN1"), std::string("ASN1Type"), __labels_ASN1_ASN1Type);
    ::zeek::spicy::rt::register_type(std::string("ASN1"), std::string("ASN1Type"), __type_ASN1_ASN1Type);

    // Creating Zeek type ASN1::ASN1Class;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_ASN1_ASN1Class;
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple(std::string_view("Universal"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple(std::string_view("Application"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple(std::string_view("ContextSpecific"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple(std::string_view("Private"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_ASN1_ASN1Class = ::zeek::spicy::rt::create_enum_type(std::string("ASN1"), std::string("ASN1Class"), __labels_ASN1_ASN1Class);
    ::zeek::spicy::rt::register_type(std::string("ASN1"), std::string("ASN1Class"), __type_ASN1_ASN1Class);

    // Creating Zeek type spicy::AddressFamily;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_AddressFamily;
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("IPv4"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("IPv6"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_AddressFamily = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("AddressFamily"), __labels_spicy_AddressFamily);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("AddressFamily"), __type_spicy_AddressFamily);

    // Creating Zeek type spicy::BitOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_BitOrder;
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("LSB0"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("MSB0"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_BitOrder = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("BitOrder"), __labels_spicy_BitOrder);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("BitOrder"), __type_spicy_BitOrder);

    // Creating Zeek type spicy::ByteOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ByteOrder;
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Little"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Big"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Network"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Host"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ByteOrder = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("ByteOrder"), __labels_spicy_ByteOrder);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("ByteOrder"), __type_spicy_ByteOrder);

    // Creating Zeek type spicy::Charset;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Charset;
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("ASCII"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("UTF8"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Charset = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Charset"), __labels_spicy_Charset);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Charset"), __type_spicy_Charset);

    // Creating Zeek type spicy::DecodeErrorStrategy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_DecodeErrorStrategy;
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("IGNORE"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("REPLACE"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("STRICT"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_DecodeErrorStrategy = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("DecodeErrorStrategy"), __labels_spicy_DecodeErrorStrategy);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("DecodeErrorStrategy"), __type_spicy_DecodeErrorStrategy);

    // Creating Zeek type spicy::Protocol;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Protocol;
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("TCP"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("UDP"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("ICMP"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Protocol = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Protocol"), __labels_spicy_Protocol);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Protocol"), __type_spicy_Protocol);

    // Creating Zeek type spicy::RealType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_RealType;
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("IEEE754_Single"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("IEEE754_Double"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_RealType = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("RealType"), __labels_spicy_RealType);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("RealType"), __type_spicy_RealType);

    // Creating Zeek type spicy::ReassemblerPolicy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ReassemblerPolicy;
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple(std::string_view("First"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ReassemblerPolicy = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("ReassemblerPolicy"), __labels_spicy_ReassemblerPolicy);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("ReassemblerPolicy"), __type_spicy_ReassemblerPolicy);

    // Creating Zeek type spicy::Side;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Side;
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Left"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Right"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Both"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Side = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Side"), __labels_spicy_Side);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Side"), __type_spicy_Side);

    // Creating Zeek type spicy::Direction;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Direction;
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Forward"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Backward"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Direction = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Direction"), __labels_spicy_Direction);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Direction"), __type_spicy_Direction);
    ::zeek::spicy::rt::register_spicy_module_end();
}

