// Begin of spicy_init (from "<root>")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_quic_hlto_scope;

namespace zeek::spicy::rt {
    extern void register_spicy_module_begin(const std::string& name, const std::string& description);
    extern void register_spicy_module_end();
}

namespace __hlt_quic::spicy_init {
    extern void zeek_preinit();
    extern void __preinit_module();
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_quic::spicy_init::__register_module)

extern void __hlt_quic::spicy_init::__preinit_module() { __hlt_quic::spicy_init::zeek_preinit(); }

extern void __hlt_quic::spicy_init::__register_module() {
    ::hilti::rt::detail::registerModule({ "spicy_init", __hlt_quic_hlto_scope, nullptr, nullptr, nullptr, nullptr});
    __preinit_module();
}

extern void __hlt_quic::spicy_init::zeek_preinit() {
    ::zeek::spicy::rt::register_spicy_module_begin(std::string("Zeek::QUIC"), std::string("QUIC analyzer"));
    ::zeek::spicy::rt::register_protocol_analyzer(std::string("QUIC"), ::hilti::rt::Protocol{::hilti::rt::Protocol::UDP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), std::string("QUIC::RequestFrame"), std::string("QUIC::ResponseFrame"), std::string(""), std::string(__hlt_quic_hlto_scope));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::initial_packet"));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::retry_packet"));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::handshake_packet"));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::zero_rtt_packet"));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::connection_close_frame"));
    ::zeek::spicy::rt::install_handler(std::string("QUIC::unhandled_version"));

    // Creating Zeek type spicy::AddressFamily;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_AddressFamily;
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("IPv4"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("IPv6"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_AddressFamily = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("AddressFamily"), __labels_spicy_AddressFamily);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("AddressFamily"), __type_spicy_AddressFamily);

    // Creating Zeek type spicy::BitOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_BitOrder;
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("LSB0"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("MSB0"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_BitOrder = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("BitOrder"), __labels_spicy_BitOrder);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("BitOrder"), __type_spicy_BitOrder);

    // Creating Zeek type spicy::ByteOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ByteOrder;
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Little"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Big"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Network"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Host"), ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ByteOrder = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("ByteOrder"), __labels_spicy_ByteOrder);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("ByteOrder"), __type_spicy_ByteOrder);

    // Creating Zeek type spicy::Charset;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Charset;
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("ASCII"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("UTF8"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Charset.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Charset = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Charset"), __labels_spicy_Charset);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Charset"), __type_spicy_Charset);

    // Creating Zeek type spicy::DecodeErrorStrategy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_DecodeErrorStrategy;
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("IGNORE"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("REPLACE"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("STRICT"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_DecodeErrorStrategy = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("DecodeErrorStrategy"), __labels_spicy_DecodeErrorStrategy);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("DecodeErrorStrategy"), __type_spicy_DecodeErrorStrategy);

    // Creating Zeek type spicy::Protocol;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Protocol;
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("TCP"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("UDP"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("ICMP"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Protocol = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Protocol"), __labels_spicy_Protocol);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Protocol"), __type_spicy_Protocol);

    // Creating Zeek type spicy::RealType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_RealType;
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("IEEE754_Single"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("IEEE754_Double"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_RealType.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_RealType = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("RealType"), __labels_spicy_RealType);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("RealType"), __type_spicy_RealType);

    // Creating Zeek type spicy::ReassemblerPolicy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ReassemblerPolicy;
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple(std::string_view("First"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ReassemblerPolicy = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("ReassemblerPolicy"), __labels_spicy_ReassemblerPolicy);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("ReassemblerPolicy"), __type_spicy_ReassemblerPolicy);

    // Creating Zeek type spicy::Side;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Side;
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Left"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Right"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Both"), ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Side.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Side = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Side"), __labels_spicy_Side);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Side"), __type_spicy_Side);

    // Creating Zeek type spicy::Direction;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Direction;
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Forward"), ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Backward"), ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Direction.emplace_back(std::make_tuple(std::string_view("Undef"), ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Direction = ::zeek::spicy::rt::create_enum_type(std::string("spicy"), std::string("Direction"), __labels_spicy_Direction);
    ::zeek::spicy::rt::register_type(std::string("spicy"), std::string("Direction"), __type_spicy_Direction);
    ::zeek::spicy::rt::register_spicy_module_end();
}

