// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"

namespace hilti { namespace detail { class Parser; } }

#include <hilti/compiler/context.h>
#include <hilti/compiler/detail/parser/driver.h>
#include <hilti/ast/builder/all.h>

#line 41 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"


#include <hilti/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(hilti::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column,
                                       (l.end.column > 0 ? l.end.column - 1 : 0)));
}

static hilti::QualifiedType* iteratorForType(hilti::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto iter = t->type()->iteratorType() )
        return iter;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

static hilti::QualifiedType* viewForType(hilti::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto v = t->type()->viewType() )
        return v;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

#define __loc__ toMeta(yylhs.location)

#define YYLLOC_DEFAULT(Current, Rhs, N)                                                                                \
do {                                                                                                                   \
    bool done = false;                                                                                                 \
    for ( int i = 1; i <= N; i++ ) {                                                                                   \
        if ( YYRHSLOC(Rhs, i).begin.line != YYRHSLOC(Rhs, i).end.line ||                                               \
             YYRHSLOC(Rhs, i).begin.column != YYRHSLOC(Rhs, i).end.column ) {                                          \
            (Current).begin = YYRHSLOC(Rhs, i).begin;                                                                  \
            (Current).end = YYRHSLOC(Rhs, N).end;                                                                      \
            done = true;                                                                                               \
            break;                                                                                                     \
        }                                                                                                              \
    }                                                                                                                  \
    if ( ! done )                                                                                                      \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;                                                        \
} while ( false )

static int _field_width = 0;


#line 101 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 29 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
namespace hilti { namespace detail { namespace parser {
#line 199 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (Driver* driver_yyarg, Builder* builder_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      builder (builder_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.copy< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.copy< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  Parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.YY_MOVE_OR_COPY< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.YY_MOVE_OR_COPY< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.YY_MOVE_OR_COPY< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.YY_MOVE_OR_COPY< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.YY_MOVE_OR_COPY< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function* > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_qtype: // qtype
        value.copy< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.copy< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch* > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< hilti::statement::try_::Catches > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< hilti::type::function::Parameters > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<Declarations, Statements> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 22 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 1995 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute* > ();
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< hilti::AttributeSet* > ();
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor* > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        yylhs.value.emplace< hilti::Declaration* > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        yylhs.value.emplace< hilti::Declarations > ();
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression* > ();
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< hilti::Expressions > ();
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        yylhs.value.emplace< hilti::Function* > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_qtype: // qtype
        yylhs.value.emplace< hilti::QualifiedType* > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement* > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< hilti::Statements > ();
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        yylhs.value.emplace< hilti::UnqualifiedType* > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element* > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< hilti::ctor::map::Elements > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field* > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< hilti::ctor::struct_::Fields > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::parameter::Kind > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case* > ();
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< hilti::statement::switch_::Cases > ();
        break;

      case symbol_kind::S_try_catch: // try_catch
        yylhs.value.emplace< hilti::statement::try_::Catch* > ();
        break;

      case symbol_kind::S_try_catches: // try_catches
        yylhs.value.emplace< hilti::statement::try_::Catches > ();
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        yylhs.value.emplace< hilti::type::bitfield::BitRange* > ();
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        yylhs.value.emplace< hilti::type::bitfield::BitRanges > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label* > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< hilti::type::enum_::Labels > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter* > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        yylhs.value.emplace< hilti::type::function::Parameters > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element* > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< hilti::type::tuple::Elements > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<Declarations, Statements> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // module: "module" local_id '{' global_scope_items '}'
#line 288 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto uid = declaration::module::UID(yystack_[3].value.as < hilti::ID > (), hilti::rt::filesystem::path(*driver->currentFile()));
                                                   auto m = builder->declarationModule(uid, {}, std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ().first), std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2374 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 3: // local_id: "identifier"
#line 296 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( ! driver->builder()->options().skip_validation ) {
                                                       if ( name.find('-') != std::string::npos )
                                                           hilti::logger().error(util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                       if ( name.substr(0, 2) == "__" && name != "__str__" )
                                                           hilti::logger().error(util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());
                                                   }

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name));
                                                 }
#line 2390 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 4: // scoped_id: local_id
#line 308 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2396 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 5: // scoped_id: "scoped identifier"
#line 309 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2402 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 6: // $@1: %empty
#line 311 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                { driver->enableDottedIDMode(); }
#line 2408 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 7: // $@2: %empty
#line 313 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                { driver->disableDottedIDMode(); }
#line 2414 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 8: // dotted_id: $@1 "dotted identifier" $@2
#line 313 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > ()); }
#line 2420 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 9: // global_scope_items: global_scope_items global_scope_decl
#line 319 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ()); yylhs.value.as < std::pair<Declarations, Statements> > ().first.push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2426 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 10: // global_scope_items: global_scope_items stmt
#line 321 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ()); yylhs.value.as < std::pair<Declarations, Statements> > ().second.push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2432 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 11: // global_scope_items: %empty
#line 322 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = {}; }
#line 2438 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 12: // global_scope_decl: type_decl
#line 326 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2444 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_decl: constant_decl
#line 327 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2450 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_decl: global_decl
#line 328 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2456 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_decl: function_decl
#line 329 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2462 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: import_decl
#line 330 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2468 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: property_decl
#line 331 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2474 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 18: // type_decl: opt_linkage "type" scoped_id '=' qtype opt_attributes ';'
#line 334 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationType(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[6].value.as < hilti::declaration::Linkage > ()), __loc__); }
#line 2480 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 19: // constant_decl: opt_linkage "const" scoped_id '=' expr ';'
#line 337 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2486 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 20: // constant_decl: opt_linkage "const" type scoped_id '=' expr ';'
#line 339 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[3].value.as < hilti::ID > (), builder->qualifiedType(yystack_[4].value.as < hilti::UnqualifiedType* > (), Constness::Const), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2492 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 21: // local_decl: "local" local_id '=' expr ';'
#line 342 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2498 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 22: // local_decl: "local" qtype local_id opt_type_arguments ';'
#line 343 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                            { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expressions > (), {}, __loc__); }
#line 2504 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 23: // local_decl: "local" qtype local_id '=' expr ';'
#line 345 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2510 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 24: // local_decl: "local" "auto" local_id '=' expr ';'
#line 347 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2516 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 25: // local_init_decl: "local" qtype local_id '=' expr
#line 352 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2522 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 26: // local_init_decl: "local" "auto" local_id '=' expr
#line 354 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2528 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 27: // global_decl: opt_linkage "global" scoped_id '=' expr ';'
#line 358 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2534 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 28: // global_decl: opt_linkage "global" qtype scoped_id opt_type_arguments ';'
#line 360 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expressions > (), {}, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2540 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 29: // global_decl: opt_linkage "global" qtype scoped_id '=' expr ';'
#line 362 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2546 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 30: // global_decl: opt_linkage "global" "auto" scoped_id '=' expr ';'
#line 364 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2552 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 31: // opt_type_arguments: '(' opt_exprs ')'
#line 368 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[1].value.as < hilti::Expressions > ()); }
#line 2558 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 32: // opt_type_arguments: %empty
#line 369 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{}; }
#line 2564 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 33: // function_decl: opt_linkage "function" function_with_body
#line 372 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2570 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 34: // function_decl: opt_linkage "hook" hook_with_body
#line 373 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                             { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2576 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 35: // function_decl: "method" method_with_body
#line 376 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), hilti::declaration::Linkage::Struct, __loc__); }
#line 2582 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 36: // function_decl: "declare" opt_linkage function_without_body ';'
#line 378 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[1].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2588 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 37: // import_decl: "import" local_id ';'
#line 381 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".hlt"), __loc__); }
#line 2594 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 38: // import_decl: "import" local_id "from" dotted_id ';'
#line 382 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".hlt"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 2600 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 39: // property_decl: "property" ';'
#line 386 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 2606 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 40: // property_decl: "property" '=' expr ';'
#line 387 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2612 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 41: // opt_linkage: "public"
#line 389 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 2618 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 42: // opt_linkage: "private"
#line 390 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2624 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 43: // opt_linkage: "init"
#line 391 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Init; }
#line 2630 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 44: // opt_linkage: "preinit"
#line 392 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::PreInit; }
#line 2636 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 45: // opt_linkage: %empty
#line 393 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2642 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 46: // function_id: local_id
#line 397 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2648 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 47: // function_id: "~finally"
#line 398 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID("~finally"); }
#line 2654 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 48: // scoped_function_id: function_id
#line 401 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2660 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 49: // scoped_function_id: "scoped identifier"
#line 402 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2666 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 50: // scoped_function_id: "scoped ~finally"
#line 403 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2672 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 51: // function_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 407 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Standard, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2681 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 52: // method_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 414 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Method, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2690 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 53: // hook_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 421 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Hook, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2699 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 54: // function_without_body: opt_func_flavor opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes
#line 428 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[5].value.as < hilti::QualifiedType* > (), yystack_[2].value.as < hilti::type::function::Parameters > (), yystack_[7].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[4].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as < hilti::function::CallingConvention > (), yystack_[0].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2708 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_flavor: func_flavor
#line 433 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = yystack_[0].value.as < hilti::type::function::Flavor > (); }
#line 2714 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_flavor: %empty
#line 434 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 2720 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 57: // func_flavor: "method"
#line 436 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Method; }
#line 2726 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 58: // func_flavor: "hook"
#line 437 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Hook; }
#line 2732 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 59: // opt_func_cc: "extern"
#line 439 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Extern; }
#line 2738 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 60: // opt_func_cc: "extern-no-suspend"
#line 440 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::ExternNoSuspend; }
#line 2744 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_cc: %empty
#line 441 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 2750 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_params: func_params
#line 443 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[0].value.as < hilti::type::function::Parameters > ()); }
#line 2756 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_params: %empty
#line 444 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters(); }
#line 2762 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 64: // func_params: func_params ',' func_param
#line 446 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                         { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[2].value.as < hilti::type::function::Parameters > ()); yylhs.value.as < hilti::type::function::Parameters > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter* > ()); }
#line 2768 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 65: // func_params: func_param
#line 447 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters{yystack_[0].value.as < hilti::type::function::Parameter* > ()}; }
#line 2774 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 66: // func_param: opt_func_param_kind func_param_type local_id opt_func_default_expr opt_attributes
#line 450 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameter* > () = builder->declarationParameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::UnqualifiedType* > (), yystack_[4].value.as < hilti::parameter::Kind > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::AttributeSet* > (), __loc__); }
#line 2780 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 67: // func_param_type: type
#line 453 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 2786 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 68: // func_param_type: "auto"
#line 454 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAuto(__loc__); }
#line 2792 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 69: // opt_func_param_kind: "copy"
#line 458 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::Copy; }
#line 2798 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 70: // opt_func_param_kind: "inout"
#line 459 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::InOut; }
#line 2804 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 71: // opt_func_param_kind: %empty
#line 460 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::In; }
#line 2810 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 72: // opt_func_default_expr: '=' expr
#line 463 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 2816 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 73: // opt_func_default_expr: %empty
#line 464 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 2822 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 74: // block: braced_block
#line 469 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2828 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 75: // block: stmt
#line 470 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock({yystack_[0].value.as < hilti::Statement* > ()}, __loc__); }
#line 2834 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 76: // braced_block: '{' opt_stmts '}'
#line 473 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock(std::move(yystack_[1].value.as < hilti::Statements > ()), __loc__); }
#line 2840 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 77: // opt_stmts: stmts
#line 475 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[0].value.as < hilti::Statements > ()); }
#line 2846 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 78: // opt_stmts: %empty
#line 476 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements(); }
#line 2852 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 79: // stmts: stmts stmt
#line 478 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[1].value.as < hilti::Statements > ()); yylhs.value.as < hilti::Statements > ().push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2858 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 80: // stmts: stmt
#line 479 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements{std::move(yystack_[0].value.as < hilti::Statement* > ())}; }
#line 2864 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 81: // stmt: stmt_expr ';'
#line 481 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[1].value.as < hilti::Statement* > ()); }
#line 2870 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 82: // stmt: stmt_decl
#line 482 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2876 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 83: // stmt: "return" ';'
#line 483 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(__loc__); }
#line 2882 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 84: // stmt: "return" expr ';'
#line 484 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2888 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 85: // stmt: "throw" expr ';'
#line 485 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2894 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 86: // stmt: "throw" ';'
#line 486 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(__loc__); }
#line 2900 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 87: // stmt: "yield" ';'
#line 487 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementYield(__loc__); }
#line 2906 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 88: // stmt: "break" ';'
#line 488 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBreak(__loc__); }
#line 2912 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 89: // stmt: "continue" ';'
#line 489 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementContinue(__loc__); }
#line 2918 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 90: // stmt: "if" '(' expr ')' block opt_else_block
#line 491 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2924 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 91: // stmt: "if" '(' local_init_decl ')' block opt_else_block
#line 493 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2930 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 92: // stmt: "if" '(' local_init_decl ';' expr ')' block opt_else_block
#line 495 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2936 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "while" '(' local_init_decl ';' expr ')' block opt_else_block
#line 497 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2942 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 94: // stmt: "while" '(' expr ')' block opt_else_block
#line 499 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2948 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 95: // stmt: "while" '(' local_init_decl ')' block opt_else_block
#line 501 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2954 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 96: // stmt: "for" '(' local_id "in" expr ')' block
#line 503 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementFor(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2960 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 97: // stmt: "switch" '(' expr ')' '{' opt_switch_cases '}'
#line 505 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 2966 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 98: // stmt: "switch" '(' local_init_decl ')' '{' opt_switch_cases '}'
#line 507 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 2972 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 99: // stmt: "try" block try_catches
#line 509 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementTry(std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::statement::try_::Catches > ()), __loc__); }
#line 2978 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 100: // stmt: "assert" expr ';'
#line 510 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, __loc__); }
#line 2984 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 101: // stmt: "assert" expr ':' expr ';'
#line 511 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2990 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 102: // stmt: "assert-exception" expr ';'
#line 512 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, {}, __loc__); }
#line 2996 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 103: // stmt: "assert-exception" expr ':' expr ';'
#line 514 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression* > ()), {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3002 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 104: // stmt: "add" expr ';'
#line 516 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3014 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 105: // stmt: "delete" expr ';'
#line 524 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3026 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 106: // stmt: "unset" expr ';'
#line 532 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3038 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 107: // opt_else_block: "else" block
#line 542 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3044 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 108: // opt_else_block: %empty
#line 543 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = {}; }
#line 3050 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 109: // opt_switch_cases: switch_cases
#line 546 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[0].value.as < hilti::statement::switch_::Cases > ()); }
#line 3056 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 110: // opt_switch_cases: %empty
#line 547 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = {}; }
#line 3062 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 111: // switch_cases: switch_cases switch_case
#line 549 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()); yylhs.value.as < hilti::statement::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())); }
#line 3068 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 112: // switch_cases: switch_case
#line 550 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = hilti::statement::switch_::Cases({std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())}); }
#line 3074 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 113: // switch_case: "case" exprs ':' block
#line 552 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(std::move(yystack_[2].value.as < hilti::Expressions > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3080 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 114: // switch_case: "default" ':' block
#line 553 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3086 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 115: // try_catches: try_catches try_catch
#line 555 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catches > () = std::move(yystack_[1].value.as < hilti::statement::try_::Catches > ()); yylhs.value.as < hilti::statement::try_::Catches > ().push_back(std::move(yystack_[0].value.as < hilti::statement::try_::Catch* > ())); }
#line 3092 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 116: // try_catches: try_catch
#line 556 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catches > () = hilti::statement::try_::Catches({ std::move(yystack_[0].value.as < hilti::statement::try_::Catch* > ()) }); }
#line 3098 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 117: // try_catch: "catch" '(' func_param_type local_id ')' block
#line 559 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catch* > () = builder->statementTryCatch(builder->declarationParameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::UnqualifiedType* > (), parameter::Kind::In, {}, {}, __loc__), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3104 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 118: // try_catch: "catch" block
#line 560 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catch* > () = builder->statementTryCatch(std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3110 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 119: // stmt_decl: local_decl
#line 562 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3116 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 120: // stmt_decl: type_decl
#line 563 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3122 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 121: // stmt_decl: constant_decl
#line 564 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3128 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 122: // stmt_expr: expr
#line 567 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementExpression(yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 3134 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_attrs: "any"
#line 572 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAny(__loc__); }
#line 3140 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_attrs: "addr"
#line 573 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAddress(__loc__); }
#line 3146 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_attrs: "bool"
#line 574 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBool(__loc__); }
#line 3152 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_attrs: "bytes"
#line 575 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBytes(__loc__); }
#line 3158 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_attrs: "error"
#line 576 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeError(__loc__); }
#line 3164 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_attrs: "interval"
#line 577 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeInterval(__loc__); }
#line 3170 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_attrs: "net"
#line 578 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeNetwork(__loc__); }
#line 3176 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_attrs: "port"
#line 579 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typePort(__loc__); }
#line 3182 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_attrs: "real"
#line 580 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeReal(__loc__); }
#line 3188 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_attrs: "regexp"
#line 581 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeRegExp(__loc__); }
#line 3194 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_attrs: "stream"
#line 582 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStream(__loc__); }
#line 3200 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_attrs: "string"
#line 583 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeString(__loc__); }
#line 3206 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_attrs: "time"
#line 584 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTime(__loc__); }
#line 3212 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_attrs: "void"
#line 585 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVoid(__loc__); }
#line 3218 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_attrs: "int" type_param_begin "unsigned integer value" type_param_end
#line 587 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3224 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_attrs: "int" type_param_begin '*' type_param_end
#line 588 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3230 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_attrs: "uint" type_param_begin "unsigned integer value" type_param_end
#line 589 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3236 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_attrs: "uint" type_param_begin '*' type_param_end
#line 590 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3242 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_attrs: "optional" type_param_begin qtype type_param_end
#line 592 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeOptional(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3248 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_attrs: "result" type_param_begin qtype type_param_end
#line 593 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeResult(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3254 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_attrs: "view" type_param_begin qtype type_param_end
#line 594 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = viewForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3260 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_attrs: "iterator" type_param_begin qtype type_param_end
#line 595 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3266 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_attrs: "strong_ref" type_param_begin qtype type_param_end
#line 596 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3272 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_attrs: "strong_ref" type_param_begin '*' type_param_end
#line 597 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(hilti::type::Wildcard(), __loc__); }
#line 3278 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_attrs: "value_ref" type_param_begin qtype type_param_end
#line 598 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeValueReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3284 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 148: // base_type_no_attrs: "value_ref" type_param_begin '*' type_param_end
#line 599 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeValueReference(hilti::type::Wildcard(), __loc__); }
#line 3290 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 149: // base_type_no_attrs: "weak_ref" type_param_begin qtype type_param_end
#line 600 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeWeakReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3296 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 150: // base_type_no_attrs: "weak_ref" type_param_begin '*' type_param_end
#line 601 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeWeakReference(hilti::type::Wildcard(), __loc__); }
#line 3302 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 151: // base_type_no_attrs: "list" type_param_begin '*' type_param_end
#line 603 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeList(hilti::type::Wildcard(), __loc__); }
#line 3308 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 152: // base_type_no_attrs: "list" type_param_begin qtype type_param_end
#line 604 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeList(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3314 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 153: // base_type_no_attrs: "vector" type_param_begin '*' type_param_end
#line 605 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(hilti::type::Wildcard(), __loc__); }
#line 3320 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 154: // base_type_no_attrs: "vector" type_param_begin qtype type_param_end
#line 606 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3326 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 155: // base_type_no_attrs: "set" type_param_begin '*' type_param_end
#line 607 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(hilti::type::Wildcard(), __loc__); }
#line 3332 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 156: // base_type_no_attrs: "set" type_param_begin qtype type_param_end
#line 608 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3338 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 157: // base_type_no_attrs: "map" type_param_begin '*' type_param_end
#line 609 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(hilti::type::Wildcard(), __loc__); }
#line 3344 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 158: // base_type_no_attrs: "map" type_param_begin qtype ',' qtype type_param_end
#line 610 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3350 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 159: // base_type_no_attrs: "exception"
#line 612 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeException(__loc__); }
#line 3356 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 160: // base_type_no_attrs: '[' "exception" ':' type ']'
#line 613 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeException(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), __loc__); }
#line 3362 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 161: // base_type_no_attrs: "library type" '(' "string value" ')'
#line 615 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeLibrary(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3368 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 162: // base_type_no_attrs: tuple_type
#line 617 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3374 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 163: // base_type_no_attrs: struct_type
#line 618 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3380 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 164: // base_type_no_attrs: union_type
#line 619 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3386 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 165: // base_type_no_attrs: enum_type
#line 620 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3392 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 166: // base_type_no_attrs: bitfield_type
#line 621 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3398 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 167: // base_type: base_type_no_attrs
#line 624 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = yystack_[0].value.as < hilti::UnqualifiedType* > (); }
#line 3404 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 168: // type: base_type
#line 627 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3410 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 169: // type: function_type
#line 628 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3416 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 170: // type: scoped_id
#line 629 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3422 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 171: // qtype: type
#line 632 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), Constness::Mutable, __loc__); }
#line 3428 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 172: // qtype: "const" type
#line 633 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), Constness::Const, __loc__); }
#line 3434 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 173: // qtype: "auto"
#line 634 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeAuto(__loc__), Constness::Const, __loc__); }
#line 3440 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 174: // type_param_begin: '<'
#line 639 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 3446 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 175: // type_param_end: '>'
#line 643 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 3452 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 176: // function_type: opt_func_flavor "function" '(' opt_func_params ')' "->" qtype
#line 646 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeFunction(yystack_[0].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), yystack_[6].value.as < hilti::type::function::Flavor > (), __loc__); }
#line 3458 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 177: // tuple_type: "tuple" type_param_begin '*' type_param_end
#line 649 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(hilti::type::Wildcard(), __loc__); }
#line 3464 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 178: // tuple_type: "tuple" type_param_begin tuple_type_elems type_param_end
#line 650 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()), __loc__); }
#line 3470 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 179: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 655 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[2].value.as < hilti::type::tuple::Elements > ()); yylhs.value.as < hilti::type::tuple::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())); }
#line 3476 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 180: // tuple_type_elems: tuple_type_elem
#line 656 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = hilti::type::tuple::Elements{std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())}; }
#line 3482 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 181: // tuple_type_elem: qtype
#line 660 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(hilti::ID(), std::move(yystack_[0].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3488 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 182: // tuple_type_elem: local_id ':' qtype
#line 661 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3494 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 183: // struct_type: "struct" opt_struct_params '{' struct_fields '}'
#line 664 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                   { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStruct(std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3500 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 184: // opt_struct_params: '(' opt_func_params ')'
#line 667 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[1].value.as < hilti::type::function::Parameters > ()); }
#line 3506 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 185: // opt_struct_params: %empty
#line 668 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters{}; }
#line 3512 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 186: // struct_fields: struct_fields struct_field
#line 670 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[1].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 3518 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 187: // struct_fields: %empty
#line 671 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; }
#line 3524 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 188: // struct_field: qtype local_id opt_attributes ';'
#line 673 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3530 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 189: // struct_field: func_flavor opt_func_cc qtype function_id '(' opt_func_params ')' opt_attributes ';'
#line 674 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                                                     {
                                                   auto ftype = builder->typeFunction(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), std::move(ftype), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                   }
#line 3539 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 190: // struct_field: func_flavor opt_func_cc qtype function_id '(' opt_func_params ')' opt_attributes braced_block
#line 678 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                                                              {
                                                   auto ftype = builder->typeFunction(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   auto func = builder->function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), std::move(yystack_[0].value.as < hilti::Statement* > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), {});
                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationField(yystack_[5].value.as < hilti::ID > (), std::move(func), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                   }
#line 3549 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 191: // union_type: "union" opt_attributes '{' opt_union_fields '}'
#line 685 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnion(std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3555 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 192: // opt_union_fields: union_fields
#line 687 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = yystack_[0].value.as < hilti::Declarations > (); }
#line 3561 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 193: // opt_union_fields: %empty
#line 688 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; }
#line 3567 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 194: // union_fields: union_fields ',' union_field
#line 690 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[2].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration* > ())); }
#line 3573 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 195: // union_fields: union_field
#line 691 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; yylhs.value.as < hilti::Declarations > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration* > ())); }
#line 3579 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 196: // union_field: qtype local_id opt_attributes
#line 693 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3585 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 197: // enum_type: "enum" '{' enum_labels '}'
#line 695 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()), __loc__); }
#line 3591 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 198: // enum_type: "enum" '<' '*' '>'
#line 696 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(type::Wildcard(), __loc__); }
#line 3597 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 199: // enum_labels: enum_labels ',' enum_label
#line 698 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[2].value.as < hilti::type::enum_::Labels > ()); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3603 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 200: // enum_labels: enum_labels ','
#line 699 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()); }
#line 3609 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 201: // enum_labels: enum_label
#line 700 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = hilti::type::enum_::Labels(); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3615 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 202: // enum_label: local_id
#line 703 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3621 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 203: // enum_label: local_id '=' "unsigned integer value"
#line 704 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3627 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 204: // $@3: %empty
#line 708 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { _field_width = yystack_[1].value.as < uint64_t > (); }
#line 3633 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 205: // bitfield_type: "bitfield" '(' "unsigned integer value" ')' $@3 '{' opt_bitfield_bit_ranges '}'
#line 710 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBitfield(yystack_[5].value.as < uint64_t > (), yystack_[1].value.as < hilti::type::bitfield::BitRanges > (), {}, __loc__); }
#line 3639 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 206: // opt_bitfield_bit_ranges: bitfield_bit_ranges
#line 714 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[0].value.as < hilti::type::bitfield::BitRanges > ()); }
#line 3645 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 207: // opt_bitfield_bit_ranges: %empty
#line 715 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = type::bitfield::BitRanges(); }
#line 3651 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 208: // bitfield_bit_ranges: bitfield_bit_ranges bitfield_bit_range
#line 719 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[1].value.as < hilti::type::bitfield::BitRanges > ()); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ()));  }
#line 3657 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 209: // bitfield_bit_ranges: bitfield_bit_range
#line 720 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = type::bitfield::BitRanges(); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ())); }
#line 3663 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 210: // bitfield_bit_range: local_id ':' "unsigned integer value" ".." "unsigned integer value" opt_attributes ';'
#line 724 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[6].value.as < hilti::ID > ()), yystack_[4].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3669 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 211: // bitfield_bit_range: local_id ':' "unsigned integer value" opt_attributes ';'
#line 726 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[4].value.as < hilti::ID > ()), yystack_[2].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3675 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 212: // expr: expr_0
#line 729 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3681 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 213: // opt_exprs: exprs
#line 732 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 3687 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 214: // opt_exprs: %empty
#line 733 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 3693 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 215: // exprs: exprs ',' expr
#line 735 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 3699 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 216: // exprs: expr
#line 736 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 3705 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 217: // expr_0: expr_1
#line 738 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3711 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 218: // expr_1: expr_2 '=' expr_1
#line 741 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionAssign(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3717 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 219: // expr_1: expr_2 "-=" expr_1
#line 742 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3723 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 220: // expr_1: expr_2 "+=" expr_1
#line 743 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3729 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 221: // expr_1: expr_2 "*=" expr_1
#line 744 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3735 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 222: // expr_1: expr_2 "/=" expr_1
#line 745 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3741 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 223: // expr_1: expr_2 '?' expr_1 ':' expr_1
#line 746 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTernary(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3747 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 224: // expr_1: expr_2
#line 747 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3753 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 225: // expr_2: expr_2 "||" expr_3
#line 749 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalOr(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3759 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 226: // expr_2: expr_3
#line 750 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3765 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 227: // expr_3: expr_3 "&&" expr_4
#line 752 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalAnd(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3771 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 228: // expr_3: expr_4
#line 753 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3777 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 229: // expr_4: expr_4 "==" expr_5
#line 755 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3783 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 230: // expr_4: expr_4 "!=" expr_5
#line 756 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3789 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 231: // expr_4: expr_5
#line 757 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3795 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 232: // expr_5: expr_5 '<' expr_6
#line 759 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3801 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 233: // expr_5: expr_5 '>' expr_6
#line 760 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3807 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 234: // expr_5: expr_5 ">=" expr_6
#line 761 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3813 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 235: // expr_5: expr_5 "<=" expr_6
#line 762 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3819 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 236: // expr_5: expr_6
#line 763 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3825 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 237: // expr_6: expr_6 '|' expr_7
#line 765 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3831 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 238: // expr_6: expr_7
#line 766 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3837 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 239: // expr_7: expr_7 '^' expr_8
#line 768 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3843 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 240: // expr_7: expr_8
#line 769 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3849 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 241: // expr_8: expr_8 '&' expr_9
#line 771 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3855 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 242: // expr_8: expr_9
#line 772 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3861 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 243: // expr_9: expr_9 "<<" expr_a
#line 774 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3867 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 244: // expr_9: expr_9 ">>" expr_a
#line 775 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3873 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 245: // expr_9: expr_a
#line 776 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3879 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 246: // expr_a: expr_a '+' expr_b
#line 778 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3885 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 247: // expr_a: expr_a '-' expr_b
#line 779 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3891 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 248: // expr_a: expr_b
#line 780 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3897 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 249: // expr_b: expr_b '%' expr_c
#line 782 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3903 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 250: // expr_b: expr_b '*' expr_c
#line 783 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3909 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 251: // expr_b: expr_b '/' expr_c
#line 784 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3915 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 252: // expr_b: expr_b "**" expr_c
#line 785 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3921 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 253: // expr_b: expr_c
#line 786 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3927 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 254: // expr_c: '!' expr_c
#line 788 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3933 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 255: // expr_c: '*' expr_c
#line 789 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3939 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 256: // expr_c: '~' expr_c
#line 790 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3945 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 257: // expr_c: '|' expr_c '|'
#line 791 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 3951 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 258: // expr_c: "--" expr_c
#line 792 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3957 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 259: // expr_c: "++" expr_c
#line 793 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3963 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 260: // expr_c: expr_d
#line 794 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3969 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 261: // expr_d: expr_d '(' opt_exprs ')'
#line 796 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 3975 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 262: // expr_d: expr_d '.' member_expr
#line 797 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3981 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 263: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 798 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                         { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 3987 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 264: // expr_d: expr_d '[' expr ']'
#line 799 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 3993 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 265: // expr_d: expr_d "?." member_expr
#line 800 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3999 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 266: // expr_d: expr_d "in" expr_d
#line 801 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4005 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 267: // expr_d: expr_d "!in" expr_d
#line 802 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__)); }
#line 4011 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 268: // expr_d: expr_d "--"
#line 803 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4017 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 269: // expr_d: expr_d "++"
#line 804 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4023 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 270: // expr_d: expr_d ".?" member_expr
#line 805 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4029 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 271: // expr_d: expr_e
#line 806 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4035 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 272: // expr_e: "begin" '(' expr ')'
#line 808 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4041 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 273: // expr_e: "cast" type_param_begin qtype type_param_end '(' expr ')'
#line 809 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression* > ()), builder->expressionType(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()))}, __loc__); }
#line 4047 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 274: // expr_e: "end" '(' expr ')'
#line 810 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4053 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 275: // expr_e: "move" '(' expr ')'
#line 811 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMove(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4059 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 276: // expr_e: "pack" tuple_expr
#line 812 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                  { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4065 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 277: // expr_e: "unpack" type_param_begin qtype type_param_end tuple_expr
#line 813 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unpack, {builder->expressionType(std::move(yystack_[2].value.as < hilti::QualifiedType* > ())), std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorBool(false), __loc__)}, __loc__); }
#line 4071 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 278: // expr_e: "new" expr
#line 814 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4077 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 279: // expr_e: "new" qtype
#line 815 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionType(std::move(yystack_[0].value.as < hilti::QualifiedType* > ())), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4083 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 280: // expr_e: "new" qtype '(' opt_exprs ')'
#line 816 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionType(std::move(yystack_[3].value.as < hilti::QualifiedType* > ())), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4089 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 281: // expr_e: "typeinfo" '(' expr ')'
#line 817 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTypeInfo(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4095 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 282: // expr_e: "typeinfo" '(' base_type ')'
#line 818 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTypeInfo(builder->expressionType(builder->qualifiedType(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), Constness::Mutable)), __loc__); }
#line 4101 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 283: // expr_e: expr_f
#line 819 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4107 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 284: // expr_f: ctor
#line 821 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4113 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 285: // expr_f: ctor_expr
#line 822 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4119 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 286: // expr_f: '-' expr_f
#line 823 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4125 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 287: // expr_f: '[' expr "for" local_id "in" expr ']'
#line 825 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[1].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4131 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 288: // expr_f: '[' expr "for" local_id "in" expr "if" expr ']'
#line 827 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[7].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()),  __loc__); }
#line 4137 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 289: // expr_f: expr_g
#line 828 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4143 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 290: // expr_g: '(' expr ')'
#line 830 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionGrouping(std::move(yystack_[1].value.as < hilti::Expression* > ())); }
#line 4149 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 291: // expr_g: scoped_id
#line 831 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4155 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 292: // expr_g: "$$"
#line 832 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move("__dd"), __loc__);}
#line 4161 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 293: // expr_g: "scope"
#line 833 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionKeyword(hilti::expression::keyword::Kind::Scope, __loc__); }
#line 4167 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 294: // member_expr: local_id
#line 836 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4173 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 295: // member_expr: "error"
#line 837 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(ID("error"), __loc__); }
#line 4179 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 296: // ctor: "bool value"
#line 841 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBool(yystack_[0].value.as < bool > (), __loc__); }
#line 4185 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 297: // ctor: "bytes value"
#line 842 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4191 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 298: // ctor: "string value"
#line 843 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorString(yystack_[0].value.as < std::string > (), false, __loc__); }
#line 4197 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 299: // ctor: "unsigned integer value"
#line 844 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 4203 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 300: // ctor: '+' "unsigned integer value"
#line 845 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( yystack_[0].value.as < uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__);
                                                 }
#line 4213 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 301: // ctor: "real value"
#line 850 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__); }
#line 4219 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 302: // ctor: '+' "real value"
#line 851 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__);; }
#line 4225 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 303: // ctor: "Null"
#line 852 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNull(__loc__); }
#line 4231 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 304: // ctor: "address value"
#line 854 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorAddress(hilti::rt::Address(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4237 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 305: // ctor: "address value" '/' "unsigned integer value"
#line 855 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNetwork(hilti::rt::Network(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 4243 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 306: // ctor: "port value"
#line 856 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorPort(hilti::rt::Port(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4249 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 307: // ctor: "optional" '(' expr ')'
#line 861 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorOptional(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4255 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 308: // ctor: "default" type_param_begin type type_param_end '(' opt_exprs ')'
#line 863 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorDefault(std::move(yystack_[4].value.as < hilti::UnqualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4261 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 309: // ctor: list
#line 864 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4267 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 310: // ctor: map
#line 865 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4273 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 311: // ctor: regexp
#line 866 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4279 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 312: // ctor: set
#line 867 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4285 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 313: // ctor: struct_
#line 868 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4291 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 314: // ctor: tuple
#line 869 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4297 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 315: // ctor_expr: "interval" '(' expr ')'
#line 872 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4303 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 316: // ctor_expr: "interval_ns" '(' expr ')'
#line 873 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4309 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 317: // ctor_expr: "time" '(' expr ')'
#line 874 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4315 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 318: // ctor_expr: "time_ns" '(' expr ')'
#line 875 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4321 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 319: // ctor_expr: "stream" '(' expr ')'
#line 876 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("stream", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4327 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 320: // ctor_expr: "error" '(' expr ')'
#line 877 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("error", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4333 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 321: // ctor_expr: "int8" '(' expr ')'
#line 878 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4339 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 322: // ctor_expr: "int16" '(' expr ')'
#line 879 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4345 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 323: // ctor_expr: "int32" '(' expr ')'
#line 880 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4351 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 324: // ctor_expr: "int64" '(' expr ')'
#line 881 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4357 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 325: // ctor_expr: "uint8" '(' expr ')'
#line 882 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4363 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 326: // ctor_expr: "uint16" '(' expr ')'
#line 883 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4369 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 327: // ctor_expr: "uint32" '(' expr ')'
#line 884 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4375 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 328: // ctor_expr: "uint64" '(' expr ')'
#line 885 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4381 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 329: // ctor_expr: "port" '(' expr ',' expr ')'
#line 886 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("port", {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4387 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 330: // tuple: '(' opt_tuple_elems1 ')'
#line 889 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4393 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 331: // opt_tuple_elems1: tuple_elem
#line 892 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4399 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 332: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 893 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 4405 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 333: // opt_tuple_elems1: %empty
#line 894 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4411 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 334: // opt_tuple_elems2: tuple_elem
#line 897 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{ std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4417 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 335: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 898 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 4423 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 336: // opt_tuple_elems2: %empty
#line 899 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4429 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 337: // tuple_elem: expr
#line 902 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4435 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 338: // tuple_expr: tuple
#line 905 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4441 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 339: // list: '[' opt_exprs ']'
#line 907 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4447 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 340: // list: "list" '(' opt_exprs ')'
#line 908 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4453 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 341: // list: "list" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 910 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4459 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 342: // list: "vector" '(' opt_exprs ')'
#line 911 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4465 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 343: // list: "vector" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 913 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4471 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 344: // set: "set" '(' opt_exprs ')'
#line 915 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4477 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 345: // set: "set" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 917 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4483 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 346: // map: "map" '(' opt_map_elems ')'
#line 919 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 4489 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 347: // map: "map" type_param_begin qtype ',' qtype type_param_end '(' opt_map_elems ')'
#line 921 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 4495 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 348: // struct_: '[' struct_elems ']'
#line 923 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                             { yylhs.value.as < hilti::Ctor* > () = builder->ctorStruct(std::move(yystack_[1].value.as < hilti::ctor::struct_::Fields > ()), __loc__); }
#line 4501 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 349: // struct_elems: struct_elems ',' struct_elem
#line 925 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = std::move(yystack_[2].value.as < hilti::ctor::struct_::Fields > ()); yylhs.value.as < hilti::ctor::struct_::Fields > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()); }
#line 4507 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 350: // struct_elems: struct_elem
#line 926 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = hilti::ctor::struct_::Fields{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()) }; }
#line 4513 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 351: // struct_elem: '$' local_id '=' expr
#line 928 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field* > () = builder->ctorStructField(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 4519 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 352: // regexp: re_patterns opt_attributes
#line 930 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Ctor* > () = builder->ctorRegExp(std::move(yystack_[1].value.as < std::vector<std::string> > ()), std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4525 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 353: // re_patterns: re_patterns '|' re_pattern_constant
#line 933 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 4531 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 354: // re_patterns: re_pattern_constant
#line 934 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 4537 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 355: // $@4: %empty
#line 937 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                    { driver->enablePatternMode(); }
#line 4543 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 356: // $@5: %empty
#line 937 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                             { driver->disablePatternMode(); }
#line 4549 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 357: // re_pattern_constant: '/' $@4 "regular expression value" $@5 '/'
#line 938 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 4555 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 358: // opt_map_elems: map_elems
#line 940 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[0].value.as < hilti::ctor::map::Elements > ()); }
#line 4561 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 359: // opt_map_elems: %empty
#line 941 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); }
#line 4567 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 360: // map_elems: map_elems ',' map_elem
#line 943 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[2].value.as < hilti::ctor::map::Elements > ()); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 4573 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 361: // map_elems: map_elem
#line 944 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 4579 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 362: // map_elem: expr ':' expr
#line 946 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Element* > () = builder->ctorMapElement(yystack_[2].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 4585 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 363: // attribute: "attribute"
#line 949 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Attribute* > () = builder->attribute(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4591 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 364: // attribute: "attribute" '=' expr
#line 950 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Attribute* > () = builder->attribute(std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4597 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 365: // opt_attributes: opt_attributes attribute
#line 953 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ()); yylhs.value.as < hilti::AttributeSet* > () = yystack_[1].value.as < hilti::AttributeSet* > (); }
#line 4603 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 366: // opt_attributes: %empty
#line 954 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 4609 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;


#line 4613 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -633;

  const short Parser::yytable_ninf_ = -334;

  const short
  Parser::yypact_[] =
  {
     -42,    67,   107,  -633,   -30,  -633,  -633,  2063,  -633,   -16,
    -633,  -633,    34,  -633,  -633,  -633,  -633,  3593,  3593,  3593,
     -26,    -8,    -6,  -633,    37,    78,    -6,  3593,  -633,    58,
      85,    90,   106,    67,  -633,   114,   120,   151,   157,   160,
     162,   -86,  5449,   -59,   206,  3593,   163,  1723,   166,   167,
    3593,   170,  -633,  -633,  -633,  3083,  -633,   -53,   172,   173,
     175,   176,  3253,  2403,   177,   178,   183,   184,   185,    -6,
    3593,   -31,   186,    63,  -633,  3593,  3593,  1211,  3593,   265,
    3911,  -633,  3593,  3593,  -633,  -633,  -633,  1383,  1553,  -633,
    -633,  -633,  -633,  -633,    51,  -633,  -633,   132,  -633,  -633,
    -633,   -28,   311,   -32,   -35,   180,   181,   182,   165,   123,
     -60,  -633,   -25,  -633,  -633,  -633,  -633,  -633,  -633,  -633,
    -633,  -633,  -633,  -633,   187,  -633,  3593,  -633,   326,   194,
      32,    62,  3593,  -633,  -633,  5575,  -633,   -12,  6079,   197,
    3593,  3593,    67,  3423,   -20,  3593,  3593,  3593,  3593,  3593,
    3593,  3593,  5575,  -633,  -633,   349,   199,  -633,  -633,  6079,
    -633,   -92,  -633,  -633,  -633,    -6,  -633,    -6,   201,    -6,
      -6,  -633,  -633,    -6,  -633,    -6,  -633,    -6,    -6,  -633,
    -633,   202,  -633,    -6,    -6,  -633,    -6,    -6,  -633,    -6,
      -6,   301,   207,  -633,   294,  -633,  -633,  -633,  -633,    67,
    -633,  -633,  -633,  -633,  -633,  -633,  3593,  5575,  -633,  -633,
    -633,  5575,  -633,  3593,  -633,   208,   209,   -86,   -59,    30,
     210,   -53,   211,   212,   -31,  1038,  4015,   214,  -633,  3593,
    3593,  -633,  -633,  -633,  3593,  -633,   216,  3593,  5575,  3593,
    3423,  3593,  3593,  -633,   217,  2573,  -633,  -633,   -19,   324,
    -633,  -633,  2233,  3593,  3593,  3593,  3593,  5575,   218,  3593,
    5575,  3423,  -633,   219,   220,   221,  -633,    67,   310,   213,
     222,    65,  -633,   215,  -633,  -633,  -633,   365,  -633,  -633,
    6079,   206,  5701,   206,   289,  -633,  3593,  3593,  3593,  3593,
    3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,
    3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,  3593,
    3593,    45,  3763,  -633,  3763,  -633,    45,  3593,  3593,    45,
     224,   373,   228,  -633,  -633,  -633,  3593,  -633,  3593,   227,
     223,   231,   206,   223,  -633,   232,   233,   315,  5827,    73,
     234,  -633,  -633,   235,   236,   237,   241,   243,   245,  -633,
     247,   223,   254,   393,  -633,    67,   251,    11,  5575,   401,
    4183,  4309,  5575,  4435,  5575,  4561,   -23,   261,  4687,    22,
      26,  4813,  5575,  4939,  5065,   256,  3593,   260,    96,   258,
     262,   263,  -633,   264,    81,   266,  4183,  4309,  4561,  4813,
    3593,   267,  -633,   269,  -633,   268,   223,   271,   274,   275,
     276,   277,  -633,   282,  2743,  -633,  2913,   380,  -633,   279,
     280,   281,   283,   284,   286,   223,  -633,   287,   223,   100,
     288,  -633,  -633,  3593,   285,    67,  -633,  3593,   244,  -633,
    -633,  -633,   296,   289,  -633,  5575,   291,   297,   289,  -633,
    5575,   299,  -633,  -633,   424,  -633,  -633,  -633,   295,   -15,
      41,    56,   290,   293,   298,   300,   303,   292,   179,   131,
     133,    24,    71,  -633,  -633,  -633,  -633,  -633,  -633,  -633,
      47,   108,  -633,   304,   305,   306,  -633,   309,  -633,  -633,
     302,   313,  -633,  -633,   317,  -633,  5575,   321,  -633,  -633,
    3593,   450,    67,  3593,  2403,  2403,   316,   457,  -633,  -633,
    -633,  -633,  -633,  -633,  -633,   322,  3593,   323,   325,   -85,
    -633,   318,   223,   223,   223,   327,   223,   223,   223,   328,
     223,   223,   223,   223,   223,   223,  -633,  -633,   330,   331,
    -633,  5953,  -633,   223,   329,  -633,    43,  -633,   223,   223,
    5191,   223,   223,   223,   223,   223,   223,   223,  6079,   335,
     -23,  3593,  3593,   336,  3593,  -633,  3593,  5575,  -633,  -633,
    -633,  -633,  -633,   338,  -633,   223,   337,   223,   223,   339,
    -633,  3593,  -633,   341,  -633,   333,   346,  -633,  -633,  -633,
    -633,  1893,  -633,  -633,  -633,  -633,  -633,  -633,  -633,  -633,
     167,  -633,   343,  3593,  2403,  2403,  -633,   342,  3593,   408,
    -633,  -633,   332,  3593,   347,    81,   348,  3593,   109,    81,
    5575,  3593,  -633,  -633,  3593,  3593,  -633,  -633,  3593,    81,
    3593,   350,   351,   352,   353,   430,   455,  -633,  -633,  3593,
     356,  -633,   486,  -633,    67,  -633,  -633,  -633,  -633,  -633,
    -633,  -633,  -633,  5575,  -633,  -633,  -633,  -633,  -633,  -633,
    -633,    10,  -633,    67,  -633,  5320,  -633,  5575,  5575,  -633,
    -633,  -633,    67,   360,   357,  -633,  -633,  -633,  -633,  -633,
    -633,  -633,  -633,   354,  -633,   361,   359,   362,  -633,  -633,
    -633,   223,   -23,   364,  5575,   366,   367,  -633,   369,  3593,
      59,    59,    67,  -633,  3593,   370,   464,   468,  3593,  -633,
    3593,  -633,   374,  3593,   368,  3593,   376,  3593,   377,   372,
    -633,  -633,   378,  -633,   379,   381,   382,  2403,  3593,  3593,
    2403,  2403,  -633,  -633,  -633,   383,  -633,   386,  -633,  -633,
     223,  -633,   387,  -633,   150,    67,  -633,  -633,  -633,  -633,
    -633,  5575,  -633,   507,  -633,  -633,   389,   385,   223,  -633,
     390,  3593,   375,   395,    59,  -633,   396,   394,   402,  2403,
    -633,  -633,  -633,   -38,  -633,   388,   -23,   391,  -633,   403,
    -633,   -23,     6,  -633,  -633,   -23,  -633,  -633,  -633,  -633,
     508,  -633,  -633,    67,  -633,  3593,  -633,  5575,  -633,   553,
    -633,  5575,  3593,  -633,   412,  -633,   147,  2403,  -633,  -633,
    -633,  2403,  -633,   516,  3593,  -633,  -633,   415,  -633,  -633,
     417,  -633,   419,  -633,   418,   431,    67,  -633,  -633,   553,
      42,    18,  -633,   426,    31,  2403,  -633,  -633,  -633,   423,
    -633,  -633,  -633,   569,  -633,  -633,   432,  -633,  -633,  -633,
    -633,  -633,    31,    31,   553,   540,   -23,  -633,  -633,   572,
      20,   435,  -633,  -633,  -633,    21,     3,  -633,  -633,  -633
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,     0,     3,     0,     1,    11,    45,     5,     0,
     298,   297,   304,   306,   301,   299,   296,     0,     0,     0,
       0,     0,     0,   303,     0,    45,     0,     0,   292,     0,
       0,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,    56,     0,    61,     0,     0,    56,     0,     0,
       0,     0,    44,    42,    41,     0,   293,     0,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,   333,     0,   214,     0,     0,
       0,   355,     0,     0,     4,   291,     9,    12,    13,   119,
      14,    15,    16,    17,     0,    10,    82,     0,   122,   212,
     217,   224,   226,   228,   231,   236,   238,   240,   242,   245,
     248,   253,   260,   271,   283,   289,   284,   285,   314,   309,
     312,   310,   313,   311,   366,   354,     0,    39,     0,     0,
       0,     0,     0,    88,   174,    56,    89,    56,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   214,    56,   124,   123,     0,     0,   125,   126,    56,
     131,     0,   127,   159,    58,     0,   128,     0,     0,     0,
       0,    57,   129,     0,   130,     0,   132,     0,     0,   133,
     134,   185,   135,     0,     0,   366,     0,     0,   136,     0,
       0,     0,     4,   170,     0,    55,   167,   168,   171,     0,
     169,   162,   163,   164,   165,   166,   359,    56,    59,    60,
      35,    56,   258,     0,   173,   127,   128,     0,     0,     0,
     130,     0,   133,   135,     0,   214,   170,   279,   278,     0,
     333,   338,   276,   259,     0,    83,     0,   214,    56,     0,
       0,     0,     0,    86,     0,    45,   120,   121,     0,     0,
      74,    75,     0,     0,     0,     0,     0,    56,     0,   214,
      56,     0,    87,   337,     0,   331,   255,     0,   216,     0,
     213,     0,   350,     0,   302,   300,   286,     0,   254,   256,
      56,    61,    56,    61,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   268,     0,   269,     0,   214,     0,     0,
       0,   352,     0,   305,   104,   100,     0,   102,     0,     0,
       0,     0,    61,     0,   105,     0,     0,     0,    56,     0,
       0,     6,    37,     0,     0,     0,     0,     0,     0,   216,
       0,     0,     0,     0,   172,     0,     0,     0,    56,     0,
      56,    56,    56,    56,    56,    56,    71,     0,    56,     0,
       0,    56,    56,    56,    56,     0,     0,     0,    32,     0,
       0,   358,   361,     0,     0,     0,    56,    56,    56,    56,
     214,     0,   337,     0,    84,     0,     0,     0,     0,     0,
       0,     0,    85,     0,    45,    80,    45,    99,   116,     0,
       0,     0,     0,     0,     0,     0,   106,     0,     0,     0,
       0,   290,   330,   336,     0,     0,   339,     0,     0,   348,
     257,   356,   170,     0,    33,    56,     0,   170,     0,    34,
      56,     0,   222,   219,   225,   220,   221,   218,     0,   227,
     229,   230,   234,   235,   232,   233,   237,   239,   241,   243,
     244,   246,   247,   252,   250,   249,   251,   295,   294,   265,
     266,   267,   270,     0,     0,   262,   353,   363,   365,    40,
       0,     0,   272,   175,     0,    36,    56,     0,   274,   320,
       0,     0,     0,     0,    45,    45,     0,     0,   322,   323,
     324,   321,   315,   316,   340,     0,     0,     0,   202,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,    70,     0,    62,
      65,    56,   187,     0,     4,   181,     0,   180,     0,     0,
      56,     0,     0,     0,     0,     0,     0,     0,    56,     0,
      71,     0,   214,     0,     0,   346,     0,    56,    49,    50,
      47,    46,    48,     0,   275,     0,     0,     0,     0,     0,
     307,     0,   344,     0,   319,     0,     0,   317,   318,    76,
      79,    56,   118,   115,   282,   281,   326,   327,   328,   325,
       0,   342,     0,     0,    45,    45,   332,   334,     0,     0,
     215,   349,     0,     0,     0,     0,     0,     0,    32,     0,
      56,     0,   261,   264,   214,     0,   101,   103,     0,     0,
     214,     0,     0,     0,     0,   108,   108,    38,     7,   333,
       0,   204,     0,   197,   200,   198,   137,   138,   144,   161,
     151,   152,   157,    56,   141,   146,   145,   142,   155,   156,
     184,    71,    68,     0,    67,    56,   177,    56,    56,   178,
     139,   140,     0,     0,   192,   195,   153,   154,   143,   148,
     147,   150,   149,     0,    21,     0,     0,     0,    22,   362,
     360,     0,    71,   152,    56,   156,   154,   280,     0,   333,
     110,   110,     0,   277,   333,     0,   108,   108,   336,   351,
       0,   357,     0,     0,     0,     0,     0,     0,     0,     0,
     366,   223,     0,   364,     0,     0,     0,    45,     0,     0,
      45,    45,    91,    90,     8,     0,    24,     0,   203,   199,
       0,    64,    73,   183,    61,     0,   186,   182,   179,   366,
     191,    56,   160,     0,    23,    31,     0,     0,     0,   329,
       0,     0,     0,     0,   109,   112,     0,     0,     0,    45,
      95,    94,   335,     0,    19,     0,    71,     0,    27,     0,
      28,    71,     0,   263,   273,    71,   308,    96,    26,    25,
     108,   107,   341,   207,   158,     0,   366,    56,   366,   196,
     194,    56,   359,   366,   158,   345,     0,    45,    98,   111,
      97,    45,   343,   108,     0,   287,    20,     0,    30,    29,
       0,    18,     0,    92,     0,     0,   206,   209,    72,    66,
       0,     0,   176,     0,     0,    45,   114,   117,    93,     0,
     366,   366,   366,     0,   205,   208,     0,   188,   347,    52,
     113,   288,     0,     0,    54,   366,    71,    51,    53,     0,
       0,     0,   366,   211,   366,     0,     0,   210,   189,   190
  };

  const short
  Parser::yypgoto_[] =
  {
    -633,  -633,    -1,   190,  -633,  -633,  -633,  -633,  -633,   584,
     585,  -633,  -180,  -633,   -13,  -633,  -633,  -633,    52,  -227,
    -458,  -633,  -633,  -633,  -633,   459,   -58,  -278,  -544,  -633,
     -52,    19,  -633,  -633,  -398,  -632,  -633,  -633,     0,  -608,
     -90,  -633,  -152,  -633,   196,  -633,  -633,  -633,   355,  -136,
     538,   815,   421,  -633,  -633,  -633,   -49,  -633,  -633,  -633,
    -633,  -633,  -633,  -633,  -135,  -633,  -633,   -29,  -633,  -633,
    -633,  -633,  -205,    17,  -147,  -139,  -633,  -275,  -633,   334,
     320,    12,   -63,   314,   344,   319,     5,     7,   -21,   -37,
    -633,   536,  -633,   -67,  -633,  -633,   -48,  -578,   -81,  -414,
      29,  -633,  -633,  -633,  -633,  -633,   225,  -633,  -633,   307,
    -633,  -633,  -163,  -633,    80,  -633,  -145
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     2,    84,    85,   496,   497,   724,     7,    86,   246,
     247,    89,   339,    90,   553,    91,    92,    93,   248,   562,
     563,   434,   210,   439,   331,   194,   195,   211,   528,   529,
     530,   653,   531,   786,   249,   250,   403,   404,   251,   722,
     753,   754,   755,   407,   408,    96,    97,   196,   197,   198,
     535,   362,   484,   200,   201,   536,   537,   202,   367,   655,
     736,   203,   663,   664,   665,   204,   509,   510,   205,   727,
     815,   816,   817,    98,   269,   270,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   469,   116,   117,   118,   264,   596,   265,
     232,   119,   120,   121,   122,   271,   272,   123,   124,   125,
     277,   602,   380,   381,   382,   478,   321
  };

  const short
  Parser::yytable_[] =
  {
       4,   231,   333,   435,   350,   440,   675,    95,   582,   597,
     477,   442,   443,   477,   445,   446,   447,   448,   723,   286,
     526,   280,   294,   354,   212,   477,   512,   477,   477,   233,
     296,   804,   144,   477,   129,   130,   131,   538,   477,   294,
     370,   192,   311,   341,   139,     3,   312,   307,     3,   297,
     527,   725,     1,   526,   486,   266,   164,   273,   355,    94,
     398,   278,   279,   287,   228,   295,   633,   313,   151,   356,
       3,   634,   236,   288,   314,   134,   289,   137,   171,   244,
     315,   419,   295,   527,     3,   558,   559,   258,   760,   761,
     395,   280,   263,   751,   268,   206,   625,   626,   308,   290,
     467,   237,   134,   560,   752,   316,   296,     5,   134,   309,
     310,   750,   417,   284,   311,   281,   758,   282,   312,   283,
       6,   296,   805,   259,   291,   297,   298,   299,   132,   317,
     134,   307,   -63,   342,   318,   292,   126,   127,   747,   313,
     297,   337,   560,   322,   433,   133,   314,   704,   319,   329,
      34,   709,   315,   245,   352,   134,   858,   335,   336,   811,
     340,   715,   343,   344,   345,   346,   347,   348,   349,   513,
     473,   837,   813,   853,   857,   311,   540,   316,   307,   312,
     539,   245,   308,   284,   229,   325,    52,    53,    54,   326,
     136,   134,   839,   309,   310,   828,   696,   697,   378,   658,
     313,   317,   298,   299,   128,   483,   318,   314,   208,   209,
     847,   848,   140,   315,   -55,   327,   262,   298,   299,   328,
     319,   428,   807,   379,   859,   429,   493,   810,   494,   308,
     385,   812,   193,   452,   453,   454,   455,   226,   316,   141,
     309,   310,   268,   569,   142,   405,   391,   392,   551,   472,
     552,   393,   475,   593,   349,   594,   397,   399,   400,   401,
     143,   707,   317,   552,   208,   209,   424,   318,   145,   410,
     411,   412,   413,   414,   146,   470,   349,   471,   420,   274,
     275,   319,   303,   304,   597,   285,   463,   464,   465,   466,
     305,   306,     3,     8,     3,     8,   303,   304,   305,   306,
     305,   306,   851,   427,   825,   147,   450,   451,   459,   460,
     468,   148,   461,   462,   149,   468,   150,   213,   468,   777,
     229,   230,   780,   781,   234,   193,   239,   240,   193,   241,
     242,   252,   253,   293,   349,   474,   711,   254,   255,   256,
     261,   323,   193,   480,   300,   481,   301,   324,   302,   193,
     334,   320,     3,   353,   508,   359,   366,   375,   377,   376,
     406,   803,   141,   149,   234,   239,   241,   534,   390,   394,
     402,   416,   425,   426,   421,   422,   431,   423,   427,   430,
     477,   479,   482,   561,   485,   483,   490,   488,   489,   495,
     498,   499,   500,   549,    81,   654,   501,   193,   502,   826,
     503,   193,   504,   827,   580,   677,   506,   349,   507,   511,
     515,   532,   673,   548,   550,   554,   406,   555,   267,   556,
     557,   564,   570,   572,   599,   571,   574,   840,   193,   575,
     576,   577,   578,   579,   584,   585,   586,   598,   587,   588,
     392,   589,   591,   595,   600,   654,   293,   193,   603,   607,
     193,   610,   611,     3,   300,   616,   787,   300,   302,   612,
     614,   615,   300,   628,   300,   613,   617,   712,   301,   627,
     432,   618,   437,   716,   441,   620,   629,   632,   631,   700,
     635,   721,   639,   690,   643,   650,   657,   651,   674,   678,
     622,   623,   682,   684,   687,   689,   691,   694,   698,   703,
     705,   728,   701,   718,   719,   717,   721,   621,   720,   726,
     624,   740,   744,   741,   742,   721,   743,   745,   629,   721,
     689,   694,   766,   630,   749,   759,   771,   764,   193,   768,
     770,   791,   797,   773,   774,   775,   783,   776,   782,   785,
     793,   806,   231,   792,   808,   795,   798,   800,   193,   801,
     193,   193,   193,   193,   193,   193,   809,   802,   193,   721,
     477,   193,   193,   193,   193,   772,   792,   721,   676,   349,
     830,   679,   831,   379,   832,   833,   193,   193,   193,   193,
     199,   838,   834,   841,   845,   227,   846,   852,   688,   849,
     854,    87,    88,   836,   789,   708,   332,   734,   263,   731,
     692,   756,   799,   583,   561,   729,   790,   409,   561,   738,
     695,   835,   796,   449,   456,   699,   276,   762,   561,   693,
     702,   458,   444,   604,   706,   193,   606,   476,   608,   823,
     193,   349,   713,   508,     0,   714,   680,   349,     0,     0,
       0,   819,     0,   821,     0,   457,   392,     0,   824,     0,
       0,     0,   732,   601,     0,     0,     0,   534,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   330,     0,     0,   193,     0,     0,     0,
       0,     0,     0,     0,     0,   842,   843,   844,     0,     0,
     351,   757,     0,     0,     0,     0,     0,     0,     0,     0,
     850,     0,     0,     0,     0,     0,   392,   855,     0,   856,
       0,   392,     0,     0,     0,   392,     0,   763,     0,     0,
     765,   193,   767,     0,   769,     0,     0,     0,     0,     0,
     193,     0,     0,     0,   788,   778,   779,     0,   193,     0,
       0,     0,     0,     0,     0,   383,     0,   193,     0,   384,
       0,     0,     0,     0,   487,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   349,     0,
       0,   226,   505,     0,     0,     0,   396,     0,     0,     0,
       0,     0,   814,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   415,     0,     0,   418,     0,
     193,     0,   818,     0,     0,     0,     0,     0,     0,   379,
       0,     0,     0,     0,     0,   814,     0,   573,     0,   561,
     438,   829,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   193,     0,     0,   590,   135,     0,   592,
       0,   138,     0,     0,     0,   193,     0,   193,   193,     0,
       0,     0,     0,     0,     0,     0,   152,     0,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,     0,   193,     0,   492,     0,     0,     0,
       0,     0,     0,     0,   257,     0,   260,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   514,     0,   517,   519,
     520,   522,   523,   525,     0,     0,     0,     0,     0,   542,
     543,   545,   547,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   565,   566,   567,   568,     0,     0,
       0,   193,     0,   636,   637,   638,     0,   640,   641,   642,
       0,   644,   645,   646,   647,   648,   649,     0,     0,     0,
       0,     0,     0,     0,   656,     0,     0,   659,     0,   660,
     661,     0,   666,   667,   668,   669,   670,   671,   672,     0,
       0,     0,     0,   605,     0,     0,     0,   193,   609,     0,
     357,   193,   358,     0,   360,   361,   683,     0,   685,   686,
     363,     0,   364,   365,     0,     0,     0,     0,   368,   369,
       0,   371,   372,     0,   373,   374,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   619,     0,     0,     0,     0,     0,
       0,     0,   386,   387,     0,     0,   388,     0,     0,   389,
       0,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,    23,   662,     0,
       0,     0,     0,    26,     0,     0,    28,     0,     0,     0,
      29,     0,     0,    30,   375,   681,     0,     0,     0,     0,
       0,     0,   746,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    35,    36,    37,    38,    39,    40,     0,
       0,     0,     0,     0,    41,     0,    43,     0,     0,     0,
      45,     0,     0,    46,    47,     0,     0,     0,    48,     0,
       0,    49,     0,    50,    51,     0,     0,     0,   710,     0,
       0,   784,     0,    56,    57,     0,     0,    58,     0,     0,
       0,    60,    61,     0,     0,     0,     0,     0,     0,   794,
       0,    64,     0,    65,    66,    67,    68,     0,    69,     0,
      71,   730,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    75,   735,     0,   737,    76,    77,     0,     0,
       0,     0,    78,     0,     0,    79,    80,     0,    81,    82,
      83,     0,   267,     0,     3,     8,     0,     0,     0,     0,
      10,    11,   748,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   662,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,   820,    56,    57,     0,   822,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     0,   267,   -12,   -12,     0,     0,
       0,   -12,   -12,   -12,     0,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,     0,     0,     0,     0,     0,     0,     0,
     -12,     0,     0,   -12,     0,     0,     0,     0,   -12,     0,
       0,     0,   -12,   -12,   -12,     0,     0,   -12,   -12,   -12,
       0,   -12,     0,     0,     0,   -12,     0,     0,   -12,     0,
       0,     0,     0,     0,     0,   -12,     0,   -12,     0,   -12,
       0,   -12,   -12,   -12,     0,   -12,     0,     0,   -12,   -12,
     -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,   -12,
     -12,   -12,     0,   -12,     0,   -12,     0,     0,   -12,   -12,
       0,     0,     0,   -12,     0,     0,   -12,     0,   -12,   -12,
       0,   -12,   -12,   -12,     0,     0,     0,   -12,   -12,   -12,
       0,     0,   -12,     0,     0,   -12,   -12,   -12,     0,     0,
       0,   -12,   -12,     0,     0,   -12,   -12,     0,   -12,   -12,
     -12,   -12,     0,   -12,   -12,   -12,     0,     0,   -12,     0,
       0,     0,   -12,     0,   -12,     0,     0,   -12,     0,     0,
       0,   -12,   -12,     0,     0,     0,     0,   -12,     0,     0,
     -12,   -12,     0,   -12,   -12,   -12,   -13,   -13,     0,     0,
       0,   -13,   -13,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,     0,     0,     0,     0,     0,     0,     0,
     -13,     0,     0,   -13,     0,     0,     0,     0,   -13,     0,
       0,     0,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,
       0,   -13,     0,     0,     0,   -13,     0,     0,   -13,     0,
       0,     0,     0,     0,     0,   -13,     0,   -13,     0,   -13,
       0,   -13,   -13,   -13,     0,   -13,     0,     0,   -13,   -13,
     -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,   -13,
     -13,   -13,     0,   -13,     0,   -13,     0,     0,   -13,   -13,
       0,     0,     0,   -13,     0,     0,   -13,     0,   -13,   -13,
       0,   -13,   -13,   -13,     0,     0,     0,   -13,   -13,   -13,
       0,     0,   -13,     0,     0,   -13,   -13,   -13,     0,     0,
       0,   -13,   -13,     0,     0,   -13,   -13,     0,   -13,   -13,
     -13,   -13,     0,   -13,   -13,   -13,     0,     0,   -13,     0,
       0,     0,   -13,     0,   -13,     0,     0,   -13,     0,     0,
       0,   -13,   -13,     0,     0,     0,     0,   -13,     0,     0,
     -13,   -13,     0,   -13,   -13,   -13,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,   153,     0,     0,   154,     0,   214,     0,
      20,   156,   157,     0,   158,     0,     0,     0,    22,     0,
       0,     0,    23,   159,     0,     0,     0,     0,    26,     0,
       0,    28,     0,   160,     0,    29,   161,     0,   215,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,   165,    35,    36,
      37,    38,   216,    40,     0,   167,     0,     0,   168,   217,
       0,   218,     0,   171,     0,    45,     0,     0,    46,    47,
       0,   172,     0,   219,     0,     0,    49,     0,    50,   220,
       0,     0,     0,     0,   175,   176,   177,     0,    56,   221,
       0,     0,   222,   180,   181,     0,   223,    61,     0,     0,
       0,     0,     0,     0,   183,     0,    64,   184,    65,    66,
      67,    68,   185,    69,     0,   224,   187,   188,     0,     0,
     189,   190,     0,     0,     0,     0,     0,    75,     0,     0,
       0,    76,   225,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,   153,     0,     0,   154,     0,   652,     0,
      20,   156,   157,     0,   158,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,   160,     0,    29,   161,     0,   215,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,   165,    35,    36,
      37,    38,   216,    40,     0,   167,     0,     0,   168,   217,
       0,   218,     0,   171,     0,    45,     0,     0,    46,    47,
       0,   172,     0,   219,     0,     0,    49,     0,    50,   220,
       0,     0,     0,     0,   175,   176,   177,     0,    56,   221,
       0,     0,   222,   180,   181,     0,   223,    61,     0,     0,
       0,     0,     0,     0,   183,     0,    64,   184,    65,    66,
      67,    68,   185,    69,     0,   224,   187,   188,     0,     0,
     189,   190,     0,     0,     0,     0,     0,    75,  -333,     0,
       0,    76,   225,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     9,    10,    11,     0,    12,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,    25,    26,    27,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,    32,    33,     0,    34,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
      42,    43,     0,    44,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,    52,    53,    54,     0,     0,     0,    55,    56,    57,
       0,     0,    58,     0,     0,    59,    60,    61,     0,     0,
       0,    62,    63,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,    70,    71,     0,     0,    72,     0,
       0,     0,    73,     0,    74,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,   153,     0,     0,   154,     0,     0,     0,
      20,   156,   157,     0,   158,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,   160,     0,    29,   161,     0,   215,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   165,    35,    36,
      37,    38,   216,    40,     0,   167,     0,     0,   168,   217,
       0,   218,     0,     0,     0,    45,     0,     0,    46,    47,
       0,   172,     0,   219,     0,     0,    49,     0,    50,   220,
       0,     0,     0,     0,   175,   176,   177,     0,    56,   221,
       0,     0,   222,   180,   181,     0,   223,    61,     0,     0,
       0,     0,     0,     0,   183,     0,    64,   184,    65,    66,
      67,    68,   185,    69,     0,   224,   187,   188,     0,     0,
     189,   190,     0,     0,     0,     0,     0,    75,     0,     0,
       0,    76,   225,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,    32,     0,     0,    34,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
      42,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,    52,    53,    54,     0,     0,     0,    55,    56,    57,
       0,     0,    58,     0,     0,    59,    60,    61,     0,     0,
       0,    62,    63,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,    70,    71,     0,     0,    72,     0,
       0,     0,    73,   245,     0,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,    32,     0,     0,    34,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
      42,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,    52,    53,    54,     0,     0,     0,    55,    56,    57,
       0,     0,    58,     0,     0,    59,    60,    61,     0,     0,
       0,    62,    63,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,    70,    71,     0,     0,    72,     0,
       0,     0,    73,     0,   -78,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,    32,     0,     0,    34,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
      42,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,    52,    53,    54,     0,     0,     0,    55,    56,    57,
       0,     0,    58,     0,     0,    59,    60,    61,     0,     0,
       0,    62,    63,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,    70,    71,     0,     0,    72,     0,
       0,     0,    73,     0,   -77,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,    32,     0,     0,    34,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
      42,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,    52,    53,    54,     0,     0,     0,    55,    56,    57,
       0,     0,    58,     0,     0,    59,    60,    61,     0,     0,
       0,    62,    63,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,    70,    71,     0,     0,    72,     0,
       0,     0,    73,   245,     0,     0,     0,   581,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
       0,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,    58,     0,     0,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
       0,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,    58,     0,     0,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   243,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
     338,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,    58,     0,     0,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
       0,    43,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,    50,    51,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,    58,     0,     0,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    75,     0,     0,
       0,    76,    77,     0,     0,     0,     0,    78,     0,     0,
      79,    80,     0,    81,    82,    83,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,    28,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,    41,
       0,    43,     0,     0,     0,     0,     0,     0,    46,    47,
       0,     0,     0,    48,     0,     0,    49,     0,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       0,     0,    58,     0,     0,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,    65,    66,
      67,    68,     0,    69,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     3,     8,     0,    75,     0,     0,
      10,    11,    77,    12,    13,    14,    15,    16,     0,     0,
      79,    80,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     0,     0,     0,     0,    51,     0,     0,
       0,     0,  -170,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,  -170,     0,     0,
       0,     0,     0,     0,     0,     0,    65,    66,    67,    68,
       0,     0,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,  -170,     0,     0,    75,     0,     0,     0,  -170,
      77,     0,     0,     0,     0,     0,     0,  -170,    79,    80,
    -170,    81,  -170,     0,  -170,     0,  -170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -170,
       0,     0,     0,     0,     0,     0,  -170,  -170,     0,     0,
       0,     0,  -170,     0,  -170,     0,  -170,     0,     0,  -170,
    -170,     0,  -170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -170,  -170,     0,     0,     0,     0,     0,     0,
       0,     0,  -170,     0,     0,  -170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,     3,     8,  -170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   153,     0,     0,   154,     0,   214,     0,
       0,   156,   157,     0,   158,     0,     0,     0,     0,     0,
       0,     0,     0,   159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,     0,   161,     0,   162,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,   165,     0,     0,
       0,     0,   166,     0,     0,   167,     0,     0,   168,   169,
       0,   170,     0,   171,     0,     0,     0,     0,     0,     0,
       0,   172,     0,   173,     0,     0,     0,     0,     0,   174,
       0,     0,     0,     0,   175,   176,   177,     0,     0,   178,
       0,     0,   179,   180,   181,     0,   182,     0,     0,     0,
       0,     0,     3,     8,   183,     0,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,   187,   188,     0,   153,
     189,   190,   154,     0,   214,     0,     0,   156,   157,     0,
     158,   516,   191,     0,     0,     0,     0,     0,     0,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,     0,   161,     0,   162,   163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,   166,     0,
       0,   167,     0,     0,   168,   169,     0,   170,     0,   171,
       0,     0,     0,     0,     0,     0,     0,   172,     0,   173,
       0,     0,     0,     0,     0,   174,     0,     0,     0,     0,
     175,   176,   177,     0,     0,   178,     0,     0,   179,   180,
     181,     0,   182,     0,     0,     0,     0,     0,     3,     8,
     183,     0,     0,   184,     0,     0,     0,     0,   185,     0,
       0,   186,   187,   188,     0,   153,   189,   190,   154,     0,
     214,     0,     0,   156,   157,     0,   158,   518,   191,     0,
       0,     0,     0,     0,     0,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,     0,   161,     0,
     162,   163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   164,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,   166,     0,     0,   167,     0,     0,
     168,   169,     0,   170,     0,   171,     0,     0,     0,     0,
       0,     0,     0,   172,     0,   173,     0,     0,     0,     0,
       0,   174,     0,     0,     0,     0,   175,   176,   177,     0,
       0,   178,     0,     0,   179,   180,   181,     0,   182,     0,
       0,     0,     0,     0,     3,     8,   183,     0,     0,   184,
       0,     0,     0,     0,   185,     0,     0,   186,   187,   188,
       0,   153,   189,   190,   154,     0,   214,     0,     0,   156,
     157,     0,   158,   521,   191,     0,     0,     0,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,     0,   161,     0,   162,   163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   164,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
     166,     0,     0,   167,     0,     0,   168,   169,     0,   170,
       0,   171,     0,     0,     0,     0,     0,     0,     0,   172,
       0,   173,     0,     0,     0,     0,     0,   174,     0,     0,
       0,     0,   175,   176,   177,     0,     0,   178,     0,     0,
     179,   180,   181,     0,   182,     0,     0,     0,     0,     0,
       3,     8,   183,     0,     0,   184,     0,     0,     0,     0,
     185,     0,     0,   186,   187,   188,     0,   153,   189,   190,
     154,     0,   214,     0,     0,   156,   157,     0,   158,   524,
     191,     0,     0,     0,     0,     0,     0,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,     0,
     161,     0,   162,   163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   164,     0,     0,     0,     0,
       0,   165,     0,     0,     0,     0,   166,     0,     0,   167,
       0,     0,   168,   169,     0,   170,     0,   171,     0,     0,
       0,     0,     0,     0,     0,   172,     0,   173,     0,     0,
       0,     0,     0,   174,     0,     0,     0,     0,   175,   176,
     177,     0,     0,   178,     0,     0,   179,   180,   181,     0,
     182,     0,     0,     0,     0,     0,     3,     8,   183,     0,
       0,   184,     0,     0,     0,     0,   185,     0,     0,   186,
     187,   188,     0,   153,   189,   190,   154,     0,   214,     0,
       0,   156,   157,     0,   158,   533,   191,     0,     0,     0,
       0,     0,     0,   159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,     0,   161,     0,   162,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,   165,     0,     0,
       0,     0,   166,     0,     0,   167,     0,     0,   168,   169,
       0,   170,     0,   171,     0,     0,     0,     0,     0,     0,
       0,   172,     0,   173,     0,     0,     0,     0,     0,   174,
       0,     0,     0,     0,   175,   176,   177,     0,     0,   178,
       0,     0,   179,   180,   181,     0,   182,     0,     0,     0,
       0,     0,     3,     8,   183,     0,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,   187,   188,     0,   153,
     189,   190,   154,     0,   214,     0,     0,   156,   157,     0,
     158,   541,   191,     0,     0,     0,     0,     0,     0,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,     0,   161,     0,   162,   163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,   166,     0,
       0,   167,     0,     0,   168,   169,     0,   170,     0,   171,
       0,     0,     0,     0,     0,     0,     0,   172,     0,   173,
       0,     0,     0,     0,     0,   174,     0,     0,     0,     0,
     175,   176,   177,     0,     0,   178,     0,     0,   179,   180,
     181,     0,   182,     0,     0,     0,     0,     0,     3,     8,
     183,     0,     0,   184,     0,     0,     0,     0,   185,     0,
       0,   186,   187,   188,     0,   153,   189,   190,   154,     0,
     214,     0,     0,   156,   157,     0,   158,   544,   191,     0,
       0,     0,     0,     0,     0,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,     0,   161,     0,
     162,   163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   164,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,   166,     0,     0,   167,     0,     0,
     168,   169,     0,   170,     0,   171,     0,     0,     0,     0,
       0,     0,     0,   172,     0,   173,     0,     0,     0,     0,
       0,   174,     0,     0,     0,     0,   175,   176,   177,     0,
       0,   178,     0,     0,   179,   180,   181,     0,   182,     0,
       0,     0,     0,     0,     3,     8,   183,     0,     0,   184,
       0,     0,     0,     0,   185,     0,     0,   186,   187,   188,
       0,   153,   189,   190,   154,     0,   214,     0,     0,   156,
     157,     0,   158,   546,   191,     0,     0,     0,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,     0,   161,     0,   162,   163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   164,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
     166,     0,     0,   167,     0,     0,   168,   169,     0,   170,
       0,   171,     0,     0,     0,     0,     0,     0,     0,   172,
       0,   173,     0,     0,     0,     0,     0,   174,     0,     0,
       0,     0,   175,   176,   177,     0,     0,   178,     0,     0,
     179,   180,   181,     0,   182,     0,     0,     0,     0,     0,
       0,     0,   183,     3,     8,   184,     0,     0,     0,     0,
     185,     0,     0,   186,   187,   188,     0,     0,   189,   190,
     153,     0,  -193,   154,     0,   214,     0,     0,   156,   157,
     191,   158,     0,     0,     0,     0,     0,     0,     0,     0,
     159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,     0,     0,   161,     0,   162,   163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   164,     0,
       0,     0,     0,     0,   165,     0,     0,     0,     0,   166,
       0,     0,   167,     0,     0,   168,   169,     0,   170,     0,
     171,     0,     0,     0,     0,     0,     0,     0,   172,     0,
     173,     0,     0,     0,     0,     0,   174,     0,     0,     0,
       0,   175,   176,   177,     0,     0,   178,     0,     0,   179,
     180,   181,     0,   182,     0,     0,     0,     0,     0,     0,
       0,   183,     3,     8,   184,     0,     0,     0,     0,   185,
       0,     0,   186,   187,   188,     0,     0,   189,   190,   153,
       0,   733,   154,     0,   155,     0,     0,   156,   157,   191,
     158,     0,     0,     0,     0,     0,     0,     0,     0,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,     0,   161,     0,   162,   163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,   166,     0,
       0,   167,     0,     0,   168,   169,     0,   170,     0,   171,
       0,     0,     0,     0,     0,     0,     0,   172,     0,   173,
       0,     0,     0,     0,     0,   174,     0,     0,     0,     0,
     175,   176,   177,     0,     0,   178,     0,     0,   179,   180,
     181,     0,   182,     0,     0,     0,     0,     0,     3,     8,
     183,     0,     0,   184,     0,     0,     0,     0,   185,     0,
       0,   186,   187,   188,     0,   153,   189,   190,   154,     0,
     214,     0,     0,   156,   157,     0,   158,     0,   191,     0,
       0,     0,     0,     0,     0,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,     0,   161,     0,
     162,   163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   164,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,   166,     0,     0,   167,     0,     0,
     168,   169,     0,   170,     0,   171,     0,     0,     0,     0,
       0,     0,     0,   172,     0,   173,     0,     0,     0,     0,
       0,   174,     0,     0,     0,     0,   175,   176,   177,     0,
       0,   178,     0,     0,   179,   180,   181,     0,   182,     0,
       0,     0,     0,     0,     3,     8,   183,     0,     0,   184,
       0,     0,     0,     0,   185,     0,     0,   186,   187,   188,
       0,   153,   189,   190,   154,     0,   436,     0,     0,   156,
     157,     0,   158,     0,   191,     0,     0,     0,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,     0,   161,     0,   162,   163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   164,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
     166,     0,     0,   167,     0,     0,   168,   169,     0,   170,
       0,   171,     0,     0,     0,     0,     0,     0,     0,   172,
       0,   173,     0,     0,     0,     0,     0,   174,     0,     0,
       0,     0,   175,   176,   177,     0,     0,   178,     0,     0,
     179,   180,   181,     0,   182,     0,     0,     0,     0,     0,
       3,     8,   183,     0,     0,   184,     0,     0,     0,     0,
     185,     0,     0,   186,   187,   188,     0,   153,   189,   190,
     154,     0,   491,     0,     0,   156,   157,     0,   158,     0,
     191,     0,     0,     0,     0,     0,     0,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,     0,
     161,     0,   162,   163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   164,     0,     0,     0,     0,
       0,   165,     0,     0,     0,     0,   166,     0,     0,   167,
       0,     0,   168,   169,     0,   170,     0,   171,     0,     0,
       0,     0,     0,     0,     0,   172,     0,   173,     0,     0,
       0,     0,     0,   174,     0,     0,     0,     0,   175,   176,
     177,     0,     0,   178,     0,     0,   179,   180,   181,     0,
     182,     0,     0,     0,     0,     0,     3,     8,   183,     0,
       0,   184,     0,     0,     0,     0,   185,     0,     0,   186,
     187,   188,     0,   153,   189,   190,   154,     0,   652,     0,
       0,   156,   157,     0,   158,     0,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,     0,   161,     0,   162,   163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,   165,     0,     0,
       0,     0,   166,     0,     0,   167,     0,     0,   168,   169,
       0,   170,     0,   171,     0,     0,     0,     0,     0,     0,
       0,   172,     0,   173,     0,     0,     0,     0,     0,   174,
       0,     0,     0,     0,   175,   176,   177,     0,     0,   178,
       0,     0,   179,   180,   181,     0,   182,     0,     0,     0,
       0,     0,     3,     8,   183,     0,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,   187,   188,     0,   153,
     189,   190,   154,     0,     0,     0,     0,   156,   157,     0,
     158,     0,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,     0,   161,     0,   162,   163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,   166,     0,
       0,   167,     0,     0,   168,   169,     0,   170,     0,   171,
       0,     0,     0,     0,     0,     0,     0,   172,     0,   173,
       0,     0,     0,     0,     0,   174,     0,     0,     0,     0,
     175,   176,   177,     0,     0,   178,     0,     0,   179,   180,
     181,     0,   182,     0,     0,     0,     0,     0,     0,     0,
     183,     0,     0,   184,     0,     0,     0,     0,   185,     0,
       0,   186,   187,   188,     0,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191
  };

  const short
  Parser::yycheck_[] =
  {
       1,    49,   138,   281,   151,   283,   550,     7,   406,   423,
       7,   286,   287,     7,   289,   290,   291,   292,   626,    47,
      43,    40,    54,   159,    45,     7,    15,     7,     7,    50,
      65,    69,    33,     7,    17,    18,    19,    15,     7,    54,
     185,    42,    67,    63,    27,     3,    71,   107,     3,    84,
      73,   629,    94,    43,   332,    76,    68,    78,   150,     7,
     240,    82,    83,    91,    47,    97,   151,    92,   154,   161,
       3,   156,    55,   101,    99,   161,   104,    25,    90,    62,
     105,   261,    97,    73,     3,     4,     5,    70,   696,   697,
     237,    40,    75,    34,    77,   154,   494,   495,   158,   127,
      55,   154,   161,    61,    45,   130,    65,     0,   161,   169,
     170,   689,   259,   132,    67,    64,   694,    66,    71,    68,
     150,    65,   160,   154,   152,    84,   161,   162,   154,   154,
     161,   107,   155,   153,   159,   163,   152,   153,   682,    92,
      84,   142,    61,   126,   280,   153,    99,   605,   173,   132,
      72,   609,   105,   150,   155,   161,   153,   140,   141,   153,
     143,   619,   145,   146,   147,   148,   149,   150,   151,   158,
     317,   153,   780,   153,   153,    67,   150,   130,   107,    71,
     158,   150,   158,   132,   154,   153,   108,   109,   110,   157,
     153,   161,   824,   169,   170,   803,   594,   595,   199,   156,
      92,   154,   161,   162,   170,   162,   159,    99,    58,    59,
     842,   843,   154,   105,    64,   153,   153,   161,   162,   157,
     173,   156,   766,   206,   856,   160,   153,   771,   155,   158,
     213,   775,    42,   296,   297,   298,   299,    47,   130,   154,
     169,   170,   225,   390,   154,   245,   229,   230,   152,   316,
     154,   234,   319,   153,   237,   155,   239,   240,   241,   242,
     154,   152,   154,   154,    58,    59,   267,   159,   154,   252,
     253,   254,   255,   256,   154,   312,   259,   314,   261,    14,
      15,   173,   117,   118,   698,   153,   307,   308,   309,   310,
     167,   168,     3,     4,     3,     4,   117,   118,   167,   168,
     167,   168,   846,   156,   157,   154,   294,   295,   303,   304,
     311,   154,   305,   306,   154,   316,   154,   154,   319,   717,
     154,   154,   720,   721,   154,   135,   154,   154,   138,   154,
     154,   154,   154,    22,   317,   318,   611,   154,   154,   154,
     154,    15,   152,   326,   164,   328,   165,   153,   166,   159,
     153,   164,     3,   154,   355,   154,   154,    56,    64,   152,
      36,   759,   154,   154,   154,   154,   154,   368,   154,   153,
     153,   153,    62,   160,   155,   155,    11,   156,   156,   164,
       7,   153,   155,   384,   153,   162,    71,   155,   155,   155,
     155,   155,   155,   376,   170,   531,   155,   207,   155,   797,
     155,   211,   155,   801,   404,   552,   152,   390,    15,   158,
       9,   150,   548,   157,   154,   157,    36,   155,   174,   156,
     156,   155,   155,   155,   425,   156,   155,   825,   238,   155,
     155,   155,   155,   151,   155,   155,   155,   152,   155,   155,
     423,   155,   155,   155,   427,   581,    22,   257,   152,   152,
     260,   152,   157,     3,   164,   153,   734,   164,   166,   155,
     154,   152,   164,     6,   164,   160,   153,   614,   165,   153,
     280,   154,   282,   620,   284,   154,   154,   152,   155,    71,
     162,    51,   155,   150,   156,   155,   157,   156,   153,   153,
     491,   492,   154,   156,   155,   154,   150,   154,   156,   152,
     152,    15,   170,   152,   152,   155,    51,   490,   155,   153,
     493,   151,   153,   156,   160,    51,   155,   155,   154,    51,
     154,   154,   154,   506,   155,   155,   154,   153,   338,   153,
     153,    24,   157,   155,   155,   154,   150,   155,   155,   152,
     155,   153,   590,   154,   153,   155,   151,   151,   358,   155,
     360,   361,   362,   363,   364,   365,   153,   155,   368,    51,
       7,   371,   372,   373,   374,   710,   154,    51,   551,   552,
     155,   554,   155,   556,   155,   157,   386,   387,   388,   389,
      42,   155,   151,   160,    15,    47,   154,    15,   571,    49,
     155,     7,     7,   820,   739,   608,   137,   655,   581,   651,
     581,   691,   754,   407,   605,   634,   741,   252,   609,   658,
     593,   816,   751,   293,   300,   598,    80,   698,   619,   590,
     603,   302,   288,   433,   607,   435,   436,   320,   438,   792,
     440,   614,   615,   634,    -1,   618,   556,   620,    -1,    -1,
      -1,   786,    -1,   788,    -1,   301,   629,    -1,   793,    -1,
      -1,    -1,   653,   428,    -1,    -1,    -1,   658,    -1,    -1,
      -1,   662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,   486,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   830,   831,   832,    -1,    -1,
     152,   692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     845,    -1,    -1,    -1,    -1,    -1,   689,   852,    -1,   854,
      -1,   694,    -1,    -1,    -1,   698,    -1,   700,    -1,    -1,
     703,   531,   705,    -1,   707,    -1,    -1,    -1,    -1,    -1,
     540,    -1,    -1,    -1,   735,   718,   719,    -1,   548,    -1,
      -1,    -1,    -1,    -1,    -1,   207,    -1,   557,    -1,   211,
      -1,    -1,    -1,    -1,   333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   751,    -1,
      -1,   581,   351,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,   783,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,
     610,    -1,   785,    -1,    -1,    -1,    -1,    -1,    -1,   792,
      -1,    -1,    -1,    -1,    -1,   816,    -1,   396,    -1,   820,
     282,   804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   643,    -1,    -1,   415,    22,    -1,   418,
      -1,    26,    -1,    -1,    -1,   655,    -1,   657,   658,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    -1,   684,    -1,   338,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,   360,   361,
     362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   386,   387,   388,   389,    -1,    -1,
      -1,   741,    -1,   512,   513,   514,    -1,   516,   517,   518,
      -1,   520,   521,   522,   523,   524,   525,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,    -1,    -1,   536,    -1,   538,
     539,    -1,   541,   542,   543,   544,   545,   546,   547,    -1,
      -1,    -1,    -1,   435,    -1,    -1,    -1,   787,   440,    -1,
     165,   791,   167,    -1,   169,   170,   565,    -1,   567,   568,
     175,    -1,   177,   178,    -1,    -1,    -1,    -1,   183,   184,
      -1,   186,   187,    -1,   189,   190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,   218,    -1,    -1,   221,    -1,    -1,   224,
      -1,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    39,   540,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,
      52,    -1,    -1,    55,    56,   557,    -1,    -1,    -1,    -1,
      -1,    -1,   681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    88,    -1,    -1,    -1,
      92,    -1,    -1,    95,    96,    -1,    -1,    -1,   100,    -1,
      -1,   103,    -1,   105,   106,    -1,    -1,    -1,   610,    -1,
      -1,   730,    -1,   115,   116,    -1,    -1,   119,    -1,    -1,
      -1,   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,   748,
      -1,   133,    -1,   135,   136,   137,   138,    -1,   140,    -1,
     142,   643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   154,   655,    -1,   657,   158,   159,    -1,    -1,
      -1,    -1,   164,    -1,    -1,   167,   168,    -1,   170,   171,
     172,    -1,   174,    -1,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,   684,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   741,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   787,   115,   116,    -1,   791,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,    -1,   174,     3,     4,    -1,    -1,
      -1,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    40,    41,    -1,    -1,    44,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    90,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,   132,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    40,    41,    -1,    -1,    44,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    90,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,   132,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    40,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    50,    -1,    52,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    92,    -1,    -1,    95,    96,
      -1,    98,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,   115,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,    -1,
     147,   148,    -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    50,    -1,    52,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    92,    -1,    -1,    95,    96,
      -1,    98,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,   115,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,    -1,
     147,   148,    -1,    -1,    -1,    -1,    -1,   154,   155,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    44,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    90,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    -1,    -1,
      27,    28,    29,    -1,    31,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    50,    -1,    52,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    98,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,   115,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,    -1,
     147,   148,    -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,   150,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,   108,   109,   110,    -1,    -1,    -1,   114,   115,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,    -1,
      -1,   128,   129,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,   141,   142,    -1,    -1,   145,    -1,
      -1,    -1,   149,   150,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,
      -1,   158,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,   168,    -1,   170,   171,   172,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      -1,    -1,    -1,   100,    -1,    -1,   103,    -1,    -1,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
     137,   138,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,    -1,   154,    -1,    -1,
       9,    10,   159,    12,    13,    14,    15,    16,    -1,    -1,
     167,   168,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,     7,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,   136,   137,   138,
      -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,   154,    -1,    -1,    -1,    54,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    62,   167,   168,
      65,   170,    67,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    -1,
      -1,    -1,    97,    -1,    99,    -1,   101,    -1,    -1,   104,
     105,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,   118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    -1,   130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     3,     4,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,     3,     4,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    20,
     147,   148,    23,    -1,    25,    -1,    -1,    28,    29,    -1,
      31,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,     3,     4,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    20,   147,   148,    23,    -1,
      25,    -1,    -1,    28,    29,    -1,    31,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    86,    -1,    88,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,     3,     4,   131,    -1,    -1,   134,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,   143,   144,
      -1,    20,   147,   148,    23,    -1,    25,    -1,    -1,    28,
      29,    -1,    31,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
       3,     4,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    20,   147,   148,
      23,    -1,    25,    -1,    -1,    28,    29,    -1,    31,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    86,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     3,     4,   131,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,
     143,   144,    -1,    20,   147,   148,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,     3,     4,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    20,
     147,   148,    23,    -1,    25,    -1,    -1,    28,    29,    -1,
      31,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,     3,     4,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    20,   147,   148,    23,    -1,
      25,    -1,    -1,    28,    29,    -1,    31,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    86,    -1,    88,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,     3,     4,   131,    -1,    -1,   134,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,   143,   144,
      -1,    20,   147,   148,    23,    -1,    25,    -1,    -1,    28,
      29,    -1,    31,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,     3,     4,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    -1,   147,   148,
      20,    -1,   151,    23,    -1,    25,    -1,    -1,    28,    29,
     159,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
     100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,
      -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,
     120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,     3,     4,   134,    -1,    -1,    -1,    -1,   139,
      -1,    -1,   142,   143,   144,    -1,    -1,   147,   148,    20,
      -1,   151,    23,    -1,    25,    -1,    -1,    28,    29,   159,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,     3,     4,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    20,   147,   148,    23,    -1,
      25,    -1,    -1,    28,    29,    -1,    31,    -1,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    86,    -1,    88,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,     3,     4,   131,    -1,    -1,   134,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,   143,   144,
      -1,    20,   147,   148,    23,    -1,    25,    -1,    -1,    28,
      29,    -1,    31,    -1,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
       3,     4,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    20,   147,   148,
      23,    -1,    25,    -1,    -1,    28,    29,    -1,    31,    -1,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    86,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     3,     4,   131,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,
     143,   144,    -1,    20,   147,   148,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,     3,     4,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    20,
     147,   148,    23,    -1,    -1,    -1,    -1,    28,    29,    -1,
      31,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    -1,   147,   148,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159
  };

  const short
  Parser::yystos_[] =
  {
       0,    94,   176,     3,   177,     0,   150,   182,     4,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      27,    30,    35,    39,    41,    44,    45,    46,    48,    52,
      55,    62,    69,    70,    72,    75,    76,    77,    78,    79,
      80,    86,    87,    88,    90,    92,    95,    96,   100,   103,
     105,   106,   108,   109,   110,   114,   115,   116,   119,   122,
     123,   124,   128,   129,   133,   135,   136,   137,   138,   140,
     141,   142,   145,   149,   151,   154,   158,   159,   164,   167,
     168,   170,   171,   172,   177,   178,   183,   184,   185,   186,
     188,   190,   191,   192,   193,   213,   220,   221,   248,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   269,   270,   271,   276,
     277,   278,   279,   282,   283,   284,   152,   153,   170,   248,
     248,   248,   154,   153,   161,   226,   153,   193,   226,   248,
     154,   154,   154,   154,   177,   154,   154,   154,   154,   154,
     154,   154,   226,    20,    23,    25,    28,    29,    31,    40,
      50,    53,    55,    56,    68,    74,    79,    82,    85,    86,
      88,    90,    98,   100,   106,   111,   112,   113,   116,   119,
     120,   121,   123,   131,   134,   139,   142,   143,   144,   147,
     148,   159,   177,   178,   200,   201,   222,   223,   224,   225,
     228,   229,   232,   236,   240,   243,   154,   226,    58,    59,
     197,   202,   263,   154,    25,    55,    79,    86,    88,   100,
     106,   116,   119,   123,   142,   159,   178,   225,   248,   154,
     154,   271,   275,   263,   154,   153,   248,   154,   226,   154,
     154,   154,   154,   153,   248,   150,   184,   185,   193,   209,
     210,   213,   154,   154,   154,   154,   154,   226,   248,   154,
     226,   154,   153,   248,   272,   274,   263,   174,   248,   249,
     250,   280,   281,   263,    14,    15,   266,   285,   263,   263,
      40,    64,    66,    68,   132,   153,    47,    91,   101,   104,
     127,   152,   163,    22,    54,    97,    65,    84,   161,   162,
     164,   165,   166,   117,   118,   167,   168,   107,   158,   169,
     170,    67,    71,    92,    99,   105,   130,   154,   159,   173,
     164,   291,   248,    15,   153,   153,   157,   153,   157,   248,
     225,   199,   200,   224,   153,   248,   248,   177,    87,   187,
     248,    63,   153,   248,   248,   248,   248,   248,   248,   248,
     249,   225,   177,   154,   224,   150,   161,   226,   226,   154,
     226,   226,   226,   226,   226,   226,   154,   233,   226,   226,
     291,   226,   226,   226,   226,    56,   152,    64,   177,   248,
     287,   288,   289,   225,   225,   248,   226,   226,   226,   226,
     154,   248,   248,   248,   153,   249,   225,   248,   187,   248,
     248,   248,   153,   211,   212,   213,    36,   218,   219,   223,
     248,   248,   248,   248,   248,   225,   153,   249,   225,   187,
     248,   155,   155,   156,   177,    62,   160,   156,   156,   160,
     164,    11,   178,   224,   196,   202,    25,   178,   225,   198,
     202,   178,   252,   252,   254,   252,   252,   252,   252,   255,
     256,   256,   257,   257,   257,   257,   258,   259,   260,   261,
     261,   262,   262,   263,   263,   263,   263,    55,   177,   268,
     264,   264,   268,   249,   248,   268,   284,     7,   290,   153,
     248,   248,   155,   162,   227,   153,   202,   227,   155,   155,
      71,    25,   225,   153,   155,   155,   179,   180,   155,   155,
     155,   155,   155,   155,   155,   227,   152,    15,   177,   241,
     242,   158,    15,   158,   225,     9,   158,   225,   158,   225,
     225,   158,   225,   225,   158,   225,    43,    73,   203,   204,
     205,   207,   150,   158,   177,   225,   230,   231,    15,   158,
     150,   158,   225,   225,   158,   225,   158,   225,   157,   248,
     154,   152,   154,   189,   157,   155,   156,   156,     4,     5,
      61,   177,   194,   195,   155,   225,   225,   225,   225,   249,
     155,   156,   155,   227,   155,   155,   155,   155,   155,   151,
     213,   154,   209,   219,   155,   155,   155,   155,   155,   155,
     227,   155,   227,   153,   155,   155,   273,   274,   152,   177,
     248,   281,   286,   152,   178,   225,   178,   152,   178,   225,
     152,   157,   155,   160,   154,   152,   153,   153,   154,   225,
     154,   248,   177,   177,   248,   209,   209,   153,     6,   154,
     248,   155,   152,   151,   156,   162,   227,   227,   227,   155,
     227,   227,   227,   156,   227,   227,   227,   227,   227,   227,
     155,   156,    25,   206,   224,   234,   227,   157,   156,   227,
     227,   227,   225,   237,   238,   239,   227,   227,   227,   227,
     227,   227,   227,   224,   153,   203,   248,   249,   153,   248,
     289,   225,   154,   227,   156,   227,   227,   155,   248,   154,
     150,   150,   206,   275,   154,   248,   209,   209,   156,   248,
      71,   170,   248,   152,   195,   152,   248,   152,   189,   195,
     225,   252,   249,   248,   248,   195,   249,   155,   152,   152,
     155,    51,   214,   214,   181,   272,   153,   244,    15,   242,
     225,   205,   177,   151,   201,   225,   235,   225,   231,   177,
     151,   156,   160,   155,   153,   155,   227,   203,   225,   155,
     272,    34,    45,   215,   216,   217,   215,   177,   272,   155,
     214,   214,   273,   248,   153,   248,   154,   248,   153,   248,
     153,   154,   291,   155,   155,   154,   155,   209,   248,   248,
     209,   209,   155,   150,   227,   152,   208,   202,   177,   291,
     239,    24,   154,   155,   227,   155,   250,   157,   151,   217,
     151,   155,   155,   209,    69,   160,   153,   203,   153,   153,
     203,   153,   203,   214,   177,   245,   246,   247,   248,   291,
     225,   291,   225,   287,   291,   157,   209,   209,   214,   248,
     155,   155,   155,   157,   151,   247,   194,   153,   155,   210,
     209,   160,   291,   291,   291,    15,   154,   210,   210,    49,
     291,   203,    15,   153,   155,   291,   291,   153,   153,   210
  };

  const short
  Parser::yyr1_[] =
  {
       0,   175,   176,   177,   178,   178,   180,   181,   179,   182,
     182,   182,   183,   183,   183,   183,   183,   183,   184,   185,
     185,   186,   186,   186,   186,   187,   187,   188,   188,   188,
     188,   189,   189,   190,   190,   190,   190,   191,   191,   192,
     192,   193,   193,   193,   193,   193,   194,   194,   195,   195,
     195,   196,   197,   198,   199,   200,   200,   201,   201,   202,
     202,   202,   203,   203,   204,   204,   205,   206,   206,   207,
     207,   207,   208,   208,   209,   209,   210,   211,   211,   212,
     212,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   214,   214,   215,
     215,   216,   216,   217,   217,   218,   218,   219,   219,   220,
     220,   220,   221,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   223,   224,   224,
     224,   225,   225,   225,   226,   227,   228,   229,   229,   230,
     230,   231,   231,   232,   233,   233,   234,   234,   235,   235,
     235,   236,   237,   237,   238,   238,   239,   240,   240,   241,
     241,   241,   242,   242,   244,   243,   245,   245,   246,   246,
     247,   247,   248,   249,   249,   250,   250,   251,   252,   252,
     252,   252,   252,   252,   252,   253,   253,   254,   254,   255,
     255,   255,   256,   256,   256,   256,   256,   257,   257,   258,
     258,   259,   259,   260,   260,   260,   261,   261,   261,   262,
     262,   262,   262,   262,   263,   263,   263,   263,   263,   263,
     263,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   266,   266,   266,   266,   266,   266,
     267,   267,   267,   267,   268,   268,   269,   269,   269,   269,
     269,   269,   269,   269,   269,   269,   269,   269,   269,   269,
     269,   269,   269,   269,   269,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     271,   272,   272,   272,   273,   273,   273,   274,   275,   276,
     276,   276,   276,   276,   277,   277,   278,   278,   279,   280,
     280,   281,   282,   283,   283,   285,   286,   284,   287,   287,
     288,   288,   289,   290,   290,   291,   291
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     5,     1,     1,     1,     0,     0,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     1,     7,     6,
       7,     5,     5,     6,     6,     5,     5,     6,     6,     7,
       7,     3,     0,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     8,     8,     8,     8,     1,     0,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     5,     1,     1,     1,
       1,     0,     2,     0,     1,     1,     3,     1,     0,     2,
       1,     2,     1,     2,     3,     3,     2,     2,     2,     2,
       6,     6,     8,     8,     6,     6,     7,     7,     7,     3,
       3,     5,     3,     5,     3,     3,     3,     2,     0,     1,
       0,     2,     1,     4,     3,     2,     1,     6,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     1,
       5,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     7,     4,     4,     3,
       1,     1,     3,     5,     3,     0,     2,     0,     4,     9,
       9,     5,     1,     0,     3,     1,     3,     4,     4,     3,
       2,     1,     1,     3,     0,     8,     1,     0,     2,     1,
       7,     5,     1,     1,     0,     3,     1,     1,     3,     3,
       3,     3,     3,     5,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     2,     2,     2,     3,     2,     2,
       1,     4,     3,     6,     4,     3,     3,     3,     2,     2,
       3,     1,     4,     7,     4,     4,     2,     5,     2,     2,
       5,     4,     4,     1,     1,     1,     2,     7,     9,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     1,     3,     1,     4,     7,     1,
       1,     1,     1,     1,     1,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       3,     1,     3,     0,     1,     3,     0,     1,     1,     3,
       4,     7,     4,     7,     4,     7,     4,     9,     3,     3,
       1,     4,     2,     3,     1,     0,     0,     5,     1,     0,
       3,     1,     3,     1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"scoped ~finally\"", "\"dotted identifier\"",
  "\"attribute\"", "\"property\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"bool value\"",
  "\"add\"", "\"assert\"", "\"assert-exception\"", "\"addr\"", "\"after\"",
  "\"&&\"", "\"any\"", "\"->\"", "\"auto\"", "\"at\"", "\"begin\"",
  "\"bitfield\"", "\"bool\"", "\"break\"", "\"bytes\"", "\"caddr\"",
  "\"callable\"", "\"case\"", "\"cast\"", "\"catch\"", "\"channel\"",
  "\"classifier\"", "\"Null\"", "\"const\"", "\"continue\"", "\"context\"",
  "\"copy\"", "\"declare\"", "\"default\"", "\"delete\"", "\"/=\"",
  "\"$$\"", "\"..\"", "\"real\"", "\"else\"", "\"end\"", "\"enum\"",
  "\"==\"", "\"error\"", "\"exception\"", "\"export\"", "\"extern\"",
  "\"extern-no-suspend\"", "\"file\"", "\"~finally\"", "\"for\"",
  "\"from\"", "\"function\"", "\">=\"", "\"global\"", "\"?.\"", "\"hook\"",
  "\"if\"", "\"import\"", "\"in\"", "\"init\"", "\"inout\"", "\"int\"",
  "\"int16\"", "\"int32\"", "\"int64\"", "\"int8\"", "\"interval\"",
  "\"interval_ns\"", "\"iosrc\"", "\"iterator\"", "\"const_iterator\"",
  "\"<=\"", "\"library type\"", "\"list\"", "\"local\"", "\"map\"",
  "\"match_token_state\"", "\"method\"", "\"-=\"", "\"--\"", "\"%\"",
  "\"module\"", "\"move\"", "\"new\"", "\"!=\"", "\"net\"", "\"!in\"",
  "\"optional\"", "\"||\"", "\"overlay\"", "\"pack\"", "\"+=\"", "\"++\"",
  "\"port\"", "\"**\"", "\"preinit\"", "\"private\"", "\"public\"",
  "\"strong_ref\"", "\"regexp\"", "\"result\"", "\"return\"", "\"scope\"",
  "\"set\"", "\"<<\"", "\">>\"", "\"stream\"", "\"string\"", "\"struct\"",
  "\"switch\"", "\"time\"", "\"time_ns\"", "\"timer\"", "\"timer_mgr\"",
  "\"*=\"", "\"throw\"", "\"try\"", "\".?\"", "\"tuple\"", "\"type\"",
  "\"typeinfo\"", "\"uint\"", "\"uint16\"", "\"uint32\"", "\"uint64\"",
  "\"uint8\"", "\"union\"", "\"unpack\"", "\"unset\"", "\"vector\"",
  "\"view\"", "\"void\"", "\"while\"", "\"with\"", "\"value_ref\"",
  "\"weak_ref\"", "\"yield\"", "'{'", "'}'", "'='", "';'", "'('", "')'",
  "','", "':'", "'*'", "'['", "']'", "'<'", "'>'", "'?'", "'|'", "'^'",
  "'&'", "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "'$'", "$accept",
  "module", "local_id", "scoped_id", "dotted_id", "$@1", "$@2",
  "global_scope_items", "global_scope_decl", "type_decl", "constant_decl",
  "local_decl", "local_init_decl", "global_decl", "opt_type_arguments",
  "function_decl", "import_decl", "property_decl", "opt_linkage",
  "function_id", "scoped_function_id", "function_with_body",
  "method_with_body", "hook_with_body", "function_without_body",
  "opt_func_flavor", "func_flavor", "opt_func_cc", "opt_func_params",
  "func_params", "func_param", "func_param_type", "opt_func_param_kind",
  "opt_func_default_expr", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "opt_switch_cases", "switch_cases",
  "switch_case", "try_catches", "try_catch", "stmt_decl", "stmt_expr",
  "base_type_no_attrs", "base_type", "type", "qtype", "type_param_begin",
  "type_param_end", "function_type", "tuple_type", "tuple_type_elems",
  "tuple_type_elem", "struct_type", "opt_struct_params", "struct_fields",
  "struct_field", "union_type", "opt_union_fields", "union_fields",
  "union_field", "enum_type", "enum_labels", "enum_label", "bitfield_type",
  "$@3", "opt_bitfield_bit_ranges", "bitfield_bit_ranges",
  "bitfield_bit_range", "expr", "opt_exprs", "exprs", "expr_0", "expr_1",
  "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7", "expr_8",
  "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e", "expr_f",
  "expr_g", "member_expr", "ctor", "ctor_expr", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "tuple_expr",
  "list", "set", "map", "struct_", "struct_elems", "struct_elem", "regexp",
  "re_patterns", "re_pattern_constant", "$@4", "$@5", "opt_map_elems",
  "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   287,   287,   296,   308,   309,   311,   313,   311,   318,
     320,   322,   326,   327,   328,   329,   330,   331,   333,   336,
     338,   342,   343,   344,   346,   351,   353,   357,   359,   361,
     363,   368,   369,   371,   373,   376,   377,   381,   382,   386,
     387,   389,   390,   391,   392,   393,   397,   398,   401,   402,
     403,   406,   413,   420,   427,   433,   434,   436,   437,   439,
     440,   441,   443,   444,   446,   447,   449,   453,   454,   458,
     459,   460,   463,   464,   469,   470,   473,   475,   476,   478,
     479,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   492,   494,   496,   498,   500,   502,   504,   506,   508,
     510,   511,   512,   513,   516,   524,   532,   542,   543,   546,
     547,   549,   550,   552,   553,   555,   556,   558,   560,   562,
     563,   564,   567,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   587,   588,   589,
     590,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   603,   604,   605,   606,   607,   608,   609,   610,   612,
     613,   615,   617,   618,   619,   620,   621,   624,   627,   628,
     629,   632,   633,   634,   638,   642,   645,   649,   650,   654,
     656,   660,   661,   664,   667,   668,   670,   671,   673,   674,
     678,   684,   687,   688,   690,   691,   693,   695,   696,   698,
     699,   700,   703,   704,   708,   707,   713,   715,   718,   720,
     723,   725,   729,   732,   733,   735,   736,   738,   741,   742,
     743,   744,   745,   746,   747,   749,   750,   752,   753,   755,
     756,   757,   759,   760,   761,   762,   763,   765,   766,   768,
     769,   771,   772,   774,   775,   776,   778,   779,   780,   782,
     783,   784,   785,   786,   788,   789,   790,   791,   792,   793,
     794,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   821,   822,   823,   824,   826,   828,
     830,   831,   832,   833,   836,   837,   841,   842,   843,   844,
     845,   850,   851,   852,   854,   855,   856,   861,   862,   864,
     865,   866,   867,   868,   869,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     889,   892,   893,   894,   897,   898,   899,   902,   905,   907,
     908,   909,   911,   912,   915,   916,   919,   920,   923,   925,
     926,   928,   930,   932,   934,   937,   937,   937,   940,   941,
     943,   944,   946,   949,   950,   953,   954
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   171,     2,     2,   174,   169,   166,     2,
     154,   155,   158,   167,   156,   168,   173,   170,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   157,   153,
     161,   152,   162,   163,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   159,     2,   160,   165,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   150,   164,   151,   172,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149
    };
    // Last valid token kind.
    const int code_max = 404;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 29 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
} } } // hilti::detail::parser
#line 6821 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

#line 956 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"


void hilti::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
