// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"

namespace spicy { namespace detail { class Parser; } }

#include <hilti/compiler/context.h>
#include <spicy/compiler/detail/parser/driver.h>
#include <spicy/ast/builder/builder.h>

#line 41 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"


#include <spicy/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(spicy::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column,
                                       (l.end.column > 0 ? l.end.column - 1 : 0)));
}

static hilti::QualifiedType* iteratorForType(spicy::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto iter = t->type()->iteratorType() )
        return iter;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

static hilti::QualifiedType* viewForType(spicy::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto v = t->type()->viewType() )
        return v;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));
    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)

#define YYLLOC_DEFAULT(Current, Rhs, N)                                                                                \
do {                                                                                                                   \
    bool done = false;                                                                                                 \
    for ( int i = 1; i <= N; i++ ) {                                                                                   \
        if ( YYRHSLOC(Rhs, i).begin.line != YYRHSLOC(Rhs, i).end.line ||                                               \
             YYRHSLOC(Rhs, i).begin.column != YYRHSLOC(Rhs, i).end.column ) {                                          \
            (Current).begin = YYRHSLOC(Rhs, i).begin;                                                                  \
            (Current).end = YYRHSLOC(Rhs, N).end;                                                                      \
            done = true;                                                                                               \
            break;                                                                                                     \
        }                                                                                                              \
    }                                                                                                                  \
    if ( ! done )                                                                                                      \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;                                                        \
} while ( false )

static int _field_width = 0;

// We keep a stack of doc strings here that's maintained during parsing. There
// would actually be a much nicer way of doing this through Bison's mid-action
// rules, but unfortunately those have a bug with Bison < 3.1 that prevents
// passing results back from a mid-action rule; see
// https://stackoverflow.com/questions/44811550/bison-c-mid-rule-value-lost-with-variants.
//
// Bison 3.1 fixes this and introduces a new, nicer typing syntax for
// mid-action rules as well; see
// https://www.gnu.org/software/bison/manual/html_node/Typed-Mid_002dRule-Actions.html#Typed-Mid_002dRule-Actions
// Unfortunately, we cannot rely on having 3.1 yet, because some of our
// supported platforms do not provide it. Once we can, we should get rid of
// this stack and move to that new syntax instead.
static std::vector<hilti::DocString> _docs;


#line 133 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 29 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
namespace spicy { namespace detail { namespace parser {
#line 231 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (Driver* driver_yyarg, Builder* builder_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      builder (builder_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.copy< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.copy< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.copy< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.copy< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  Parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.YY_MOVE_OR_COPY< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.YY_MOVE_OR_COPY< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.YY_MOVE_OR_COPY< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.YY_MOVE_OR_COPY< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.YY_MOVE_OR_COPY< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.YY_MOVE_OR_COPY< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.YY_MOVE_OR_COPY< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.YY_MOVE_OR_COPY< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.YY_MOVE_OR_COPY< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.YY_MOVE_OR_COPY< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.YY_MOVE_OR_COPY< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.YY_MOVE_OR_COPY< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.copy< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< hilti::declaration::Parameters > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::declaration::Hook* > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< spicy::declaration::Hooks > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.copy< spicy::type::unit::Item* > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.copy< spicy::type::unit::Items > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< spicy::type::unit::item::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<hilti::Declarations, hilti::Statements> > (that.value);
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.copy< std::pair<hilti::QualifiedType*, hilti::Expression*> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (that.value);
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 22 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 2303 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute* > ();
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< hilti::AttributeSet* > ();
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor* > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        yylhs.value.emplace< hilti::Declaration* > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        yylhs.value.emplace< hilti::Declarations > ();
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression* > ();
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< hilti::Expressions > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        yylhs.value.emplace< hilti::QualifiedType* > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement* > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< hilti::Statements > ();
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        yylhs.value.emplace< hilti::UnqualifiedType* > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element* > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< hilti::ctor::map::Elements > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field* > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< hilti::ctor::struct_::Fields > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        yylhs.value.emplace< hilti::declaration::Parameters > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::parameter::Kind > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case* > ();
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< hilti::statement::switch_::Cases > ();
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        yylhs.value.emplace< hilti::type::bitfield::BitRange* > ();
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        yylhs.value.emplace< hilti::type::bitfield::BitRanges > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label* > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< hilti::type::enum_::Labels > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter* > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element* > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< hilti::type::tuple::Elements > ();
        break;

      case symbol_kind::S_const_sint: // const_sint
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        yylhs.value.emplace< spicy::declaration::Hook* > ();
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        yylhs.value.emplace< spicy::declaration::Hooks > ();
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        yylhs.value.emplace< spicy::type::unit::Item* > ();
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        yylhs.value.emplace< spicy::type::unit::Items > ();
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        yylhs.value.emplace< spicy::type::unit::item::switch_::Case* > ();
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        yylhs.value.emplace< spicy::type::unit::item::switch_::Cases > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<hilti::Declarations, hilti::Statements> > ();
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        yylhs.value.emplace< std::pair<hilti::QualifiedType*, hilti::Expression*> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 4: // start_expr: expr
#line 331 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { driver->setDestinationExpression(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 2725 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 5: // $@1: %empty
#line 333 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2731 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 6: // module: MODULE local_id ';' $@1 global_scope_items
#line 334 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto uid = hilti::declaration::module::UID(yystack_[3].value.as < hilti::ID > (), hilti::rt::filesystem::path(*driver->currentFile()));
                                                   auto m = builder->declarationModule(uid, {}, std::move(yystack_[0].value.as < std::pair<hilti::Declarations, hilti::Statements> > ().first), std::move(yystack_[0].value.as < std::pair<hilti::Declarations, hilti::Statements> > ().second), __loc__);
                                                   m->setDocumentation(_docs.back());
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2741 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 7: // local_id: "identifier"
#line 343 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( ! driver->builder()->options().skip_validation ) {
                                                       if ( name.find('-') != std::string::npos)
                                                           hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                       if ( name.substr(0, 2) == "__" )
                                                           hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());
                                                   }

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name));
                                                 }
#line 2757 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 8: // scoped_id: local_id
#line 355 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2763 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 9: // scoped_id: "scoped identifier"
#line 356 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2769 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 10: // $@2: %empty
#line 358 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                { driver->enableDottedIDMode(); }
#line 2775 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 11: // $@3: %empty
#line 360 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                { driver->disableDottedIDMode(); }
#line 2781 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 12: // dotted_id: $@2 "dotted identifier" $@3
#line 360 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > ()); }
#line 2787 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_items: global_scope_items global_scope_decl
#line 366 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = std::move(yystack_[1].value.as < std::pair<hilti::Declarations, hilti::Statements> > ()); yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > ().first.push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2793 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_items: global_scope_items stmt
#line 368 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = std::move(yystack_[1].value.as < std::pair<hilti::Declarations, hilti::Statements> > ()); yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > ().second.push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2799 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_items: %empty
#line 369 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = {}; }
#line 2805 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: type_decl
#line 373 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2811 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: constant_decl
#line 374 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2817 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 18: // global_scope_decl: global_decl
#line 375 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2823 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 19: // global_scope_decl: function_decl
#line 376 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2829 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 20: // global_scope_decl: import_decl
#line 377 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2835 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 21: // global_scope_decl: property_decl
#line 378 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2841 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 22: // global_scope_decl: hook_decl
#line 379 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2847 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 23: // $@4: %empty
#line 381 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2853 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 24: // type_decl: opt_linkage TYPE scoped_id '=' $@4 qtype opt_attributes ';'
#line 382 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto u = yystack_[2].value.as < hilti::QualifiedType* > ()->type()->tryAs<type::Unit>(); u && yystack_[1].value.as < hilti::AttributeSet* > () && *yystack_[1].value.as < hilti::AttributeSet* > () ) {
                                                      u->setAttributes(builder->context(), yystack_[1].value.as < hilti::AttributeSet* > ());
                                                      yystack_[1].value.as < hilti::AttributeSet* > () = {}; // don't associate with declaration
                                                   }

                                                   // Type decls can have attributes, but only for certain types
                                                   if ( yystack_[1].value.as < hilti::AttributeSet* > () && ! yystack_[1].value.as < hilti::AttributeSet* > ()->attributes().empty() ) {
                                                      auto ty = yystack_[2].value.as < hilti::QualifiedType* > ()->type();
                                                      if ( ! (ty->isA<hilti::type::Struct>() || ty->isA<hilti::type::Enum>() || ty->isA<hilti::type::Bitfield>()) )
                                                          error(yystack_[1].location, "attributes are not allowed on type aliases");
                                                   }

                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationType(std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[7].value.as < hilti::declaration::Linkage > ()), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2874 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 25: // $@5: %empty
#line 399 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2880 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 26: // constant_decl: opt_linkage CONST scoped_id $@5 '=' expr ';'
#line 400 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[4].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2889 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 27: // $@6: %empty
#line 405 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2895 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 28: // constant_decl: opt_linkage CONST scoped_id $@6 ':' qtype '=' expr ';'
#line 406 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[6].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[8].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2904 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 29: // local_decl: LOCAL scoped_id '=' expr ';'
#line 412 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2910 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 30: // local_decl: LOCAL scoped_id ':' qtype ';'
#line 413 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::QualifiedType* > (), {}, __loc__); }
#line 2916 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 31: // local_decl: LOCAL scoped_id ':' qtype '=' expr ';'
#line 415 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[5].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2922 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 32: // local_init_decl: LOCAL local_id ':' qtype '=' expr
#line 420 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[4].value.as < hilti::ID > (), yystack_[2].value.as < hilti::QualifiedType* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2928 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 33: // local_init_decl: LOCAL local_id '=' expr
#line 422 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2934 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 34: // $@7: %empty
#line 425 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2940 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 35: // global_decl: opt_linkage GLOBAL scoped_id $@7 '=' expr ';'
#line 426 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[4].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2949 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 36: // $@8: %empty
#line 431 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2955 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 37: // global_decl: opt_linkage GLOBAL scoped_id $@8 ':' global_decl_type_and_init
#line 432 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[0].value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > ().first, yystack_[0].value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > ().second, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2964 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 38: // global_decl_type_and_init: qtype ';'
#line 439 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > () = std::make_pair(yystack_[1].value.as < hilti::QualifiedType* > (), nullptr); }
#line 2970 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 39: // global_decl_type_and_init: qtype '=' expr ';'
#line 440 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > () = std::make_pair(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > ()); }
#line 2976 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 40: // $@9: %empty
#line 443 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2982 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 41: // function_decl: opt_linkage FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes $@9 ';'
#line 444 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[5].value.as < hilti::declaration::Parameters > (), yystack_[9].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    auto func = builder->function(yystack_[7].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[8].value.as < hilti::function::CallingConvention > (), yystack_[2].value.as < hilti::AttributeSet* > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(std::move(func), yystack_[11].value.as < hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 2994 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 42: // $@10: %empty
#line 453 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 3000 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 43: // function_decl: opt_linkage FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes $@10 braced_block
#line 454 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[5].value.as < hilti::declaration::Parameters > (), yystack_[9].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    auto func = builder->function(yystack_[7].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement* > (), yystack_[8].value.as < hilti::function::CallingConvention > (), yystack_[2].value.as < hilti::AttributeSet* > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(std::move(func), yystack_[11].value.as < hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 3012 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 44: // import_decl: IMPORT local_id ';'
#line 463 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".spicy"), __loc__); }
#line 3018 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 45: // import_decl: IMPORT local_id FROM dotted_id ';'
#line 464 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".spicy"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 3024 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 46: // property_decl: "property" ';'
#line 467 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 3030 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 47: // property_decl: "property" '=' expr ';'
#line 468 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3036 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 48: // hook_decl: ON unit_hook_id unit_hook
#line 471 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { ID unit = yystack_[1].value.as < hilti::ID > ().namespace_();
                                                   if ( unit.empty() )
                                                      error(yylhs.location, "hook requires unit namespace");

                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationUnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::declaration::Hook* > ()), __loc__);
                                                 }
#line 3047 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 49: // opt_linkage: PUBLIC
#line 479 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 3053 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 50: // opt_linkage: PRIVATE
#line 480 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3059 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 51: // opt_linkage: %empty
#line 481 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3065 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 52: // opt_func_flavor: %empty
#line 485 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 3071 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 53: // opt_func_cc: "string value"
#line 487 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { try {
                                                       yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::calling_convention::from_string(yystack_[0].value.as < std::string > ());
                                                   } catch ( std::out_of_range& e ) {
                                                       error(yylhs.location, "unknown calling convention");
                                                   }
                                                 }
#line 3082 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 54: // opt_func_cc: %empty
#line 493 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 3088 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_params: func_params
#line 497 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[0].value.as < hilti::declaration::Parameters > ()); }
#line 3094 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_params: %empty
#line 498 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 3100 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 57: // func_params: func_params ',' func_param
#line 500 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[2].value.as < hilti::declaration::Parameters > ()); yylhs.value.as < hilti::declaration::Parameters > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter* > ()); }
#line 3106 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 58: // func_params: func_param
#line 501 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{yystack_[0].value.as < hilti::type::function::Parameter* > ()}; }
#line 3112 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 59: // func_param: opt_func_param_kind local_id ':' type opt_init_expression
#line 504 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameter* > () = builder->declarationParameter(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::UnqualifiedType* > (), yystack_[4].value.as < hilti::parameter::Kind > (), yystack_[0].value.as < hilti::Expression* > (), {}, __loc__); }
#line 3118 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 60: // func_result: ':' qtype
#line 506 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = std::move(yystack_[0].value.as < hilti::QualifiedType* > ()); }
#line 3124 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_result: func_result
#line 508 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = std::move(yystack_[0].value.as < hilti::QualifiedType* > ()); }
#line 3130 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_result: %empty
#line 509 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeVoid(), hilti::Constness::Const); }
#line 3136 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_param_kind: INOUT
#line 512 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::InOut; }
#line 3142 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 64: // opt_func_param_kind: %empty
#line 513 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::In; }
#line 3148 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 65: // opt_init_expression: '=' expr
#line 516 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3154 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 66: // opt_init_expression: %empty
#line 517 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 3160 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 67: // block: braced_block
#line 522 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3166 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 68: // block: stmt
#line 523 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock({yystack_[0].value.as < hilti::Statement* > ()}, __loc__); }
#line 3172 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 69: // braced_block: '{' opt_stmts '}'
#line 526 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock(std::move(yystack_[1].value.as < hilti::Statements > ()), __loc__); }
#line 3178 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 70: // opt_stmts: stmts
#line 528 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[0].value.as < hilti::Statements > ()); }
#line 3184 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 71: // opt_stmts: %empty
#line 529 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements{}; }
#line 3190 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 72: // stmts: stmts stmt
#line 531 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[1].value.as < hilti::Statements > ()); yylhs.value.as < hilti::Statements > ().push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3196 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 73: // stmts: stmt
#line 532 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = Statements{std::move(yystack_[0].value.as < hilti::Statement* > ())}; }
#line 3202 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 74: // stmt: stmt_expr ';'
#line 534 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[1].value.as < hilti::Statement* > ()); }
#line 3208 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 75: // stmt: stmt_decl
#line 535 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3214 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 76: // stmt: "assert" expr ';'
#line 536 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, __loc__); }
#line 3220 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 77: // stmt: "assert" expr ':' expr ';'
#line 537 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3226 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 78: // stmt: "assert-exception" expr ';'
#line 538 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, {}, __loc__); }
#line 3232 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 79: // stmt: "assert-exception" expr ':' expr ';'
#line 540 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression* > ()), {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3238 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 80: // stmt: BREAK ';'
#line 541 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBreak(__loc__); }
#line 3244 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 81: // stmt: CONTINUE ';'
#line 542 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementContinue(__loc__); }
#line 3250 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 82: // stmt: FOR '(' local_id IN expr ')' block
#line 544 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementFor(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3256 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 83: // stmt: IF '(' expr ')' block opt_else_block
#line 546 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3262 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 84: // stmt: IF '(' local_init_decl ')' block opt_else_block
#line 548 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3268 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 85: // stmt: IF '(' local_init_decl ';' expr ')' block opt_else_block
#line 550 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3274 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 86: // stmt: PRINT opt_exprs ';'
#line 551 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementPrint(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 3280 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 87: // stmt: RETURN ';'
#line 552 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(__loc__); }
#line 3286 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 88: // stmt: RETURN expr ';'
#line 553 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3292 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 89: // stmt: STOP ';'
#line 554 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementStop(__loc__); }
#line 3298 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 90: // stmt: THROW expr ';'
#line 555 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(builder->exception(builder->typeName("~spicy_rt::ParseError"), yystack_[1].value.as < hilti::Expression* > (), __loc__), __loc__); }
#line 3304 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 91: // stmt: SWITCH '(' expr ')' '{' switch_cases '}'
#line 557 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 3310 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 92: // stmt: SWITCH '(' local_init_decl ')' '{' switch_cases '}'
#line 559 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 3316 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "confirm" ';'
#line 560 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementConfirm(__loc__); }
#line 3322 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 94: // stmt: "reject" ';'
#line 561 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReject(__loc__); }
#line 3328 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 95: // stmt: WHILE '(' local_init_decl ';' expr ')' block
#line 563 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3334 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 96: // stmt: WHILE '(' expr ')' block
#line 565 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3340 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 97: // stmt: WHILE '(' local_init_decl ')' block
#line 567 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[2].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3346 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 98: // stmt: ADD expr ';'
#line 569 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3358 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 99: // stmt: DELETE expr ';'
#line 577 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3370 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 100: // stmt: UNSET expr ';'
#line 585 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3382 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 101: // opt_else_block: ELSE block
#line 596 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3388 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 102: // opt_else_block: %empty
#line 597 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = {}; }
#line 3394 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 103: // switch_cases: switch_cases switch_case
#line 599 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()); yylhs.value.as < hilti::statement::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())); }
#line 3400 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 104: // switch_cases: switch_case
#line 600 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = hilti::statement::switch_::Cases({ std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ()) }); }
#line 3406 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 105: // switch_case: CASE exprs ':' block
#line 602 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(std::move(yystack_[2].value.as < hilti::Expressions > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3412 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 106: // switch_case: DEFAULT ':' block
#line 603 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3418 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 107: // stmt_decl: local_decl
#line 605 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3424 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 108: // stmt_decl: type_decl
#line 606 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3430 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 109: // stmt_decl: constant_decl
#line 607 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3436 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 110: // stmt_expr: expr
#line 610 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementExpression(yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 3442 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 111: // base_type_no_ref: ANY
#line 615 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAny(__loc__); }
#line 3448 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 112: // base_type_no_ref: ADDRESS
#line 616 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAddress(__loc__); }
#line 3454 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 113: // base_type_no_ref: BOOL
#line 617 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBool(__loc__); }
#line 3460 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 114: // base_type_no_ref: BYTES
#line 618 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBytes(__loc__); }
#line 3466 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 115: // base_type_no_ref: __ERROR
#line 619 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeError(__loc__); }
#line 3472 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 116: // base_type_no_ref: INTERVAL
#line 620 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeInterval(__loc__); }
#line 3478 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 117: // base_type_no_ref: NETWORK
#line 621 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeNetwork(__loc__); }
#line 3484 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 118: // base_type_no_ref: PORT
#line 622 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typePort(__loc__); }
#line 3490 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 119: // base_type_no_ref: REAL
#line 623 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeReal(__loc__); }
#line 3496 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 120: // base_type_no_ref: REGEXP
#line 624 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeRegExp(__loc__); }
#line 3502 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 121: // base_type_no_ref: "stream"
#line 625 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStream(__loc__); }
#line 3508 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 122: // base_type_no_ref: STRING
#line 626 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeString(__loc__); }
#line 3514 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_ref: TIME
#line 627 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTime(__loc__); }
#line 3520 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_ref: VOID
#line 628 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVoid(__loc__); }
#line 3526 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_ref: INT8
#line 630 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(8, __loc__); }
#line 3532 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_ref: INT16
#line 631 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(16, __loc__); }
#line 3538 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_ref: INT32
#line 632 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(32, __loc__); }
#line 3544 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_ref: INT64
#line 633 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(64, __loc__); }
#line 3550 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_ref: UINT8
#line 634 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(8, __loc__); }
#line 3556 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_ref: UINT16
#line 635 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(16, __loc__); }
#line 3562 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_ref: UINT32
#line 636 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(32, __loc__); }
#line 3568 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_ref: UINT64
#line 637 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(64, __loc__); }
#line 3574 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_ref: CONST_ITERATOR type_param_begin qtype type_param_end
#line 639 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3580 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_ref: ITERATOR type_param_begin qtype type_param_end
#line 640 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3586 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_ref: OPTIONAL type_param_begin qtype type_param_end
#line 641 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeOptional(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3592 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_ref: RESULT type_param_begin qtype type_param_end
#line 642 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeResult(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3598 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_ref: VIEW type_param_begin qtype type_param_end
#line 643 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = viewForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3604 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_ref: MAP type_param_begin qtype ',' qtype type_param_end
#line 645 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                           { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3610 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_ref: SET type_param_begin qtype type_param_end
#line 646 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3616 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_ref: VECTOR type_param_begin qtype type_param_end
#line 647 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3622 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_ref: SINK
#line 649 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSink(__loc__); }
#line 3628 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_ref: "library type" '(' "string value" ')'
#line 651 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeLibrary(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3634 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_ref: tuple_type
#line 653 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3640 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_ref: struct_type
#line 654 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3646 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_ref: enum_type
#line 655 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3652 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_ref: bitfield_type
#line 656 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3658 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_ref: unit_type
#line 657 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3664 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 148: // reference_type: qtype '&'
#line 662 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::QualifiedType* > ()->setSide(hilti::Side::LHS);
                                                   yystack_[1].value.as < hilti::QualifiedType* > ()->setConst(hilti::Constness::Mutable);
                                                   yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__);
                                                 }
#line 3673 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 149: // base_type: base_type_no_ref
#line 667 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3679 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 150: // reference_type: qtype '&'
#line 668 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::QualifiedType* > ()->setSide(hilti::Side::LHS);
                                                   yystack_[1].value.as < hilti::QualifiedType* > ()->setConst(hilti::Constness::Mutable);
                                                   yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__);
                                                 }
#line 3688 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 151: // type: base_type
#line 674 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3694 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 152: // type: reference_type
#line 675 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3700 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 153: // type: scoped_id
#line 676 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3706 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 154: // type_no_ref: base_type
#line 679 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3712 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 155: // type_no_ref: scoped_id
#line 680 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3718 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 156: // qtype: type_no_ref
#line 683 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable, __loc__); }
#line 3724 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 157: // qtype: CONST type_no_ref
#line 684 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Const, __loc__); }
#line 3730 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 158: // qtype: reference_type
#line 685 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Const, __loc__); }
#line 3736 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 159: // qtype: AUTO
#line 686 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeAuto(__loc__), hilti::Constness::Const, __loc__); }
#line 3742 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 160: // type_param_begin: '<'
#line 691 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 3748 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 161: // type_param_end: '>'
#line 695 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 3754 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 162: // tuple_type: TUPLE type_param_begin '*' type_param_end
#line 697 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(hilti::type::Wildcard(), __loc__); }
#line 3760 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 163: // tuple_type: TUPLE type_param_begin tuple_type_elems type_param_end
#line 698 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()), __loc__); }
#line 3766 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 164: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 703 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[2].value.as < hilti::type::tuple::Elements > ()); yylhs.value.as < hilti::type::tuple::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())); }
#line 3772 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 165: // tuple_type_elems: tuple_type_elems ','
#line 704 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()); }
#line 3778 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 166: // tuple_type_elems: tuple_type_elem
#line 705 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = hilti::type::tuple::Elements{std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())}; }
#line 3784 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 167: // tuple_type_elem: qtype
#line 709 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[0].value.as < hilti::QualifiedType* > ())); }
#line 3790 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 168: // tuple_type_elem: local_id ':' qtype
#line 710 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::QualifiedType* > ())); }
#line 3796 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 169: // struct_type: STRUCT '{' struct_fields '}'
#line 713 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStruct(std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3802 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 170: // struct_fields: struct_fields struct_field
#line 715 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[1].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 3808 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 171: // struct_fields: %empty
#line 716 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = Declarations{}; }
#line 3814 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 172: // struct_field: local_id ':' qtype opt_attributes ';'
#line 718 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                      { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3820 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 173: // enum_type: ENUM '{' enum_labels '}'
#line 720 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()), __loc__); }
#line 3826 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 174: // enum_labels: enum_labels ',' enum_label
#line 722 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[2].value.as < hilti::type::enum_::Labels > ()); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3832 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 175: // enum_labels: enum_labels ','
#line 723 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()); }
#line 3838 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 176: // enum_labels: enum_label
#line 724 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = hilti::type::enum_::Labels(); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3844 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 177: // enum_label: local_id
#line 727 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3850 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 178: // enum_label: local_id '=' "unsigned integer value"
#line 728 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3856 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 179: // $@11: %empty
#line 732 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _field_width = yystack_[1].value.as < uint64_t > (); }
#line 3862 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 180: // bitfield_type: BITFIELD '(' "unsigned integer value" ')' $@11 '{' opt_bitfield_bit_ranges '}'
#line 734 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBitfield(yystack_[5].value.as < uint64_t > (), yystack_[1].value.as < hilti::type::bitfield::BitRanges > (), {}, __loc__); }
#line 3868 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 181: // opt_bitfield_bit_ranges: bitfield_bit_ranges
#line 738 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[0].value.as < hilti::type::bitfield::BitRanges > ()); }
#line 3874 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 182: // opt_bitfield_bit_ranges: %empty
#line 739 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = hilti::type::bitfield::BitRanges(); }
#line 3880 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 183: // bitfield_bit_ranges: bitfield_bit_ranges bitfield_bit_range
#line 743 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[1].value.as < hilti::type::bitfield::BitRanges > ()); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ()));  }
#line 3886 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 184: // bitfield_bit_ranges: bitfield_bit_range
#line 744 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = hilti::type::bitfield::BitRanges(); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ())); }
#line 3892 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 185: // bitfield_bit_range: local_id ':' "unsigned integer value" DOTDOT "unsigned integer value" opt_bitfield_range_value opt_attributes ';'
#line 748 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[7].value.as < hilti::ID > ()), yystack_[5].value.as < uint64_t > (), yystack_[3].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), __loc__); }
#line 3898 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 186: // bitfield_bit_range: local_id ':' "unsigned integer value" opt_bitfield_range_value opt_attributes ';'
#line 750 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[3].value.as < uint64_t > (), yystack_[3].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), __loc__); }
#line 3904 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 187: // opt_bitfield_range_value: '=' expr
#line 753 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3910 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 188: // opt_bitfield_range_value: %empty
#line 754 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 3916 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 189: // unit_type: UNIT opt_unit_params '{' opt_unit_items '}'
#line 761 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnit(std::move(yystack_[3].value.as < hilti::declaration::Parameters > ()), std::move(yystack_[1].value.as < spicy::type::unit::Items > ()), {}, __loc__); }
#line 3922 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 190: // opt_unit_params: '(' opt_func_params ')'
#line 764 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[1].value.as < hilti::declaration::Parameters > ()); }
#line 3928 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 191: // opt_unit_params: %empty
#line 765 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 3934 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 192: // unit_items: unit_items unit_item
#line 767 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[1].value.as < spicy::type::unit::Items > ()); yylhs.value.as < spicy::type::unit::Items > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::Item* > ())); }
#line 3940 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 193: // unit_items: unit_item
#line 768 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = spicy::type::unit::Items(); yylhs.value.as < spicy::type::unit::Items > ().push_back(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3946 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 194: // opt_unit_items: unit_items
#line 770 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[0].value.as < spicy::type::unit::Items > ());}
#line 3952 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 195: // opt_unit_items: %empty
#line 771 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = spicy::type::unit::Items{}; }
#line 3958 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 196: // unit_item: unit_field
#line 774 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3964 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 197: // unit_item: unit_variable
#line 775 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3970 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 198: // unit_item: unit_wide_hook
#line 776 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3976 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 199: // unit_item: unit_property
#line 777 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3982 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 200: // unit_item: unit_sink
#line 778 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3988 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 201: // unit_item: unit_switch
#line 779 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3994 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 202: // unit_item: unit_block
#line 780 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 4000 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 203: // unit_variable: VAR local_id ':' qtype opt_init_expression opt_attributes ';'
#line 785 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemVariable(std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4006 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 204: // unit_sink: SINK local_id opt_attributes ';'
#line 787 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemSink(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4012 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 205: // unit_property: "property" opt_attributes ';'
#line 789 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), false, __loc__); }
#line 4018 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 206: // unit_property: "property" '=' expr opt_attributes ';'
#line 791 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[4].value.as < std::string > ())), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), false, __loc__); }
#line 4024 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 207: // unit_property: "property" '=' base_type_no_ref ';'
#line 792 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                        { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[3].value.as < std::string > ())), builder->expressionType(builder->qualifiedType(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable)), {}, false, __loc__); }
#line 4030 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 208: // unit_field_base_type: base_type
#line 794 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   {   if ( yystack_[0].value.as < hilti::UnqualifiedType* > ()->isA<hilti::type::Vector>() )
                                                         error(yylhs.location, "vector<T> syntax is no longer supported for parsing sequences; use T[] instead.");
                                                     yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable);
                                                 }
#line 4039 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 209: // unit_field: opt_unit_field_id ':' opt_skip unit_field_base_type opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 800 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[7].value.as < hilti::ID > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), yystack_[5].value.as < bool > (), {}, std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4045 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 210: // unit_field: opt_unit_field_id ':' opt_skip unit_field_base_type unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 802 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {   auto typeField = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[5].value.as < hilti::QualifiedType* > ()), false, {}, {}, {}, {}, {}, toMeta(yystack_[5].location));
                                                     yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(typeField), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__);
                                                 }
#line 4053 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 211: // unit_field: opt_unit_field_id ':' opt_skip unit_field_ctor opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 807 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(yystack_[5].value.as < hilti::Ctor* > ()), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4059 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 212: // unit_field: opt_unit_field_id ':' opt_skip scoped_id opt_unit_field_args opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 810 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[6].value.as < bool > (), std::move(yystack_[4].value.as < hilti::Expressions > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4065 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 213: // unit_field: opt_unit_field_id ':' opt_skip scoped_id_in_container unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 812 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), yystack_[5].value.as < spicy::type::unit::Item* > (), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4071 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 214: // unit_field: opt_unit_field_id ':' opt_skip '(' unit_field_in_container ')' opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 814 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[10].value.as < hilti::ID > ()), std::move(yystack_[6].value.as < spicy::type::unit::Item* > ()), yystack_[8].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4077 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 215: // const_sint: "unsigned integer value"
#line 816 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4083 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 216: // const_sint: '+' "unsigned integer value"
#line 817 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4089 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 217: // const_sint: '-' "unsigned integer value"
#line 818 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = -check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__); }
#line 4095 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 218: // const_uint: "unsigned integer value"
#line 820 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4101 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 219: // const_uint: '+' "unsigned integer value"
#line 821 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4107 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 220: // unit_field_ctor: ctor
#line 824 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4113 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 221: // unit_field_ctor: UINT8 '(' const_uint ')'
#line 825 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 8, __loc__); }
#line 4119 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 222: // unit_field_ctor: UINT16 '(' const_uint ')'
#line 826 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 16, __loc__); }
#line 4125 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 223: // unit_field_ctor: UINT32 '(' const_uint ')'
#line 827 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 32, __loc__); }
#line 4131 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 224: // unit_field_ctor: UINT64 '(' const_uint ')'
#line 828 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 64, __loc__); }
#line 4137 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 225: // unit_field_ctor: INT8 '(' const_sint ')'
#line 829 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 8, __loc__); }
#line 4143 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 226: // unit_field_ctor: INT16 '(' const_sint ')'
#line 830 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 16, __loc__); }
#line 4149 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 227: // unit_field_ctor: INT32 '(' const_sint ')'
#line 831 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 32, __loc__); }
#line 4155 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 228: // unit_field_ctor: INT64 '(' const_sint ')'
#line 832 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 64, __loc__); }
#line 4161 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 229: // unit_field_in_container: unit_field_ctor opt_unit_field_args opt_attributes
#line 836 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[2].value.as < hilti::Ctor* > ()), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4167 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 230: // unit_field_in_container: scoped_id opt_unit_field_args opt_attributes
#line 838 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[2].value.as < hilti::ID > ()), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4173 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 231: // unit_field_in_container: scoped_id_in_container unit_field_repeat opt_attributes
#line 840 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, yystack_[2].value.as < spicy::type::unit::Item* > (), false, {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4179 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 232: // unit_field_in_container: unit_field_base_type opt_unit_field_args opt_attributes
#line 842 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, yystack_[2].value.as < hilti::QualifiedType* > (), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4185 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 233: // unit_field_in_container: unit_field_base_type unit_field_repeat opt_unit_field_args opt_attributes
#line 844 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {   auto typeField = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), false, {}, {}, {}, {}, {}, toMeta(yystack_[3].location));
                                                     yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(typeField), false, {}, std::move(yystack_[2].value.as < hilti::Expression* > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__);
                                                 }
#line 4193 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 234: // scoped_id_in_container: scoped_id opt_unit_field_args
#line 849 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[1].value.as < hilti::ID > ()), false, std::move(yystack_[0].value.as < hilti::Expressions > ()), {}, {}, {}, {}, __loc__); }
#line 4199 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 235: // unit_wide_hook: ON unit_hook_id unit_hook
#line 851 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::declaration::Hook* > ()), __loc__); }
#line 4205 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 236: // opt_unit_field_id: local_id
#line 854 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 4211 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 237: // opt_unit_field_id: %empty
#line 855 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = {}; }
#line 4217 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 238: // $@12: %empty
#line 858 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableNewKeywordMode(); }
#line 4223 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 239: // opt_skip: $@12 opt_skip_
#line 860 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableNewKeywordMode(); yylhs.value.as < bool > () = yystack_[0].value.as < bool > (); }
#line 4229 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 240: // opt_skip_: SKIP
#line 863 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < bool > () = true; }
#line 4235 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 241: // opt_skip_: %empty
#line 864 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < bool > () = false; }
#line 4241 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 242: // opt_unit_field_args: '(' opt_exprs ')'
#line 867 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[1].value.as < hilti::Expressions > ()); }
#line 4247 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 243: // opt_unit_field_args: %empty
#line 868 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4253 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 244: // unit_field_repeat: '[' expr ']'
#line 871 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4259 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 245: // unit_field_repeat: '[' ']'
#line 872 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->null(); }
#line 4265 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 246: // opt_unit_field_repeat: unit_field_repeat
#line 875 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4271 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 247: // opt_unit_field_repeat: %empty
#line 876 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4277 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 248: // opt_unit_field_condition: IF '(' expr ')'
#line 879 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4283 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 249: // opt_unit_field_condition: %empty
#line 880 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4289 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 250: // opt_unit_field_sinks: ARROW exprs
#line 883 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 4295 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 251: // opt_unit_field_sinks: %empty
#line 884 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4301 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 252: // opt_unit_item_hooks: unit_hooks
#line 887 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()); }
#line 4307 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 253: // opt_unit_item_hooks: ';'
#line 888 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = spicy::declaration::Hooks(); }
#line 4313 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 254: // unit_hooks: unit_hooks unit_hook
#line 890 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = std::move(yystack_[1].value.as < spicy::declaration::Hooks > ()); yylhs.value.as < spicy::declaration::Hooks > ().push_back(std::move(yystack_[0].value.as < spicy::declaration::Hook* > ())); }
#line 4319 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 255: // unit_hooks: unit_hook
#line 891 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = spicy::declaration::Hooks{std::move(yystack_[0].value.as < spicy::declaration::Hook* > ())}; }
#line 4325 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 256: // unit_hook: opt_unit_hook_params opt_unit_hook_attributes braced_block
#line 894 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hook* > () = builder->declarationHook(std::move(yystack_[2].value.as < hilti::declaration::Parameters > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4331 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 257: // opt_unit_hook_params: '(' opt_func_params ')'
#line 897 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[1].value.as < hilti::declaration::Parameters > ()); }
#line 4337 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 258: // opt_unit_hook_params: %empty
#line 898 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 4343 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 259: // opt_unit_hook_attributes: opt_unit_hook_attributes unit_hook_attribute
#line 902 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ()); yylhs.value.as < hilti::AttributeSet* > () = std::move(yystack_[1].value.as < hilti::AttributeSet* > ()); }
#line 4349 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 260: // opt_unit_hook_attributes: %empty
#line 903 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 4355 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 261: // $@13: %empty
#line 905 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableHookIDMode(); }
#line 4361 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 262: // $@14: %empty
#line 907 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableHookIDMode(); }
#line 4367 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 263: // unit_hook_id: $@13 "hook identifier" $@14
#line 907 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                               { yylhs.value.as < hilti::ID > () = hilti::ID(hilti::util::replace(yystack_[1].value.as < std::string > (), "%", "0x25_")); }
#line 4373 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 264: // unit_hook_attribute: FOREACH
#line 910 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = builder->attribute("foreach", __loc__); }
#line 4379 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 265: // unit_hook_attribute: PRIORITY '=' expr
#line 911 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = builder->attribute("&priority", std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4385 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 266: // unit_hook_attribute: "property"
#line 912 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = builder->attribute(yystack_[0].value.as < std::string > (), __loc__); }
#line 4391 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 267: // unit_hook_attribute: attribute
#line 913 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = std::move(yystack_[0].value.as < hilti::Attribute* > ()); }
#line 4397 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 268: // unit_switch: SWITCH opt_unit_switch_expr '{' unit_switch_cases '}' opt_attributes opt_unit_field_condition ';'
#line 916 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemSwitch(std::move(yystack_[6].value.as < hilti::Expression* > ()), std::move(yystack_[4].value.as < spicy::type::unit::item::switch_::Cases > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, std::move(yystack_[2].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4403 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 269: // opt_unit_switch_expr: '(' expr ')'
#line 918 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4409 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 270: // opt_unit_switch_expr: %empty
#line 919 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4415 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 271: // unit_switch_cases: unit_switch_cases unit_switch_case
#line 923 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Cases > () = std::move(yystack_[1].value.as < spicy::type::unit::item::switch_::Cases > ()); yylhs.value.as < spicy::type::unit::item::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case* > ())); }
#line 4421 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 272: // unit_switch_cases: unit_switch_case
#line 924 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Cases > () = spicy::type::unit::item::switch_::Cases(); yylhs.value.as < spicy::type::unit::item::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case* > ())); }
#line 4427 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 273: // unit_switch_case: exprs ARROW '{' unit_items '}'
#line 927 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[4].value.as < hilti::Expressions > (), yystack_[1].value.as < spicy::type::unit::Items > (), __loc__); }
#line 4433 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 274: // unit_switch_case: '*' ARROW '{' unit_items '}'
#line 928 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[1].value.as < spicy::type::unit::Items > (), __loc__); }
#line 4439 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 275: // unit_switch_case: exprs ARROW unit_item
#line 929 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[2].value.as < hilti::Expressions > (), {yystack_[0].value.as < spicy::type::unit::Item* > ()}, __loc__); }
#line 4445 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 276: // unit_switch_case: '*' ARROW unit_item
#line 930 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(type::unit::Items{yystack_[0].value.as < spicy::type::unit::Item* > ()}, __loc__); }
#line 4451 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 277: // unit_switch_case: ARROW unit_field
#line 931 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[0].value.as < spicy::type::unit::Item* > (), __loc__); }
#line 4457 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 278: // unit_switch_case: ARROW unit_switch
#line 932 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[0].value.as < spicy::type::unit::Item* > (), __loc__); }
#line 4463 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 279: // opt_unit_block_else_items: ELSE '{' opt_unit_items '}'
#line 935 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[1].value.as < spicy::type::unit::Items > ()); }
#line 4469 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 280: // opt_unit_block_else_items: %empty
#line 936 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = {}; }
#line 4475 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 281: // unit_block: IF '(' expr ')' '{' opt_unit_items '}' opt_unit_block_else_items ';'
#line 939 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemBlock(std::move(yystack_[6].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < spicy::type::unit::Items > ()), std::move(yystack_[1].value.as < spicy::type::unit::Items > ()), {}, __loc__); }
#line 4481 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 282: // $@15: %empty
#line 946 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 4487 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 283: // $@16: %empty
#line 948 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 4493 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 284: // expr: $@15 expr_0 $@16
#line 949 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4499 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 285: // opt_exprs: exprs
#line 952 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 4505 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 286: // opt_exprs: %empty
#line 953 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = Expressions(); }
#line 4511 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 287: // exprs: exprs ',' expr
#line 955 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 4517 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 288: // exprs: expr
#line 956 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4523 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 289: // expr_0: expr_1
#line 958 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4529 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 290: // expr_1: expr_2 '=' expr_1
#line 961 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionAssign(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4535 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 291: // expr_1: expr_2 MINUSASSIGN expr_1
#line 962 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4541 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 292: // expr_1: expr_2 PLUSASSIGN expr_1
#line 963 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4547 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 293: // expr_1: expr_2 TIMESASSIGN expr_1
#line 964 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4553 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 294: // expr_1: expr_2 DIVIDEASSIGN expr_1
#line 965 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4559 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 295: // expr_1: expr_2 '?' expr ':' expr
#line 966 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTernary(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4565 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 296: // expr_1: expr_2
#line 967 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4571 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 297: // expr_2: expr_2 OR expr_3
#line 969 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalOr(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4577 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 298: // expr_2: expr_3
#line 970 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4583 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 299: // expr_3: expr_3 AND expr_4
#line 972 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalAnd(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4589 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 300: // expr_3: expr_4
#line 973 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4595 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 301: // expr_4: expr_4 EQ expr_5
#line 975 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4601 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 302: // expr_4: expr_4 NEQ expr_5
#line 976 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4607 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 303: // expr_4: expr_5
#line 977 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4613 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 304: // expr_5: expr_5 '<' expr_6
#line 979 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4619 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 305: // expr_5: expr_5 '>' expr_6
#line 980 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4625 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 306: // expr_5: expr_5 GEQ expr_6
#line 981 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4631 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 307: // expr_5: expr_5 LEQ expr_6
#line 982 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4637 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 308: // expr_5: expr_6
#line 983 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4643 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 309: // expr_6: expr_6 '|' expr_7
#line 985 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4649 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 310: // expr_6: expr_7
#line 986 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4655 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 311: // expr_7: expr_7 '^' expr_8
#line 988 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4661 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 312: // expr_7: expr_8
#line 989 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4667 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 313: // expr_8: expr_8 '&' expr_9
#line 991 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4673 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 314: // expr_8: expr_9
#line 992 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4679 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 315: // expr_9: expr_9 SHIFTLEFT expr_a
#line 994 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4685 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 316: // expr_9: expr_9 SHIFTRIGHT expr_a
#line 995 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4691 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 317: // expr_9: expr_a
#line 996 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4697 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 318: // expr_a: expr_a '+' expr_b
#line 998 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4703 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 319: // expr_a: expr_a '-' expr_b
#line 999 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4709 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 320: // expr_a: expr_b
#line 1000 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4715 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 321: // expr_b: expr_b '%' expr_c
#line 1002 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4721 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 322: // expr_b: expr_b '*' expr_c
#line 1003 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4727 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 323: // expr_b: expr_b '/' expr_c
#line 1004 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4733 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 324: // expr_b: expr_b POW expr_c
#line 1005 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4739 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 325: // expr_b: expr_c
#line 1006 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4745 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 326: // expr_c: '!' expr_c
#line 1008 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4751 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 327: // expr_c: '*' expr_c
#line 1009 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4757 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 328: // expr_c: '~' expr_c
#line 1010 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4763 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 329: // expr_c: '|' expr_c '|'
#line 1011 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4769 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 330: // expr_c: MINUSMINUS expr_c
#line 1012 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4775 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 331: // expr_c: PLUSPLUS expr_c
#line 1013 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4781 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 332: // expr_c: expr_d
#line 1014 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4787 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 333: // expr_d: expr_d '(' opt_exprs ')'
#line 1016 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4793 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 334: // expr_d: expr_d '.' member_expr
#line 1017 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4799 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 335: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 1018 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                         { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4805 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 336: // expr_d: expr_d '[' expr ']'
#line 1019 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4811 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 337: // expr_d: expr_d HASATTR member_expr
#line 1020 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4817 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 338: // expr_d: expr_d IN expr_d
#line 1021 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4823 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 339: // expr_d: expr_d NOT_IN expr_d
#line 1022 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__)); }
#line 4829 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 340: // expr_d: expr_d MINUSMINUS
#line 1023 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4835 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 341: // expr_d: expr_d PLUSPLUS
#line 1024 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4841 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 342: // expr_d: expr_d TRYATTR member_expr
#line 1025 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4847 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 343: // expr_d: expr_e
#line 1026 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4853 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 344: // expr_e: CAST type_param_begin qtype type_param_end '(' expr ')'
#line 1028 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression* > ()), builder->expressionType(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()))}, __loc__); }
#line 4859 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 345: // expr_e: PACK tuple_expr
#line 1029 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4865 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 346: // expr_e: UNPACK type_param_begin qtype type_param_end tuple_expr
#line 1030 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unpack, {builder->expressionType(std::move(yystack_[2].value.as < hilti::QualifiedType* > ())), std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorBool(true), __loc__)}, __loc__); }
#line 4871 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 347: // expr_e: BEGIN_ '(' expr ')'
#line 1031 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4877 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 348: // expr_e: END_ '(' expr ')'
#line 1032 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4883 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 349: // expr_e: NEW base_type_no_ref
#line 1033 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionCtor(builder->ctorDefault(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()))), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4889 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 350: // expr_e: NEW ctor
#line 1034 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__),             builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4895 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 351: // expr_e: NEW scoped_id
#line 1035 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4901 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 352: // expr_e: NEW scoped_id '(' opt_exprs ')'
#line 1036 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionName(std::move(yystack_[3].value.as < hilti::ID > ()), __loc__), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4907 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 353: // expr_e: expr_f
#line 1037 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4913 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 354: // expr_f: ctor
#line 1039 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4919 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 355: // expr_f: ctor_expr
#line 1040 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4925 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 356: // expr_f: '-' expr_f
#line 1041 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4931 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 357: // expr_f: '[' expr FOR local_id IN expr ']'
#line 1043 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[1].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4937 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 358: // expr_f: '[' expr FOR local_id IN expr IF expr ']'
#line 1045 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[7].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()),  __loc__); }
#line 4943 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 359: // expr_f: expr_g
#line 1046 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4949 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 360: // expr_g: '(' expr ')'
#line 1048 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionGrouping(std::move(yystack_[1].value.as < hilti::Expression* > ())); }
#line 4955 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 361: // expr_g: scoped_id
#line 1049 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4961 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 362: // expr_g: DOLLARDOLLAR
#line 1050 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move("__dd"), __loc__);}
#line 4967 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 363: // expr_g: "$<N>"
#line 1051 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { // $N -> $@[N] (with $@ being available internally only, not exposed to users)
                                                   auto captures = builder->expressionKeyword(hilti::expression::keyword::Kind::Captures, builder->qualifiedType(builder->typeName("~hilti::Captures"), hilti::Constness::Mutable), __loc__);
                                                   auto index = builder->expressionCtor(builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__), __loc__);
                                                   yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(captures), std::move(index)}, __loc__);
                                                 }
#line 4977 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 364: // member_expr: local_id
#line 1057 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4983 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 365: // member_expr: "stream"
#line 1058 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(ID("stream"), __loc__); }
#line 4989 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 366: // ctor: "address value"
#line 1062 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorAddress(hilti::rt::Address(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4995 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 367: // ctor: "address value" '/' "unsigned integer value"
#line 1063 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNetwork(hilti::rt::Network(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 5001 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 368: // ctor: "bool value"
#line 1064 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBool(yystack_[0].value.as < bool > (), __loc__); }
#line 5007 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 369: // ctor: "bytes value"
#line 1065 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5013 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 370: // ctor: "error value"
#line 1066 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorError(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5019 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 371: // ctor: "port value"
#line 1067 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorPort(hilti::rt::Port(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5025 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 372: // ctor: "null value"
#line 1068 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNull(__loc__); }
#line 5031 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 373: // ctor: "string value"
#line 1069 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorString(yystack_[0].value.as < std::string > (), false, __loc__); }
#line 5037 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 374: // ctor: "unsigned integer value"
#line 1070 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 5043 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 375: // ctor: '+' "unsigned integer value"
#line 1071 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( yystack_[0].value.as < uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    hilti::logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__);
                                                 }
#line 5053 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 376: // ctor: "real value"
#line 1076 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__); }
#line 5059 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 377: // ctor: '+' "real value"
#line 1077 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__);; }
#line 5065 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 378: // ctor: OPTIONAL '(' expr ')'
#line 1082 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorOptional(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 5071 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 379: // ctor: RESULT '(' expr ')'
#line 1083 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorResult(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 5077 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 380: // ctor: list
#line 1085 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5083 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 381: // ctor: map
#line 1086 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5089 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 382: // ctor: regexp
#line 1087 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5095 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 383: // ctor: set
#line 1088 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5101 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 384: // ctor: struct_
#line 1089 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5107 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 385: // ctor: tuple
#line 1090 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5113 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 386: // ctor: vector
#line 1091 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5119 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 387: // ctor_expr: INTERVAL '(' expr ')'
#line 1094 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5125 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 388: // ctor_expr: INTERVAL_NS '(' expr ')'
#line 1095 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5131 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 389: // ctor_expr: TIME '(' expr ')'
#line 1096 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5137 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 390: // ctor_expr: TIME_NS '(' expr ')'
#line 1097 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5143 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 391: // ctor_expr: "stream" '(' expr ')'
#line 1098 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("stream", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5149 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 392: // ctor_expr: INT8 '(' expr ')'
#line 1099 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5155 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 393: // ctor_expr: INT16 '(' expr ')'
#line 1100 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5161 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 394: // ctor_expr: INT32 '(' expr ')'
#line 1101 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5167 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 395: // ctor_expr: INT64 '(' expr ')'
#line 1102 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5173 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 396: // ctor_expr: UINT8 '(' expr ')'
#line 1103 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5179 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 397: // ctor_expr: UINT16 '(' expr ')'
#line 1104 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5185 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 398: // ctor_expr: UINT32 '(' expr ')'
#line 1105 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5191 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 399: // ctor_expr: UINT64 '(' expr ')'
#line 1106 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5197 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 400: // ctor_expr: PORT '(' expr ',' expr ')'
#line 1107 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("port", {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 5203 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 401: // tuple: '(' opt_tuple_elems1 ')'
#line 1110 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5209 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 402: // tuple: TUPLE '(' opt_exprs ')'
#line 1111 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5215 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 403: // opt_tuple_elems1: tuple_elem
#line 1114 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5221 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 404: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 1115 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 5227 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 405: // opt_tuple_elems1: %empty
#line 1116 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 5233 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 406: // opt_tuple_elems2: tuple_elem
#line 1119 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5239 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 407: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 1120 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 5245 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 408: // opt_tuple_elems2: tuple_elem
#line 1121 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5251 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 409: // opt_tuple_elems2: %empty
#line 1122 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 5257 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 410: // tuple_elem: expr
#line 1125 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 5263 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 411: // tuple_elem: NONE
#line 1126 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(builder->ctorNull(__loc__), __loc__); }
#line 5269 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 412: // tuple_expr: tuple
#line 1128 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 5275 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 413: // list: '[' opt_exprs ']'
#line 1130 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5281 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 414: // list: LIST '(' opt_exprs ')'
#line 1131 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5287 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 415: // list: LIST type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1133 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5293 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 416: // vector: VECTOR '(' opt_exprs ')'
#line 1135 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5299 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 417: // vector: VECTOR type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1137 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5305 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 418: // set: SET '(' opt_exprs ')'
#line 1139 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5311 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 419: // set: SET type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1141 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5317 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 420: // map: MAP '(' opt_map_elems ')'
#line 1143 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 5323 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 421: // map: MAP type_param_begin qtype ',' qtype type_param_end '(' opt_map_elems ')'
#line 1145 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 5329 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 422: // struct_: '[' struct_elems ']'
#line 1147 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorStruct(std::move(yystack_[1].value.as < hilti::ctor::struct_::Fields > ()), __loc__); }
#line 5335 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 423: // struct_elems: struct_elems ',' struct_elem
#line 1150 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = std::move(yystack_[2].value.as < hilti::ctor::struct_::Fields > ()); yylhs.value.as < hilti::ctor::struct_::Fields > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()); }
#line 5341 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 424: // struct_elems: struct_elem
#line 1151 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = hilti::ctor::struct_::Fields{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()) }; }
#line 5347 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 425: // struct_elem: "$-identifier" '=' expr
#line 1153 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field* > () = builder->ctorStructField(hilti::ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 5353 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 426: // regexp: re_patterns
#line 1155 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorRegExp(std::move(yystack_[0].value.as < std::vector<std::string> > ()), {}, __loc__); }
#line 5359 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 427: // re_patterns: re_patterns '|' re_pattern_constant
#line 1158 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 5365 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 428: // re_patterns: re_pattern_constant
#line 1159 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 5371 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 429: // $@17: %empty
#line 1162 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                    { driver->enablePatternMode(); }
#line 5377 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 430: // $@18: %empty
#line 1162 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                             { driver->disablePatternMode(); }
#line 5383 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 431: // re_pattern_constant: '/' $@17 "regular expression value" $@18 '/'
#line 1163 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 5389 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 432: // opt_map_elems: map_elems
#line 1165 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[0].value.as < hilti::ctor::map::Elements > ()); }
#line 5395 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 433: // opt_map_elems: %empty
#line 1166 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); }
#line 5401 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 434: // map_elems: map_elems ',' map_elem
#line 1168 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[2].value.as < hilti::ctor::map::Elements > ()); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 5407 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 435: // map_elems: map_elem
#line 1169 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 5413 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 436: // map_elem: expr ':' expr
#line 1171 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Element* > () = builder->ctorMapElement(yystack_[2].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::Expression* > ()); }
#line 5419 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 437: // attribute: "attribute"
#line 1175 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Attribute* > () = builder->attribute(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5425 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 438: // attribute: "attribute" '=' expr
#line 1176 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Attribute* > () = builder->attribute(std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 5431 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 439: // opt_attributes: opt_attributes attribute
#line 1179 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ()); yylhs.value.as < hilti::AttributeSet* > () = yystack_[1].value.as < hilti::AttributeSet* > (); }
#line 5437 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 440: // opt_attributes: %empty
#line 1180 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 5443 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;


#line 5447 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -730;

  const short Parser::yytable_ninf_ = -434;

  const short
  Parser::yypact_[] =
  {
     322,   -60,  -730,    80,    61,  -730,  -730,  -730,  1186,  -730,
    -730,   -50,  -730,  -730,  -730,  -730,    30,  -730,  -730,  -730,
    -730,  -730,  -730,    57,    60,  -730,   125,   147,   159,   163,
     192,   204,   211,   -56,   140,  1186,  1500,   238,   -58,  1186,
     257,   273,   161,   285,   311,   315,   320,   332,   336,   344,
     351,    60,   162,   -43,  1186,   415,  1945,     9,  1186,  -730,
    1186,  1186,  -730,  -730,  -730,  -730,   303,   350,    31,   254,
     187,    59,   227,   364,   337,   296,  -730,   308,  -730,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
     289,  -730,  -730,   489,  -730,  -730,  2289,  -730,  -730,  -730,
    -730,  -730,  -730,  -730,   368,  2289,   378,  2289,  -730,  -730,
    -730,   358,  -730,  -730,  -730,   386,  -730,  -730,  -730,  -730,
    -730,  -730,    60,    60,   390,   140,  -730,   166,  -730,  -730,
     170,   161,  -730,  -730,  -730,   388,  -730,   199,  -730,  -730,
    -730,  -730,   392,   162,    60,  -730,   -43,     9,   393,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,  -730,   368,  2289,  -730,  -730,  -730,   368,  -730,  -730,
    -730,  -730,  2289,   368,  2289,  -730,   394,   395,   396,  -730,
    -730,  -730,  -730,   399,   492,   389,   398,    76,  -730,   391,
     539,  -730,  -730,  -730,  1186,  1186,  1186,  1186,  1186,  1186,
    -730,  1186,  1186,  1186,  1186,  1186,  1186,  1186,  1186,  1186,
    1186,  1186,  1186,  1186,  1186,  1186,  1186,  1186,  1186,    42,
    1808,  -730,  1808,  -730,    42,   368,  -730,    42,   387,  -730,
    -730,   405,  -730,  2385,    60,    60,    60,    60,    60,    60,
    -730,  -730,  -730,  -730,  -730,   -41,   406,   407,   409,   411,
     414,   417,   418,  -730,   419,   -41,   422,   421,   425,  -730,
      90,   562,    61,  2289,  2289,   573,  2289,  2289,  2289,  2289,
    -730,  2063,    26,   431,  2289,  2289,  -730,   368,   434,   435,
     440,   441,   -41,   445,   446,   449,   450,   453,   456,   457,
     458,   -41,   460,   -41,  -730,  -730,   -11,  -730,    61,  -730,
    -730,   580,  -730,  -730,  -730,  -730,  -730,   350,  -730,  -730,
    -730,   454,    31,   254,   254,   187,   187,   187,   187,    59,
     227,   364,   337,   337,   296,   296,  -730,  -730,  -730,  -730,
    -730,  -730,  -730,   530,   671,  -730,   461,   451,   464,  -730,
    2180,  -730,  -730,  2289,  2289,  2289,   183,  -730,   465,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,   466,  -730,  -730,
    -730,  2289,   467,   472,   104,  -730,   -41,   -41,   470,   214,
     -41,   -41,   -41,    12,   468,   473,   471,   -40,  -730,  -730,
     476,   477,  -730,    61,   284,   -41,   -41,   479,  -730,  -730,
    -730,  -730,   478,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,   -58,  -730,   482,  -730,   348,  -730,   555,  -730,  -730,
     469,  -730,  -730,  -730,   368,   357,  -730,  -730,  -730,   486,
     490,  -730,   494,   495,    61,   510,  -730,   493,  -730,  -730,
     499,   500,   498,   502,   503,  -730,  -730,   501,  -730,   863,
    1026,  -730,  -730,  -730,  -730,  -730,  -730,   201,  -730,  -730,
     509,  -730,   242,   -41,   -41,  -730,   -43,  -730,  -730,   -41,
    -730,   640,    61,  -730,  -730,  -730,  -730,  2289,  -730,  -730,
     511,  -730,   513,  -730,  -730,  2289,  2289,  -730,  -730,   591,
     514,   517,   516,  -730,    61,   521,    61,  -730,   284,   518,
    -730,  -730,  -730,  -730,  -730,  -730,   524,  -730,  -730,   526,
    -730,  -730,   528,   -43,  -730,   -43,   -11,  -730,  -730,  -730,
     532,  -730,  -730,   136,   269,   520,  -730,  -730,   534,    61,
     595,    -8,   374,   536,   679,   547,  -730,   549,  -730,   595,
    -730,  -730,   550,   554,   595,   510,  -730,   510,   510,  -730,
    2289,  -730,  -730,   551,   552,   556,   558,  -730,  -730,   -41,
    2289,   471,  -730,  -730,  2289,  2622,    35,  -730,   536,  -730,
    -730,   559,   560,  -730,  -730,  -730,  -730,   553,   565,  -730,
     -31,  -730,   570,  -730,  -730,  -730,  -730,  -730,  -730,   639,
      61,   -15,   567,  -730,  -730,  -730,  2289,    26,  -730,  -730,
    -730,  -730,  -730,   568,   571,  -730,  -730,   249,   572,   575,
     711,   576,   579,   -41,  -730,  -730,   378,    61,   578,   471,
     574,   577,   582,   583,   471,   588,  -730,   592,  -730,  -730,
     594,  -730,    45,   599,     0,  2289,  1654,   615,  -730,  -730,
    -730,  -730,  -730,   605,   607,  -730,   377,  -730,  2521,  2521,
     608,   738,   609,   105,   606,    10,  -730,   610,   611,  -730,
    2521,  2521,   612,   613,  -730,   510,   618,   619,  -730,  -730,
     616,   620,   617,    61,  -730,    46,  -730,  -730,  -730,    51,
    -730,   621,  -730,  -730,    29,   732,    -1,  -730,     3,    81,
     623,   625,   626,   628,   629,   631,   633,   635,  1346,   637,
    -730,   600,   600,   600,  -730,  -730,  -730,   630,  -730,  -730,
     642,  -730,  2289,   643,  2129,  -730,  -730,    17,   739,  -730,
    -730,   741,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
     649,  -730,  -730,  -730,   146,   146,   647,  -730,  -730,  -730,
    2289,   641,  -730,  2289,  2289,  -730,   784,  -730,  -730,  -730,
    -730,  -730,  -730,   284,  -730,  -730,   232,  -730,  -730,   233,
    -730,    20,    20,    20,    20,     2,     2,     2,     2,   652,
     -81,   652,   653,   600,   368,   645,   646,  -730,    27,  -730,
    -730,  -730,  -730,  2521,  -730,   114,  2521,   655,  2429,  -730,
    2521,  -730,  -730,  -730,   656,  -730,  -730,   661,   -10,  -730,
      13,  2521,   664,   123,    26,   665,  -730,   155,   471,   -24,
     659,   225,  -730,    53,   225,  -730,    52,  -730,   797,   798,
     666,   667,   668,   669,  -730,   799,   672,   673,   674,   675,
     645,  -730,   652,  -730,   600,  -730,   676,    63,  -730,   660,
      68,   678,   802,    71,    79,  -730,  -730,   781,  -730,  -730,
    -730,  -730,  -730,   -53,  2521,  -730,  -730,  -730,  -730,  -730,
    -730,   680,  -730,  -730,  -730,    64,   816,  -730,  -730,   785,
     154,   688,   223,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,  -730,  -730,  -730,  -730,   829,   829,  -730,   829,  -730,
     829,  -730,   802,  -730,   802,  -730,  -730,    58,   802,   802,
    -730,  -730,  2521,  -730,   690,   689,   692,  -730,   694,  -730,
      70,   691,   696,  -730,  -730,  -730,   829,   128,    58,    58,
     695,   398,  -730,  -730,    33,  -730,    58,    58,  -730,  -730,
    2289,  -730,  -730,  -730,  -730,  -730,   284,  -730,   802,  -730,
    -730,  -730,  -730,  -730,  -730,   471,    25,    74,   693,    58,
     698,   700,  -730,  -730,  -730,  -730,  -730
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,   282,     0,     0,     2,     3,     4,     0,     1,
       7,     0,     9,   373,   369,   370,   366,   371,   376,   374,
     363,   368,   372,     0,     0,   362,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   282,     0,     0,     0,   282,     0,   429,
       0,     0,     8,   361,   283,   289,   296,   298,   300,   303,
     308,   310,   312,   314,   317,   320,   325,   332,   343,   353,
     359,   354,   355,   385,   380,   386,   383,   381,   384,   382,
     426,   428,     5,     0,   282,   160,     0,   282,   282,   282,
     282,   282,   282,   282,   282,     0,   282,     0,   330,   112,
     111,     0,   113,   114,   119,     0,   115,   126,   127,   128,
     125,   116,     0,     0,     0,     0,   117,     0,   118,   120,
       0,     0,   141,   121,   122,     0,   123,     0,   130,   131,
     132,   129,   191,     0,     0,   124,   282,   282,   351,   349,
     143,   144,   145,   146,   147,   350,   282,   412,   345,   331,
     282,   282,   282,     0,   282,   282,   282,   282,   282,   282,
     282,   282,     0,   282,     0,   411,   410,     0,   403,   327,
     377,   375,   356,     0,   288,     0,   285,     0,   424,     0,
       0,   326,   328,   284,     0,     0,     0,     0,     0,     0,
     282,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   340,     0,   341,     0,   282,   282,     0,     0,    15,
     367,     0,   159,     0,     0,     0,     0,     0,     0,     0,
     155,   149,   158,   154,   156,     0,     0,     0,     0,     0,
       0,     0,     0,   288,     0,     0,     0,     0,   432,   435,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,     0,    56,     0,     0,     0,   410,   282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   360,   401,   282,   282,     0,   413,
     282,     0,   422,   329,   430,   294,   291,   297,   292,   293,
     290,     0,   299,   301,   302,   306,   307,   304,   305,   309,
     311,   313,   315,   316,   318,   319,   324,   322,   321,   323,
     365,   364,   337,   338,   339,   342,     0,     0,   334,   427,
     282,   347,   157,     0,     0,     0,   148,   161,     0,   348,
     393,   394,   395,   392,   387,   388,   414,     0,   282,   420,
     282,     0,     0,   177,     0,   176,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     8,   167,     0,   166,    63,
       0,    55,    58,     0,   195,     0,     0,     0,   378,   282,
     379,   418,     0,   391,   389,   390,   402,   397,   398,   399,
     396,     0,   416,     0,   404,   406,   425,     0,   287,   423,
       0,   282,   333,   336,   282,     0,   282,   282,   282,     0,
       0,   282,     0,     0,     0,     0,   261,   282,    50,    49,
     282,     0,     0,     0,     0,   282,   282,     0,    13,    16,
      17,   107,    18,    19,    20,    21,    22,     0,    14,    75,
       0,   110,     0,     0,     0,   282,   282,   436,   434,     0,
     179,     0,   175,   173,   134,   133,   142,     0,   135,   136,
     139,   169,     0,   170,   162,     0,   165,   163,   190,    64,
       0,   440,     0,   261,     0,   270,     0,   236,   194,     0,
     193,   197,   200,   199,   196,   198,     0,   201,   202,   140,
     137,   352,     0,   282,   346,   282,   282,   282,   431,   295,
       0,    46,   282,     0,     0,     0,    80,    81,     0,     0,
     282,     0,     0,   258,     0,     0,    87,     0,    89,   282,
      93,    94,     0,     0,   282,     0,    52,     0,     0,    74,
       0,   139,   140,     0,     0,     0,     0,   178,   174,     0,
       0,   168,   164,    57,     0,   282,     0,   282,   258,   440,
     282,     0,     0,   192,   189,   238,   400,     0,     0,   407,
       0,   335,     0,    76,   282,    78,   282,    98,    99,     0,
       0,     0,     0,    10,    44,   282,     0,    56,    48,   260,
     262,    86,    88,     0,     0,    90,   100,     0,     0,    25,
      54,    34,     0,     0,   344,   415,   282,   182,   138,   440,
     153,   152,   151,    66,     0,     0,   440,   437,   205,   439,
       0,   235,     0,     0,   282,     0,     0,   241,   419,   417,
     282,   357,    47,     0,     0,   282,     0,   282,   282,   282,
       0,     0,     0,     0,     0,     0,   263,     0,     0,   282,
     282,   282,     0,     0,    53,     0,     0,     0,    23,   138,
       0,     0,     0,   181,   184,     0,   282,    59,   207,     0,
     282,     0,   204,   269,   237,     0,   282,   272,     0,    66,
     126,   127,   128,   125,   130,   131,   132,   129,   282,   243,
     208,   440,   247,     0,   220,   240,   239,     0,    77,    79,
       0,   282,     0,     0,   282,   108,   109,     0,   102,    67,
      68,   102,    45,    11,    29,    30,   282,   257,   266,   264,
       0,   256,   259,   267,     0,     0,     0,    97,    96,   282,
       0,     0,   282,     0,     0,   421,     0,   180,   183,   172,
      65,   206,   438,   195,   277,   278,   237,   440,   271,   237,
     440,     0,     0,     0,     0,     0,     0,     0,     0,   243,
     243,   243,     0,     0,   282,   440,   282,   440,   249,   246,
     440,   440,   358,   282,    33,     0,   282,     0,   282,    73,
     282,    84,    83,    12,     0,   282,   282,     0,     0,   104,
       0,   282,     0,     0,    56,     0,    37,     0,   440,   188,
       0,   237,   276,   249,   237,   275,     0,   215,     0,     0,
       0,     0,     0,     0,   218,     0,     0,     0,     0,     0,
     440,   440,   243,   440,   247,   440,     0,   249,   245,     0,
     249,     0,   251,   249,   249,    82,   282,   102,    69,    72,
     101,    31,   265,     0,   282,    92,   103,    91,    95,    26,
     282,     0,    35,    38,   282,     0,     0,   282,   440,   280,
     237,     0,   237,   203,   216,   217,   226,   227,   228,   225,
     219,   222,   223,   224,   221,   230,   232,   440,   229,   440,
     231,   242,   251,   244,   251,   282,   282,   258,   251,   251,
      32,    85,   282,   106,     0,    62,     0,    24,   188,   187,
       0,     0,     0,   274,   268,   273,   233,   249,   258,   258,
       0,   250,   253,   209,   252,   255,   258,   258,   105,    28,
       0,    61,   440,    39,   440,   186,   195,   281,   251,   212,
     210,   248,   254,   211,   213,    60,    40,     0,     0,   258,
       0,     0,   185,   279,   214,    41,    43
  };

  const short
  Parser::yypgoto_[] =
  {
    -730,  -730,  -730,  -730,  -730,    -4,   -19,  -730,  -730,  -730,
    -730,  -730,   512,  -730,   525,  -730,  -730,  -730,  -296,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,   529,
    -730,  -730,  -581,  -730,   371,  -730,  -730,  -730,   178,  -584,
    -634,  -730,  -730,  -336,  -689,   135,  -360,  -730,  -730,   -33,
     307,  -541,  -730,   638,    14,   452,  -243,  -730,  -730,   397,
    -730,  -730,  -730,  -730,  -730,   402,  -730,  -730,  -730,  -730,
     205,   -28,  -730,  -730,  -577,  -729,  -478,  -730,  -730,  -730,
     189,   215,  -309,  -283,   200,  -730,   203,  -730,  -730,  -730,
    -730,  -730,  -670,  -264,    69,  -442,  -475,  -643,  -730,  -521,
    -730,  -730,   412,  -730,  -730,  -730,   218,  -730,  -730,   222,
    -730,  -730,     5,  -730,  -730,   -99,  -601,  -730,   252,  -730,
     703,   702,   326,   286,   697,   704,   699,   321,   323,   -14,
     217,  -730,   850,  -730,   191,   -35,  -730,   -30,  -391,   401,
    -287,   515,  -730,  -730,  -730,  -730,  -730,  -730,   614,  -730,
    -730,   683,  -730,  -730,   306,  -730,   557,   274,   -71
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     6,     5,   229,    62,    63,   640,   641,   783,
     340,   438,   705,   734,   706,   652,   653,   441,   581,   442,
     656,   657,   796,   443,   940,   941,   444,   445,   446,   707,
     600,   655,   380,   381,   382,   921,   922,   383,   667,   708,
     709,   777,   778,   710,   781,   788,   789,   449,   450,   241,
     242,   243,   613,   244,   376,   267,   348,   150,   377,   378,
     151,   373,   473,   152,   364,   365,   153,   546,   662,   663,
     664,   858,   154,   273,   488,   489,   490,   491,   492,   493,
     691,   494,   810,   816,   692,   762,   693,   495,   496,   626,
     627,   696,   765,   769,   770,   832,   887,   913,   914,   915,
     589,   645,   523,   524,   646,   722,   497,   561,   676,   677,
     902,   498,   253,     8,   193,   185,   186,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,   332,    81,    82,    83,   177,   404,
     178,   158,    84,    85,    86,    87,    88,   187,   188,    89,
      90,    91,   190,   410,   257,   258,   259,   619,   556
  };

  const short
  Parser::yytable_[] =
  {
      11,   155,   588,   149,   448,   254,   644,     7,   157,   405,
     563,   721,   357,   612,   800,    10,   183,   148,   617,   718,
     814,   108,   782,   678,   856,   159,   786,   674,   674,   -64,
       4,   749,    10,   617,   787,   617,   630,   621,   807,   392,
     179,  -258,  -252,   617,   189,    10,   191,   192,   401,   786,
     403,   175,   583,   617,   617,   711,   535,   787,   176,   617,
     617,   617,   184,   281,    10,   544,   727,   728,   286,   719,
     764,   617,   617,    46,   292,   678,   617,   240,   617,   617,
       9,   766,   617,   175,   202,   690,   240,   617,   240,   820,
     821,   823,  -258,   146,   831,   104,   379,   892,    92,   231,
     300,    95,   246,   247,   248,   249,   250,   251,   252,  -405,
     245,   256,   567,   476,   568,   346,   720,   347,   347,   255,
     831,   260,   203,   464,   465,   857,   336,   468,   469,   470,
     831,   474,   631,   637,   477,   831,   617,   638,   831,  -258,
     584,  -409,   499,   500,   240,   845,   831,   690,   891,   538,
     485,   276,   877,   240,   747,   240,   300,    10,   675,   675,
     330,   278,   815,   481,   704,   279,   280,   471,   847,   283,
     284,   285,  -286,   287,   288,   289,   290,   282,   387,   -42,
     808,   809,   786,   618,   587,   843,   291,  -258,   293,   835,
     787,  -148,   837,   672,   739,   831,   840,   938,    93,   741,
     863,   326,   327,   328,   329,   311,   912,   848,    94,   587,
     541,   542,   897,   851,   240,   331,   545,    95,   925,   405,
     331,   482,   942,   331,   860,   209,    10,   862,    10,   301,
     666,   337,   481,   593,   481,    10,    10,   346,   597,   302,
     535,   481,   481,   361,   240,   240,   346,   240,   240,   240,
     240,   483,   240,   715,   716,   240,   240,   462,   363,   463,
     893,   346,   536,   836,   537,   929,   930,   375,   802,   484,
     346,   805,   850,   933,   934,   485,    97,   366,   367,   346,
     369,   370,   371,   372,   573,   911,   574,    10,   385,   386,
     482,   106,   482,   481,   407,   486,   944,    95,    98,   482,
     482,   276,   406,   853,   854,   408,   608,   946,   918,   903,
      99,   346,   162,   173,   100,   510,   204,   156,    95,    95,
     483,   161,   483,    95,   240,   240,   240,    95,   525,   483,
     483,  -148,  -148,   538,   205,  -148,  -148,  -148,   484,  -148,
     484,  -148,   240,   101,   485,   451,   485,   484,   484,   194,
     167,   482,   208,   485,   485,   102,    95,   452,   453,   454,
     659,   861,   103,   457,   486,   256,   486,   467,   779,   472,
     346,   157,   219,   486,   486,   459,   201,   220,   905,   480,
     487,   483,   563,   210,   563,   882,   801,   804,   884,   156,
     195,   888,   889,   932,   502,   540,   221,   649,   346,   484,
     215,   650,   196,   222,   197,   485,   522,   908,   160,   909,
     223,   206,   207,   916,   917,   335,   509,   575,   338,   576,
     521,   513,   514,   515,   161,   486,   518,   767,   846,   771,
     846,   198,   180,   181,  -237,   527,   164,   333,   224,   334,
     532,   533,   839,   811,   812,   813,   305,   306,   240,   308,
     309,   310,   199,   939,   228,   216,   240,   240,   363,   225,
     543,   276,   165,   217,   218,   928,   166,   200,     1,     2,
     226,   167,   375,   817,   818,   819,    96,   211,   212,   227,
     559,   549,   562,   168,   487,   105,   107,   169,   622,   551,
     315,   316,   317,   318,   163,   170,   822,   213,   214,   825,
    -406,   506,   171,   172,   174,   511,   512,   230,   276,   261,
     276,   276,   570,    10,    12,   579,   599,   572,   601,   602,
    -286,   240,   615,   585,   586,   582,   701,   702,   313,   314,
    -433,   240,   322,   323,   594,   610,   324,   325,   665,   598,
     262,   265,   270,   272,   277,   669,   294,   295,   297,   296,
     298,   300,   299,   304,   603,    59,   303,   341,   349,   350,
     616,   351,   620,   352,   609,   623,   353,   240,   614,   354,
     355,   356,   358,   359,   263,   264,   636,   266,   360,   633,
     362,   634,   268,   269,   368,   384,   388,   183,   389,   271,
     642,   694,   390,   391,   219,   274,   275,   393,   394,   220,
     643,   395,   396,   661,   411,   397,   240,   689,   398,   399,
     400,   256,   402,   412,   413,   414,   455,   456,   221,   460,
     768,   461,   466,   475,   507,   222,   347,   346,   478,   503,
     479,   501,   223,   505,   516,   697,   731,   508,   517,   679,
     700,  -286,   703,   451,   451,   519,   520,   526,   528,   529,
     530,   531,   534,   694,   726,   451,   451,   539,   547,   661,
     224,   379,   503,   550,   554,   826,   555,   557,   577,   759,
     487,   740,   560,   564,   565,   742,   803,   505,   580,   806,
     566,   225,   578,   240,   571,   590,   343,   587,   268,   344,
     271,   345,   226,   276,   827,   591,   830,   592,   595,   833,
     834,   227,   596,   604,   605,   628,   774,   606,   635,   451,
     625,   240,   607,   624,   240,   240,   775,   629,   632,   639,
     647,   784,   654,   648,   651,   -27,   -36,   855,   658,   606,
    -155,   695,   666,  -158,   792,   219,   668,   795,  -154,   487,
     220,   670,   487,   713,   793,   487,   671,   797,   798,   875,
     876,   673,   878,   698,   880,   699,   712,   714,   717,   221,
     746,   729,   766,   730,   724,   725,   222,   732,   735,   733,
     736,   829,   737,   223,   751,   743,   752,   753,   451,   754,
     755,   451,   756,   451,   757,   451,   758,   900,   764,   780,
     842,   780,   794,   772,   773,   776,   451,   487,   785,   791,
     487,   224,   799,   764,   841,   824,   906,  -234,   907,   828,
     838,   844,   849,   852,   859,   864,   865,   870,   866,   867,
     868,   869,   225,   883,   871,   872,   873,   874,   881,   885,
     886,   780,   895,   226,   898,   901,   904,   617,   919,   920,
     923,   890,   227,   857,   927,   926,   945,   931,   943,   451,
     553,   936,   439,   937,   704,   894,   487,   750,   487,   896,
     790,   611,   899,   -16,   548,   440,   -16,   -16,   738,   447,
     924,   342,   -16,   552,   -16,   -16,   -16,   760,   -16,   -16,
     -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   761,   744,
     910,   763,   745,   879,   -16,   558,   -16,   451,   748,   307,
     -16,   240,   -16,   312,   -16,   319,   182,   569,   -16,   321,
     -16,   339,   660,   320,   -16,   409,   504,   458,     0,   723,
       0,   -16,   487,     0,   -16,     0,   -16,     0,     0,     0,
     -16,   -16,     0,     0,   935,   -16,   -16,   -16,   -16,   -16,
     -16,     0,     0,     0,     0,   -16,   -16,   -16,     0,     0,
       0,   -16,     0,     0,     0,     0,   -16,     0,     0,     0,
     -16,   -16,     0,   -16,     0,   -16,   -16,     0,   -16,     0,
     -16,   -16,     0,   -16,   -16,   -16,     0,     0,     0,     0,
     -16,   -16,     0,     0,   -16,   -16,   -16,   -16,   -16,   -16,
       0,     0,     0,     0,   -16,   -16,     0,   -16,   -16,   -16,
     -16,     0,   -16,   -16,     0,   -16,     0,     0,   -16,     0,
       0,     0,     0,     0,   -16,     0,     0,     0,     0,     0,
       0,     0,   -16,   -16,   -16,   -16,   -17,     0,   -16,   -17,
     -17,   -16,   -16,   -16,     0,   -17,     0,   -17,   -17,   -17,
       0,   -17,   -17,   -17,   -17,   -17,   -17,   -17,   -17,   -17,
     -17,     0,     0,     0,     0,     0,     0,   -17,     0,   -17,
       0,     0,     0,   -17,     0,   -17,     0,   -17,     0,     0,
       0,   -17,     0,   -17,     0,     0,     0,   -17,     0,     0,
       0,     0,     0,     0,   -17,     0,     0,   -17,     0,   -17,
       0,     0,     0,   -17,   -17,     0,     0,     0,   -17,   -17,
     -17,   -17,   -17,   -17,     0,     0,     0,     0,   -17,   -17,
     -17,     0,     0,     0,   -17,     0,     0,     0,     0,   -17,
       0,     0,     0,   -17,   -17,     0,   -17,     0,   -17,   -17,
       0,   -17,     0,   -17,   -17,     0,   -17,   -17,   -17,     0,
       0,     0,     0,   -17,   -17,     0,     0,   -17,   -17,   -17,
     -17,   -17,   -17,     0,     0,     0,     0,   -17,   -17,     0,
     -17,   -17,   -17,   -17,     0,   -17,   -17,     0,   -17,     0,
       0,   -17,     0,     0,     0,     0,     0,   -17,     0,     0,
       0,     0,     0,     0,     0,   -17,   -17,   -17,   -17,    10,
      12,   -17,     0,     0,   -17,   -17,   -17,    13,    14,    15,
       0,    16,    17,    18,    19,    20,    21,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,     0,     0,     0,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,    28,
      29,    30,    31,    32,     0,     0,     0,     0,    33,     0,
      34,     0,     0,     0,    35,     0,     0,     0,     0,    36,
       0,     0,     0,     0,    37,     0,    38,     0,    39,    40,
       0,     0,     0,     0,     0,     0,    41,     0,    42,     0,
       0,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,    44,    45,     0,     0,     0,     0,    46,     0,     0,
      47,    48,    49,    50,     0,    51,     0,     0,    52,     0,
       0,     0,     0,     0,     0,     0,     0,    53,     0,     0,
       0,     0,     0,     0,     0,    54,    55,    56,    57,    10,
      12,    58,     0,     0,    59,    60,    61,    13,    14,    15,
       0,    16,    17,    18,    19,     0,    21,    22,     0,     0,
       0,   109,     0,   110,     0,     0,   111,     0,   112,     0,
     113,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   114,     0,     0,   115,     0,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   680,   681,
     682,   683,   121,     0,   122,   123,     0,   124,    33,     0,
     125,     0,     0,     0,     0,     0,     0,     0,   126,     0,
     175,     0,     0,     0,   127,     0,     0,     0,     0,   128,
       0,     0,     0,     0,     0,   129,   130,     0,   131,     0,
       0,   132,     0,     0,   133,   134,   135,     0,     0,     0,
       0,   136,     0,     0,     0,     0,     0,   137,     0,     0,
     684,   685,   686,   687,   142,     0,     0,     0,   143,   144,
     145,     0,     0,     0,     0,     0,     0,   146,  -405,     0,
       0,     0,     0,    10,    12,     0,    55,     0,   147,     0,
       0,    13,    14,    15,    59,    16,    17,    18,    19,     0,
      21,    22,     0,     0,     0,   109,     0,   110,     0,     0,
     111,     0,   112,     0,   113,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   114,
       0,     0,   115,     0,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,   118,   119,   120,   121,     0,   122,   123,
       0,   124,    33,     0,   125,     0,     0,     0,     0,     0,
       0,     0,   126,     0,     0,     0,     0,     0,   127,     0,
       0,     0,     0,   128,     0,     0,     0,     0,     0,   129,
     130,     0,   131,     0,     0,   132,     0,     0,   133,   134,
     135,     0,     0,     0,     0,   136,     0,     0,     0,     0,
       0,   137,     0,     0,   138,   139,   140,   141,   142,     0,
       0,     0,   143,   144,   145,     0,     0,     0,     0,     0,
       0,   146,     0,     0,     0,     0,     0,    10,    12,     0,
      55,     0,   147,     0,     0,    13,    14,    15,    59,    16,
      17,    18,    19,     0,    21,    22,     0,     0,     0,   109,
       0,   110,     0,     0,   111,     0,   112,     0,   113,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   114,     0,     0,   115,     0,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   680,   681,   682,   683,
     121,     0,   122,   123,     0,   124,    33,     0,   125,     0,
       0,     0,     0,     0,     0,     0,   126,     0,     0,     0,
       0,     0,   127,     0,     0,     0,     0,   128,     0,     0,
       0,     0,     0,   129,   130,     0,   131,     0,     0,   132,
       0,     0,   133,   134,   135,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,   137,     0,     0,   684,   685,
     686,   687,   142,     0,     0,     0,   143,   144,   145,     0,
       0,     0,     0,     0,     0,   688,     0,     0,     0,     0,
       0,    10,    12,     0,    55,     0,   147,     0,     0,    13,
      14,    15,    59,    16,    17,    18,    19,    20,    21,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,     0,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    28,    29,    30,    31,    32,     0,     0,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     0,    37,     0,    38,     0,
       0,    40,     0,     0,     0,     0,     0,     0,    41,     0,
      42,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,    44,    45,     0,     0,     0,     0,    46,
       0,     0,    47,    48,    49,    50,     0,    51,    10,    12,
      52,     0,     0,     0,     0,     0,    13,    14,    15,    53,
      16,    17,    18,    19,    20,    21,    22,     0,    55,    56,
      57,     0,     0,     0,     0,     0,    59,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,    28,    29,
      30,    31,    32,     0,     0,     0,     0,    33,     0,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,     0,     0,     0,     0,    40,     0,
       0,     0,     0,     0,     0,    41,     0,    42,     0,     0,
       0,     0,     0,    43,     0,     0,    10,    12,     0,     0,
      44,    45,     0,     0,     0,     0,    46,     0,     0,    47,
      48,    49,    50,     0,     0,     0,     0,    52,   109,     0,
     110,     0,   232,   111,     0,   112,    53,   113,     0,     0,
       0,     0,   233,     0,     0,    55,    56,    57,     0,     0,
       0,     0,   114,    59,     0,   115,     0,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,   118,   119,   120,   121,
       0,   122,   123,     0,   124,     0,     0,   234,     0,     0,
       0,   416,   417,   418,     0,   126,     0,     0,     0,     0,
       0,   235,   419,     0,     0,     0,   128,     0,   -51,     0,
     420,     0,   129,   236,   421,   237,     0,     0,   132,     0,
      -6,   133,   134,   135,     0,     0,     0,   422,   136,   415,
       0,     0,     0,     0,   238,     0,   423,   138,   139,   140,
     141,   142,   416,   417,   418,   239,   144,   145,     0,     0,
       0,     0,   425,   419,     0,     0,     0,     0,     0,   -51,
       0,   420,   374,     0,     0,   421,     0,     0,     0,     0,
       0,     0,     0,     0,   427,     0,   428,   429,   422,     0,
     430,   -51,     0,   -51,     0,     0,   431,   423,   424,     0,
     432,   433,   434,   435,     0,     0,     0,     0,     0,     0,
       0,   -51,     0,   425,     0,     0,     0,     0,     0,   436,
       0,     0,     0,     0,   437,     0,     0,   426,     0,     0,
       0,     0,     0,     0,   -71,   427,     0,   428,   429,     0,
       0,   430,    10,    12,     0,     0,     0,   431,     0,     0,
       0,   432,   433,   434,   435,     0,     0,     0,     0,     0,
       0,     0,   -51,     0,   109,     0,   110,     0,   232,   111,
     436,   112,     0,   113,     0,   437,     0,     0,   233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   114,     0,
       0,   115,     0,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,   118,   119,   120,   121,     0,   122,   123,     0,
     124,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,   126,     0,     0,     0,     0,     0,   235,    10,    12,
       0,     0,   128,     0,     0,     0,     0,     0,   129,   236,
       0,   237,     0,     0,   132,     0,     0,   133,   134,   135,
     109,     0,   110,     0,   136,   111,     0,   112,     0,   113,
     238,     0,     0,   138,   139,   140,   141,   142,     0,     0,
       0,   239,   144,   145,   114,     0,     0,   115,     0,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   416,   417,   418,     0,     0,     0,   117,   118,   119,
     120,   121,   419,   122,   123,     0,   124,     0,   -51,   234,
     420,     0,     0,     0,   421,     0,     0,   126,     0,     0,
       0,     0,     0,   235,     0,     0,     0,   422,   128,     0,
       0,     0,     0,     0,   129,   236,   423,   237,     0,     0,
     132,     0,     0,   133,   134,   135,     0,     0,     0,     0,
     136,     0,   425,     0,     0,     0,   238,     0,     0,   138,
     139,   140,   141,   142,     0,     0,     0,   239,   144,   145,
       0,     0,     0,     0,   427,     0,   428,   429,     0,     0,
     430,     0,     0,   416,   417,   418,   431,     0,     0,     0,
     432,   433,   434,   435,   419,     0,     0,     0,     0,     0,
     -51,   -51,   420,     0,     0,     0,   421,     0,     0,   436,
       0,     0,     0,     0,   437,     0,     0,     0,     0,   422,
       0,     0,     0,     0,   -70,     0,     0,     0,   423,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   427,     0,   428,   429,
       0,     0,   430,     0,     0,     0,     0,     0,   431,     0,
       0,     0,   432,   433,   434,   435,     0,   109,     0,   110,
       0,     0,   111,   -51,   112,     0,   113,     0,     0,     0,
       0,   436,     0,     0,     0,     0,   437,     0,     0,     0,
       0,   114,     0,     0,   115,   704,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   118,   119,   120,   121,     0,
     122,   123,     0,   124,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,   126,     0,     0,     0,     0,     0,
     235,     0,     0,     0,     0,   128,     0,     0,     0,     0,
       0,   129,   236,     0,   237,     0,     0,   132,     0,     0,
     133,   134,   135,     0,     0,     0,     0,   136,     0,     0,
       0,     0,     0,   238,     0,     0,   138,   139,   140,   141,
     142,     0,     0,     0,   239,   144,   145
  };

  const short
  Parser::yycheck_[] =
  {
       4,    36,   523,    36,   340,   104,   587,     2,    38,   296,
     488,   645,   255,   554,   743,     3,     7,    36,     8,     9,
      18,    35,   711,   624,    48,    39,    36,    28,    28,     3,
      90,    28,     3,     8,    44,     8,    67,   558,    18,   282,
      54,     8,     9,     8,    58,     3,    60,    61,   291,    36,
     293,    94,    60,     8,     8,   639,    39,    44,    53,     8,
       8,     8,    57,   162,     3,   456,   650,   651,   167,    59,
     151,     8,     8,   131,   173,   676,     8,    96,     8,     8,
       0,   162,     8,    94,    53,   626,   105,     8,   107,   759,
     760,   761,    59,   151,    67,   151,    70,   150,   148,    94,
     153,   157,    97,    98,    99,   100,   101,   102,   103,   152,
      96,   106,   503,   153,   505,   156,   106,   158,   158,   105,
      67,   107,    91,   366,   367,   149,   225,   370,   371,   372,
      67,   374,   163,   148,   377,    67,     8,   152,    67,   106,
     148,   152,   385,   386,   163,   155,    67,   688,   837,   132,
     121,   146,   822,   172,   155,   174,   153,     3,   159,   159,
     118,   156,   160,     9,   154,   160,   161,   155,   155,   164,
     165,   166,   163,   168,   169,   170,   171,   163,   277,   154,
     160,   161,    36,   148,   151,   786,   172,   154,   174,   773,
      44,     8,   776,   148,   148,    67,   780,   926,   168,   148,
     148,   215,   216,   217,   218,   200,   148,   791,   151,   151,
     453,   454,   148,   794,   233,   219,   459,   157,   148,   506,
     224,    67,   148,   227,   801,   166,     3,   804,     3,   153,
     149,   226,     9,   529,     9,     3,     3,   156,   534,   163,
      39,     9,     9,   153,   263,   264,   156,   266,   267,   268,
     269,    97,   271,   148,   149,   274,   275,   153,   262,   155,
     844,   156,    61,   149,    63,   908,   909,   271,   746,   115,
     156,   749,   149,   916,   917,   121,   151,   263,   264,   156,
     266,   267,   268,   269,   148,   886,   150,     3,   274,   275,
      67,   151,    67,     9,   298,   141,   939,   157,   151,    67,
      67,   296,   297,   148,   149,   300,   549,   941,   892,   155,
     151,   156,   151,   151,   151,   414,    62,   151,   157,   157,
      97,   151,    97,   157,   343,   344,   345,   157,   427,    97,
      97,   148,   149,   132,    80,   152,   153,   154,   115,   156,
     115,   158,   361,   151,   121,   340,   121,   115,   115,    46,
     151,    67,   165,   121,   121,   151,   157,   343,   344,   345,
     603,   803,   151,   358,   141,   360,   141,   153,   704,   373,
     156,   401,    64,   141,   141,   361,    26,    69,   155,   383,
     384,    97,   860,   156,   862,   827,   154,   154,   830,   151,
      87,   833,   834,   914,   389,   153,    88,   148,   156,   115,
     104,   152,    99,    95,   101,   121,   425,   882,   151,   884,
     102,   157,   158,   888,   889,   224,   411,   148,   227,   150,
     424,   416,   417,   418,   151,   141,   421,   691,   788,   693,
     790,   128,    17,    18,   150,   430,   151,   220,   130,   222,
     435,   436,   778,   752,   753,   754,   194,   195,   467,   197,
     198,   199,   149,   928,   165,   159,   475,   476,   462,   151,
     455,   456,   151,   167,   168,   907,   151,   164,   146,   147,
     162,   151,   476,   756,   757,   758,    24,   113,   114,   171,
     484,   467,   486,   151,   488,    33,    34,   151,   559,   475,
     204,   205,   206,   207,    42,   151,   760,   160,   161,   763,
     152,   153,   151,    51,    52,   148,   149,    18,   503,   151,
     505,   506,   507,     3,     4,   519,   535,   512,   537,   538,
     152,   540,   555,   149,   150,   520,   149,   150,   202,   203,
     152,   550,   211,   212,   529,   554,   213,   214,   609,   534,
     154,   151,   154,   151,   151,   616,   152,   152,   149,   153,
      58,   153,   163,    14,   540,   168,   165,   152,   152,   152,
     555,   152,   557,   152,   550,   560,   152,   586,   554,   152,
     152,   152,   150,   152,   122,   123,   580,   125,   153,   574,
      18,   576,   130,   131,    11,   154,   152,     7,   153,   137,
     585,   626,   152,   152,    64,   143,   144,   152,   152,    69,
     586,   152,   152,   607,   150,   152,   625,   626,   152,   152,
     152,   606,   152,   152,   163,   151,   151,   151,    88,   152,
     691,   149,   152,   150,    69,    95,   158,   156,   152,   151,
     153,   152,   102,   151,   148,   630,   655,   168,   148,   625,
     635,   148,   637,   638,   639,   151,   151,   148,   148,   151,
     148,   148,   151,   688,   649,   650,   651,   148,    18,   663,
     130,    70,   151,   150,   150,   764,   149,   151,   148,   688,
     674,   666,   151,   155,   150,   670,   747,   151,    83,   750,
     152,   151,   148,   702,   152,     6,   234,   151,   236,   237,
     238,   239,   162,   688,   765,   148,   767,   148,   148,   770,
     771,   171,   148,   152,   152,   152,   701,   151,    69,   704,
     150,   730,   154,   154,   733,   734,   702,   152,   148,   152,
     152,   716,    11,   152,   152,   150,   150,   798,   149,   151,
     156,   116,   149,   156,   729,    64,   148,   732,   156,   743,
      69,   149,   746,     5,   730,   749,   152,   733,   734,   820,
     821,   152,   823,   148,   825,   148,   148,   148,   152,    88,
      28,   149,   162,   150,   154,   154,    95,   149,   152,   150,
     150,   766,   155,   102,   151,   154,   151,   151,   773,   151,
     151,   776,   151,   778,   151,   780,   151,   858,   151,    50,
     785,    50,   151,   163,   152,   152,   791,   801,   149,   152,
     804,   130,    18,   151,   148,   152,   877,   162,   879,   163,
     155,   150,   148,   148,   155,    18,    18,    18,   152,   152,
     152,   152,   151,   163,   152,   152,   152,   152,   152,   151,
      28,    50,   152,   162,    18,    50,   148,     8,   148,   150,
     148,   836,   171,   149,   148,   154,   148,   152,   155,   844,
     479,   922,   340,   924,   154,   850,   860,   679,   862,   854,
     725,   554,   857,     0,   462,   340,     3,     4,   663,   340,
     898,   233,     9,   476,    11,    12,    13,   688,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,   688,   674,
     885,   688,   674,   824,    31,   483,    33,   892,   676,   196,
      37,   920,    39,   201,    41,   208,    56,   506,    45,   210,
      47,   228,   606,   209,    51,   301,   401,   360,    -1,   645,
      -1,    58,   926,    -1,    61,    -1,    63,    -1,    -1,    -1,
      67,    68,    -1,    -1,   920,    72,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    -1,   100,    -1,   102,   103,    -1,   105,    -1,
     107,   108,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
     117,   118,    -1,    -1,   121,   122,   123,   124,   125,   126,
      -1,    -1,    -1,    -1,   131,   132,    -1,   134,   135,   136,
     137,    -1,   139,   140,    -1,   142,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,   161,   162,     0,    -1,   165,     3,
       4,   168,   169,   170,    -1,     9,    -1,    11,    12,    13,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,
      -1,    -1,    -1,    37,    -1,    39,    -1,    41,    -1,    -1,
      -1,    45,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    61,    -1,    63,
      -1,    -1,    -1,    67,    68,    -1,    -1,    -1,    72,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    82,    83,
      84,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    97,    98,    -1,   100,    -1,   102,   103,
      -1,   105,    -1,   107,   108,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,   117,   118,    -1,    -1,   121,   122,   123,
     124,   125,   126,    -1,    -1,    -1,    -1,   131,   132,    -1,
     134,   135,   136,   137,    -1,   139,   140,    -1,   142,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,   160,   161,   162,     3,
       4,   165,    -1,    -1,   168,   169,   170,    11,    12,    13,
      -1,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    82,    -1,
      84,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,   100,    -1,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,   112,    -1,
      -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,   125,   126,    -1,    -1,    -1,    -1,   131,    -1,    -1,
     134,   135,   136,   137,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,   160,   161,   162,     3,
       4,   165,    -1,    -1,   168,   169,   170,    11,    12,    13,
      -1,    15,    16,    17,    18,    -1,    20,    21,    -1,    -1,
      -1,    25,    -1,    27,    -1,    -1,    30,    -1,    32,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    76,    -1,    78,    79,    -1,    81,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,   103,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,    -1,
      -1,   115,    -1,    -1,   118,   119,   120,    -1,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
     134,   135,   136,   137,   138,    -1,    -1,    -1,   142,   143,
     144,    -1,    -1,    -1,    -1,    -1,    -1,   151,   152,    -1,
      -1,    -1,    -1,     3,     4,    -1,   160,    -1,   162,    -1,
      -1,    11,    12,    13,   168,    15,    16,    17,    18,    -1,
      20,    21,    -1,    -1,    -1,    25,    -1,    27,    -1,    -1,
      30,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    73,    74,    75,    76,    -1,    78,    79,
      -1,    81,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,    -1,    -1,   115,    -1,    -1,   118,   119,
     120,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,   135,   136,   137,   138,    -1,
      -1,    -1,   142,   143,   144,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
     160,    -1,   162,    -1,    -1,    11,    12,    13,   168,    15,
      16,    17,    18,    -1,    20,    21,    -1,    -1,    -1,    25,
      -1,    27,    -1,    -1,    30,    -1,    32,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      76,    -1,    78,    79,    -1,    81,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,    -1,    -1,    -1,    -1,   125,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,   134,   135,
     136,   137,   138,    -1,    -1,    -1,   142,   143,   144,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,     3,     4,    -1,   160,    -1,   162,    -1,    -1,    11,
      12,    13,   168,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    76,    77,    -1,    -1,    -1,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,
     112,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,   125,   126,    -1,    -1,    -1,    -1,   131,
      -1,    -1,   134,   135,   136,   137,    -1,   139,     3,     4,
     142,    -1,    -1,    -1,    -1,    -1,    11,    12,    13,   151,
      15,    16,    17,    18,    19,    20,    21,    -1,   160,   161,
     162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    -1,    82,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,    -1,   110,    -1,   112,    -1,    -1,
      -1,    -1,    -1,   118,    -1,    -1,     3,     4,    -1,    -1,
     125,   126,    -1,    -1,    -1,    -1,   131,    -1,    -1,   134,
     135,   136,   137,    -1,    -1,    -1,    -1,   142,    25,    -1,
      27,    -1,    29,    30,    -1,    32,   151,    34,    -1,    -1,
      -1,    -1,    39,    -1,    -1,   160,   161,   162,    -1,    -1,
      -1,    -1,    49,   168,    -1,    52,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    76,
      -1,    78,    79,    -1,    81,    -1,    -1,    84,    -1,    -1,
      -1,    22,    23,    24,    -1,    92,    -1,    -1,    -1,    -1,
      -1,    98,    33,    -1,    -1,    -1,   103,    -1,    39,    -1,
      41,    -1,   109,   110,    45,   112,    -1,    -1,   115,    -1,
       0,   118,   119,   120,    -1,    -1,    -1,    58,   125,     9,
      -1,    -1,    -1,    -1,   131,    -1,    67,   134,   135,   136,
     137,   138,    22,    23,    24,   142,   143,   144,    -1,    -1,
      -1,    -1,    83,    33,    -1,    -1,    -1,    -1,    -1,    39,
      -1,    41,   159,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,   107,   108,    58,    -1,
     111,    61,    -1,    63,    -1,    -1,   117,    67,    68,    -1,
     121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,    -1,    83,    -1,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,   145,    -1,    -1,    97,    -1,    -1,
      -1,    -1,    -1,    -1,   155,   105,    -1,   107,   108,    -1,
      -1,   111,     3,     4,    -1,    -1,    -1,   117,    -1,    -1,
      -1,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,    25,    -1,    27,    -1,    29,    30,
     140,    32,    -1,    34,    -1,   145,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    52,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    73,    74,    75,    76,    -1,    78,    79,    -1,
      81,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,    -1,    -1,    98,     3,     4,
      -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,    -1,    -1,   115,    -1,    -1,   118,   119,   120,
      25,    -1,    27,    -1,   125,    30,    -1,    32,    -1,    34,
     131,    -1,    -1,   134,   135,   136,   137,   138,    -1,    -1,
      -1,   142,   143,   144,    49,    -1,    -1,    52,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    -1,    -1,    -1,    72,    73,    74,
      75,    76,    33,    78,    79,    -1,    81,    -1,    39,    84,
      41,    -1,    -1,    -1,    45,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    58,   103,    -1,
      -1,    -1,    -1,    -1,   109,   110,    67,   112,    -1,    -1,
     115,    -1,    -1,   118,   119,   120,    -1,    -1,    -1,    -1,
     125,    -1,    83,    -1,    -1,    -1,   131,    -1,    -1,   134,
     135,   136,   137,   138,    -1,    -1,    -1,   142,   143,   144,
      -1,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,    -1,
     111,    -1,    -1,    22,    23,    24,   117,    -1,    -1,    -1,
     121,   122,   123,   124,    33,    -1,    -1,    -1,    -1,    -1,
      39,   132,    41,    -1,    -1,    -1,    45,    -1,    -1,   140,
      -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,   121,   122,   123,   124,    -1,    25,    -1,    27,
      -1,    -1,    30,   132,    32,    -1,    34,    -1,    -1,    -1,
      -1,   140,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,   154,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    73,    74,    75,    76,    -1,
      78,    79,    -1,    81,    -1,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,    -1,    -1,   115,    -1,    -1,
     118,   119,   120,    -1,    -1,    -1,    -1,   125,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,   134,   135,   136,   137,
     138,    -1,    -1,    -1,   142,   143,   144
  };

  const short
  Parser::yystos_[] =
  {
       0,   146,   147,   173,    90,   175,   174,   284,   285,     0,
       3,   177,     4,    11,    12,    13,    15,    16,    17,    18,
      19,    20,    21,    31,    37,    47,    51,    72,    73,    74,
      75,    76,    77,    82,    84,    88,    93,    98,   100,   102,
     103,   110,   112,   118,   125,   126,   131,   134,   135,   136,
     137,   139,   142,   151,   159,   160,   161,   162,   165,   168,
     169,   170,   177,   178,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   307,   308,   309,   314,   315,   316,   317,   318,   321,
     322,   323,   148,   168,   151,   157,   227,   151,   151,   151,
     151,   151,   151,   151,   151,   227,   151,   227,   301,    25,
      27,    30,    32,    34,    49,    52,    54,    72,    73,    74,
      75,    76,    78,    79,    81,    84,    92,    98,   103,   109,
     110,   112,   115,   118,   119,   120,   125,   131,   134,   135,
     136,   137,   138,   142,   143,   144,   151,   162,   178,   221,
     229,   232,   235,   238,   244,   307,   151,   309,   313,   301,
     151,   151,   151,   227,   151,   151,   151,   151,   151,   151,
     151,   151,   227,   151,   227,    94,   284,   310,   312,   301,
      17,    18,   304,     7,   284,   287,   288,   319,   320,   301,
     324,   301,   301,   286,    46,    87,    99,   101,   128,   149,
     164,    26,    53,    91,    62,    80,   157,   158,   165,   166,
     156,   113,   114,   160,   161,   104,   159,   167,   168,    64,
      69,    88,    95,   102,   130,   151,   162,   171,   165,   176,
      18,   284,    29,    39,    84,    98,   110,   112,   131,   142,
     178,   221,   222,   223,   225,   226,   284,   284,   284,   284,
     284,   284,   284,   284,   287,   226,   284,   326,   327,   328,
     226,   151,   154,   227,   227,   151,   227,   227,   227,   227,
     154,   227,   151,   245,   227,   227,   284,   151,   284,   284,
     284,   287,   226,   284,   284,   284,   287,   284,   284,   284,
     284,   226,   287,   226,   152,   152,   153,   149,    58,   163,
     153,   153,   163,   165,    14,   290,   290,   292,   290,   290,
     290,   284,   293,   294,   294,   295,   295,   295,   295,   296,
     297,   298,   299,   299,   300,   300,   301,   301,   301,   301,
     118,   177,   306,   302,   302,   306,   287,   284,   306,   323,
     182,   152,   225,   227,   227,   227,   156,   158,   228,   152,
     152,   152,   152,   152,   152,   152,   152,   228,   150,   152,
     153,   153,    18,   177,   236,   237,   226,   226,    11,   226,
     226,   226,   226,   233,   159,   177,   226,   230,   231,    70,
     204,   205,   206,   209,   154,   226,   226,   287,   152,   153,
     152,   152,   228,   152,   152,   152,   152,   152,   152,   152,
     152,   228,   152,   228,   311,   312,   284,   177,   284,   320,
     325,   150,   152,   163,   151,     9,    22,    23,    24,    33,
      41,    45,    58,    67,    68,    83,    97,   105,   107,   108,
     111,   117,   121,   122,   123,   124,   140,   145,   183,   184,
     186,   189,   191,   195,   198,   199,   200,   201,   215,   219,
     220,   284,   226,   226,   226,   151,   151,   284,   328,   226,
     152,   149,   153,   155,   228,   228,   152,   153,   228,   228,
     228,   155,   177,   234,   228,   150,   153,   228,   152,   153,
     177,     9,    67,    97,   115,   121,   141,   177,   246,   247,
     248,   249,   250,   251,   253,   259,   260,   278,   283,   228,
     228,   152,   284,   151,   313,   151,   153,    69,   168,   284,
     287,   148,   149,   284,   284,   284,   148,   148,   284,   151,
     151,   177,   178,   274,   275,   287,   148,   284,   148,   151,
     148,   148,   284,   284,   151,    39,    61,    63,   132,   148,
     153,   228,   228,   284,   310,   228,   239,    18,   237,   226,
     150,   226,   231,   206,   150,   149,   330,   151,   274,   177,
     151,   279,   177,   248,   155,   150,   152,   310,   310,   311,
     284,   152,   284,   148,   150,   148,   150,   148,   148,   177,
      83,   190,   284,    60,   148,   149,   150,   151,   271,   272,
       6,   148,   148,   190,   284,   148,   148,   190,   284,   178,
     202,   178,   178,   226,   152,   152,   151,   154,   228,   226,
     178,   222,   223,   224,   226,   221,   284,     8,   148,   329,
     284,   271,   330,   284,   154,   150,   261,   262,   152,   152,
      67,   163,   148,   284,   284,    69,   177,   148,   152,   152,
     179,   180,   284,   226,   204,   273,   276,   152,   152,   148,
     152,   152,   187,   188,    11,   203,   192,   193,   149,   228,
     326,   177,   240,   241,   242,   330,   149,   210,   148,   330,
     149,   152,   148,   152,    28,   159,   280,   281,   288,   226,
      72,    73,    74,    75,   134,   135,   136,   137,   151,   178,
     223,   252,   256,   258,   307,   116,   263,   284,   148,   148,
     284,   149,   150,   284,   154,   184,   186,   201,   211,   212,
     215,   211,   148,     5,   148,   148,   149,   152,     9,    59,
     106,   212,   277,   329,   154,   154,   284,   211,   211,   149,
     150,   178,   149,   150,   185,   152,   150,   155,   242,   148,
     284,   148,   284,   154,   253,   278,    28,   155,   281,    28,
     210,   151,   151,   151,   151,   151,   151,   151,   151,   178,
     252,   256,   257,   258,   151,   264,   162,   265,   330,   265,
     266,   265,   163,   152,   284,   226,   152,   213,   214,   215,
      50,   216,   216,   181,   284,   149,    36,    44,   217,   218,
     217,   152,   284,   226,   151,   284,   194,   226,   226,    18,
     247,   154,   248,   330,   154,   248,   330,    18,   160,   161,
     254,   254,   254,   254,    18,   160,   255,   255,   255,   255,
     264,   264,   265,   264,   152,   265,   287,   330,   163,   284,
     330,    67,   267,   330,   330,   211,   149,   211,   155,   215,
     211,   148,   284,   288,   150,   155,   218,   155,   211,   148,
     149,   204,   148,   148,   149,   330,    48,   149,   243,   155,
     246,   267,   246,   148,    18,    18,   152,   152,   152,   152,
      18,   152,   152,   152,   152,   330,   330,   264,   330,   266,
     330,   152,   267,   163,   267,   151,    28,   268,   267,   267,
     284,   216,   150,   211,   284,   152,   284,   148,    18,   284,
     330,    50,   282,   155,   148,   155,   330,   330,   268,   268,
     284,   288,   148,   269,   270,   271,   268,   268,   211,   148,
     150,   207,   208,   148,   243,   148,   154,   148,   267,   269,
     269,   152,   271,   269,   269,   226,   330,   330,   247,   268,
     196,   197,   148,   155,   269,   148,   212
  };

  const short
  Parser::yyr1_[] =
  {
       0,   172,   173,   173,   174,   176,   175,   177,   178,   178,
     180,   181,   179,   182,   182,   182,   183,   183,   183,   183,
     183,   183,   183,   185,   184,   187,   186,   188,   186,   189,
     189,   189,   190,   190,   192,   191,   193,   191,   194,   194,
     196,   195,   197,   195,   198,   198,   199,   199,   200,   201,
     201,   201,   202,   203,   203,   204,   204,   205,   205,   206,
     207,   208,   208,   209,   209,   210,   210,   211,   211,   212,
     213,   213,   214,   214,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   216,   216,   217,   217,   218,   218,   219,   219,   219,
     220,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   222,   223,
     222,   224,   224,   224,   225,   225,   226,   226,   226,   226,
     227,   228,   229,   229,   230,   230,   230,   231,   231,   232,
     233,   233,   234,   235,   236,   236,   236,   237,   237,   239,
     238,   240,   240,   241,   241,   242,   242,   243,   243,   244,
     245,   245,   246,   246,   247,   247,   248,   248,   248,   248,
     248,   248,   248,   249,   250,   251,   251,   251,   252,   253,
     253,   253,   253,   253,   253,   254,   254,   254,   255,   255,
     256,   256,   256,   256,   256,   256,   256,   256,   256,   257,
     257,   257,   257,   257,   258,   259,   260,   260,   262,   261,
     263,   263,   264,   264,   265,   265,   266,   266,   267,   267,
     268,   268,   269,   269,   270,   270,   271,   272,   272,   273,
     273,   275,   276,   274,   277,   277,   277,   277,   278,   279,
     279,   280,   280,   281,   281,   281,   281,   281,   281,   282,
     282,   283,   285,   286,   284,   287,   287,   288,   288,   289,
     290,   290,   290,   290,   290,   290,   290,   291,   291,   292,
     292,   293,   293,   293,   294,   294,   294,   294,   294,   295,
     295,   296,   296,   297,   297,   298,   298,   298,   299,   299,
     299,   300,   300,   300,   300,   300,   301,   301,   301,   301,
     301,   301,   301,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   304,   304,   304,   304,   304,   304,
     305,   305,   305,   305,   306,   306,   307,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   308,   308,   308,
     308,   308,   308,   308,   308,   308,   308,   308,   308,   308,
     308,   309,   309,   310,   310,   310,   311,   311,   311,   311,
     312,   312,   313,   314,   314,   314,   315,   315,   316,   316,
     317,   317,   318,   319,   319,   320,   321,   322,   322,   324,
     325,   323,   326,   326,   327,   327,   328,   329,   329,   330,
     330
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     2,     2,     1,     0,     5,     1,     1,     1,
       0,     0,     3,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     0,     8,     0,     7,     0,     9,     5,
       5,     7,     6,     4,     0,     7,     0,     6,     2,     4,
       0,    12,     0,    12,     3,     5,     2,     4,     3,     1,
       1,     0,     0,     1,     0,     1,     0,     3,     1,     5,
       2,     1,     0,     1,     0,     2,     0,     1,     1,     3,
       1,     0,     2,     1,     2,     1,     3,     5,     3,     5,
       2,     2,     7,     6,     6,     8,     3,     2,     3,     2,
       3,     7,     7,     2,     2,     7,     5,     5,     3,     3,
       3,     2,     0,     2,     1,     4,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     4,     6,     4,
       4,     1,     4,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     4,     4,     3,     2,     1,     1,     3,     4,
       2,     0,     5,     4,     3,     2,     1,     1,     3,     0,
       8,     1,     0,     2,     1,     8,     6,     2,     0,     5,
       3,     0,     2,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     7,     4,     3,     5,     4,     1,     8,
       9,     9,     9,     9,    11,     1,     2,     2,     1,     2,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     3,
       3,     3,     3,     4,     2,     3,     1,     0,     0,     2,
       1,     0,     3,     0,     3,     2,     1,     0,     4,     0,
       2,     0,     1,     1,     2,     1,     3,     3,     0,     2,
       0,     0,     0,     3,     1,     3,     1,     1,     8,     3,
       0,     2,     1,     5,     5,     3,     3,     2,     2,     4,
       0,     9,     0,     0,     3,     1,     0,     3,     1,     1,
       3,     3,     3,     3,     3,     5,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     2,     2,     2,     3,
       2,     2,     1,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     1,     7,     2,     5,     4,     4,     2,
       2,     2,     5,     1,     1,     1,     2,     7,     9,     1,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       6,     3,     4,     1,     3,     0,     1,     3,     1,     0,
       1,     1,     1,     3,     4,     7,     4,     7,     4,     7,
       4,     9,     3,     3,     1,     3,     1,     3,     1,     0,
       0,     5,     1,     0,     3,     1,     3,     1,     3,     2,
       0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"dotted identifier\"", "\"hook identifier\"",
  "\"$-identifier\"", "\"attribute\"", "\"property\"",
  "\"preprocessor directive\"", "\"string value\"", "\"bytes value\"",
  "\"error value\"", "\"regular expression value\"", "\"address value\"",
  "\"port value\"", "\"real value\"", "\"unsigned integer value\"",
  "\"$<N>\"", "\"bool value\"", "\"null value\"", "\"assert\"",
  "\"assert-exception\"", "ADD", "ADDRESS", "AND", "ANY", "ARROW", "AUTO",
  "BITFIELD", "BEGIN_", "BOOL", "BREAK", "BYTES", "CADDR", "CASE", "CAST",
  "CATCH", "CONST", "CONSTANT", "CONTINUE", "DEBUG_", "DECLARE", "DEFAULT",
  "DELETE", "DIVIDEASSIGN", "DOLLARDOLLAR", "DOTDOT", "REAL", "ELSE",
  "END_", "ENUM", "EQ", "__ERROR", "EXCEPTION", "EXPORT", "FILE", "FOR",
  "FOREACH", "FROM", "FUNCTION", "GEQ", "GLOBAL", "HASATTR",
  "HOOK_COMPOSE", "HOOK_PARSE", "IF", "IMPORT", "IN", "INOUT", "INT",
  "INT16", "INT32", "INT64", "INT8", "INTERVAL", "INTERVAL_NS", "ITERATOR",
  "CONST_ITERATOR", "LEQ", "\"library type\"", "LIST", "LOCAL", "MAP",
  "MARK", "CAPTURES", "MINUSASSIGN", "MINUSMINUS", "MOD", "MODULE", "NEQ",
  "NETWORK", "NEW", "NONE", "NOT_IN", "OBJECT", "ON", "OPTIONAL", "OR",
  "PACK", "PLUSASSIGN", "PLUSPLUS", "PORT", "POW", "PRINT", "PRIORITY",
  "PRIVATE", "PUBLIC", "REGEXP", "RESULT", "RETURN", "SET", "SHIFTLEFT",
  "SHIFTRIGHT", "SINK", "SKIP", "STOP", "\"stream\"", "STRING", "STRUCT",
  "SWITCH", "\"confirm\"", "\"reject\"", "THROW", "TIME", "TIME_NS",
  "TIMER", "TIMESASSIGN", "TRY", "TRYATTR", "TUPLE", "TYPE", "UINT",
  "UINT16", "UINT32", "UINT64", "UINT8", "UNIT", "UNPACK", "UNSET", "VAR",
  "VECTOR", "VIEW", "VOID", "WHILE", "START_MODULE", "START_EXPRESSION",
  "';'", "'='", "':'", "'('", "')'", "','", "'{'", "'}'", "'&'", "'<'",
  "'>'", "'*'", "'+'", "'-'", "'['", "']'", "'?'", "'|'", "'^'", "'%'",
  "'/'", "'!'", "'~'", "'.'", "$accept", "start", "start_expr", "module",
  "$@1", "local_id", "scoped_id", "dotted_id", "$@2", "$@3",
  "global_scope_items", "global_scope_decl", "type_decl", "$@4",
  "constant_decl", "$@5", "$@6", "local_decl", "local_init_decl",
  "global_decl", "$@7", "$@8", "global_decl_type_and_init",
  "function_decl", "$@9", "$@10", "import_decl", "property_decl",
  "hook_decl", "opt_linkage", "opt_func_flavor", "opt_func_cc",
  "opt_func_params", "func_params", "func_param", "func_result",
  "opt_func_result", "opt_func_param_kind", "opt_init_expression", "block",
  "braced_block", "opt_stmts", "stmts", "stmt", "opt_else_block",
  "switch_cases", "switch_case", "stmt_decl", "stmt_expr",
  "base_type_no_ref", "reference_type", "base_type", "type", "type_no_ref",
  "qtype", "type_param_begin", "type_param_end", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type", "struct_fields",
  "struct_field", "enum_type", "enum_labels", "enum_label",
  "bitfield_type", "$@11", "opt_bitfield_bit_ranges",
  "bitfield_bit_ranges", "bitfield_bit_range", "opt_bitfield_range_value",
  "unit_type", "opt_unit_params", "unit_items", "opt_unit_items",
  "unit_item", "unit_variable", "unit_sink", "unit_property",
  "unit_field_base_type", "unit_field", "const_sint", "const_uint",
  "unit_field_ctor", "unit_field_in_container", "scoped_id_in_container",
  "unit_wide_hook", "opt_unit_field_id", "opt_skip", "$@12", "opt_skip_",
  "opt_unit_field_args", "unit_field_repeat", "opt_unit_field_repeat",
  "opt_unit_field_condition", "opt_unit_field_sinks",
  "opt_unit_item_hooks", "unit_hooks", "unit_hook", "opt_unit_hook_params",
  "opt_unit_hook_attributes", "unit_hook_id", "$@13", "$@14",
  "unit_hook_attribute", "unit_switch", "opt_unit_switch_expr",
  "unit_switch_cases", "unit_switch_case", "opt_unit_block_else_items",
  "unit_block", "expr", "$@15", "$@16", "opt_exprs", "exprs", "expr_0",
  "expr_1", "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7",
  "expr_8", "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e",
  "expr_f", "expr_g", "member_expr", "ctor", "ctor_expr", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "tuple_expr",
  "list", "vector", "set", "map", "struct_", "struct_elems", "struct_elem",
  "regexp", "re_patterns", "re_pattern_constant", "$@17", "$@18",
  "opt_map_elems", "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   327,   327,   328,   331,   333,   333,   343,   355,   356,
     358,   360,   358,   365,   367,   369,   373,   374,   375,   376,
     377,   378,   379,   381,   381,   399,   399,   405,   405,   412,
     413,   414,   419,   421,   425,   425,   431,   431,   439,   440,
     443,   442,   453,   452,   463,   464,   467,   468,   471,   479,
     480,   481,   485,   487,   493,   497,   498,   500,   501,   503,
     506,   508,   509,   512,   513,   516,   517,   522,   523,   526,
     528,   529,   531,   532,   534,   535,   536,   537,   538,   539,
     541,   542,   543,   545,   547,   549,   551,   552,   553,   554,
     555,   556,   558,   560,   561,   562,   564,   566,   569,   577,
     585,   596,   597,   599,   600,   602,   603,   605,   606,   607,
     610,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   630,   631,   632,   633,   634,
     635,   636,   637,   639,   640,   641,   642,   643,   645,   646,
     647,   649,   651,   653,   654,   655,   656,   657,   662,   667,
     668,   674,   675,   676,   679,   680,   683,   684,   685,   686,
     690,   694,   697,   698,   702,   704,   705,   709,   710,   713,
     715,   716,   718,   720,   722,   723,   724,   727,   728,   732,
     731,   737,   739,   742,   744,   747,   749,   753,   754,   760,
     764,   765,   767,   768,   770,   771,   774,   775,   776,   777,
     778,   779,   780,   784,   787,   789,   790,   792,   794,   799,
     801,   806,   809,   811,   813,   816,   817,   818,   820,   821,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   835,
     837,   839,   841,   843,   849,   851,   854,   855,   858,   858,
     863,   864,   867,   868,   871,   872,   875,   876,   879,   880,
     883,   884,   887,   888,   890,   891,   893,   897,   898,   901,
     903,   905,   907,   905,   910,   911,   912,   913,   915,   918,
     919,   922,   924,   927,   928,   929,   930,   931,   932,   935,
     936,   938,   946,   948,   946,   952,   953,   955,   956,   958,
     961,   962,   963,   964,   965,   966,   967,   969,   970,   972,
     973,   975,   976,   977,   979,   980,   981,   982,   983,   985,
     986,   988,   989,   991,   992,   994,   995,   996,   998,   999,
    1000,  1002,  1003,  1004,  1005,  1006,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1039,  1040,  1041,  1042,  1044,  1046,
    1048,  1049,  1050,  1051,  1057,  1058,  1062,  1063,  1064,  1065,
    1066,  1067,  1068,  1069,  1070,  1071,  1076,  1077,  1082,  1083,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1110,  1111,  1114,  1115,  1116,  1119,  1120,  1121,  1122,
    1125,  1126,  1128,  1130,  1131,  1132,  1135,  1136,  1139,  1140,
    1143,  1144,  1147,  1150,  1151,  1153,  1155,  1157,  1159,  1162,
    1162,  1162,  1165,  1166,  1168,  1169,  1171,  1175,  1176,  1179,
    1180
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   169,     2,     2,     2,   167,   156,     2,
     151,   152,   159,   160,   153,   161,   171,   168,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   150,   148,
     157,   149,   158,   164,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   162,     2,   163,   166,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   154,   165,   155,   170,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147
    };
    // Last valid token kind.
    const int code_max = 402;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 29 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
} } } // spicy::detail::parser
#line 7025 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

#line 1182 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"


void spicy::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
