{ OP_VECTOR_ELEM_ASSIGN_VVV,
	{
	"VVV",
	"",
	"EvalVectorElemAssign(frame[z.v1], frame[z.v2],, copy_vec_elem(vv, ind, frame[z.v3], Z_TYPE))\n"	}
},
{ OP_ANY_VECTOR_ELEM_ASSIGN_VVV,
	{
	"VVV",
	"",
	"auto ind = frame[z.v2].AsCount();\n	auto vv = frame[z.v1].AsVector();\n	auto yt = vv->RawYieldTypes();\n	if ( ind < vv->Size() && yt && (*yt)[ind] && ZVal::IsManagedType((*yt)[ind]) )\n		{\n		auto orig_elem = vv->RawVec()[ind];\n		if ( ! vv->Assign(ind, frame[z.v3].ToVal(Z_TYPE)) )\n			ERROR(\"value used but not set\");\n		if ( orig_elem )\n			ZVal::DeleteManagedType(*orig_elem);\n		}\n	else if ( ! vv->Assign(ind, frame[z.v3].ToVal(Z_TYPE)) )\n		ERROR(\"value used but not set\");\n"	}
},
{ OP_ANY_VECTOR_ELEM_ASSIGN_VVC,
	{
	"VVC",
	"",
	"auto ind = frame[z.v2].AsCount();\n	auto vv = frame[z.v1].AsVector();\n	auto yt = vv->RawYieldTypes();\n	if ( ind < vv->Size() && yt && (*yt)[ind] && ZVal::IsManagedType((*yt)[ind]) )\n		{\n		auto orig_elem = vv->RawVec()[ind];\n		if ( ! vv->Assign(ind, z.c.ToVal(Z_TYPE)) )\n			ERROR(\"value used but not set\");\n		if ( orig_elem )\n			ZVal::DeleteManagedType(*orig_elem);\n		}\n	else if ( ! vv->Assign(ind, z.c.ToVal(Z_TYPE)) )\n		ERROR(\"value used but not set\");\n"	}
},
{ OP_VECTOR_ELEM_ASSIGN_ANY_VVV,
	{
	"VVV",
	"XXa", 
	"EvalVectorElemAssign(frame[z.v1], frame[z.v2], auto any_v = frame[z.v3].AsAny();, vv->Assign(ind, {NewRef{}, any_v}))\n"	}
},
{ OP_VECTOR_ELEM_ASSIGN_VVC,
	{
	"VVC",
	"",
	"VectorElemAssignPre(frame[z.v1], frame[z.v2])\n	(void) copy_vec_elem(vv, ind, z.c, Z_TYPE);\n"	}
},
{ OP_VECTOR_ELEM_ASSIGN_VVi,
	{
	"VVi",
	"VXU", 
	"auto vv = frame[z.v1].AsVector();\n	if ( ! copy_vec_elem(vv, zeek_uint_t(z.v3), frame[z.v2], Z_TYPE) )\n		ERROR(\"value used but not set\");\n"	}
},
{ OP_ANY_VECTOR_ELEM_ASSIGN_VVi,
	{
	"VVi",
	"VXI", 
	"auto vv = frame[z.v1].AsVector();\n	if ( ! vv->Assign(z.v3, frame[z.v2].ToVal(Z_TYPE)) )\n		ERROR(\"value used but not set\");\n"	}
},
{ OP_VECTOR_ELEM_ASSIGN_ANY_VVi,
	{
	"VVi",
	"VaI", 
	"auto vv = frame[z.v1].AsVector();\n	auto any_v = frame[z.v2].AsAny();\n	vv->Assign(z.v3, {NewRef{}, any_v});\n"	}
},
{ OP_VECTOR_SLICE_ASSIGN_VV,
	{
	"VV",
	"VV", 
	"ValPtr vec = {NewRef{}, frame[z.v1].AsVector()};\n	auto indices = Z_AUX->ToListVal(frame);\n	ValPtr vals = {NewRef{}, frame[z.v2].AsVector()};\n	bool iterators_invalidated;\n	auto error = assign_to_index(std::move(vec), std::move(indices), std::move(vals), iterators_invalidated);\n	if ( error )\n		ERROR(error);\n	if ( iterators_invalidated )\n		WARN(\"possible loop/iterator invalidation\");\n"	}
},
{ OP_TABLE_ELEM_ASSIGN_VV,
	{
	"VV",
	"TX", 
	"auto indices = Z_AUX->ToListVal(frame);\n	auto val = frame[z.v2].ToVal(Z_TYPE);\n	bool iterators_invalidated = false;\n	frame[z.v1].AsTable()->Assign(std::move(indices), std::move(val), true, &iterators_invalidated);\n	if ( iterators_invalidated )\n		WARN(\"possible loop/iterator invalidation\");\n"	}
},
{ OP_TABLE_ELEM_ASSIGN_VC,
	{
	"VC",
	"TX", 
	"auto indices = Z_AUX->ToListVal(frame);\n	auto val = z.c.ToVal(Z_TYPE);\n	bool iterators_invalidated = false;\n	frame[z.v1].AsTable()->Assign(std::move(indices), std::move(val), true, &iterators_invalidated);\n	if ( iterators_invalidated )\n		WARN(\"possible loop/iterator invalidation\");\n"	}
},
{ OP_ADD_VCV_S,
	{
	"VCV",
	"SSS", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(z.c.AsString()->AsString());\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		frame[z.v1].AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VCV_D,
	{
	"VCV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = z.c.AsDouble() + frame[z.v2].AsDouble();\n"	}
},
{ OP_ADD_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() + frame[z.v2].AsCount();\n"	}
},
{ OP_ADD_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() + frame[z.v2].AsInt();\n"	}
},
{ OP_ADD_VCVi_field_S,
	{
	"VCVi",
	"RSSI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(z.c.AsString()->AsString());\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VCVi_field_D,
	{
	"VCVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = z.c.AsDouble() + frame[z.v2].AsDouble();\n"	}
},
{ OP_ADD_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() + frame[z.v2].AsCount();\n"	}
},
{ OP_ADD_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() + frame[z.v2].AsInt();\n"	}
},
{ OP_ADD_VVC_S,
	{
	"VVC",
	"SSS", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		strings.push_back(z.c.AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		frame[z.v1].AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VVC_D,
	{
	"VVC",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() + z.c.AsDouble();\n"	}
},
{ OP_ADD_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() + z.c.AsCount();\n"	}
},
{ OP_ADD_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() + z.c.AsInt();\n"	}
},
{ OP_ADD_VVCi_field_S,
	{
	"VVCi",
	"RSSI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		strings.push_back(z.c.AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VVCi_field_D,
	{
	"VVCi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = frame[z.v2].AsDouble() + z.c.AsDouble();\n"	}
},
{ OP_ADD_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() + z.c.AsCount();\n"	}
},
{ OP_ADD_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() + z.c.AsInt();\n"	}
},
{ OP_ADD_VVV_S,
	{
	"VVV",
	"SSS", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		strings.push_back(frame[z.v3].AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		frame[z.v1].AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VVV_D,
	{
	"VVV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() + frame[z.v3].AsDouble();\n"	}
},
{ OP_ADD_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() + frame[z.v3].AsCount();\n"	}
},
{ OP_ADD_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() + frame[z.v3].AsInt();\n"	}
},
{ OP_ADD_VVVi_field_S,
	{
	"VVVi",
	"RSSI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	vector<const String*> strings;\n		strings.push_back(frame[z.v2].AsString()->AsString());\n		strings.push_back(frame[z.v3].AsString()->AsString());\n		auto res = new StringVal(concatenate(strings));\n		DirectField(frame[z.v1].AsRecord(), z.v4).AsStringRef() = res;\n	Unref(hold_lhs);"
	}
},
{ OP_ADD_VVVi_field_D,
	{
	"VVVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsDoubleRef() = frame[z.v2].AsDouble() + frame[z.v3].AsDouble();\n"	}
},
{ OP_ADD_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() + frame[z.v3].AsCount();\n"	}
},
{ OP_ADD_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() + frame[z.v3].AsInt();\n"	}
},
{ OP_ADD_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_ADD_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_ADD_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_ADD_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_ADD_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_ADD_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_ADD_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_ADD_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_SUB_VCV_T,
	{
	"VCV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = z.c.AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		frame[z.v2].AsTable()->RemoveFrom(s);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VCV_D,
	{
	"VCV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = z.c.AsDouble() - frame[z.v2].AsDouble();\n"	}
},
{ OP_SUB_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() - frame[z.v2].AsCount();\n"	}
},
{ OP_SUB_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() - frame[z.v2].AsInt();\n"	}
},
{ OP_SUB_VCVi_field_T,
	{
	"VCVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	auto v = z.c.AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		frame[z.v2].AsTable()->RemoveFrom(s);\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VCVi_field_D,
	{
	"VCVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = z.c.AsDouble() - frame[z.v2].AsDouble();\n"	}
},
{ OP_SUB_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() - frame[z.v2].AsCount();\n"	}
},
{ OP_SUB_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() - frame[z.v2].AsInt();\n"	}
},
{ OP_SUB_VVC_T,
	{
	"VVC",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		z.c.AsTable()->RemoveFrom(s);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VVC_D,
	{
	"VVC",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() - z.c.AsDouble();\n"	}
},
{ OP_SUB_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() - z.c.AsCount();\n"	}
},
{ OP_SUB_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() - z.c.AsInt();\n"	}
},
{ OP_SUB_VVCi_field_T,
	{
	"VVCi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		z.c.AsTable()->RemoveFrom(s);\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VVCi_field_D,
	{
	"VVCi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = frame[z.v2].AsDouble() - z.c.AsDouble();\n"	}
},
{ OP_SUB_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() - z.c.AsCount();\n"	}
},
{ OP_SUB_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() - z.c.AsInt();\n"	}
},
{ OP_SUB_VVV_T,
	{
	"VVV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		frame[z.v3].AsTable()->RemoveFrom(s);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VVV_D,
	{
	"VVV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() - frame[z.v3].AsDouble();\n"	}
},
{ OP_SUB_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() - frame[z.v3].AsCount();\n"	}
},
{ OP_SUB_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() - frame[z.v3].AsInt();\n"	}
},
{ OP_SUB_VVVi_field_T,
	{
	"VVVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		frame[z.v3].AsTable()->RemoveFrom(s);\n		DirectField(frame[z.v1].AsRecord(), z.v4).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_SUB_VVVi_field_D,
	{
	"VVVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsDoubleRef() = frame[z.v2].AsDouble() - frame[z.v3].AsDouble();\n"	}
},
{ OP_SUB_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() - frame[z.v3].AsCount();\n"	}
},
{ OP_SUB_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() - frame[z.v3].AsInt();\n"	}
},
{ OP_SUB_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_SUB_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_SUB_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_SUB_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_SUB_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_SUB_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_SUB_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_SUB_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_TIMES_VCV_D,
	{
	"VCV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = z.c.AsDouble() * frame[z.v2].AsDouble();\n"	}
},
{ OP_TIMES_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() * frame[z.v2].AsCount();\n"	}
},
{ OP_TIMES_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() * frame[z.v2].AsInt();\n"	}
},
{ OP_TIMES_VCVi_field_D,
	{
	"VCVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = z.c.AsDouble() * frame[z.v2].AsDouble();\n"	}
},
{ OP_TIMES_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() * frame[z.v2].AsCount();\n"	}
},
{ OP_TIMES_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() * frame[z.v2].AsInt();\n"	}
},
{ OP_TIMES_VVC_D,
	{
	"VVC",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() * z.c.AsDouble();\n"	}
},
{ OP_TIMES_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() * z.c.AsCount();\n"	}
},
{ OP_TIMES_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() * z.c.AsInt();\n"	}
},
{ OP_TIMES_VVCi_field_D,
	{
	"VVCi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = frame[z.v2].AsDouble() * z.c.AsDouble();\n"	}
},
{ OP_TIMES_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() * z.c.AsCount();\n"	}
},
{ OP_TIMES_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() * z.c.AsInt();\n"	}
},
{ OP_TIMES_VVV_D,
	{
	"VVV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() * frame[z.v3].AsDouble();\n"	}
},
{ OP_TIMES_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() * frame[z.v3].AsCount();\n"	}
},
{ OP_TIMES_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() * frame[z.v3].AsInt();\n"	}
},
{ OP_TIMES_VVVi_field_D,
	{
	"VVVi",
	"RDDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsDoubleRef() = frame[z.v2].AsDouble() * frame[z.v3].AsDouble();\n"	}
},
{ OP_TIMES_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() * frame[z.v3].AsCount();\n"	}
},
{ OP_TIMES_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() * frame[z.v3].AsInt();\n"	}
},
{ OP_TIMES_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_TIMES_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_TIMES_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_TIMES_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_TIMES_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_TIMES_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_DIVIDE_VCV_D,
	{
	"VCV",
	"DDD", 
	"if ( frame[z.v2].AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsDoubleRef() = z.c.AsDouble() / frame[z.v2].AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VCV_U,
	{
	"VCV",
	"UUU", 
	"if ( frame[z.v2].AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = z.c.AsCount() / frame[z.v2].AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VCV_I,
	{
	"VCV",
	"III", 
	"if ( frame[z.v2].AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = z.c.AsInt() / frame[z.v2].AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VCVi_field_D,
	{
	"VCVi",
	"RDDI", 
	"if ( frame[z.v2].AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = z.c.AsDouble() / frame[z.v2].AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"if ( frame[z.v2].AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() / frame[z.v2].AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"if ( frame[z.v2].AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() / frame[z.v2].AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VVC_D,
	{
	"VVC",
	"DDD", 
	"if ( z.c.AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() / z.c.AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VVC_U,
	{
	"VVC",
	"UUU", 
	"if ( z.c.AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = frame[z.v2].AsCount() / z.c.AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VVC_I,
	{
	"VVC",
	"III", 
	"if ( z.c.AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = frame[z.v2].AsInt() / z.c.AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VVCi_field_D,
	{
	"VVCi",
	"RDDI", 
	"if ( z.c.AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = frame[z.v2].AsDouble() / z.c.AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"if ( z.c.AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() / z.c.AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"if ( z.c.AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() / z.c.AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VVV_D,
	{
	"VVV",
	"DDD", 
	"if ( frame[z.v3].AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble() / frame[z.v3].AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VVV_U,
	{
	"VVV",
	"UUU", 
	"if ( frame[z.v3].AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = frame[z.v2].AsCount() / frame[z.v3].AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VVV_I,
	{
	"VVV",
	"III", 
	"if ( frame[z.v3].AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = frame[z.v2].AsInt() / frame[z.v3].AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VVVi_field_D,
	{
	"VVVi",
	"RDDI", 
	"if ( frame[z.v3].AsDouble() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsDoubleRef() = frame[z.v2].AsDouble() / frame[z.v3].AsDouble();\n\n	}"
	}
},
{ OP_DIVIDE_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"if ( frame[z.v3].AsCount() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() / frame[z.v3].AsCount();\n\n	}"
	}
},
{ OP_DIVIDE_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"if ( frame[z.v3].AsInt() == 0)\n	{\n	ERROR(\"division by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() / frame[z.v3].AsInt();\n\n	}"
	}
},
{ OP_DIVIDE_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_DIVIDE_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_DIVIDE_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_DIVIDE_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_DIVIDE_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_DIVIDE_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_MASK_VCV_AI,
	{
	"VCV",
	"XAI", 
	"auto mask = static_cast<uint32_t>(frame[z.v2].AsInt());\n		auto a = z.c.AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(frame[z.v1].AsSubNet());\n		frame[z.v1].AsSubNetRef() = v.release();\n"	}
},
{ OP_MASK_VCVi_field_AI,
	{
	"VCVi",
	"XAII", 
	"auto mask = static_cast<uint32_t>(frame[z.v2].AsInt());\n		auto a = z.c.AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(DirectField(frame[z.v1].AsRecord(), z.v3).AsSubNet());\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsSubNetRef() = v.release();\n"	}
},
{ OP_MASK_VVC_AI,
	{
	"VVC",
	"XAI", 
	"auto mask = static_cast<uint32_t>(z.c.AsInt());\n		auto a = frame[z.v2].AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(frame[z.v1].AsSubNet());\n		frame[z.v1].AsSubNetRef() = v.release();\n"	}
},
{ OP_MASK_VVCi_field_AI,
	{
	"VVCi",
	"XAII", 
	"auto mask = static_cast<uint32_t>(z.c.AsInt());\n		auto a = frame[z.v2].AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(DirectField(frame[z.v1].AsRecord(), z.v3).AsSubNet());\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsSubNetRef() = v.release();\n"	}
},
{ OP_MASK_VVV_AI,
	{
	"VVV",
	"XAI", 
	"auto mask = static_cast<uint32_t>(frame[z.v3].AsInt());\n		auto a = frame[z.v2].AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(frame[z.v1].AsSubNet());\n		frame[z.v1].AsSubNetRef() = v.release();\n"	}
},
{ OP_MASK_VVVi_field_AI,
	{
	"VVVi",
	"XAII", 
	"auto mask = static_cast<uint32_t>(frame[z.v3].AsInt());\n		auto a = frame[z.v2].AsAddr()->AsAddr();\n		if ( a.GetFamily() == IPv4 && mask > 32 )\n			ERROR(util::fmt(\"bad IPv4 subnet prefix length: %\" PRIu32, mask));\n		if ( a.GetFamily() == IPv6 && mask > 128 )\n			ERROR(util::fmt(\"bad IPv6 subnet prefix length: %\" PRIu32, mask));\n		auto v = make_intrusive<SubNetVal>(a, mask);\n		Unref(DirectField(frame[z.v1].AsRecord(), z.v4).AsSubNet());\n		DirectField(frame[z.v1].AsRecord(), z.v4).AsSubNetRef() = v.release();\n"	}
},
{ OP_MOD_VCV_U,
	{
	"VCV",
	"UUU", 
	"if ( frame[z.v2].AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = z.c.AsCount() % frame[z.v2].AsCount();\n\n	}"
	}
},
{ OP_MOD_VCV_I,
	{
	"VCV",
	"III", 
	"if ( frame[z.v2].AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = z.c.AsInt() % frame[z.v2].AsInt();\n\n	}"
	}
},
{ OP_MOD_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"if ( frame[z.v2].AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() % frame[z.v2].AsCount();\n\n	}"
	}
},
{ OP_MOD_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"if ( frame[z.v2].AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() % frame[z.v2].AsInt();\n\n	}"
	}
},
{ OP_MOD_VVC_U,
	{
	"VVC",
	"UUU", 
	"if ( z.c.AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = frame[z.v2].AsCount() % z.c.AsCount();\n\n	}"
	}
},
{ OP_MOD_VVC_I,
	{
	"VVC",
	"III", 
	"if ( z.c.AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = frame[z.v2].AsInt() % z.c.AsInt();\n\n	}"
	}
},
{ OP_MOD_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"if ( z.c.AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() % z.c.AsCount();\n\n	}"
	}
},
{ OP_MOD_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"if ( z.c.AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() % z.c.AsInt();\n\n	}"
	}
},
{ OP_MOD_VVV_U,
	{
	"VVV",
	"UUU", 
	"if ( frame[z.v3].AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsCountRef() = frame[z.v2].AsCount() % frame[z.v3].AsCount();\n\n	}"
	}
},
{ OP_MOD_VVV_I,
	{
	"VVV",
	"III", 
	"if ( frame[z.v3].AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	frame[z.v1].AsIntRef() = frame[z.v2].AsInt() % frame[z.v3].AsInt();\n\n	}"
	}
},
{ OP_MOD_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"if ( frame[z.v3].AsCount() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() % frame[z.v3].AsCount();\n\n	}"
	}
},
{ OP_MOD_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"if ( frame[z.v3].AsInt() == 0)\n	{\n	ERROR(\"modulo by zero\");\n	}\n	else\n	{\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() % frame[z.v3].AsInt();\n\n	}"
	}
},
{ OP_MOD_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_MOD_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_MOD_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_MOD_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_AND_AND_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(z.c.AsInt() && frame[z.v2].AsInt());\n"	}
},
{ OP_AND_AND_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = zeek_int_t(z.c.AsInt() && frame[z.v2].AsInt());\n"	}
},
{ OP_AND_AND_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(frame[z.v2].AsInt() && z.c.AsInt());\n"	}
},
{ OP_AND_AND_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = zeek_int_t(frame[z.v2].AsInt() && z.c.AsInt());\n"	}
},
{ OP_AND_AND_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(frame[z.v2].AsInt() && frame[z.v3].AsInt());\n"	}
},
{ OP_AND_AND_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = zeek_int_t(frame[z.v2].AsInt() && frame[z.v3].AsInt());\n"	}
},
{ OP_AND_AND_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_AND_AND_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_OR_OR_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(z.c.AsInt() || frame[z.v2].AsInt());\n"	}
},
{ OP_OR_OR_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = zeek_int_t(z.c.AsInt() || frame[z.v2].AsInt());\n"	}
},
{ OP_OR_OR_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(frame[z.v2].AsInt() || z.c.AsInt());\n"	}
},
{ OP_OR_OR_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = zeek_int_t(frame[z.v2].AsInt() || z.c.AsInt());\n"	}
},
{ OP_OR_OR_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = zeek_int_t(frame[z.v2].AsInt() || frame[z.v3].AsInt());\n"	}
},
{ OP_OR_OR_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = zeek_int_t(frame[z.v2].AsInt() || frame[z.v3].AsInt());\n"	}
},
{ OP_OR_OR_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_OR_OR_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_AND_VCV_T,
	{
	"VCV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsTableRef() = z.c.AsTable()->Intersection(*frame[z.v2].AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VCV_P,
	{
	"VCV",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_conjunction(z.c.AsPattern()->AsPattern(), frame[z.v2].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() & frame[z.v2].AsCount();\n"	}
},
{ OP_AND_VCVi_field_T,
	{
	"VCVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = z.c.AsTable()->Intersection(*frame[z.v2].AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VCVi_field_P,
	{
	"VCVi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsPatternRef() = new PatternVal(RE_Matcher_conjunction(z.c.AsPattern()->AsPattern(), frame[z.v2].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() & frame[z.v2].AsCount();\n"	}
},
{ OP_AND_VVC_T,
	{
	"VVC",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsTableRef() = frame[z.v2].AsTable()->Intersection(*z.c.AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVC_P,
	{
	"VVC",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_conjunction(frame[z.v2].AsPattern()->AsPattern(), z.c.AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() & z.c.AsCount();\n"	}
},
{ OP_AND_VVCi_field_T,
	{
	"VVCi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = frame[z.v2].AsTable()->Intersection(*z.c.AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVCi_field_P,
	{
	"VVCi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsPatternRef() = new PatternVal(RE_Matcher_conjunction(frame[z.v2].AsPattern()->AsPattern(), z.c.AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() & z.c.AsCount();\n"	}
},
{ OP_AND_VVV_T,
	{
	"VVV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsTableRef() = frame[z.v2].AsTable()->Intersection(*frame[z.v3].AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVV_P,
	{
	"VVV",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_conjunction(frame[z.v2].AsPattern()->AsPattern(), frame[z.v3].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() & frame[z.v3].AsCount();\n"	}
},
{ OP_AND_VVVi_field_T,
	{
	"VVVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsTableRef() = frame[z.v2].AsTable()->Intersection(*frame[z.v3].AsTable()).release();\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVVi_field_P,
	{
	"VVVi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsPatternRef() = new PatternVal(RE_Matcher_conjunction(frame[z.v2].AsPattern()->AsPattern(), frame[z.v3].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_AND_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() & frame[z.v3].AsCount();\n"	}
},
{ OP_AND_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_AND_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_AND_VVV_vec_P,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_AND_VVV_vec_P, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_AND_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_AND_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_OR_VCV_T,
	{
	"VCV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = z.c.AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) frame[z.v2].AsTable()->AddTo(s, false, false);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VCV_P,
	{
	"VCV",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_disjunction(z.c.AsPattern()->AsPattern(), frame[z.v2].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() | frame[z.v2].AsCount();\n"	}
},
{ OP_OR_VCVi_field_T,
	{
	"VCVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	auto v = z.c.AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) frame[z.v2].AsTable()->AddTo(s, false, false);\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VCVi_field_P,
	{
	"VCVi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsPatternRef() = new PatternVal(RE_Matcher_disjunction(z.c.AsPattern()->AsPattern(), frame[z.v2].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() | frame[z.v2].AsCount();\n"	}
},
{ OP_OR_VVC_T,
	{
	"VVC",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) z.c.AsTable()->AddTo(s, false, false);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVC_P,
	{
	"VVC",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_disjunction(frame[z.v2].AsPattern()->AsPattern(), z.c.AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() | z.c.AsCount();\n"	}
},
{ OP_OR_VVCi_field_T,
	{
	"VVCi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) z.c.AsTable()->AddTo(s, false, false);\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVCi_field_P,
	{
	"VVCi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v3).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3).AsPatternRef() = new PatternVal(RE_Matcher_disjunction(frame[z.v2].AsPattern()->AsPattern(), z.c.AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() | z.c.AsCount();\n"	}
},
{ OP_OR_VVV_T,
	{
	"VVV",
	"TTT", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) frame[z.v3].AsTable()->AddTo(s, false, false);\n		frame[z.v1].AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVV_P,
	{
	"VVV",
	"PPP", 
	"auto hold_lhs = frame[z.v1].ManagedVal();\n	frame[z.v1].AsPatternRef() = new PatternVal(RE_Matcher_disjunction(frame[z.v2].AsPattern()->AsPattern(), frame[z.v3].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() | frame[z.v3].AsCount();\n"	}
},
{ OP_OR_VVVi_field_T,
	{
	"VVVi",
	"RTTI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	auto v = frame[z.v2].AsTable()->Clone();\n		auto s = v.release()->AsTableVal();\n		(void) frame[z.v3].AsTable()->AddTo(s, false, false);\n		DirectField(frame[z.v1].AsRecord(), z.v4).AsTableRef() = s;\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVVi_field_P,
	{
	"VVVi",
	"RPPI", 
	"auto hold_lhs = DirectField(frame[z.v1].AsRecord(), z.v4).ManagedVal();\n	DirectField(frame[z.v1].AsRecord(), z.v4).AsPatternRef() = new PatternVal(RE_Matcher_disjunction(frame[z.v2].AsPattern()->AsPattern(), frame[z.v3].AsPattern()->AsPattern()));\n	Unref(hold_lhs);"
	}
},
{ OP_OR_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() | frame[z.v3].AsCount();\n"	}
},
{ OP_OR_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_OR_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_OR_VVV_vec_P,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_OR_VVV_vec_P, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_OR_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_OR_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_XOR_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() ^ frame[z.v2].AsCount();\n"	}
},
{ OP_XOR_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() ^ frame[z.v2].AsCount();\n"	}
},
{ OP_XOR_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() ^ z.c.AsCount();\n"	}
},
{ OP_XOR_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() ^ z.c.AsCount();\n"	}
},
{ OP_XOR_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() ^ frame[z.v3].AsCount();\n"	}
},
{ OP_XOR_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() ^ frame[z.v3].AsCount();\n"	}
},
{ OP_XOR_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_XOR_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LSHIFT_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() << frame[z.v2].AsCount();\n"	}
},
{ OP_LSHIFT_VCV_I,
	{
	"VCV",
	"III", 
	"if ( z.c.AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		frame[z.v1].AsIntRef() = z.c.AsInt() << frame[z.v2].AsInt();\n"	}
},
{ OP_LSHIFT_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() << frame[z.v2].AsCount();\n"	}
},
{ OP_LSHIFT_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"if ( z.c.AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() << frame[z.v2].AsInt();\n"	}
},
{ OP_LSHIFT_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() << z.c.AsCount();\n"	}
},
{ OP_LSHIFT_VVC_I,
	{
	"VVC",
	"III", 
	"if ( frame[z.v2].AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		frame[z.v1].AsIntRef() = frame[z.v2].AsInt() << z.c.AsInt();\n"	}
},
{ OP_LSHIFT_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() << z.c.AsCount();\n"	}
},
{ OP_LSHIFT_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"if ( frame[z.v2].AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() << z.c.AsInt();\n"	}
},
{ OP_LSHIFT_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() << frame[z.v3].AsCount();\n"	}
},
{ OP_LSHIFT_VVV_I,
	{
	"VVV",
	"III", 
	"if ( frame[z.v2].AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		frame[z.v1].AsIntRef() = frame[z.v2].AsInt() << frame[z.v3].AsInt();\n"	}
},
{ OP_LSHIFT_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() << frame[z.v3].AsCount();\n"	}
},
{ OP_LSHIFT_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"if ( frame[z.v2].AsInt() < 0 )\n			ERROR(\"left shifting a negative number is undefined\");\n		DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() << frame[z.v3].AsInt();\n"	}
},
{ OP_LSHIFT_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LSHIFT_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LSHIFT_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LSHIFT_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_RSHIFT_VCV_U,
	{
	"VCV",
	"UUU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount() >> frame[z.v2].AsCount();\n"	}
},
{ OP_RSHIFT_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() >> frame[z.v2].AsInt();\n"	}
},
{ OP_RSHIFT_VCVi_field_U,
	{
	"VCVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = z.c.AsCount() >> frame[z.v2].AsCount();\n"	}
},
{ OP_RSHIFT_VCVi_field_I,
	{
	"VCVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = z.c.AsInt() >> frame[z.v2].AsInt();\n"	}
},
{ OP_RSHIFT_VVC_U,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() >> z.c.AsCount();\n"	}
},
{ OP_RSHIFT_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() >> z.c.AsInt();\n"	}
},
{ OP_RSHIFT_VVCi_field_U,
	{
	"VVCi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount() >> z.c.AsCount();\n"	}
},
{ OP_RSHIFT_VVCi_field_I,
	{
	"VVCi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt() >> z.c.AsInt();\n"	}
},
{ OP_RSHIFT_VVV_U,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount() >> frame[z.v3].AsCount();\n"	}
},
{ OP_RSHIFT_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() >> frame[z.v3].AsInt();\n"	}
},
{ OP_RSHIFT_VVVi_field_U,
	{
	"VVVi",
	"RUUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsCountRef() = frame[z.v2].AsCount() >> frame[z.v3].AsCount();\n"	}
},
{ OP_RSHIFT_VVVi_field_I,
	{
	"VVVi",
	"RIII", 
	"DirectField(frame[z.v1].AsRecord(), z.v4).AsIntRef() = frame[z.v2].AsInt() >> frame[z.v3].AsInt();\n"	}
},
{ OP_RSHIFT_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_RSHIFT_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_RSHIFT_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_RSHIFT_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_CALL0_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL0_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v1].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_C,
	{
	"C",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_A,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_a,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_U,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_D,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_f,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_F,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_I,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_L,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_O,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_P,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_R,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_S,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_N,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_T,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_t,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VV_V,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(frame[z.v2].ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_A,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_a,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_U,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_D,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_f,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_F,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_I,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_L,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_O,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_P,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_R,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_S,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_N,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_T,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_t,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL1_VC_V,
	{
	"VC",
	"",
	"std::vector<ValPtr> args;\nargs.push_back(z.c.ToVal(Z_TYPE));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL2_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL3_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL4_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALL5_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nargs.push_back(aux->ToVal(frame, 0));\nargs.push_back(aux->ToVal(frame, 1));\nargs.push_back(aux->ToVal(frame, 2));\nargs.push_back(aux->ToVal(frame, 3));\nargs.push_back(aux->ToVal(frame, 4));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) Z_AUX->func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_CALLN_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = Z_AUX->func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_X,
	{
	"X",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_A,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_a,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_U,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_D,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_f,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_F,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_I,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_L,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_O,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_P,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_R,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_S,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_N,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_T,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_t,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_INDCALLN_V_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func_v = aux->id_val->GetVal();\nauto func = func_v ? func_v->AsFunc() : nullptr;\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_V,
	{
	"V",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v1].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\n(void) func->Invoke(&args, f);\nZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_A,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_a,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_U,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsCount());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_D,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsDouble());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_f,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_F,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_I,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nframe[z.v1] = ZVal(v->AsInt());\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_L,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_O,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_P,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_R,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_S,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_N,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_T,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_t,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_LOCAL_INDCALLN_VV_V,
	{
	"VV",
	"",
	"std::vector<ValPtr> args;\nauto aux = Z_AUX;\nauto func = frame[z.v2].AsFunc();\nif ( ! func )\n	{\n	ZAM_run_time_error(Z_LOC, \"value used but not set\");\n	break;\n	}\nauto n = aux->n;\nfor ( auto i = 0; i < n; ++i )\n	args.push_back(aux->ToVal(frame, i));\nf->SetOnlyCall(Z_AUX->call_expr.get());\nZAM_PROFILE_PRE_CALL\nauto v = func->Invoke(&args, f);\nif ( ! v ) { ZAM_error = true; break; }\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	"ZAM_PROFILE_POST_CALL\n"	}
},
{ OP_WHENCALLN_V,
	{
	"V",
	"",
	"WhenCall(frame[z.v1], Z_AUX_FUNC)\n"	}
},
{ OP_WHENINDCALLN_VV,
	{
	"VV",
	"XF", 
	"WhenCall(frame[z.v1], frame[z.v2].AsFunc())\n"	}
},
{ OP_WHEN_ID_INDCALLN_V,
	{
	"V",
	"",
	"WhenCall(frame[z.v1], Z_AUX_ID->GetVal()->AsFunc())\n"	}
},
{ OP_COERCE_UI_VV,
	{
	"VV",
	"UI", 
	"auto v = frame[z.v2].AsInt();\n	if ( v < 0 )\n		ERROR(\"underflow converting int to count\");\n	else\n		frame[z.v1].AsCountRef() = zeek_uint_t(v);\n"	}
},
{ OP_COERCE_UD_VV,
	{
	"VV",
	"UD", 
	"auto v = frame[z.v2].AsDouble();\n	if ( v < 0.0 )\n		ERROR(\"underflow converting double to count\");\n	else if ( v > static_cast<double>(UINT64_MAX) )\n		ERROR(\"overflow converting double to count\");\n	else\n		frame[z.v1].AsCountRef() = zeek_uint_t(v);\n"	}
},
{ OP_COERCE_IU_VV,
	{
	"VV",
	"IU", 
	"auto v = frame[z.v2].AsCount();\n	if ( v > INT64_MAX )\n		ERROR(\"overflow converting count to int\");\n	else\n		frame[z.v1].AsIntRef() = zeek_int_t(v);\n"	}
},
{ OP_COERCE_ID_VV,
	{
	"VV",
	"ID", 
	"auto v = frame[z.v2].AsDouble();\n	if ( v < static_cast<double>(INT64_MIN) )\n		ERROR(\"underflow converting double to int\");\n	else if ( v > static_cast<double>(INT64_MAX) )\n		ERROR(\"overflow converting double to int\");\n	else\n		frame[z.v1].AsIntRef() = zeek_int_t(v);\n"	}
},
{ OP_COERCE_DI_VV,
	{
	"VV",
	"DI", 
	"frame[z.v1].AsDoubleRef() = double(frame[z.v2].AsInt());\n"	}
},
{ OP_COERCE_DU_VV,
	{
	"VV",
	"DU", 
	"frame[z.v1].AsDoubleRef() = double(frame[z.v2].AsCount());\n"	}
},
{ OP_COERCE_UI_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_UI)\n"	}
},
{ OP_COERCE_UD_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_UD)\n"	}
},
{ OP_COERCE_IU_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_IU)\n"	}
},
{ OP_COERCE_ID_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_ID)\n"	}
},
{ OP_COERCE_DI_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_DI)\n"	}
},
{ OP_COERCE_DU_VEC_VV,
	{
	"VV",
	"",
	"EvalCoerceVec(frame[z.v1], frame[z.v2], vec_coerce_DU)\n"	}
},
{ OP_RECORD_COERCE_VV,
	{
	"VV",
	"RR", 
	"auto rt = cast_intrusive<RecordType>(Z_TYPE);\n	auto v = frame[z.v2].AsRecord();\n	auto to_r = coerce_to_record(std::move(rt), v, Z_AUX_MAP);\n	Unref(frame[z.v1].AsRecordRef());\n	frame[z.v1].AsRecordRef() = to_r.release();\n"	}
},
{ OP_TABLE_COERCE_VV,
	{
	"VV",
	"TT", 
	"auto tv = frame[z.v2].AsTable();\n	if ( tv->Size() > 0 )\n		ERROR(\"coercion of non-empty table/set\");\n	else\n		{\n		auto tt = cast_intrusive<TableType>(Z_TYPE);\n		AttributesPtr attrs = tv->GetAttrs();\n		auto t = make_intrusive<TableVal>(tt, attrs);\n		Unref(frame[z.v1].AsTableRef());\n		frame[z.v1].AsTableRef() = t.release();\n		}\n"	}
},
{ OP_VECTOR_COERCE_VV,
	{
	"VV",
	"VV", 
	"if ( frame[z.v2].AsVector()->Size() > 0 )\n		ERROR(\"coercion of non-empty vector\");\n	else\n		{\n		auto vv = new VectorVal(cast_intrusive<VectorType>(Z_TYPE));\n		Unref(frame[z.v1].AsVectorRef());\n		frame[z.v1].AsVectorRef() = vv;\n		}\n"	}
},
{ OP_TO_ANY_COERCE_VC,
	{
	"VC",
	"XX", 
	"auto orig_lhs = frame[z.v1]; /* hold in case frame[z.v1] = z.c */\n	frame[z.v1] = ZVal(z.c.ToVal(Z_TYPE), ZAM::any_base_type);\n	ZVal::DeleteManagedType(orig_lhs);\n"	}
},
{ OP_TO_ANY_COERCE_VV,
	{
	"VV",
	"XX", 
	"auto orig_lhs = frame[z.v1]; /* hold in case frame[z.v1] = frame[z.v2] */\n	frame[z.v1] = ZVal(frame[z.v2].ToVal(Z_TYPE), ZAM::any_base_type);\n	ZVal::DeleteManagedType(orig_lhs);\n"	}
},
{ OP_FROM_ANY_COERCE_VV,
	{
	"VV",
	"XX", 
	"auto v = frame[z.v2].AsAny();\n	AssignTarget(frame[z.v1], ZVal({NewRef{}, v}, Z_TYPE))\n"	}
},
{ OP_FROM_ANY_VEC_COERCE_VV,
	{
	"VV",
	"XX", 
	"auto vv = frame[z.v2].AsVector();\n	if ( ! vv->Concretize(Z_TYPE->Yield()) )\n		ERROR(\"incompatible vector-of-any\");\n	else\n		{\n		zeek::Ref(vv);\n		AssignTarget(frame[z.v1], ZVal(vv))\n		}\n"	}
},
{ OP_CONSTRUCT_TABLE_Vi,
	{
	"Vi",
	"",
	"ConstructTableOrSetPre(z.v2)\n	for ( auto i = 0; i < n; ++i )\n		{\n		auto indices = aux->ToIndices(frame, i, ind_width);\n		auto v = aux->ToVal(frame, i + ind_width);\n		new_t->Assign(indices, v);\n		i += ind_width;\n		}\n	ConstructTableOrSetPost(frame[z.v1])\n"	}
},
{ OP_SET_TABLE_DEFAULT_LAMBDA_VV,
	{
	"VV",
	"TX", 
	"auto tbl = frame[z.v1].AsTable();\n	auto lambda = frame[z.v2].ToVal(Z_TYPE);\n	tbl->InitDefaultVal(std::move(lambda));\n"	}
},
{ OP_CONSTRUCT_SET_Vi,
	{
	"Vi",
	"",
	"ConstructTableOrSetPre(z.v2)\n	for ( auto i = 0; i < n; i += ind_width )\n		{\n		auto indices = aux->ToIndices(frame, i, ind_width);\n		new_t->Assign(indices, nullptr);\n		}\n	ConstructTableOrSetPost(frame[z.v1])\n"	}
},
{ OP_CONSTRUCT_DIRECT_RECORD_V,
	{
	"V",
	"R", 
	"auto init_vals = Z_AUX->ToZValVec(frame);\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_V,
	{
	"V",
	"R", 
	"auto init_vals = Z_AUX->ToZValVecWithMap(frame);\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_FROM_VV,
	{
	"VV",
	"RR", 
	"auto init_vals = Z_AUX->ToZValVecWithMap(frame);\n	AssignFromRec(frame[z.v2].AsRecord())\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_NT_Vi,
	{
	"Vi",
	"RI", 
	"auto init_vals = Z_AUX->ToZValVecWithMap(frame);\n	DoNetworkTimeInit(z.v2)\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_NT_FROM_VVi,
	{
	"VVi",
	"RRI", 
	"auto init_vals = Z_AUX->ToZValVecWithMap(frame);\n	DoNetworkTimeInit(z.v3)\n	AssignFromRec(frame[z.v2].AsRecord())\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_INITS_V,
	{
	"V",
	"R", 
	"GenInits()\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_INITS_FROM_VV,
	{
	"VV",
	"RR", 
	"GenInits()\n	AssignFromRec(frame[z.v2].AsRecord())\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_INITS_AND_NT_Vi,
	{
	"Vi",
	"RI", 
	"GenInits()\n	DoNetworkTimeInit(z.v2)\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_CONSTRUCT_KNOWN_RECORD_WITH_INITS_AND_NT_FROM_VVi,
	{
	"VVi",
	"RRI", 
	"GenInits()\n	DoNetworkTimeInit(z.v3)\n	AssignFromRec(frame[z.v2].AsRecord())\n	ConstructRecordPost(frame[z.v1].AsRecordRef())\n"	}
},
{ OP_REC_ASSIGN_FIELDS_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	for ( size_t i = 0U; i < n; ++i )\n		frame[z.v1].AsRecord()->RawOptField(lhs_map[i]) = frame[z.v2].AsRecord()->RawField(rhs_map[i]);\n"	}
},
{ OP_REC_ASSIGN_FIELDS_MANAGED_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	DoManagedRecAssign(frame[z.v1].AsRecord(), frame[z.v2].AsRecord())\n"	}
},
{ OP_REC_ASSIGN_FIELDS_ALL_MANAGED_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	for ( size_t i = 0U; i < n; ++i )\n		{\n		auto& lhs_i = frame[z.v1].AsRecord()->RawOptField(lhs_map[i]);\n		auto rhs_i = frame[z.v2].AsRecord()->RawField(rhs_map[i]);\n		zeek::Ref(rhs_i.ManagedVal());\n		if ( lhs_i )\n			ZVal::DeleteManagedType(*lhs_i);\n		lhs_i = rhs_i;\n		}\n"	}
},
{ OP_REC_ADD_INT_FIELDS_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	for ( size_t i = 0U; i < n; ++i )\n		frame[z.v1].AsRecord()->RawField(lhs_map[i]).AsIntRef() += frame[z.v2].AsRecord()->RawField(rhs_map[i]).AsInt();\n"	}
},
{ OP_REC_ADD_DOUBLE_FIELDS_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	for ( size_t i = 0U; i < n; ++i )\n		frame[z.v1].AsRecord()->RawField(lhs_map[i]).AsDoubleRef() += frame[z.v2].AsRecord()->RawField(rhs_map[i]).AsDouble();\n"	}
},
{ OP_REC_ADD_FIELDS_VV,
	{
	"VV",
	"RR", 
	"SetUpRecFieldOps(map)\n	auto& types = Z_AUX->types;\n	for ( size_t i = 0U; i < n; ++i )\n		{\n		auto& lhs_i = frame[z.v1].AsRecord()->RawField(lhs_map[i]);\n		auto rhs_i = frame[z.v2].AsRecord()->RawField(rhs_map[i]);\n		auto tag = types[i]->Tag();\n		if ( tag == TYPE_INT )\n			lhs_i.AsIntRef() += rhs_i.AsInt();\n		else if ( tag == TYPE_COUNT )\n			lhs_i.AsCountRef() += rhs_i.AsCount();\n		else\n			lhs_i.AsDoubleRef() += rhs_i.AsDouble();\n		}\n"	}
},
{ OP_CONCRETIZE_VECTOR_FIELDS_V,
	{
	"V",
	"R", 
	"auto rt = cast_intrusive<RecordType>(Z_TYPE);\n	auto r = frame[z.v1].AsRecord();\n	auto aux = Z_AUX;\n	auto n = aux->n;\n	for ( auto i = 0; i < n; ++i )\n		{\n		auto ind = aux->elems[i].IntVal();\n		auto v_i = r->GetField(ind);\n		ASSERT(v_i);\n		if ( v_i->GetType<VectorType>()->IsUnspecifiedVector() )\n			{\n			const auto& t_i = rt->GetFieldType(ind);\n			v_i->AsVectorVal()->Concretize(t_i->Yield());\n			}\n		}\n"	}
},
{ OP_CONSTRUCT_VECTOR_V,
	{
	"V",
	"V", 
	"auto new_vv = new VectorVal(cast_intrusive<VectorType>(Z_TYPE));\n	auto aux = Z_AUX;\n	auto n = aux->n;\n	for ( auto i = 0; i < n; ++i )\n		new_vv->Assign(i, aux->ToVal(frame, i));\n	auto& vv = frame[z.v1].AsVectorRef();\n	Unref(vv);\n	vv = new_vv;\n"	}
},
{ OP_INDEXVECBOOLSELECT_VVV,
	{
	"VVV",
	"VVV", 
	"if ( frame[z.v2].AsVector()->Size() != frame[z.v3].AsVector()->Size() )\n		ERROR(\"size mismatch, boolean index and vector\");\n	else\n		{\n		auto vt = cast_intrusive<VectorType>(Z_TYPE);\n		auto v2 = frame[z.v2].AsVector();\n		auto v3 = frame[z.v3].AsVector();\n		auto v = vector_bool_select(std::move(vt), v2, v3);\n		Unref(frame[z.v1].AsVectorRef());\n		frame[z.v1].AsVectorRef() = v.release();\n		}\n"	}
},
{ OP_INDEXVECBOOLSELECT_VCV,
	{
	"VCV",
	"VVV", 
	"if ( z.c.AsVector()->Size() != frame[z.v2].AsVector()->Size() )\n		ERROR(\"size mismatch, boolean index and vector\");\n	else\n		{\n		auto vt = cast_intrusive<VectorType>(Z_TYPE);\n		auto v2 = z.c.AsVector();\n		auto v3 = frame[z.v2].AsVector();\n		auto v = vector_bool_select(std::move(vt), v2, v3);\n		Unref(frame[z.v1].AsVectorRef());\n		frame[z.v1].AsVectorRef() = v.release();\n		}\n"	}
},
{ OP_INDEXVECINTSELECT_VVV,
	{
	"VVV",
	"VVV", 
	"auto vt = cast_intrusive<VectorType>(Z_TYPE);\n	auto v2 = frame[z.v2].AsVector();\n	auto v3 = frame[z.v3].AsVector();\n	auto v = vector_int_select(std::move(vt), v2, v3);\n	Unref(frame[z.v1].AsVectorRef());\n	frame[z.v1].AsVectorRef() = v.release();\n"	}
},
{ OP_INDEXVECINTSELECT_VCV,
	{
	"VCV",
	"VVV", 
	"auto vt = cast_intrusive<VectorType>(Z_TYPE);\n	auto v2 = z.c.AsVector();\n	auto v3 = frame[z.v2].AsVector();\n	auto v = vector_int_select(std::move(vt), v2, v3);\n	Unref(frame[z.v1].AsVectorRef());\n	frame[z.v1].AsVectorRef() = v.release();\n"	}
},
{ OP_INDEX_VEC_VVV,
	{
	"VVV",
	"XVI", 
	"EvalIndexVec(frame[z.v1], frame[z.v2].AsVector(), frame[z.v3].AsInt())\n"	}
},
{ OP_INDEX_VECC_VVi,
	{
	"VVi",
	"XVI", 
	"EvalIndexVec(frame[z.v1], frame[z.v2].AsVector(), z.v3)\n"	}
},
{ OP_INDEX_ANY_VEC_VVV,
	{
	"VVV",
	"XVI", 
	"EvalIndexAnyVec(frame[z.v1], frame[z.v2].AsVector(), frame[z.v3].AsInt())\n"	}
},
{ OP_INDEX_ANY_VECC_VVi,
	{
	"VVi",
	"XVI", 
	"EvalIndexAnyVec(frame[z.v1], frame[z.v2].AsVector(), z.v3)\n"	}
},
{ OP_WHEN_INDEX_VEC_VVV,
	{
	"VVV",
	"XVI", 
	"EvalIndexAnyVec(frame[z.v1], frame[z.v2].AsVector(), frame[z.v3].AsInt())\n	WhenIndexResCheck(frame[z.v1].AsVector())\n"	}
},
{ OP_WHEN_INDEX_VECC_VVi,
	{
	"VVi",
	"XVI", 
	"EvalIndexAnyVec(frame[z.v1], frame[z.v2].AsVector(), z.v3)\n	WhenIndexResCheck(frame[z.v1].AsVector())\n"	}
},
{ OP_INDEX_VEC_SLICE_VV,
	{
	"VV",
	"VV", 
	"auto indices = Z_AUX->ToListVal(frame);\n	EvalVecSlice(frame[z.v1].AsVectorRef(), frame[z.v2].AsVector())\n"	}
},
{ OP_WHEN_INDEX_VEC_SLICE_VV,
	{
	"VV",
	"VV", 
	"auto indices = Z_AUX->ToListVal(frame);\n	EvalVecSlice(frame[z.v1].AsVectorRef(), frame[z.v2].AsVector())\n	WhenIndexResCheck(frame[z.v1].AsVectorRef())\n"	}
},
{ OP_TABLE_INDEX_VV,
	{
	"VV",
	"",
	"auto indices = Z_AUX->ToListVal(frame);\n	EvalTableIndex(frame[z.v2], indices)\n	if ( v )\n		AssignTarget(frame[z.v1], BuildVal(v, Z_TYPE))\n"	}
},
{ OP_TABLE_PATSTR_INDEX_VVV,
	{
	"VVV",
	"XTS", 
	"auto vec = ZVal(frame[z.v2].AsTable()->LookupPattern({NewRef{}, frame[z.v3].AsString()}));\n	ZVal::DeleteManagedType(frame[z.v1]);\n	frame[z.v1] = vec;\n"	}
},
{ OP_TABLE_PATSTR_INDEX_VVC,
	{
	"VVC",
	"XTS", 
	"auto vec = ZVal(frame[z.v2].AsTable()->LookupPattern({NewRef{}, z.c.AsString()}));\n	ZVal::DeleteManagedType(frame[z.v1]);\n	frame[z.v1] = vec;\n"	}
},
{ OP_WHEN_TABLE_INDEX_VV,
	{
	"VV",
	"",
	"auto indices = Z_AUX->ToListVal(frame);\n	EvalTableIndex(frame[z.v2], indices)\n	if ( v )\n		{\n		if ( IndexExprWhen::evaluating > 0 )\n			IndexExprWhen::results.emplace_back(v);\n		AssignTarget(frame[z.v1], BuildVal(v, Z_TYPE))\n		}\n"	}
},
{ OP_WHEN_PATSTR_INDEX_VV,
	{
	"VV",
	"XT", 
	"auto indices = Z_AUX->ToListVal(frame);\n	auto arg0 = indices->Idx(0);\n	auto v = frame[z.v2].AsTable()->LookupPattern({NewRef{}, arg0->AsStringVal()});\n	if ( IndexExprWhen::evaluating > 0 )\n		IndexExprWhen::results.emplace_back(v);\n	AssignTarget(frame[z.v1], BuildVal(v, Z_TYPE))\n"	}
},
{ OP_TABLE_INDEX1_VVV_A,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_a,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_U,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsCount());\n"	}
},
{ OP_TABLE_INDEX1_VVV_D,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsDouble());\n"	}
},
{ OP_TABLE_INDEX1_VVV_f,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_F,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_I,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsInt());\n"	}
},
{ OP_TABLE_INDEX1_VVV_L,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_O,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_P,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_R,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_S,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_N,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_T,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_t,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVV_V,
	{
	"VVV",
	"",
	"EvalTableIndex(frame[z.v2], frame[z.v3].ToVal(Z_TYPE))\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_A,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_a,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_U,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsCount());\n"	}
},
{ OP_TABLE_INDEX1_VVC_D,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsDouble());\n"	}
},
{ OP_TABLE_INDEX1_VVC_f,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_F,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_I,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nframe[z.v1] = ZVal(v->AsInt());\n"	}
},
{ OP_TABLE_INDEX1_VVC_L,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_O,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_P,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_R,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_S,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_N,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_T,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_t,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_TABLE_INDEX1_VVC_V,
	{
	"VVC",
	"",
	"EvalTableIndex(frame[z.v2], z.c.ToVal(Z_TYPE))\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_INDEX_STRING_VVV,
	{
	"VVV",
	"SSI", 
	"EvalIndexString(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), frame[z.v3].AsInt())\n"	}
},
{ OP_INDEX_STRINGC_VVi,
	{
	"VVi",
	"SSI", 
	"EvalIndexString(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), z.v3)\n"	}
},
{ OP_INDEX_STRING_SLICE_VV,
	{
	"VV",
	"SS", 
	"auto str = frame[z.v2].AsString()->AsString();\n	auto indices = Z_AUX->ToListVal(frame);\n	auto slice = index_string(str, indices.get());\n	Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = new StringVal(slice->ToStdString());\n"	}
},
{ OP_ANYINDEX_VVi,
	{
	"VVi",
	"XaI", 
	"auto lv = frame[z.v2].AsAny()->AsListVal();\n	if ( z.v3 < 0 || z.v3 >= lv->Length() )\n		reporter->InternalError(\"bad \\\"any\\\" element index\");\n	ValPtr elem = lv->Idx(z.v3);\n	if ( CheckAnyType(elem->GetType(), Z_TYPE, Z_LOC) )\n		AssignTarget(frame[z.v1], BuildVal(elem, Z_TYPE))\n	else\n		ZAM_error = true;\n"	}
},
{ OP_ASSIGN_ANY_VV,
	{
	"VV",
	"aX", 
	"auto v = frame[z.v2].ToVal(Z_TYPE);\n	frame[z.v1].AsAnyRef() = v.release();\n"	}
},
{ OP_ASSIGN_ANY_VC,
	{
	"VC",
	"aX", 
	"auto v = z.c.ToVal(Z_TYPE);\n	frame[z.v1].AsAnyRef() = v.release();\n"	}
},
{ OP_ASSIGN_CONST_VC,
	{
	"VC",
	"",
	"AssignTarget(frame[z.v1], BuildVal(z.c.ToVal(Z_TYPE), Z_TYPE))\n"	}
},
{ OP_LOAD_VAL_Vi_A,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_a,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_U,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nframe[z.v1] = ZVal(v->AsCount());\n"	}
},
{ OP_LOAD_VAL_Vi_D,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nframe[z.v1] = ZVal(v->AsDouble());\n"	}
},
{ OP_LOAD_VAL_Vi_f,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_F,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_I,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nframe[z.v1] = ZVal(v->AsInt());\n"	}
},
{ OP_LOAD_VAL_Vi_L,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_O,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_P,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_R,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_S,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_N,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_T,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_t,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_VAL_Vi_V,
	{
	"Vi",
	"",
	"auto& v = Z_FRAME->GetElement(z.v2);\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_A,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsAddrVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_a,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v.get();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_U,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nframe[z.v1] = ZVal(v->AsCount());\n"	}
},
{ OP_LOAD_GLOBAL_Vg_D,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nframe[z.v1] = ZVal(v->AsDouble());\n"	}
},
{ OP_LOAD_GLOBAL_Vg_f,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_F,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_I,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nframe[z.v1] = ZVal(v->AsInt());\n"	}
},
{ OP_LOAD_GLOBAL_Vg_L,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsListVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_O,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsOpaqueVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_P,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsPatternVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_R,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsRecordVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_S,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsStringVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_N,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsSubNetVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_T,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsTableVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_t,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsTypeVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_Vg_V,
	{
	"Vg",
	"",
	"auto& v = GlobalID(z.v2)->GetVal();\n	if ( ! v )\n		ERROR2(\"value used but not set\", Z_AUX_ID.get());\nauto rhs = v->AsVectorVal();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_LOAD_GLOBAL_TYPE_Vg,
	{
	"Vg",
	"tI", 
	"auto& v = frame[z.v1].AsTypeRef();\n	Unref(v);\n	auto& t = GlobalID(z.v2)->GetType();\n	v = new TypeVal(t, true);\n"	}
},
{ OP_LOAD_CAPTURE_Vi,
	{
	"Vi",
	"",
	"frame[z.v1] = Z_FRAME->GetFunction()->GetCapturesVec()[z.v2];\n"	}
},
{ OP_LOAD_MANAGED_CAPTURE_Vi,
	{
	"Vi",
	"",
	"auto& lhs = frame[z.v1];\n	auto& rhs = Z_FRAME->GetFunction()->GetCapturesVec()[z.v2];\n	zeek::Ref(rhs.ManagedVal());\n	ZVal::DeleteManagedType(lhs);\n	lhs = rhs;\n"	}
},
{ OP_STORE_GLOBAL_g,
	{
	"g",
	"",
	"GlobalID(z.v1)->SetVal(GlobalVal(z.v1).ToVal(Z_TYPE));\n"	}
},
{ OP_STORE_CAPTURE_Vi,
	{
	"Vi",
	"",
	"Z_FRAME->GetFunction()->GetCapturesVec()[z.v2] = frame[z.v1];\n"	}
},
{ OP_STORE_MANAGED_CAPTURE_Vi,
	{
	"Vi",
	"",
	"auto& lhs = Z_FRAME->GetFunction()->GetCapturesVec()[z.v2];\n	auto& rhs = frame[z.v1];\n	zeek::Ref(rhs.ManagedVal());\n	ZVal::DeleteManagedType(lhs);\n	lhs = rhs;\n"	}
},
{ OP_COPY_TO_VC,
	{
	"VC",
	"",
	"AssignTarget(frame[z.v1], CopyVal(z.c))\n"	}
},
{ OP_GOTO_b,
	{
	"b",
	"",
	"Branch(z.v1)\n"	}
},
{ OP_HOOK_BREAK_X,
	{
	"X",
	"",
	"flow = FLOW_BREAK;\n	pc = end_pc;\n	DO_ZAM_PROFILE\n	continue;\n"	}
},
{ OP_LAMBDA_Vi,
	{
	"Vi",
	"FI", 
	"auto& primary_func = Z_AUX_PRIMARY_FUNC;\n	auto& body = primary_func->GetBodies()[0].stmts;\n	ASSERT(body->Tag() == STMT_ZAM);\n	auto lamb = make_intrusive<ScriptFunc>(Z_AUX_ID);\n	lamb->AddBody(body, z.v2);\n	lamb->SetName(Z_AUX_LAMBDA_NAME.c_str());\n	auto& aux = Z_AUX;\n	if ( aux->n > 0 )\n		{\n		auto captures = std::make_unique<std::vector<ZVal>>();\n		for ( auto i = 0; i < aux->n; ++i )\n			{\n			auto slot = aux->elems[i].Slot();\n			if ( slot >= 0 )\n				{\n				auto& cp = frame[slot];\n				if ( aux->elems[i].IsManaged() )\n					zeek::Ref(cp.ManagedVal());\n				captures->push_back(cp);\n				}\n			else\n				/* Used for when-locals. */\n				captures->push_back(ZVal());\n			}\n		lamb->CreateCaptures(std::move(captures));\n		}\n	Unref(frame[z.v1].AsFuncRef());\n	frame[z.v1].AsFuncRef() = lamb.release();\n"	}
},
{ OP_INIT_TABLE_LOOP_Vf,
	{
	"Vf",
	"TI", 
	"TableIter(z.v2).BeginLoop({NewRef{}, frame[z.v1].AsTable()}, frame, Z_AUX);\n"	}
},
{ OP_NEXT_TABLE_ITER_fb,
	{
	"fb",
	"",
	"NextTableIterPre(TableIter(z.v1), Branch(z.v2))\n	TableIter(z.v1).NextIter();\n"	}
},
{ OP_NEXT_TABLE_ITER_NO_VARS_fb,
	{
	"fb",
	"",
	"NextTableIterPre(TableIter(z.v1), Branch(z.v2))\n	TableIter(z.v1).IterFinished();\n"	}
},
{ OP_NEXT_TABLE_ITER_VAL_VAR_Vfb,
	{
	"Vfb",
	"",
	"NextTableIterPre(TableIter(z.v2), Branch(z.v3))\n	AssignTarget(frame[z.v1], TableIter(z.v2).IterValue());\n	TableIter(z.v2).NextIter();\n"	}
},
{ OP_NEXT_TABLE_ITER_VAL_VAR_NO_VARS_Vfb,
	{
	"Vfb",
	"",
	"NextTableIterPre(TableIter(z.v2), Branch(z.v3))\n	AssignTarget(frame[z.v1], TableIter(z.v2).IterValue());\n	TableIter(z.v2).IterFinished();\n"	}
},
{ OP_INIT_VECTOR_LOOP_Vs,
	{
	"Vs",
	"VI", 
	"auto& vv = frame[z.v1].AsVector()->RawVec();\n	StepIter(z.v2).InitLoop(&vv);\n"	}
},
{ OP_NEXT_VECTOR_ITER_Vsb,
	{
	"Vsb",
	"UII", 
	"NextVectorIterCore(StepIter(z.v2), Branch(z.v3))\n	frame[z.v1].AsCountRef() = StepIter(z.v2).iter;\n	StepIter(z.v2).IterFinished();\n"	}
},
{ OP_NEXT_VECTOR_BLANK_ITER_sb,
	{
	"sb",
	"",
	"NextVectorIterCore(StepIter(z.v1), Branch(z.v2))\n	StepIter(z.v1).IterFinished();\n"	}
},
{ OP_NEXT_VECTOR_ITER_VAL_VAR_VVsb,
	{
	"VVsb",
	"UXII", 
	"NextVectorIterCore(StepIter(z.v3), Branch(z.v4))\n	frame[z.v1].AsCountRef() = StepIter(z.v3).iter;\n	if ( Z_IS_MANAGED )\n		{\n		ZVal::DeleteManagedType(frame[z.v2]);\n		frame[z.v2] = BuildVal(vv[StepIter(z.v3).iter]->ToVal(Z_TYPE), Z_TYPE);\n		}\n	else\n		frame[z.v2] = *vv[StepIter(z.v3).iter];\n	StepIter(z.v3).IterFinished();\n"	}
},
{ OP_NEXT_VECTOR_BLANK_ITER_VAL_VAR_Vsb,
	{
	"Vsb",
	"",
	"NextVectorIterCore(StepIter(z.v2), Branch(z.v3))\n	if ( Z_IS_MANAGED )\n		{\n		ZVal::DeleteManagedType(frame[z.v1]);\n		frame[z.v1] = BuildVal(vv[StepIter(z.v2).iter]->ToVal(Z_TYPE), Z_TYPE);\n		}\n	else\n		frame[z.v1] = *vv[StepIter(z.v2).iter];\n	StepIter(z.v2).IterFinished();\n"	}
},
{ OP_INIT_STRING_LOOP_Vs,
	{
	"Vs",
	"SI", 
	"StepIter(z.v2).InitLoop(frame[z.v1].AsString()->AsString());\n"	}
},
{ OP_INIT_STRING_LOOP_Cs,
	{
	"Cs",
	"SI", 
	"StepIter(z.v1).InitLoop(z.c.AsString()->AsString());\n"	}
},
{ OP_NEXT_STRING_ITER_Vsb,
	{
	"Vsb",
	"SII", 
	"if ( StepIter(z.v2).IsDoneIterating() )\n		Branch(z.v3)\n	auto bytes = (const char*) StepIter(z.v2).s->Bytes() + StepIter(z.v2).iter;\n	auto sv = new StringVal(1, bytes);\n	Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = sv;\n	StepIter(z.v2).IterFinished();\n"	}
},
{ OP_NEXT_STRING_BLANK_ITER_sb,
	{
	"sb",
	"",
	"if ( StepIter(z.v1).IsDoneIterating() )\n		Branch(z.v2)\n	StepIter(z.v1).IterFinished();\n"	}
},
{ OP_END_TABLE_LOOP_f,
	{
	"f",
	"",
	"TableIter(z.v1).Clear();\n"	}
},
{ OP_FIELD_RCi_A,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsAddr();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_a,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsAny();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_U,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsCount());\n"	}
},
{ OP_FIELD_RCi_D,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsDouble());\n"	}
},
{ OP_FIELD_RCi_f,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_F,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_I,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsInt());\n"	}
},
{ OP_FIELD_RCi_L,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsList();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_O,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsOpaque();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_P,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsPattern();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_R,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsRecord();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_S,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsString();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_N,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsSubNet();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_T,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsTable();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_t,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsType();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RCi_V,
	{
	"RCi",
	"",
	"auto r = z.c.AsRecord();\n	auto& rv = DirectOptField(r, z.v2);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v2);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsVector();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_A,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsAddr();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_a,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsAny();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_U,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsCount());\n"	}
},
{ OP_FIELD_RVi_D,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsDouble());\n"	}
},
{ OP_FIELD_RVi_f,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsFile();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_F,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsFunc();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_I,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nframe[z.v1] = ZVal(v.AsInt());\n"	}
},
{ OP_FIELD_RVi_L,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsList();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_O,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsOpaque();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_P,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsPattern();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_R,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsRecord();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_S,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsString();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_N,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsSubNet();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_T,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsTable();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_t,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsType();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_FIELD_RVi_V,
	{
	"RVi",
	"",
	"auto r = frame[z.v2].AsRecord();\n	auto& rv = DirectOptField(r, z.v3);\n	ZVal v;\n	if ( ! rv )\n		{\n		auto def = r->GetType<RecordType>()->FieldDefault(z.v3);\n		if ( def )\n			v = ZVal(def, Z_TYPE);\n		else\n			ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n		}\n	else\n		v = *rv;\nauto rhs = v.AsVector();\nzeek::Ref(rhs);\nUnref(frame[z.v1].ManagedVal());\nframe[z.v1] = ZVal(rhs);\n"	}
},
{ OP_HAS_FIELD_VRi,
	{
	"VRi",
	"IRI", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsRecord()->HasField(z.v3);\n"	}
},
{ OP_HAS_FIELD_VRii,
	{
	"VRii",
	"RRII", 
	"DirectOptField(frame[z.v1].AsRecordRef(), z.v3) = ZVal(zeek_int_t(frame[z.v2].AsRecord()->HasField(z.v4)));\n"	}
},
{ OP_HAS_FIELD_VVi,
	{
	"VVi",
	"IRI", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsRecord()->HasField(z.v3);"
	}
},
{ OP_HAS_FIELD_COND_Vib,
	{
	"Vib",
	"RII", 
	"if ( ! (frame[z.v1].AsRecord()->HasField(z.v2)) )\n		Branch(z.v3)"
	}
},
{ OP_NOT_HAS_FIELD_COND_Vib,
	{
	"Vib",
	"RII", 
	"if ( (frame[z.v1].AsRecord()->HasField(z.v2)) )\n		Branch(z.v3)"
	}
},
{ OP_TABLE_HAS_ELEMENTS_VV,
	{
	"VV",
	"IT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->Size() > 0;"
	}
},
{ OP_TABLE_HAS_ELEMENTS_COND_Vb,
	{
	"Vb",
	"TI", 
	"if ( ! (frame[z.v1].AsTable()->Size() > 0) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_TABLE_HAS_ELEMENTS_COND_Vb,
	{
	"Vb",
	"TI", 
	"if ( (frame[z.v1].AsTable()->Size() > 0) )\n		Branch(z.v2)"
	}
},
{ OP_VECTOR_HAS_ELEMENTS_VV,
	{
	"VV",
	"IV", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsVector()->Size() > 0;"
	}
},
{ OP_VECTOR_HAS_ELEMENTS_COND_Vb,
	{
	"Vb",
	"VI", 
	"if ( ! (frame[z.v1].AsVector()->Size() > 0) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_VECTOR_HAS_ELEMENTS_COND_Vb,
	{
	"Vb",
	"VI", 
	"if ( (frame[z.v1].AsVector()->Size() > 0) )\n		Branch(z.v2)"
	}
},
{ OP_P_IN_S_VVV,
	{
	"VVV",
	"IPS", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsPattern()->MatchAnywhere(frame[z.v3].AsString()->AsString()) != 0;\n"	}
},
{ OP_P_IN_S_VCV,
	{
	"VCV",
	"IPS", 
	"frame[z.v1].AsIntRef() = z.c.AsPattern()->MatchAnywhere(frame[z.v2].AsString()->AsString()) != 0;\n"	}
},
{ OP_P_IN_S_VVC,
	{
	"VVC",
	"IPS", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsPattern()->MatchAnywhere(z.c.AsString()->AsString()) != 0;\n"	}
},
{ OP_STR_IN_PAT_TBL_VVV,
	{
	"VVV",
	"IST", 
	"frame[z.v1].AsIntRef() = frame[z.v3].AsTable()->MatchPattern({NewRef{}, frame[z.v2].AsString()});\n"	}
},
{ OP_STR_IN_PAT_TBL_VCV,
	{
	"VCV",
	"IST", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->MatchPattern({NewRef{}, z.c.AsString()});\n"	}
},
{ OP_S_IN_S_VVV,
	{
	"VVV",
	"ISS", 
	"auto sc = reinterpret_cast<const unsigned char*>(frame[z.v2].AsString()->CheckString());\n	auto cmp = util::strstr_n(frame[z.v3].AsString()->Len(), frame[z.v3].AsString()->Bytes(), frame[z.v2].AsString()->Len(), sc);\n	frame[z.v1].AsIntRef() = cmp != -1;\n"	}
},
{ OP_S_IN_S_VCV,
	{
	"VCV",
	"ISS", 
	"auto sc = reinterpret_cast<const unsigned char*>(z.c.AsString()->CheckString());\n	auto cmp = util::strstr_n(frame[z.v2].AsString()->Len(), frame[z.v2].AsString()->Bytes(), z.c.AsString()->Len(), sc);\n	frame[z.v1].AsIntRef() = cmp != -1;\n"	}
},
{ OP_S_IN_S_VVC,
	{
	"VVC",
	"ISS", 
	"auto sc = reinterpret_cast<const unsigned char*>(frame[z.v2].AsString()->CheckString());\n	auto cmp = util::strstr_n(z.c.AsString()->Len(), z.c.AsString()->Bytes(), frame[z.v2].AsString()->Len(), sc);\n	frame[z.v1].AsIntRef() = cmp != -1;\n"	}
},
{ OP_A_IN_S_VVV,
	{
	"VVV",
	"IAN", 
	"frame[z.v1].AsIntRef() = frame[z.v3].AsSubNet()->Contains(frame[z.v2].AsAddr()->AsAddr());\n"	}
},
{ OP_A_IN_S_VCV,
	{
	"VCV",
	"IAN", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsSubNet()->Contains(z.c.AsAddr()->AsAddr());\n"	}
},
{ OP_A_IN_S_VVC,
	{
	"VVC",
	"IAN", 
	"frame[z.v1].AsIntRef() = z.c.AsSubNet()->Contains(frame[z.v2].AsAddr()->AsAddr());\n"	}
},
{ OP_VAL_IS_IN_TABLE_VVV,
	{
	"VVV",
	"IXT", 
	"frame[z.v1].AsIntRef() = frame[z.v3].AsTable()->Find(frame[z.v2].ToVal(Z_TYPE)) != nullptr;"
	}
},
{ OP_VAL_IS_IN_TABLE_COND_VVb,
	{
	"VVb",
	"XTI", 
	"if ( ! (frame[z.v2].AsTable()->Find(frame[z.v1].ToVal(Z_TYPE)) != nullptr) )\n		Branch(z.v3)"
	}
},
{ OP_NOT_VAL_IS_IN_TABLE_COND_VVb,
	{
	"VVb",
	"XTI", 
	"if ( (frame[z.v2].AsTable()->Find(frame[z.v1].ToVal(Z_TYPE)) != nullptr) )\n		Branch(z.v3)"
	}
},
{ OP_VAL2_IS_IN_TABLE_VVVV,
	{
	"VVVV",
	"",
	"EvalVal2InTablePre(frame[z.v2],frame[z.v3],frame[z.v4])\n	EvalVal2InTableAssignCore(frame[z.v1], frame[z.v4])\n"	}
},
{ OP_VAL2_IS_IN_TABLE_COND_VVVb,
	{
	"VVVb",
	"",
	"EvalVal2InTablePre(frame[z.v1],frame[z.v2],frame[z.v3])\n	EvalVal2InTableCond(frame[z.v3], INDEX_LIST, Branch(z.v4), !)\n"	}
},
{ OP_VAL2_IS_NOT_IN_TABLE_COND_VVVb,
	{
	"VVVb",
	"",
	"EvalVal2InTablePre(frame[z.v1],frame[z.v2],frame[z.v3])\n	EvalVal2InTableCond(frame[z.v3], INDEX_LIST, Branch(z.v4),)\n"	}
},
{ OP_VAL2_IS_IN_TABLE_VVVC,
	{
	"VVVC",
	"",
	"EvalVal2InTableCore(frame[z.v2].ToVal(Z_TYPE2), z.c.ToVal(Z_TYPE))\n	EvalVal2InTableAssignCore(frame[z.v1], frame[z.v3])\n"	}
},
{ OP_VAL2_IS_IN_TABLE_VVCV,
	{
	"VVCV",
	"",
	"EvalVal2InTableCore(z.c.ToVal(Z_TYPE), frame[z.v2].ToVal(Z_TYPE2))\n	EvalVal2InTableAssignCore(frame[z.v1], frame[z.v3])\n"	}
},
{ OP_VAL2_IS_IN_TABLE_COND_VVbC,
	{
	"VVbC",
	"",
	"EvalVal2InTableCore(frame[z.v1].ToVal(Z_TYPE2), z.c.ToVal(Z_TYPE))\n	EvalVal2InTableCond(frame[z.v2], INDEX_LIST, Branch(z.v3), !)\n"	}
},
{ OP_VAL2_IS_IN_TABLE_COND_VVCb,
	{
	"VVCb",
	"",
	"EvalVal2InTableCore(z.c.ToVal(Z_TYPE), frame[z.v1].ToVal(Z_TYPE2))\n	EvalVal2InTableCond(frame[z.v2], INDEX_LIST, Branch(z.v3), !)\n"	}
},
{ OP_VAL2_IS_NOT_IN_TABLE_COND_VVbC,
	{
	"VVbC",
	"",
	"EvalVal2InTableCore(frame[z.v1].ToVal(Z_TYPE2), z.c.ToVal(Z_TYPE))\n	EvalVal2InTableCond(frame[z.v2], INDEX_LIST, Branch(z.v3), )\n"	}
},
{ OP_VAL2_IS_NOT_IN_TABLE_COND_VVCb,
	{
	"VVCb",
	"",
	"EvalVal2InTableCore(z.c.ToVal(Z_TYPE), frame[z.v1].ToVal(Z_TYPE2))\n	EvalVal2InTableCond(frame[z.v2], INDEX_LIST, Branch(z.v3), )\n"	}
},
{ OP_CONST_IS_IN_TABLE_VVC,
	{
	"VVC",
	"ITX", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->Find(z.c.ToVal(Z_TYPE)) != nullptr;"
	}
},
{ OP_CONST_IS_IN_TABLE_COND_VCb,
	{
	"VCb",
	"TXI", 
	"if ( ! (frame[z.v1].AsTable()->Find(z.c.ToVal(Z_TYPE)) != nullptr) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_CONST_IS_IN_TABLE_COND_VCb,
	{
	"VCb",
	"TXI", 
	"if ( (frame[z.v1].AsTable()->Find(z.c.ToVal(Z_TYPE)) != nullptr) )\n		Branch(z.v2)"
	}
},
{ OP_LIST_IS_IN_TABLE_VV,
	{
	"VV",
	"IT", 
	"auto indices = Z_AUX->ToListVal(frame);\n	frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->Find(std::move(indices)) != nullptr;\n"	}
},
{ OP_LIST_IS_IN_TABLE_VC,
	{
	"VC",
	"IT", 
	"auto indices = Z_AUX->ToListVal(frame);\n	frame[z.v1].AsIntRef() = z.c.AsTable()->Find(std::move(indices)) != nullptr;\n"	}
},
{ OP_VAL_IS_IN_VECTOR_VVV,
	{
	"VVV",
	"IIV", 
	"auto vec = frame[z.v3].AsVector();\n	auto ind = frame[z.v2].AsInt();\n	frame[z.v1].AsIntRef() = vec->Has(ind);\n"	}
},
{ OP_CONST_IS_IN_VECTOR_VCV,
	{
	"VCV",
	"IIV", 
	"auto vec = frame[z.v2].AsVector();\n	auto ind = z.c.AsInt();\n	frame[z.v1].AsIntRef() = vec->Has(ind);\n"	}
},
{ OP_COND_VVVV,
	{
	"VVVV",
	"XIXX", 
	"AssignTarget(frame[z.v1], frame[z.v2].AsInt() ? CopyVal(frame[z.v3]) : CopyVal(frame[z.v4]))\n"	}
},
{ OP_COND_VVVC,
	{
	"VVVC",
	"XIXX", 
	"AssignTarget(frame[z.v1], frame[z.v2].AsInt() ? CopyVal(frame[z.v3]) : CopyVal(z.c))\n"	}
},
{ OP_COND_VVCV,
	{
	"VVCV",
	"XIXX", 
	"AssignTarget(frame[z.v1], frame[z.v2].AsInt() ? CopyVal(z.c) : CopyVal(frame[z.v3]))\n"	}
},
{ OP_BOOL_VEC_COND_VVVV,
	{
	"VVVV",
	"VVVV", 
	"auto& vsel = frame[z.v2].AsVector()->RawVec();\n	auto& v1 = frame[z.v3].AsVector()->RawVec();\n	auto& v2 = frame[z.v4].AsVector()->RawVec();\n	auto n = v1.size();\n	vector<std::optional<ZVal>> res(n);\n	for ( auto i = 0U; i < n; ++i )\n		if ( vsel[i] )\n			res[i] = vsel[i]->AsInt() ? v1[i] : v2[i];\n	auto& full_res = frame[z.v1].AsVectorRef();\n	Unref(full_res);\n	full_res = new VectorVal(cast_intrusive<VectorType>(Z_TYPE), &res);\n"	}
},
{ OP_CONDC1_VVC,
	{
	"VVC",
	"XIX", 
	"if ( frame[z.v2].AsInt() )\n		AssignTarget(frame[z.v1], CopyVal(z.c))\n"	}
},
{ OP_CONDC2_VVC,
	{
	"VVC",
	"XIX", 
	"if ( ! frame[z.v2].AsInt() )\n		AssignTarget(frame[z.v1], CopyVal(z.c))\n"	}
},
{ OP_LT_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = z.c.AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr();\n"	}
},
{ OP_LT_VCV_T,
	{
	"VCV",
	"ITT", 
	"frame[z.v1].AsIntRef() = z.c.AsTable()->IsSubsetOf(*frame[z.v2].AsTable()) && z.c.AsTable()->Size() < frame[z.v2].AsTable()->Size();\n"	}
},
{ OP_LT_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) < 0;\n"	}
},
{ OP_LT_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() < frame[z.v2].AsDouble();\n"	}
},
{ OP_LT_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() < frame[z.v2].AsCount();\n"	}
},
{ OP_LT_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() < frame[z.v2].AsInt();\n"	}
},
{ OP_LT_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (z.c.AsAddr()->AsAddr() < frame[z.v1].AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_LT_CVb_cond_T,
	{
	"CVb",
	"TTI", 
	"if ( ! (z.c.AsTable()->IsSubsetOf(*frame[z.v1].AsTable()) && z.c.AsTable()->Size() < frame[z.v1].AsTable()->Size()) ) Branch(z.v2)"
	}
},
{ OP_LT_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) < 0) ) Branch(z.v2)"
	}
},
{ OP_LT_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() < frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_LT_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() < frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_LT_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() < frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_LT_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr();\n"	}
},
{ OP_LT_VVC_T,
	{
	"VVC",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->IsSubsetOf(*z.c.AsTable()) && frame[z.v2].AsTable()->Size() < z.c.AsTable()->Size();\n"	}
},
{ OP_LT_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) < 0;\n"	}
},
{ OP_LT_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() < z.c.AsDouble();\n"	}
},
{ OP_LT_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() < z.c.AsCount();\n"	}
},
{ OP_LT_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() < z.c.AsInt();\n"	}
},
{ OP_LT_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_LT_VCb_cond_T,
	{
	"VCb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->IsSubsetOf(*z.c.AsTable()) && frame[z.v1].AsTable()->Size() < z.c.AsTable()->Size()) ) Branch(z.v2)"
	}
},
{ OP_LT_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) < 0) ) Branch(z.v2)"
	}
},
{ OP_LT_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() < z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_LT_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() < z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_LT_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() < z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_LT_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() < frame[z.v3].AsAddr()->AsAddr();\n"	}
},
{ OP_LT_VVV_T,
	{
	"VVV",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->IsSubsetOf(*frame[z.v3].AsTable()) && frame[z.v2].AsTable()->Size() < frame[z.v3].AsTable()->Size();\n"	}
},
{ OP_LT_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) < 0;\n"	}
},
{ OP_LT_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() < frame[z.v3].AsDouble();\n"	}
},
{ OP_LT_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() < frame[z.v3].AsCount();\n"	}
},
{ OP_LT_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() < frame[z.v3].AsInt();\n"	}
},
{ OP_LT_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LT_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LT_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr()) ) Branch(z.v3)"
	}
},
{ OP_LT_VVb_cond_T,
	{
	"VVb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->IsSubsetOf(*frame[z.v2].AsTable()) && frame[z.v1].AsTable()->Size() < frame[z.v2].AsTable()->Size()) ) Branch(z.v3)"
	}
},
{ OP_LT_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) < 0) ) Branch(z.v3)"
	}
},
{ OP_LT_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() < frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_LT_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() < frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_LT_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() < frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_LE_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = z.c.AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr() || z.c.AsAddr()->AsAddr() == frame[z.v2].AsAddr()->AsAddr();\n"	}
},
{ OP_LE_VCV_T,
	{
	"VCV",
	"ITT", 
	"frame[z.v1].AsIntRef() = z.c.AsTable()->IsSubsetOf(*frame[z.v2].AsTable());\n"	}
},
{ OP_LE_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) <= 0;\n"	}
},
{ OP_LE_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() <= frame[z.v2].AsDouble();\n"	}
},
{ OP_LE_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() <= frame[z.v2].AsCount();\n"	}
},
{ OP_LE_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() <= frame[z.v2].AsInt();\n"	}
},
{ OP_LE_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (z.c.AsAddr()->AsAddr() < frame[z.v1].AsAddr()->AsAddr() || z.c.AsAddr()->AsAddr() == frame[z.v1].AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_LE_CVb_cond_T,
	{
	"CVb",
	"TTI", 
	"if ( ! (z.c.AsTable()->IsSubsetOf(*frame[z.v1].AsTable())) ) Branch(z.v2)"
	}
},
{ OP_LE_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) <= 0) ) Branch(z.v2)"
	}
},
{ OP_LE_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() <= frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_LE_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() <= frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_LE_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() <= frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_LE_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr() || frame[z.v2].AsAddr()->AsAddr() == z.c.AsAddr()->AsAddr();\n"	}
},
{ OP_LE_VVC_T,
	{
	"VVC",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->IsSubsetOf(*z.c.AsTable());\n"	}
},
{ OP_LE_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) <= 0;\n"	}
},
{ OP_LE_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() <= z.c.AsDouble();\n"	}
},
{ OP_LE_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() <= z.c.AsCount();\n"	}
},
{ OP_LE_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() <= z.c.AsInt();\n"	}
},
{ OP_LE_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr() || frame[z.v1].AsAddr()->AsAddr() == z.c.AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_LE_VCb_cond_T,
	{
	"VCb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->IsSubsetOf(*z.c.AsTable())) ) Branch(z.v2)"
	}
},
{ OP_LE_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) <= 0) ) Branch(z.v2)"
	}
},
{ OP_LE_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() <= z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_LE_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() <= z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_LE_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() <= z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_LE_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() < frame[z.v3].AsAddr()->AsAddr() || frame[z.v2].AsAddr()->AsAddr() == frame[z.v3].AsAddr()->AsAddr();\n"	}
},
{ OP_LE_VVV_T,
	{
	"VVV",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->IsSubsetOf(*frame[z.v3].AsTable());\n"	}
},
{ OP_LE_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) <= 0;\n"	}
},
{ OP_LE_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() <= frame[z.v3].AsDouble();\n"	}
},
{ OP_LE_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() <= frame[z.v3].AsCount();\n"	}
},
{ OP_LE_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() <= frame[z.v3].AsInt();\n"	}
},
{ OP_LE_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_LE_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_LE_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr() || frame[z.v1].AsAddr()->AsAddr() == frame[z.v2].AsAddr()->AsAddr()) ) Branch(z.v3)"
	}
},
{ OP_LE_VVb_cond_T,
	{
	"VVb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->IsSubsetOf(*frame[z.v2].AsTable())) ) Branch(z.v3)"
	}
},
{ OP_LE_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) <= 0) ) Branch(z.v3)"
	}
},
{ OP_LE_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() <= frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_LE_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() <= frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_LE_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() <= frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VCV_F,
	{
	"VCV",
	"IFF", 
	"frame[z.v1].AsIntRef() = z.c.AsFunc()->GetName() == frame[z.v2].AsFunc()->GetName();\n"	}
},
{ OP_EQ_VCV_N,
	{
	"VCV",
	"INN", 
	"frame[z.v1].AsIntRef() = z.c.AsSubNet()->AsSubNet() == frame[z.v2].AsSubNet()->AsSubNet();\n"	}
},
{ OP_EQ_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = z.c.AsAddr()->AsAddr() == frame[z.v2].AsAddr()->AsAddr();\n"	}
},
{ OP_EQ_VCV_T,
	{
	"VCV",
	"ITT", 
	"frame[z.v1].AsIntRef() = z.c.AsTable()->EqualTo(*frame[z.v2].AsTable());\n"	}
},
{ OP_EQ_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) == 0;\n"	}
},
{ OP_EQ_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() == frame[z.v2].AsDouble();\n"	}
},
{ OP_EQ_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() == frame[z.v2].AsCount();\n"	}
},
{ OP_EQ_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() == frame[z.v2].AsInt();\n"	}
},
{ OP_EQ_VCV_PS,
	{
	"VCV",
	"IPS", 
	"frame[z.v1].AsIntRef() = z.c.AsPattern()->MatchExactly(frame[z.v2].AsString()->AsString());\n"	}
},
{ OP_EQ_CVb_cond_F,
	{
	"CVb",
	"FFI", 
	"if ( ! (z.c.AsFunc()->GetName() == frame[z.v1].AsFunc()->GetName()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_N,
	{
	"CVb",
	"NNI", 
	"if ( ! (z.c.AsSubNet()->AsSubNet() == frame[z.v1].AsSubNet()->AsSubNet()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (z.c.AsAddr()->AsAddr() == frame[z.v1].AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_T,
	{
	"CVb",
	"TTI", 
	"if ( ! (z.c.AsTable()->EqualTo(*frame[z.v1].AsTable())) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) == 0) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() == frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() == frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() == frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_EQ_CVb_cond_PS,
	{
	"CVb",
	"PSI", 
	"if ( ! (z.c.AsPattern()->MatchExactly(frame[z.v1].AsString()->AsString())) ) Branch(z.v2)"
	}
},
{ OP_EQ_VVC_F,
	{
	"VVC",
	"IFF", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsFunc()->GetName() == z.c.AsFunc()->GetName();\n"	}
},
{ OP_EQ_VVC_N,
	{
	"VVC",
	"INN", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsSubNet()->AsSubNet() == z.c.AsSubNet()->AsSubNet();\n"	}
},
{ OP_EQ_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() == z.c.AsAddr()->AsAddr();\n"	}
},
{ OP_EQ_VVC_T,
	{
	"VVC",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->EqualTo(*z.c.AsTable());\n"	}
},
{ OP_EQ_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) == 0;\n"	}
},
{ OP_EQ_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() == z.c.AsDouble();\n"	}
},
{ OP_EQ_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() == z.c.AsCount();\n"	}
},
{ OP_EQ_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() == z.c.AsInt();\n"	}
},
{ OP_EQ_VVC_PS,
	{
	"VVC",
	"IPS", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsPattern()->MatchExactly(z.c.AsString()->AsString());\n"	}
},
{ OP_EQ_VCb_cond_F,
	{
	"VCb",
	"FFI", 
	"if ( ! (frame[z.v1].AsFunc()->GetName() == z.c.AsFunc()->GetName()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_N,
	{
	"VCb",
	"NNI", 
	"if ( ! (frame[z.v1].AsSubNet()->AsSubNet() == z.c.AsSubNet()->AsSubNet()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() == z.c.AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_T,
	{
	"VCb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->EqualTo(*z.c.AsTable())) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) == 0) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() == z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() == z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() == z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_EQ_VCb_cond_PS,
	{
	"VCb",
	"PSI", 
	"if ( ! (frame[z.v1].AsPattern()->MatchExactly(z.c.AsString()->AsString())) ) Branch(z.v2)"
	}
},
{ OP_EQ_VVV_F,
	{
	"VVV",
	"IFF", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsFunc()->GetName() == frame[z.v3].AsFunc()->GetName();\n"	}
},
{ OP_EQ_VVV_N,
	{
	"VVV",
	"INN", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsSubNet()->AsSubNet() == frame[z.v3].AsSubNet()->AsSubNet();\n"	}
},
{ OP_EQ_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() == frame[z.v3].AsAddr()->AsAddr();\n"	}
},
{ OP_EQ_VVV_T,
	{
	"VVV",
	"ITT", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsTable()->EqualTo(*frame[z.v3].AsTable());\n"	}
},
{ OP_EQ_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) == 0;\n"	}
},
{ OP_EQ_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() == frame[z.v3].AsDouble();\n"	}
},
{ OP_EQ_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() == frame[z.v3].AsCount();\n"	}
},
{ OP_EQ_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() == frame[z.v3].AsInt();\n"	}
},
{ OP_EQ_VVV_PS,
	{
	"VVV",
	"IPS", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsPattern()->MatchExactly(frame[z.v3].AsString()->AsString());\n"	}
},
{ OP_EQ_VVV_vec_F,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_F, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_N,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_N, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_EQ_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_EQ_VVb_cond_F,
	{
	"VVb",
	"FFI", 
	"if ( ! (frame[z.v1].AsFunc()->GetName() == frame[z.v2].AsFunc()->GetName()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_N,
	{
	"VVb",
	"NNI", 
	"if ( ! (frame[z.v1].AsSubNet()->AsSubNet() == frame[z.v2].AsSubNet()->AsSubNet()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() == frame[z.v2].AsAddr()->AsAddr()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_T,
	{
	"VVb",
	"TTI", 
	"if ( ! (frame[z.v1].AsTable()->EqualTo(*frame[z.v2].AsTable())) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) == 0) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() == frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() == frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() == frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_EQ_VVb_cond_PS,
	{
	"VVb",
	"PSI", 
	"if ( ! (frame[z.v1].AsPattern()->MatchExactly(frame[z.v2].AsString()->AsString())) ) Branch(z.v3)"
	}
},
{ OP_NE_VCV_F,
	{
	"VCV",
	"IFF", 
	"frame[z.v1].AsIntRef() = z.c.AsFunc()->GetName() != frame[z.v2].AsFunc()->GetName();\n"	}
},
{ OP_NE_VCV_N,
	{
	"VCV",
	"INN", 
	"frame[z.v1].AsIntRef() = z.c.AsSubNet()->AsSubNet() != frame[z.v2].AsSubNet()->AsSubNet();\n"	}
},
{ OP_NE_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = z.c.AsAddr()->AsAddr() != frame[z.v2].AsAddr()->AsAddr();\n"	}
},
{ OP_NE_VCV_T,
	{
	"VCV",
	"ITT", 
	"frame[z.v1].AsIntRef() = ! z.c.AsTable()->EqualTo(*frame[z.v2].AsTable());\n"	}
},
{ OP_NE_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) != 0;\n"	}
},
{ OP_NE_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() != frame[z.v2].AsDouble();\n"	}
},
{ OP_NE_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() != frame[z.v2].AsCount();\n"	}
},
{ OP_NE_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() != frame[z.v2].AsInt();\n"	}
},
{ OP_NE_VCV_PS,
	{
	"VCV",
	"IPS", 
	"frame[z.v1].AsIntRef() = ! z.c.AsPattern()->MatchExactly(frame[z.v2].AsString()->AsString());\n"	}
},
{ OP_NE_CVb_cond_F,
	{
	"CVb",
	"FFI", 
	"if ( ! (z.c.AsFunc()->GetName() != frame[z.v1].AsFunc()->GetName()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_N,
	{
	"CVb",
	"NNI", 
	"if ( ! (z.c.AsSubNet()->AsSubNet() != frame[z.v1].AsSubNet()->AsSubNet()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (z.c.AsAddr()->AsAddr() != frame[z.v1].AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_T,
	{
	"CVb",
	"TTI", 
	"if ( ! (! z.c.AsTable()->EqualTo(*frame[z.v1].AsTable())) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) != 0) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() != frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() != frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() != frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_NE_CVb_cond_PS,
	{
	"CVb",
	"PSI", 
	"if ( ! (! z.c.AsPattern()->MatchExactly(frame[z.v1].AsString()->AsString())) ) Branch(z.v2)"
	}
},
{ OP_NE_VVC_F,
	{
	"VVC",
	"IFF", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsFunc()->GetName() != z.c.AsFunc()->GetName();\n"	}
},
{ OP_NE_VVC_N,
	{
	"VVC",
	"INN", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsSubNet()->AsSubNet() != z.c.AsSubNet()->AsSubNet();\n"	}
},
{ OP_NE_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() != z.c.AsAddr()->AsAddr();\n"	}
},
{ OP_NE_VVC_T,
	{
	"VVC",
	"ITT", 
	"frame[z.v1].AsIntRef() = ! frame[z.v2].AsTable()->EqualTo(*z.c.AsTable());\n"	}
},
{ OP_NE_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) != 0;\n"	}
},
{ OP_NE_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() != z.c.AsDouble();\n"	}
},
{ OP_NE_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() != z.c.AsCount();\n"	}
},
{ OP_NE_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() != z.c.AsInt();\n"	}
},
{ OP_NE_VVC_PS,
	{
	"VVC",
	"IPS", 
	"frame[z.v1].AsIntRef() = ! frame[z.v2].AsPattern()->MatchExactly(z.c.AsString()->AsString());\n"	}
},
{ OP_NE_VCb_cond_F,
	{
	"VCb",
	"FFI", 
	"if ( ! (frame[z.v1].AsFunc()->GetName() != z.c.AsFunc()->GetName()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_N,
	{
	"VCb",
	"NNI", 
	"if ( ! (frame[z.v1].AsSubNet()->AsSubNet() != z.c.AsSubNet()->AsSubNet()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() != z.c.AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_T,
	{
	"VCb",
	"TTI", 
	"if ( ! (! frame[z.v1].AsTable()->EqualTo(*z.c.AsTable())) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) != 0) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() != z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() != z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() != z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_NE_VCb_cond_PS,
	{
	"VCb",
	"PSI", 
	"if ( ! (! frame[z.v1].AsPattern()->MatchExactly(z.c.AsString()->AsString())) ) Branch(z.v2)"
	}
},
{ OP_NE_VVV_F,
	{
	"VVV",
	"IFF", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsFunc()->GetName() != frame[z.v3].AsFunc()->GetName();\n"	}
},
{ OP_NE_VVV_N,
	{
	"VVV",
	"INN", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsSubNet()->AsSubNet() != frame[z.v3].AsSubNet()->AsSubNet();\n"	}
},
{ OP_NE_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr() != frame[z.v3].AsAddr()->AsAddr();\n"	}
},
{ OP_NE_VVV_T,
	{
	"VVV",
	"ITT", 
	"frame[z.v1].AsIntRef() = ! frame[z.v2].AsTable()->EqualTo(*frame[z.v3].AsTable());\n"	}
},
{ OP_NE_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) != 0;\n"	}
},
{ OP_NE_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() != frame[z.v3].AsDouble();\n"	}
},
{ OP_NE_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() != frame[z.v3].AsCount();\n"	}
},
{ OP_NE_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() != frame[z.v3].AsInt();\n"	}
},
{ OP_NE_VVV_PS,
	{
	"VVV",
	"IPS", 
	"frame[z.v1].AsIntRef() = ! frame[z.v2].AsPattern()->MatchExactly(frame[z.v3].AsString()->AsString());\n"	}
},
{ OP_NE_VVV_vec_F,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_F, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_N,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_N, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_T,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_T, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_NE_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_NE_VVb_cond_F,
	{
	"VVb",
	"FFI", 
	"if ( ! (frame[z.v1].AsFunc()->GetName() != frame[z.v2].AsFunc()->GetName()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_N,
	{
	"VVb",
	"NNI", 
	"if ( ! (frame[z.v1].AsSubNet()->AsSubNet() != frame[z.v2].AsSubNet()->AsSubNet()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr() != frame[z.v2].AsAddr()->AsAddr()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_T,
	{
	"VVb",
	"TTI", 
	"if ( ! (! frame[z.v1].AsTable()->EqualTo(*frame[z.v2].AsTable())) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) != 0) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() != frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() != frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() != frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_NE_VVb_cond_PS,
	{
	"VVb",
	"PSI", 
	"if ( ! (! frame[z.v1].AsPattern()->MatchExactly(frame[z.v2].AsString()->AsString())) ) Branch(z.v3)"
	}
},
{ OP_GE_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (z.c.AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr());\n"	}
},
{ OP_GE_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) >= 0;\n"	}
},
{ OP_GE_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() >= frame[z.v2].AsDouble();\n"	}
},
{ OP_GE_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() >= frame[z.v2].AsCount();\n"	}
},
{ OP_GE_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() >= frame[z.v2].AsInt();\n"	}
},
{ OP_GE_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (! (z.c.AsAddr()->AsAddr() < frame[z.v1].AsAddr()->AsAddr())) ) Branch(z.v2)"
	}
},
{ OP_GE_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) >= 0) ) Branch(z.v2)"
	}
},
{ OP_GE_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() >= frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_GE_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() >= frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_GE_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() >= frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_GE_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (frame[z.v2].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr());\n"	}
},
{ OP_GE_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) >= 0;\n"	}
},
{ OP_GE_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() >= z.c.AsDouble();\n"	}
},
{ OP_GE_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() >= z.c.AsCount();\n"	}
},
{ OP_GE_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() >= z.c.AsInt();\n"	}
},
{ OP_GE_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (! (frame[z.v1].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr())) ) Branch(z.v2)"
	}
},
{ OP_GE_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) >= 0) ) Branch(z.v2)"
	}
},
{ OP_GE_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() >= z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_GE_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() >= z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_GE_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() >= z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_GE_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (frame[z.v2].AsAddr()->AsAddr() < frame[z.v3].AsAddr()->AsAddr());\n"	}
},
{ OP_GE_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) >= 0;\n"	}
},
{ OP_GE_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() >= frame[z.v3].AsDouble();\n"	}
},
{ OP_GE_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() >= frame[z.v3].AsCount();\n"	}
},
{ OP_GE_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() >= frame[z.v3].AsInt();\n"	}
},
{ OP_GE_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GE_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GE_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GE_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GE_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GE_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GE_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GE_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GE_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GE_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GE_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (! (frame[z.v1].AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr())) ) Branch(z.v3)"
	}
},
{ OP_GE_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) >= 0) ) Branch(z.v3)"
	}
},
{ OP_GE_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() >= frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_GE_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() >= frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_GE_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() >= frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_GT_VCV_A,
	{
	"VCV",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (z.c.AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr()) && z.c.AsAddr()->AsAddr() != frame[z.v2].AsAddr()->AsAddr();\n"	}
},
{ OP_GT_VCV_S,
	{
	"VCV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(z.c.AsString()->AsString(), frame[z.v2].AsString()->AsString()) > 0;\n"	}
},
{ OP_GT_VCV_D,
	{
	"VCV",
	"IDD", 
	"frame[z.v1].AsIntRef() = z.c.AsDouble() > frame[z.v2].AsDouble();\n"	}
},
{ OP_GT_VCV_U,
	{
	"VCV",
	"IUU", 
	"frame[z.v1].AsIntRef() = z.c.AsCount() > frame[z.v2].AsCount();\n"	}
},
{ OP_GT_VCV_I,
	{
	"VCV",
	"III", 
	"frame[z.v1].AsIntRef() = z.c.AsInt() > frame[z.v2].AsInt();\n"	}
},
{ OP_GT_CVb_cond_A,
	{
	"CVb",
	"AAI", 
	"if ( ! (! (z.c.AsAddr()->AsAddr() < frame[z.v1].AsAddr()->AsAddr()) && z.c.AsAddr()->AsAddr() != frame[z.v1].AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_GT_CVb_cond_S,
	{
	"CVb",
	"SSI", 
	"if ( ! (Bstr_cmp(z.c.AsString()->AsString(), frame[z.v1].AsString()->AsString()) > 0) ) Branch(z.v2)"
	}
},
{ OP_GT_CVb_cond_D,
	{
	"CVb",
	"DDI", 
	"if ( ! (z.c.AsDouble() > frame[z.v1].AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_GT_CVb_cond_U,
	{
	"CVb",
	"UUI", 
	"if ( ! (z.c.AsCount() > frame[z.v1].AsCount()) ) Branch(z.v2)"
	}
},
{ OP_GT_CVb_cond_I,
	{
	"CVb",
	"III", 
	"if ( ! (z.c.AsInt() > frame[z.v1].AsInt()) ) Branch(z.v2)"
	}
},
{ OP_GT_VVC_A,
	{
	"VVC",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (frame[z.v2].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr()) && frame[z.v2].AsAddr()->AsAddr() != z.c.AsAddr()->AsAddr();\n"	}
},
{ OP_GT_VVC_S,
	{
	"VVC",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), z.c.AsString()->AsString()) > 0;\n"	}
},
{ OP_GT_VVC_D,
	{
	"VVC",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() > z.c.AsDouble();\n"	}
},
{ OP_GT_VVC_U,
	{
	"VVC",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() > z.c.AsCount();\n"	}
},
{ OP_GT_VVC_I,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() > z.c.AsInt();\n"	}
},
{ OP_GT_VCb_cond_A,
	{
	"VCb",
	"AAI", 
	"if ( ! (! (frame[z.v1].AsAddr()->AsAddr() < z.c.AsAddr()->AsAddr()) && frame[z.v1].AsAddr()->AsAddr() != z.c.AsAddr()->AsAddr()) ) Branch(z.v2)"
	}
},
{ OP_GT_VCb_cond_S,
	{
	"VCb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), z.c.AsString()->AsString()) > 0) ) Branch(z.v2)"
	}
},
{ OP_GT_VCb_cond_D,
	{
	"VCb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() > z.c.AsDouble()) ) Branch(z.v2)"
	}
},
{ OP_GT_VCb_cond_U,
	{
	"VCb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() > z.c.AsCount()) ) Branch(z.v2)"
	}
},
{ OP_GT_VCb_cond_I,
	{
	"VCb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() > z.c.AsInt()) ) Branch(z.v2)"
	}
},
{ OP_GT_VVV_A,
	{
	"VVV",
	"IAA", 
	"frame[z.v1].AsIntRef() = ! (frame[z.v2].AsAddr()->AsAddr() < frame[z.v3].AsAddr()->AsAddr()) && frame[z.v2].AsAddr()->AsAddr() != frame[z.v3].AsAddr()->AsAddr();\n"	}
},
{ OP_GT_VVV_S,
	{
	"VVV",
	"ISS", 
	"frame[z.v1].AsIntRef() = Bstr_cmp(frame[z.v2].AsString()->AsString(), frame[z.v3].AsString()->AsString()) > 0;\n"	}
},
{ OP_GT_VVV_D,
	{
	"VVV",
	"IDD", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsDouble() > frame[z.v3].AsDouble();\n"	}
},
{ OP_GT_VVV_U,
	{
	"VVV",
	"IUU", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsCount() > frame[z.v3].AsCount();\n"	}
},
{ OP_GT_VVV_I,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt() > frame[z.v3].AsInt();\n"	}
},
{ OP_GT_VVV_vec_A,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GT_VVV_vec_A, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GT_VVV_vec_S,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GT_VVV_vec_S, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GT_VVV_vec_D,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GT_VVV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GT_VVV_vec_U,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GT_VVV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GT_VVV_vec_I,
	{
	"VVV",
	"VVV", 
	"vec_exec(OP_GT_VVV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), frame[z.v3].AsVector(), z);"
	}
},
{ OP_GT_VVb_cond_A,
	{
	"VVb",
	"AAI", 
	"if ( ! (! (frame[z.v1].AsAddr()->AsAddr() < frame[z.v2].AsAddr()->AsAddr()) && frame[z.v1].AsAddr()->AsAddr() != frame[z.v2].AsAddr()->AsAddr()) ) Branch(z.v3)"
	}
},
{ OP_GT_VVb_cond_S,
	{
	"VVb",
	"SSI", 
	"if ( ! (Bstr_cmp(frame[z.v1].AsString()->AsString(), frame[z.v2].AsString()->AsString()) > 0) ) Branch(z.v3)"
	}
},
{ OP_GT_VVb_cond_D,
	{
	"VVb",
	"DDI", 
	"if ( ! (frame[z.v1].AsDouble() > frame[z.v2].AsDouble()) ) Branch(z.v3)"
	}
},
{ OP_GT_VVb_cond_U,
	{
	"VVb",
	"UUI", 
	"if ( ! (frame[z.v1].AsCount() > frame[z.v2].AsCount()) ) Branch(z.v3)"
	}
},
{ OP_GT_VVb_cond_I,
	{
	"VVb",
	"III", 
	"if ( ! (frame[z.v1].AsInt() > frame[z.v2].AsInt()) ) Branch(z.v3)"
	}
},
{ OP_MINU_VVV,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = std::min(frame[z.v2].AsCount(), frame[z.v3].AsCount());\n"	}
},
{ OP_MINU_VVC,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = std::min(frame[z.v2].AsCount(), z.c.AsCount());\n"	}
},
{ OP_MINI_VVV,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = std::min(frame[z.v2].AsInt(), frame[z.v3].AsInt());\n"	}
},
{ OP_MINI_VVC,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = std::min(frame[z.v2].AsInt(), z.c.AsInt());\n"	}
},
{ OP_MIND_VVV,
	{
	"VVV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = std::min(frame[z.v2].AsDouble(), frame[z.v3].AsDouble());\n"	}
},
{ OP_MIND_VVC,
	{
	"VVC",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = std::min(frame[z.v2].AsDouble(), z.c.AsDouble());\n"	}
},
{ OP_MAXU_VVV,
	{
	"VVV",
	"UUU", 
	"frame[z.v1].AsCountRef() = std::max(frame[z.v2].AsCount(), frame[z.v3].AsCount());\n"	}
},
{ OP_MAXU_VVC,
	{
	"VVC",
	"UUU", 
	"frame[z.v1].AsCountRef() = std::max(frame[z.v2].AsCount(), z.c.AsCount());\n"	}
},
{ OP_MAXI_VVV,
	{
	"VVV",
	"III", 
	"frame[z.v1].AsIntRef() = std::max(frame[z.v2].AsInt(), frame[z.v3].AsInt());\n"	}
},
{ OP_MAXI_VVC,
	{
	"VVC",
	"III", 
	"frame[z.v1].AsIntRef() = std::max(frame[z.v2].AsInt(), z.c.AsInt());\n"	}
},
{ OP_MAXD_VVV,
	{
	"VVV",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = std::max(frame[z.v2].AsDouble(), frame[z.v3].AsDouble());\n"	}
},
{ OP_MAXD_VVC,
	{
	"VVC",
	"DDD", 
	"frame[z.v1].AsDoubleRef() = std::max(frame[z.v2].AsDouble(), z.c.AsDouble());\n"	}
},
{ OP_FUNC_ID_STRING_VV,
	{
	"VV",
	"SR", 
	"auto id_rec = frame[z.v2].AsRecord();\n	auto orig_h = DirectField(id_rec, 0).AsAddr()->AsAddr().AsString();\n	auto resp_h = DirectField(id_rec, 2).AsAddr()->AsAddr().AsString();\n	auto orig_p = static_cast<uint32_t>(DirectField(id_rec, 1).AsCount()) & ~PORT_SPACE_MASK;\n	auto resp_p = static_cast<uint32_t>(DirectField(id_rec, 3).AsCount()) & ~PORT_SPACE_MASK;\n	/* Maximum address size is for IPv6 with no compression. Each\n	 * 8 16-bit hex elements plus 7 colons between them plus the two []'s\n	 * = 8*4 + 7 + 2 = 41 characters.\n	 *\n	 * Maximum port size is 5.\n	 *\n	 * Two of these = 2*41 + 2*5 = 92.\n	 * Other delimiters: two ':', one ' < ' for 5 more.\n	 *\n	 * TOTAL: 97 characters.\n	 *\n	 * We use considerably more for safety.\n	 */\n	char buf[128];\n	snprintf(buf, sizeof buf, \"%s:%u > %s:%u\", orig_h.c_str(), orig_p, resp_h.c_str(), resp_p);\n	Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = new StringVal(buf);\n"	}
},
{ OP_SCHEDULE_ViHL,
	{
	"ViHL",
	"DIXX", 
	"EvalSchedule(frame[z.v1].AsDouble(), z.v2)\n"	}
},
{ OP_SCHEDULE_CiHL,
	{
	"CiHL",
	"DIXX", 
	"EvalSchedule(z.c.AsDouble(), z.v1)\n"	}
},
{ OP_SCHEDULE0_ViH,
	{
	"ViH",
	"DIX", 
	"EvalScheduleArgs(frame[z.v1].AsDouble(), z.v2,)\n"	}
},
{ OP_SCHEDULE0_CiH,
	{
	"CiH",
	"DIX", 
	"EvalScheduleArgs(z.c.AsDouble(), z.v1,)\n"	}
},
{ OP_EVENT_HL,
	{
	"HL",
	"",
	"ValVec args;\n	Z_AUX->FillValVec(args, frame);\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_EVENT0_X,
	{
	"X",
	"",
	"ValVec args(0);\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_EVENT1_V,
	{
	"V",
	"",
	"ValVec args(1);\n	args[0] = frame[z.v1].ToVal(Z_TYPE);\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_EVENT2_VV,
	{
	"VV",
	"",
	"ValVec args(2);\n	args[0] = frame[z.v1].ToVal(Z_TYPE);\n	args[1] = frame[z.v2].ToVal(Z_TYPE2);\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_EVENT3_VVV,
	{
	"VVV",
	"",
	"ValVec args(3);\n	auto& aux = Z_AUX;\n	args[0] = frame[z.v1].ToVal(Z_TYPE);\n	args[1] = frame[z.v2].ToVal(Z_TYPE2);\n	args[2] = frame[z.v3].ToVal(aux->elems[2].GetType());\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_EVENT4_VVVV,
	{
	"VVVV",
	"",
	"ValVec args(4);\n	auto& aux = Z_AUX;\n	args[0] = frame[z.v1].ToVal(Z_TYPE);\n	args[1] = frame[z.v2].ToVal(Z_TYPE2);\n	args[2] = frame[z.v3].ToVal(aux->elems[2].GetType());\n	args[3] = frame[z.v4].ToVal(aux->elems[3].GetType());\n	QueueEvent(Z_AUX_EVENT_HANDLER, args);\n"	}
},
{ OP_RETURN_X,
	{
	"X",
	"",
	"EvalReturn(nullptr,)\n"	}
},
{ OP_RETURN_V,
	{
	"V",
	"",
	"EvalReturn(&frame[z.v1], SET_RET_TYPE(Z_TYPE))\n"	}
},
{ OP_RETURN_C,
	{
	"C",
	"",
	"EvalReturn(&z.c, SET_RET_TYPE(Z_TYPE))\n"	}
},
{ OP_WHEN_RETURN_X,
	{
	"X",
	"",
	"static auto any_val = ZVal();\n	EvalReturn(&any_val,);\n"	}
},
{ OP_SWITCHI_Vii,
	{
	"Vii",
	"III", 
	"auto v = frame[z.v1].AsInt();\n	EvalSwitchBody(z.v2, z.v3, int_cases,)\n"	}
},
{ OP_SWITCHU_Vii,
	{
	"Vii",
	"UII", 
	"auto v = frame[z.v1].AsCount();\n	EvalSwitchBody(z.v2, z.v3, uint_cases,)\n"	}
},
{ OP_SWITCHD_Vii,
	{
	"Vii",
	"DII", 
	"auto v = frame[z.v1].AsDouble();\n	EvalSwitchBody(z.v2, z.v3, double_cases,)\n"	}
},
{ OP_SWITCHS_Vii,
	{
	"Vii",
	"SII", 
	"auto vs = frame[z.v1].AsString()->AsString()->Render();\n	std::string v(vs);\n	EvalSwitchBody(z.v2, z.v3, str_cases,delete[] vs;)\n"	}
},
{ OP_SWITCHA_Vii,
	{
	"Vii",
	"AII", 
	"auto v = frame[z.v1].AsAddr()->AsAddr().AsString();\n	EvalSwitchBody(z.v2, z.v3, str_cases,)\n"	}
},
{ OP_SWITCHN_Vii,
	{
	"Vii",
	"NII", 
	"auto v = frame[z.v1].AsSubNet()->AsSubNet().AsString();\n	EvalSwitchBody(z.v2, z.v3, str_cases,)\n"	}
},
{ OP_DETERMINE_TYPE_MATCH_VV,
	{
	"VV",
	"Ia", 
	"auto& aux = Z_AUX;\n	int match = -1;\n	for ( int i = 0; i < aux->n; ++i )\n		{\n		auto& el = aux->elems[i];\n		auto& et = el.GetType();\n		if ( can_cast_value_to_type(frame[z.v2].AsAny(), et.get()) )\n			{\n			match = i;\n			if ( el.Slot() >= 0 )\n				{\n				auto& tv = frame[el.Slot()];\n				if ( el.IsManaged() )\n					Unref(tv.ManagedVal());\n				tv = ZVal(cast_value_to_type(frame[z.v2].AsAny(), et.get()), et);\n				}\n			break;\n			}\n		}\n	frame[z.v1].AsIntRef() = match;\n"	}
},
{ OP_CHECKANYLEN_Vi,
	{
	"Vi",
	"LU", 
	"auto v = frame[z.v1].AsList();\n	if ( v->Vals().size() != zeek_uint_t(z.v2) )\n		ERROR(\"mismatch in list lengths\");\n"	}
},
{ OP_PRINT_O,
	{
	"O",
	"",
	"do_print_stmt(Z_AUX->ToValVec(frame));\n"	}
},
{ OP_PRINT1_V,
	{
	"V",
	"",
	"std::vector<ValPtr> vals;\n	vals.push_back(frame[z.v1].ToVal(Z_TYPE));\n	do_print_stmt(vals);\n"	}
},
{ OP_PRINT1_C,
	{
	"C",
	"",
	"std::vector<ValPtr> vals;\n	vals.push_back(z.c.ToVal(Z_TYPE));\n	do_print_stmt(vals);\n"	}
},
{ OP_IF_ELSE_Vb,
	{
	"Vb",
	"II", 
	"if ( ! frame[z.v1].AsInt() ) Branch(z.v2)\n"	}
},
{ OP_IF_Vb,
	{
	"Vb",
	"II", 
	"if ( ! frame[z.v1].AsInt() ) Branch(z.v2)\n"	}
},
{ OP_IF_NOT_Vb,
	{
	"Vb",
	"II", 
	"if ( frame[z.v1].AsInt() ) Branch(z.v2)\n"	}
},
{ OP_ADDSTMT_VO,
	{
	"VO",
	"",
	"auto indices = Z_AUX->ToListVal(frame);\n	EvalAddStmt(frame[z.v1], indices)\n"	}
},
{ OP_ADDSTMT1_VV,
	{
	"VV",
	"",
	"EvalAddStmt(frame[z.v1], frame[z.v2].ToVal(Z_TYPE))\n"	}
},
{ OP_ADDSTMT1_VC,
	{
	"VC",
	"",
	"EvalAddStmt(frame[z.v1], z.c.ToVal(Z_TYPE))\n"	}
},
{ OP_CLEARTABLE_V,
	{
	"V",
	"T", 
	"frame[z.v1].AsTable()->RemoveAll();\n"	}
},
{ OP_CLEARVECTOR_V,
	{
	"V",
	"V", 
	"frame[z.v1].AsVector()->Resize(0);\n"	}
},
{ OP_DELTABLE_VO,
	{
	"VO",
	"TX", 
	"auto indices = Z_AUX->ToListVal(frame);\n	bool iterators_invalidated = false;\n	frame[z.v1].AsTable()->Remove(*indices, true, &iterators_invalidated);\n	if ( iterators_invalidated )\n		WARN(\"possible loop/iterator invalidation\");\n"	}
},
{ OP_DELFIELD_Vi,
	{
	"Vi",
	"RI", 
	"frame[z.v1].AsRecord()->Remove(z.v2);\n"	}
},
{ OP_INIT_RECORD_V,
	{
	"V",
	"R", 
	"auto r = new RecordVal(cast_intrusive<RecordType>(Z_TYPE));\n	Unref(frame[z.v1].AsRecordRef());\n	frame[z.v1].AsRecordRef() = r;\n"	}
},
{ OP_INIT_VECTOR_V,
	{
	"V",
	"V", 
	"auto vt = cast_intrusive<VectorType>(Z_TYPE);\n	auto vec = new VectorVal(std::move(vt));\n	Unref(frame[z.v1].AsVectorRef());\n	frame[z.v1].AsVectorRef() = vec;\n"	}
},
{ OP_INIT_TABLE_V,
	{
	"V",
	"T", 
	"auto tt = cast_intrusive<TableType>(Z_TYPE);\n	auto t = new TableVal(tt, Z_AUX_ATTRS);\n	Unref(frame[z.v1].AsTableRef());\n	frame[z.v1].AsTableRef() = t;\n"	}
},
{ OP_WHEN_V,
	{
	"V",
	"F", 
	"BuildWhen(frame[z.v1].AsFunc(), -1.0)\n"	}
},
{ OP_WHEN_TIMEOUT_VV,
	{
	"VV",
	"FD", 
	"BuildWhen(frame[z.v1].AsFunc(), frame[z.v2].AsDouble())\n"	}
},
{ OP_WHEN_TIMEOUT_VC,
	{
	"VC",
	"FD", 
	"BuildWhen(frame[z.v1].AsFunc(), z.c.AsDouble())\n"	}
},
{ OP_ASSIGN_VC_A,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsAddr());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsAddr());"
	}
},
{ OP_ASSIGN_VC_a,
	{
	"VC",
	"",
	"auto v = z.c.ToVal(Z_TYPE);"
	"auto& f = frame[z.v1];"
	"zeek::Unref(f.ManagedVal());"
	"f = ZVal(v.release());"
	}
},
{ OP_ASSIGN_VC_U,
	{
	"VC",
	"",
	"frame[z.v1] = ZVal(z.c.AsCount());"
	}
},
{ OP_ASSIGN_VC_D,
	{
	"VC",
	"",
	"frame[z.v1] = ZVal(z.c.AsDouble());"
	}
},
{ OP_ASSIGN_VC_f,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsFile());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsFile());"
	}
},
{ OP_ASSIGN_VC_F,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsFunc());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsFunc());"
	}
},
{ OP_ASSIGN_VC_I,
	{
	"VC",
	"",
	"frame[z.v1] = ZVal(z.c.AsInt());"
	}
},
{ OP_ASSIGN_VC_L,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsList());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsList());"
	}
},
{ OP_ASSIGN_VC_O,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsOpaque());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsOpaque());"
	}
},
{ OP_ASSIGN_VC_P,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsPattern());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsPattern());"
	}
},
{ OP_ASSIGN_VC_R,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsRecord());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsRecord());"
	}
},
{ OP_ASSIGN_VC_S,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsString());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsString());"
	}
},
{ OP_ASSIGN_VC_N,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsSubNet());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsSubNet());"
	}
},
{ OP_ASSIGN_VC_T,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsTable());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsTable());"
	}
},
{ OP_ASSIGN_VC_t,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsType());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsType());"
	}
},
{ OP_ASSIGN_VC_V,
	{
	"VC",
	"",
	"zeek::Ref(z.c.AsVector());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(z.c.AsVector());"
	}
},
{ OP_ASSIGN_VV_A,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsAddr());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsAddr());"
	}
},
{ OP_ASSIGN_VV_a,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsAny());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsAny());"
	}
},
{ OP_ASSIGN_VV_U,
	{
	"VV",
	"",
	"frame[z.v1] = ZVal(frame[z.v2].AsCount());"
	}
},
{ OP_ASSIGN_VV_D,
	{
	"VV",
	"",
	"frame[z.v1] = ZVal(frame[z.v2].AsDouble());"
	}
},
{ OP_ASSIGN_VV_f,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsFile());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsFile());"
	}
},
{ OP_ASSIGN_VV_F,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsFunc());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsFunc());"
	}
},
{ OP_ASSIGN_VV_I,
	{
	"VV",
	"",
	"frame[z.v1] = ZVal(frame[z.v2].AsInt());"
	}
},
{ OP_ASSIGN_VV_L,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsList());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsList());"
	}
},
{ OP_ASSIGN_VV_O,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsOpaque());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsOpaque());"
	}
},
{ OP_ASSIGN_VV_P,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsPattern());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsPattern());"
	}
},
{ OP_ASSIGN_VV_R,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsRecord());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsRecord());"
	}
},
{ OP_ASSIGN_VV_S,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsString());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsString());"
	}
},
{ OP_ASSIGN_VV_N,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsSubNet());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsSubNet());"
	}
},
{ OP_ASSIGN_VV_T,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsTable());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsTable());"
	}
},
{ OP_ASSIGN_VV_t,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsType());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsType());"
	}
},
{ OP_ASSIGN_VV_V,
	{
	"VV",
	"",
	"zeek::Ref(frame[z.v2].AsVector());"
	"zeek::Unref(frame[z.v1].ManagedVal());"
	"frame[z.v1] = ZVal(frame[z.v2].AsVector());"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_A,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsAddr());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_a,
	{
	"FCi",
	"",
	"auto v = z.c.ToVal(Z_TYPE);"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = ZVal(v.release());"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_U,
	{
	"FCi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_D,
	{
	"FCi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_f,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsFile());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_F,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsFunc());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_I,
	{
	"FCi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_L,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsList());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_O,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsOpaque());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_P,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsPattern());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_R,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsRecord());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_S,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsString());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_N,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsSubNet());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_T,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsTable());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_t,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsType());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCi_V,
	{
	"FCi",
	"",
	"zeek::Ref(z.c.AsVector());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v2);"
	"zeek::Unref(f.ManagedVal());"
	"f = z.c;"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_A,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsAddr());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_a,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsAny());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_U,
	{
	"FVi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_D,
	{
	"FVi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_f,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsFile());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_F,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsFunc());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_I,
	{
	"FVi",
	"",
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_L,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsList());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_O,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsOpaque());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_P,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsPattern());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_R,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsRecord());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_S,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsString());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_N,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsSubNet());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_T,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsTable());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_t,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsType());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVi_V,
	{
	"FVi",
	"",
	"zeek::Ref(frame[z.v2].AsVector());"
	"auto r = frame[z.v1].AsRecord();"
	"auto& f = DirectField(r, z.v3);"
	"zeek::Unref(f.ManagedVal());"
	"f = frame[z.v2];"
	"r->Modified();"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_A,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsAddr());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_a,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsAny());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_U,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_D,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_f,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsFile());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_F,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsFunc());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_I,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_L,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsList());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_O,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsOpaque());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_P,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsPattern());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_R,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsRecord());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_S,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsString());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_N,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsSubNet());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_T,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsTable());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_t,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsType());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FVii_V,
	{
	"FVii",
	"",
	"auto v = DirectOptField(frame[z.v2].AsRecord(), z.v3); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v4); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsVector());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_A,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsAddr());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_a,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsAny());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_U,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_D,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_f,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsFile());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_F,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsFunc());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_I,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_L,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsList());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_O,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsOpaque());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_P,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsPattern());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_R,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsRecord());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_S,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsString());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_N,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsSubNet());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_T,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsTable());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_t,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsType());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_FIELD_LHS_ASSIGN_FCii_V,
	{
	"FCii",
	"",
	"auto v = DirectOptField(z.c.AsRecord(), z.v2); // note, RHS field before LHS field\n"	"if ( ! v )"
		"{"
		"ZAM_run_time_error(Z_LOC, \"field value missing\");"
		"}"
	"else"
		"{"
		"auto r = frame[z.v1].AsRecord();"
		"auto& f = DirectField(r, z.v3); // note, LHS field after RHS field\n"		"zeek::Ref((*v).AsVector());"
		"zeek::Unref(f.ManagedVal());"
		"f = *v;"
		"r->Modified();"
		"}"
	}
},
{ OP_CLONE_VV,
	{
	"VV",
	"XX", 
	"auto v = frame[z.v2].ToVal(Z_TYPE2)->Clone();\n	AssignTarget(frame[z.v1], BuildVal(v, Z_TYPE))\n"	}
},
{ OP_SIZE_VV,
	{
	"VV",
	"XX", 
	"auto v = frame[z.v2].ToVal(Z_TYPE2)->SizeVal();\n	frame[z.v1] = BuildVal(v, Z_TYPE);\n"	}
},
{ OP_SIZE_VV_V,
	{
	"VV",
	"XV", 
	"frame[z.v1] = ZVal(zeek_uint_t(frame[z.v2].AsVector()->Size()));\n"	}
},
{ OP_SIZE_VV_T,
	{
	"VV",
	"XT", 
	"frame[z.v1] = ZVal(zeek_uint_t(frame[z.v2].AsTable()->Size()));\n"	}
},
{ OP_SIZE_VV_S,
	{
	"VV",
	"XS", 
	"frame[z.v1] = ZVal(zeek_uint_t(frame[z.v2].AsString()->Len()));\n"	}
},
{ OP_SIZE_VV_N,
	{
	"VV",
	"XN", 
	"frame[z.v1] = ZVal(pow(2.0, double(128 - frame[z.v2].AsSubNet()->AsSubNet().LengthIPv6())));\n"	}
},
{ OP_SIZE_VV_A,
	{
	"VV",
	"XA", 
	"frame[z.v1] = ZVal(zeek_uint_t(frame[z.v2].AsAddr()->AsAddr().GetFamily() == IPv4 ? 32 : 128));\n"	}
},
{ OP_SIZE_VV_D,
	{
	"VV",
	"XD", 
	"frame[z.v1] = ZVal(frame[z.v2].AsDouble() < 0 ? -frame[z.v2].AsDouble() : frame[z.v2].AsDouble());\n"	}
},
{ OP_SIZE_VV_U,
	{
	"VV",
	"XU", 
	"frame[z.v1] = ZVal(frame[z.v2].AsCount());\n"	}
},
{ OP_SIZE_VV_I,
	{
	"VV",
	"XI", 
	"frame[z.v1] = ZVal(zeek_int_t(frame[z.v2].AsInt() < 0 ? -frame[z.v2].AsInt() : frame[z.v2].AsInt()));\n"	}
},
{ OP_SIZE_VVi_field,
	{
	"VVi",
	"XXI", 
	"auto v = frame[z.v2].ToVal(Z_TYPE2)->SizeVal();\n	DirectField(frame[z.v1].AsRecord(), z.v3) = BuildVal(v, Z_TYPE);\n"	}
},
{ OP_SIZE_VVi_field_V,
	{
	"VVi",
	"XVI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(zeek_uint_t(frame[z.v2].AsVector()->Size()));\n"	}
},
{ OP_SIZE_VVi_field_T,
	{
	"VVi",
	"XTI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(zeek_uint_t(frame[z.v2].AsTable()->Size()));\n"	}
},
{ OP_SIZE_VVi_field_S,
	{
	"VVi",
	"XSI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(zeek_uint_t(frame[z.v2].AsString()->Len()));\n"	}
},
{ OP_SIZE_VVi_field_N,
	{
	"VVi",
	"XNI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(pow(2.0, double(128 - frame[z.v2].AsSubNet()->AsSubNet().LengthIPv6())));\n"	}
},
{ OP_SIZE_VVi_field_A,
	{
	"VVi",
	"XAI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(zeek_uint_t(frame[z.v2].AsAddr()->AsAddr().GetFamily() == IPv4 ? 32 : 128));\n"	}
},
{ OP_SIZE_VVi_field_D,
	{
	"VVi",
	"XDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(frame[z.v2].AsDouble() < 0 ? -frame[z.v2].AsDouble() : frame[z.v2].AsDouble());\n"	}
},
{ OP_SIZE_VVi_field_U,
	{
	"VVi",
	"XUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(frame[z.v2].AsCount());\n"	}
},
{ OP_SIZE_VVi_field_I,
	{
	"VVi",
	"XII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3) = ZVal(zeek_int_t(frame[z.v2].AsInt() < 0 ? -frame[z.v2].AsInt() : frame[z.v2].AsInt()));\n"	}
},
{ OP_NOT_VC_I,
	{
	"VC",
	"II", 
	"frame[z.v1].AsIntRef() = ! z.c.AsInt();\n"	}
},
{ OP_NOT_VCi_field_I,
	{
	"VCi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsIntRef() = ! z.c.AsInt();\n"	}
},
{ OP_NOT_VV_I,
	{
	"VV",
	"II", 
	"frame[z.v1].AsIntRef() = ! frame[z.v2].AsInt();\n"	}
},
{ OP_NOT_VVi_field_I,
	{
	"VVi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = ! frame[z.v2].AsInt();\n"	}
},
{ OP_COMPLEMENT_VC_U,
	{
	"VC",
	"UU", 
	"frame[z.v1].AsCountRef() = ~ z.c.AsCount();\n"	}
},
{ OP_COMPLEMENT_VCi_field_U,
	{
	"VCi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsCountRef() = ~ z.c.AsCount();\n"	}
},
{ OP_COMPLEMENT_VV_U,
	{
	"VV",
	"UU", 
	"frame[z.v1].AsCountRef() = ~ frame[z.v2].AsCount();\n"	}
},
{ OP_COMPLEMENT_VVi_field_U,
	{
	"VVi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = ~ frame[z.v2].AsCount();\n"	}
},
{ OP_POSITIVE_VC_D,
	{
	"VC",
	"DD", 
	"frame[z.v1].AsDoubleRef() = z.c.AsDouble();\n"	}
},
{ OP_POSITIVE_VC_U,
	{
	"VC",
	"UU", 
	"frame[z.v1].AsCountRef() = z.c.AsCount();\n"	}
},
{ OP_POSITIVE_VC_I,
	{
	"VC",
	"II", 
	"frame[z.v1].AsIntRef() = z.c.AsInt();\n"	}
},
{ OP_POSITIVE_VCi_field_D,
	{
	"VCi",
	"RDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsDoubleRef() = z.c.AsDouble();\n"	}
},
{ OP_POSITIVE_VCi_field_U,
	{
	"VCi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsCountRef() = z.c.AsCount();\n"	}
},
{ OP_POSITIVE_VCi_field_I,
	{
	"VCi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsIntRef() = z.c.AsInt();\n"	}
},
{ OP_POSITIVE_VV_D,
	{
	"VV",
	"DD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble();\n"	}
},
{ OP_POSITIVE_VV_U,
	{
	"VV",
	"UU", 
	"frame[z.v1].AsCountRef() = frame[z.v2].AsCount();\n"	}
},
{ OP_POSITIVE_VV_I,
	{
	"VV",
	"II", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsInt();\n"	}
},
{ OP_POSITIVE_VVi_field_D,
	{
	"VVi",
	"RDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = frame[z.v2].AsDouble();\n"	}
},
{ OP_POSITIVE_VVi_field_U,
	{
	"VVi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = frame[z.v2].AsCount();\n"	}
},
{ OP_POSITIVE_VVi_field_I,
	{
	"VVi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = frame[z.v2].AsInt();\n"	}
},
{ OP_POSITIVE_VV_vec_D,
	{
	"VV",
	"VV", 
	"vec_exec(OP_POSITIVE_VV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_POSITIVE_VV_vec_U,
	{
	"VV",
	"VV", 
	"vec_exec(OP_POSITIVE_VV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_POSITIVE_VV_vec_I,
	{
	"VV",
	"VV", 
	"vec_exec(OP_POSITIVE_VV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_NEGATE_VC_D,
	{
	"VC",
	"DD", 
	"frame[z.v1].AsDoubleRef() = -z.c.AsDouble();\n"	}
},
{ OP_NEGATE_VC_U,
	{
	"VC",
	"UU", 
	"frame[z.v1].AsCountRef() = -z.c.AsCount();\n"	}
},
{ OP_NEGATE_VC_I,
	{
	"VC",
	"II", 
	"frame[z.v1].AsIntRef() = -z.c.AsInt();\n"	}
},
{ OP_NEGATE_VCi_field_D,
	{
	"VCi",
	"RDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsDoubleRef() = -z.c.AsDouble();\n"	}
},
{ OP_NEGATE_VCi_field_U,
	{
	"VCi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsCountRef() = -z.c.AsCount();\n"	}
},
{ OP_NEGATE_VCi_field_I,
	{
	"VCi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v2).AsIntRef() = -z.c.AsInt();\n"	}
},
{ OP_NEGATE_VV_D,
	{
	"VV",
	"DD", 
	"frame[z.v1].AsDoubleRef() = -frame[z.v2].AsDouble();\n"	}
},
{ OP_NEGATE_VV_U,
	{
	"VV",
	"UU", 
	"frame[z.v1].AsCountRef() = -frame[z.v2].AsCount();\n"	}
},
{ OP_NEGATE_VV_I,
	{
	"VV",
	"II", 
	"frame[z.v1].AsIntRef() = -frame[z.v2].AsInt();\n"	}
},
{ OP_NEGATE_VVi_field_D,
	{
	"VVi",
	"RDI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsDoubleRef() = -frame[z.v2].AsDouble();\n"	}
},
{ OP_NEGATE_VVi_field_U,
	{
	"VVi",
	"RUI", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsCountRef() = -frame[z.v2].AsCount();\n"	}
},
{ OP_NEGATE_VVi_field_I,
	{
	"VVi",
	"RII", 
	"DirectField(frame[z.v1].AsRecord(), z.v3).AsIntRef() = -frame[z.v2].AsInt();\n"	}
},
{ OP_NEGATE_VV_vec_D,
	{
	"VV",
	"VV", 
	"vec_exec(OP_NEGATE_VV_vec_D, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_NEGATE_VV_vec_U,
	{
	"VV",
	"VV", 
	"vec_exec(OP_NEGATE_VV_vec_U, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_NEGATE_VV_vec_I,
	{
	"VV",
	"VV", 
	"vec_exec(OP_NEGATE_VV_vec_I, Z_TYPE, frame[z.v1].AsVectorRef(), frame[z.v2].AsVector(), z);"
	}
},
{ OP_INCRI_V,
	{
	"V",
	"I", 
	"++frame[z.v1].AsIntRef();\n"	}
},
{ OP_INCRU_V,
	{
	"V",
	"U", 
	"++frame[z.v1].AsCountRef();\n"	}
},
{ OP_DECRI_V,
	{
	"V",
	"I", 
	"--frame[z.v1].AsIntRef();\n"	}
},
{ OP_DECRU_V,
	{
	"V",
	"U", 
	"auto& u = frame[z.v1].AsCountRef();\n	if ( u == 0 )\n		WARN(\"count underflow\");\n	--u;\n"	}
},
{ OP_APPENDTO_VC,
	{
	"VC",
	"",
	"auto vv = frame[z.v1].AsVector();\n	if ( vv->Size() == 0 )\n		/* Use the slightly more expensive Assign(), since it\n		 * knows how to deal with empty vectors that do not yet\n		 * have concrete types.\n		 */\n		vv->Assign(0, z.c.ToVal(Z_TYPE));\n	else\n		{\n		vv->RawVec().push_back(CopyVal(z.c));\n		vv->Modified();\n		}\n"	}
},
{ OP_APPENDTO_VV,
	{
	"VV",
	"",
	"auto vv = frame[z.v1].AsVector();\n	if ( vv->Size() == 0 )\n		/* Use the slightly more expensive Assign(), since it\n		 * knows how to deal with empty vectors that do not yet\n		 * have concrete types.\n		 */\n		vv->Assign(0, frame[z.v2].ToVal(Z_TYPE));\n	else\n		{\n		vv->RawVec().push_back(CopyVal(frame[z.v2]));\n		vv->Modified();\n		}\n"	}
},
{ OP_APPENDTOANYVEC_VC,
	{
	"VC",
	"",
	"auto vv = frame[z.v1].AsVector();\n	vv->Assign(vv->Size(), z.c.ToVal(Z_TYPE));\n"	}
},
{ OP_APPENDTOANYVEC_VV,
	{
	"VV",
	"",
	"auto vv = frame[z.v1].AsVector();\n	vv->Assign(vv->Size(), frame[z.v2].ToVal(Z_TYPE));\n"	}
},
{ OP_ADDPATTERNTOFIELD_VVi,
	{
	"VVi",
	"RPI", 
	"auto r = frame[z.v1].AsRecordRef();\n	auto fpat = r->GetField(z.v3)->AsPatternVal();\n	if ( fpat )\n		{\n		frame[z.v2].AsPattern()->AddTo(fpat, false);\n		r->Modified();\n		}\n	else\n		ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v3)));\n"	}
},
{ OP_ADDPATTERNTOFIELD_VCi,
	{
	"VCi",
	"RPI", 
	"auto r = frame[z.v1].AsRecordRef();\n	auto fpat = r->GetField(z.v2)->AsPatternVal();\n	if ( fpat )\n		{\n		z.c.AsPattern()->AddTo(fpat, false);\n		r->Modified();\n		}\n	else\n		ERROR(util::fmt(\"field value missing: $%s\", r->GetType()->AsRecordType()->FieldName(z.v2)));\n"	}
},
{ OP_EXTENDPATTERN_VC,
	{
	"VC",
	"",
	"z.c.AsPattern()->AddTo(frame[z.v1].AsPattern(), false);\n"	}
},
{ OP_EXTENDPATTERN_VV,
	{
	"VV",
	"",
	"frame[z.v2].AsPattern()->AddTo(frame[z.v1].AsPattern(), false);\n"	}
},
{ OP_ADDVECTOVEC_VC,
	{
	"VC",
	"",
	"if ( ! z.c.AsVector()->AddTo(frame[z.v1].AsVector(), false) )\n		ERROR(\"incompatible vector element assignment\");\n"	}
},
{ OP_ADDVECTOVEC_VV,
	{
	"VV",
	"",
	"if ( ! frame[z.v2].AsVector()->AddTo(frame[z.v1].AsVector(), false) )\n		ERROR(\"incompatible vector element assignment\");\n"	}
},
{ OP_ADDTABLETOTABLE_VC,
	{
	"VC",
	"",
	"auto t = frame[z.v1].AsTable();\n	auto v = z.c.AsTable();\n	if ( v->Size() > 0 )\n		{\n		v->AddTo(t, false);\n		t->Modified();\n		}\n"	}
},
{ OP_ADDTABLETOTABLE_VV,
	{
	"VV",
	"",
	"auto t = frame[z.v1].AsTable();\n	auto v = frame[z.v2].AsTable();\n	if ( v->Size() > 0 )\n		{\n		v->AddTo(t, false);\n		t->Modified();\n		}\n"	}
},
{ OP_REMOVETABLEFROMTABLE_VC,
	{
	"VC",
	"",
	"auto t = frame[z.v1].AsTable();\n	auto v = z.c.AsTable();\n	if ( v->Size() > 0 )\n		{\n		v->RemoveFrom(t);\n		t->Modified();\n		}\n"	}
},
{ OP_REMOVETABLEFROMTABLE_VV,
	{
	"VV",
	"",
	"auto t = frame[z.v1].AsTable();\n	auto v = frame[z.v2].AsTable();\n	if ( v->Size() > 0 )\n		{\n		v->RemoveFrom(t);\n		t->Modified();\n		}\n"	}
},
{ OP_CAST_VC,
	{
	"VC",
	"XX", 
	"EvalCast(frame[z.v1], z.c.ToVal(Z_TYPE2))\n"	}
},
{ OP_CAST_VV,
	{
	"VV",
	"XX", 
	"EvalCast(frame[z.v1], frame[z.v2].ToVal(Z_TYPE2))\n"	}
},
{ OP_IS_VV,
	{
	"VV",
	"IX", 
	"auto rhs = frame[z.v2].ToVal(Z_TYPE2).get();\n	frame[z.v1].AsIntRef() = can_cast_value_to_type(rhs, Z_TYPE.get());\n"	}
},
{ OP_SET_FILE_HANDLE_V,
	{
	"V",
	"S", 
	"ZAM::file_mgr_set_handle(frame[z.v1].AsString());\n"	}
},
{ OP_SUBNET_TO_ADDR_VV,
	{
	"VV",
	"XN", 
	"auto addr_v = make_intrusive<AddrVal>(frame[z.v2].AsSubNet()->Prefix());\n	ZVal::DeleteManagedType(frame[z.v1]);\n	frame[z.v1] = ZVal(std::move(addr_v));\n"	}
},
{ OP_SUB_BYTES_VVVV,
	{
	"VVVV",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), frame[z.v3].AsCount(), frame[z.v4].AsInt())\n"	}
},
{ OP_SUB_BYTES_VVVC,
	{
	"VVVC",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), frame[z.v3].AsCount(), z.c.AsInt())\n"	}
},
{ OP_SUB_BYTES_VVCV,
	{
	"VVCV",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), z.c.AsCount(), frame[z.v3].AsInt())\n"	}
},
{ OP_SUB_BYTES_VCVV,
	{
	"VCVV",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), z.c.AsString(), frame[z.v2].AsCount(), frame[z.v3].AsInt())\n"	}
},
{ OP_SUB_BYTES_VVCi,
	{
	"VVCi",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), frame[z.v2].AsString(), z.c.AsCount(), z.v3)\n"	}
},
{ OP_SUB_BYTES_VCVi,
	{
	"VCVi",
	"SSUI", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), z.c.AsString(), frame[z.v2].AsCount(), z.v3)\n"	}
},
{ OP_SUB_BYTES2_VCVi,
	{
	"VCVi",
	"SSIU", 
	"EvalSubBytes(frame[z.v1].AsStringRef(), z.c.AsString(), zeek_uint_t(z.v3), frame[z.v2].AsInt())\n"	}
},
{ OP_TIME_TO_DOUBLE_VV,
	{
	"VV",
	"DD", 
	"frame[z.v1].AsDoubleRef() = frame[z.v2].AsDouble();\n"	}
},
{ OP_TO_LOWER_VV,
	{
	"VV",
	"SS", 
	"auto sv = ZAM_to_lower(frame[z.v2].AsString());\n	Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = sv;\n"	}
},
{ OP_LOG_WRITE_VVV,
	{
	"VVV",
	"IXR", 
	"LogWritePre(LogEnum(frame[z.v2]), frame[z.v3].AsRecord())\n	LogWriteResPost(frame[z.v1].AsIntRef())\n"	}
},
{ OP_LOG_WRITEC_VCV,
	{
	"VCV",
	"IXR", 
	"LogWritePre(LogEnum(z.c), frame[z.v2].AsRecord())\n	LogWriteResPost(frame[z.v1].AsIntRef())\n"	}
},
{ OP_LOG_WRITE_VV,
	{
	"VV",
	"XR", 
	"LogWritePre(LogEnum(frame[z.v1]), frame[z.v2].AsRecord())\n	(void) ZAM::log_mgr_write(id->AsEnumVal(), columns->AsRecordVal());\n"	}
},
{ OP_LOG_WRITE_CV,
	{
	"CV",
	"XR", 
	"LogWritePre(LogEnum(z.c), frame[z.v1].AsRecord())\n	(void) ZAM::log_mgr_write(id->AsEnumVal(), columns->AsRecordVal());\n"	}
},
{ OP_BROKER_FLUSH_LOGS_V,
	{
	"V",
	"U", 
	"frame[z.v1].AsCountRef() = ZAM::broker_mgr_flush_log_buffers();\n"	}
},
{ OP_BROKER_FLUSH_LOGS_X,
	{
	"X",
	"",
	"(void) ZAM::broker_mgr_flush_log_buffers();\n"	}
},
{ OP_GET_PORT_TRANSPORT_PROTO_VV,
	{
	"VV",
	"UU", 
	"auto mask = frame[z.v2].AsCount() & PORT_SPACE_MASK;\n	auto v = 0; /* TRANSPORT_UNKNOWN */\n	if ( mask == TCP_PORT_MASK )\n		v = 1;\n	else if ( mask == UDP_PORT_MASK )\n		v = 2;\n	else if ( mask == ICMP_PORT_MASK )\n		v = 3;\n	frame[z.v1].AsCountRef() = v;\n"	}
},
{ OP_CONN_EXISTS_VV,
	{
	"VV",
	"IR", 
	"frame[z.v1].AsIntRef() = ZAM::session_mgr_find_connection(frame[z.v2].AsRecord()) != nullptr;"
	}
},
{ OP_CONN_EXISTS_COND_Vb,
	{
	"Vb",
	"RI", 
	"if ( ! (ZAM::session_mgr_find_connection(frame[z.v1].AsRecord()) != nullptr) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_CONN_EXISTS_COND_Vb,
	{
	"Vb",
	"RI", 
	"if ( (ZAM::session_mgr_find_connection(frame[z.v1].AsRecord()) != nullptr) )\n		Branch(z.v2)"
	}
},
{ OP_LOOKUP_CONN_VV,
	{
	"VV",
	"XR", 
	"auto cid = frame[z.v2].AsRecord();\n	Connection* conn = ZAM::session_mgr_find_connection(cid);\n	ValPtr res;\n	if ( conn )\n		res = conn->GetVal();\n	else\n		{\n		ERROR2(\"connection ID not a known connection\", cid);\n		res = build_dummy_conn_record();\n		}\n	AssignTarget(frame[z.v1], ZVal(res, res->GetType()));\n"	}
},
{ OP_IS_ICMP_PORT_VV,
	{
	"VV",
	"IU", 
	"frame[z.v1].AsIntRef() = (frame[z.v2].AsCount() & PORT_SPACE_MASK) == ICMP_PORT_MASK;"
	}
},
{ OP_IS_ICMP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ! ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == ICMP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_IS_ICMP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == ICMP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_IS_TCP_PORT_VV,
	{
	"VV",
	"IU", 
	"frame[z.v1].AsIntRef() = (frame[z.v2].AsCount() & PORT_SPACE_MASK) == TCP_PORT_MASK;"
	}
},
{ OP_IS_TCP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ! ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == TCP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_IS_TCP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == TCP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_IS_UDP_PORT_VV,
	{
	"VV",
	"IU", 
	"frame[z.v1].AsIntRef() = (frame[z.v2].AsCount() & PORT_SPACE_MASK) == UDP_PORT_MASK;"
	}
},
{ OP_IS_UDP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ! ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == UDP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_IS_UDP_PORT_COND_Vb,
	{
	"Vb",
	"UI", 
	"if ( ((frame[z.v1].AsCount() & PORT_SPACE_MASK) == UDP_PORT_MASK) )\n		Branch(z.v2)"
	}
},
{ OP_IS_V4_ADDR_VV,
	{
	"VV",
	"IA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr().GetFamily() == IPv4;"
	}
},
{ OP_IS_V4_ADDR_COND_Vb,
	{
	"Vb",
	"AI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr().GetFamily() == IPv4) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_IS_V4_ADDR_COND_Vb,
	{
	"Vb",
	"AI", 
	"if ( (frame[z.v1].AsAddr()->AsAddr().GetFamily() == IPv4) )\n		Branch(z.v2)"
	}
},
{ OP_IS_V6_ADDR_VV,
	{
	"VV",
	"IA", 
	"frame[z.v1].AsIntRef() = frame[z.v2].AsAddr()->AsAddr().GetFamily() == IPv6;"
	}
},
{ OP_IS_V6_ADDR_COND_Vb,
	{
	"Vb",
	"AI", 
	"if ( ! (frame[z.v1].AsAddr()->AsAddr().GetFamily() == IPv6) )\n		Branch(z.v2)"
	}
},
{ OP_NOT_IS_V6_ADDR_COND_Vb,
	{
	"Vb",
	"AI", 
	"if ( (frame[z.v1].AsAddr()->AsAddr().GetFamily() == IPv6) )\n		Branch(z.v2)"
	}
},
{ OP_NETWORK_TIME_V,
	{
	"V",
	"D", 
	"frame[z.v1].AsDoubleRef() = run_state::network_time;\n"	}
},
{ OP_CURRENT_TIME_V,
	{
	"V",
	"D", 
	"frame[z.v1].AsDoubleRef() = util::current_time();\n"	}
},
{ OP_READING_LIVE_TRAFFIC_V,
	{
	"V",
	"",
	"frame[z.v1].AsIntRef() = run_state::reading_live;"
	}
},
{ OP_READING_LIVE_TRAFFIC_COND_b,
	{
	"b",
	"",
	"if ( ! (run_state::reading_live) )\n		Branch(z.v1)"
	}
},
{ OP_NOT_READING_LIVE_TRAFFIC_COND_b,
	{
	"b",
	"",
	"if ( (run_state::reading_live) )\n		Branch(z.v1)"
	}
},
{ OP_READING_TRACES_V,
	{
	"V",
	"",
	"frame[z.v1].AsIntRef() = run_state::reading_traces;"
	}
},
{ OP_READING_TRACES_COND_b,
	{
	"b",
	"",
	"if ( ! (run_state::reading_traces) )\n		Branch(z.v1)"
	}
},
{ OP_NOT_READING_TRACES_COND_b,
	{
	"b",
	"",
	"if ( (run_state::reading_traces) )\n		Branch(z.v1)"
	}
},
{ OP_SORT_V,
	{
	"V",
	"V", 
	"if ( frame[z.v1].AsVector()->Size() > 1 )\n		frame[z.v1].AsVector()->Sort();\n"	}
},
{ OP_SORT_VV,
	{
	"VV",
	"VV", 
	"auto vv = frame[z.v2].AsVector();\n	if ( vv->Size() > 1 )\n		vv->Sort();\n	zeek::Ref(vv);\n	Unref(frame[z.v1].AsVectorRef());\n	frame[z.v1].AsVectorRef() = vv;\n"	}
},
{ OP_SORT_WITH_CMP_VV,
	{
	"VV",
	"VF", 
	"if ( frame[z.v1].AsVector()->Size() > 1 )\n		frame[z.v1].AsVector()->Sort(frame[z.v2].AsFunc());\n"	}
},
{ OP_SORT_WITH_CMP_VVV,
	{
	"VVV",
	"VVF", 
	"auto vv = frame[z.v2].AsVector();\n	if ( vv->Size() > 1 )\n		vv->Sort(frame[z.v3].AsFunc());\n	zeek::Ref(vv);\n	Unref(frame[z.v1].AsVectorRef());\n	frame[z.v1].AsVectorRef() = vv;\n"	}
},
{ OP_STARTS_WITH_VVV,
	{
	"VVV",
	"ISS", 
	"auto str = frame[z.v2].AsString();\n	auto sub = frame[z.v3].AsString();\n	auto str_n = str->Len();\n	auto sub_n = sub->Len();\n	if ( str_n < sub_n )\n		frame[z.v1].AsIntRef() = 0;\n	else\n		{\n		auto str_b = str->Bytes();\n		auto sub_b = sub->Bytes();\n		int i;\n		for ( i = 0; i < sub_n; ++i )\n			if ( str_b[i] != sub_b[i] )\n				break;\n		frame[z.v1].AsIntRef() = i == sub_n;\n		}\n"	}
},
{ OP_STARTS_WITH_VCV,
	{
	"VCV",
	"ISS", 
	"auto str = z.c.AsString();\n	auto sub = frame[z.v2].AsString();\n	auto str_n = str->Len();\n	auto sub_n = sub->Len();\n	if ( str_n < sub_n )\n		frame[z.v1].AsIntRef() = 0;\n	else\n		{\n		auto str_b = str->Bytes();\n		auto sub_b = sub->Bytes();\n		int i;\n		for ( i = 0; i < sub_n; ++i )\n			if ( str_b[i] != sub_b[i] )\n				break;\n		frame[z.v1].AsIntRef() = i == sub_n;\n		}\n"	}
},
{ OP_STARTS_WITH_VVC,
	{
	"VVC",
	"ISS", 
	"auto str = frame[z.v2].AsString();\n	auto sub = z.c.AsString();\n	auto str_n = str->Len();\n	auto sub_n = sub->Len();\n	if ( str_n < sub_n )\n		frame[z.v1].AsIntRef() = 0;\n	else\n		{\n		auto str_b = str->Bytes();\n		auto sub_b = sub->Bytes();\n		int i;\n		for ( i = 0; i < sub_n; ++i )\n			if ( str_b[i] != sub_b[i] )\n				break;\n		frame[z.v1].AsIntRef() = i == sub_n;\n		}\n"	}
},
{ OP_STRCMP_VVV,
	{
	"VVV",
	"ISS", 
	"auto s1 = frame[z.v2].AsString();\n	auto s2 = frame[z.v3].AsString();\n	frame[z.v1].AsIntRef() = Bstr_cmp(s1->AsString(), s2->AsString());\n"	}
},
{ OP_STRCMP_VCV,
	{
	"VCV",
	"ISS", 
	"auto s1 = z.c.AsString();\n	auto s2 = frame[z.v2].AsString();\n	frame[z.v1].AsIntRef() = Bstr_cmp(s1->AsString(), s2->AsString());\n"	}
},
{ OP_STRCMP_VVC,
	{
	"VVC",
	"ISS", 
	"auto s1 = frame[z.v2].AsString();\n	auto s2 = z.c.AsString();\n	frame[z.v1].AsIntRef() = Bstr_cmp(s1->AsString(), s2->AsString());\n"	}
},
{ OP_STRSTR_VVV,
	{
	"VVV",
	"ISS", 
	"auto big = frame[z.v2].AsString();\n	auto little = frame[z.v3].AsString();\n	frame[z.v1].AsIntRef() = 1 + big->AsString()->FindSubstring(little->AsString());\n"	}
},
{ OP_STRSTR_VCV,
	{
	"VCV",
	"ISS", 
	"auto big = z.c.AsString();\n	auto little = frame[z.v2].AsString();\n	frame[z.v1].AsIntRef() = 1 + big->AsString()->FindSubstring(little->AsString());\n"	}
},
{ OP_STRSTR_VVC,
	{
	"VVC",
	"ISS", 
	"auto big = frame[z.v2].AsString();\n	auto little = z.c.AsString();\n	frame[z.v1].AsIntRef() = 1 + big->AsString()->FindSubstring(little->AsString());\n"	}
},
{ OP_CAT1_VV,
	{
	"VV",
	"",
	"Cat1Op(frame[z.v1], frame[z.v2])\n	zeek::Ref(v1.AsString());\n"	}
},
{ OP_CAT1_VC,
	{
	"VC",
	"",
	"Cat1Op(frame[z.v1], z.c)\n	zeek::Ref(v1.AsString());\n"	}
},
{ OP_CAT1FULL_VV,
	{
	"VV",
	"",
	"auto formatted_val = ZVal(ZAM_val_cat(frame[z.v2].ToVal(Z_TYPE)));\n	Cat1Op(frame[z.v1], formatted_val)\n"	}
},
{ OP_CAT1FULL_VC,
	{
	"VC",
	"",
	"auto formatted_val = ZVal(ZAM_val_cat(z.c.ToVal(Z_TYPE)));\n	Cat1Op(frame[z.v1], formatted_val)\n"	}
},
{ OP_CATN_V,
	{
	"V",
	"",
	"CatNPre()\n	int n = aux->n;\n	size_t max_size = 0;\n	for ( int i = 0; i < n; ++i )\n		max_size += ca[i]->MaxSize(aux->elems[i].ToDirectZVal(frame));\n	auto res = new char[max_size + /* slop */ n + 1];\n	auto res_p = res;\n	for ( int i = 0; i < n; ++i )\n		ca[i]->RenderInto(aux->elems[i].ToDirectZVal(frame), res_p);\n	*res_p = '\\0';\n	auto s = new String(true, reinterpret_cast<byte_vec>(res), res_p - res);\n	Cat1Op(frame[z.v1], ZVal(new StringVal(s)))\n"	}
},
{ OP_CAT2_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT3_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT4_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	max_size += ca[3]->MaxSize(aux->elems[3].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	ca[3]->RenderInto(aux->elems[3].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT5_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	max_size += ca[3]->MaxSize(aux->elems[3].ToDirectZVal(frame));\n	max_size += ca[4]->MaxSize(aux->elems[4].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	ca[3]->RenderInto(aux->elems[3].ToDirectZVal(frame), res_p);\n	ca[4]->RenderInto(aux->elems[4].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT6_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	max_size += ca[3]->MaxSize(aux->elems[3].ToDirectZVal(frame));\n	max_size += ca[4]->MaxSize(aux->elems[4].ToDirectZVal(frame));\n	max_size += ca[5]->MaxSize(aux->elems[5].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	ca[3]->RenderInto(aux->elems[3].ToDirectZVal(frame), res_p);\n	ca[4]->RenderInto(aux->elems[4].ToDirectZVal(frame), res_p);\n	ca[5]->RenderInto(aux->elems[5].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT7_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	max_size += ca[3]->MaxSize(aux->elems[3].ToDirectZVal(frame));\n	max_size += ca[4]->MaxSize(aux->elems[4].ToDirectZVal(frame));\n	max_size += ca[5]->MaxSize(aux->elems[5].ToDirectZVal(frame));\n	max_size += ca[6]->MaxSize(aux->elems[6].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	ca[3]->RenderInto(aux->elems[3].ToDirectZVal(frame), res_p);\n	ca[4]->RenderInto(aux->elems[4].ToDirectZVal(frame), res_p);\n	ca[5]->RenderInto(aux->elems[5].ToDirectZVal(frame), res_p);\n	ca[6]->RenderInto(aux->elems[6].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_CAT8_V,
	{
	"V",
	"",
	"CatNPre()\n	size_t max_size = ca[0]->MaxSize(aux->elems[0].ToDirectZVal(frame));\n	max_size += ca[1]->MaxSize(aux->elems[1].ToDirectZVal(frame));\n	max_size += ca[2]->MaxSize(aux->elems[2].ToDirectZVal(frame));\n	max_size += ca[3]->MaxSize(aux->elems[3].ToDirectZVal(frame));\n	max_size += ca[4]->MaxSize(aux->elems[4].ToDirectZVal(frame));\n	max_size += ca[5]->MaxSize(aux->elems[5].ToDirectZVal(frame));\n	max_size += ca[6]->MaxSize(aux->elems[6].ToDirectZVal(frame));\n	max_size += ca[7]->MaxSize(aux->elems[7].ToDirectZVal(frame));\n	CatNMid()\n	ca[0]->RenderInto(aux->elems[0].ToDirectZVal(frame), res_p);\n	ca[1]->RenderInto(aux->elems[1].ToDirectZVal(frame), res_p);\n	ca[2]->RenderInto(aux->elems[2].ToDirectZVal(frame), res_p);\n	ca[3]->RenderInto(aux->elems[3].ToDirectZVal(frame), res_p);\n	ca[4]->RenderInto(aux->elems[4].ToDirectZVal(frame), res_p);\n	ca[5]->RenderInto(aux->elems[5].ToDirectZVal(frame), res_p);\n	ca[6]->RenderInto(aux->elems[6].ToDirectZVal(frame), res_p);\n	ca[7]->RenderInto(aux->elems[7].ToDirectZVal(frame), res_p);\n	CatNPost(frame[z.v1])\n"	}
},
{ OP_ANALYZER_NAME_VV,
	{
	"VV",
	"SX", 
	"Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = ZAM::analyzer_name(frame[z.v2].ToVal(Z_TYPE)->AsEnumVal());\n"	}
},
{ OP_ANALYZER_NAME_VC,
	{
	"VC",
	"SX", 
	"Unref(frame[z.v1].AsStringRef());\n	frame[z.v1].AsStringRef() = ZAM::analyzer_name(z.c.ToVal(Z_TYPE)->AsEnumVal());\n"	}
},
{ OP_FILES_ADD_ANALYZER_VVV,
	{
	"VVV",
	"SXR", 
	"ZAM::file_mgr_add_analyzer(frame[z.v1].AsString(), frame[z.v2].ToVal(Z_TYPE)->AsEnumVal(), frame[z.v3].AsRecord());\n"	}
},
{ OP_FILES_ADD_ANALYZER_VCV,
	{
	"VCV",
	"SXR", 
	"ZAM::file_mgr_add_analyzer(frame[z.v1].AsString(), z.c.ToVal(Z_TYPE)->AsEnumVal(), frame[z.v2].AsRecord());\n"	}
},
{ OP_FILES_ADD_ANALYZER_VVVV,
	{
	"VVVV",
	"ISXR", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_add_analyzer(frame[z.v2].AsString(), frame[z.v3].ToVal(Z_TYPE)->AsEnumVal(), frame[z.v4].AsRecord());\n"	}
},
{ OP_FILES_ADD_ANALYZER_VVCV,
	{
	"VVCV",
	"ISXR", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_add_analyzer(frame[z.v2].AsString(), z.c.ToVal(Z_TYPE)->AsEnumVal(), frame[z.v3].AsRecord());\n"	}
},
{ OP_FILES_REMOVE_ANALYZER_VVV,
	{
	"VVV",
	"SXR", 
	"ZAM::file_mgr_remove_analyzer(frame[z.v1].AsString(), frame[z.v2].ToVal(Z_TYPE)->AsEnumVal(), frame[z.v3].AsRecord());\n"	}
},
{ OP_FILES_REMOVE_ANALYZER_VCV,
	{
	"VCV",
	"SXR", 
	"ZAM::file_mgr_remove_analyzer(frame[z.v1].AsString(), z.c.ToVal(Z_TYPE)->AsEnumVal(), frame[z.v2].AsRecord());\n"	}
},
{ OP_FILES_REMOVE_ANALYZER_VVVV,
	{
	"VVVV",
	"ISXR", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_remove_analyzer(frame[z.v2].AsString(), frame[z.v3].ToVal(Z_TYPE)->AsEnumVal(), frame[z.v4].AsRecord());\n"	}
},
{ OP_FILES_REMOVE_ANALYZER_VVCV,
	{
	"VVCV",
	"ISXR", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_remove_analyzer(frame[z.v2].AsString(), z.c.ToVal(Z_TYPE)->AsEnumVal(), frame[z.v3].AsRecord());\n"	}
},
{ OP_ANALYZER_ENABLED_VV,
	{
	"VV",
	"IX", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_analyzer_enabled(frame[z.v2].ToVal(Z_TYPE)->AsEnumVal());\n"	}
},
{ OP_ANALYZER_ENABLED_VC,
	{
	"VC",
	"IX", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_analyzer_enabled(z.c.ToVal(Z_TYPE)->AsEnumVal());\n"	}
},
{ OP_FILE_ANALYZER_NAME_VV,
	{
	"VV",
	"",
	"auto atype = frame[z.v2].ToVal(Z_TYPE);\n	Unref(frame[z.v1].AsString());\n	frame[z.v1] = ZVal(ZAM::file_mgr_analyzer_name(atype->AsEnumVal()));\n"	}
},
{ OP_FILE_ANALYZER_NAME_VC,
	{
	"VC",
	"",
	"auto atype = z.c.ToVal(Z_TYPE);\n	Unref(frame[z.v1].AsString());\n	frame[z.v1] = ZVal(ZAM::file_mgr_analyzer_name(atype->AsEnumVal()));\n"	}
},
{ OP_IS_PROTOCOL_ANALYZER_VV,
	{
	"VV",
	"IX", 
	"auto atype = frame[z.v2].ToVal(Z_TYPE);\n	frame[z.v1].AsIntRef() = ZAM::analyzer_mgr_lookup(atype->AsEnumVal()) != nullptr;\n"	}
},
{ OP_IS_PROTOCOL_ANALYZER_VC,
	{
	"VC",
	"IX", 
	"auto atype = z.c.ToVal(Z_TYPE);\n	frame[z.v1].AsIntRef() = ZAM::analyzer_mgr_lookup(atype->AsEnumVal()) != nullptr;\n"	}
},
{ OP_CLEAR_TABLE_V,
	{
	"V",
	"T", 
	"frame[z.v1].AsTable()->RemoveAll();\n"	}
},
{ OP_FILES_ENABLE_REASSEMBLY_V,
	{
	"V",
	"S", 
	"ZAM::file_mgr_enable_reassembly(frame[z.v1].AsString());\n"	}
},
{ OP_FILES_SET_REASSEMBLY_BUFFER_VV,
	{
	"VV",
	"SU", 
	"ZAM::file_mgr_set_reassembly_buffer(frame[z.v1].AsString(), frame[z.v2].AsCount());\n"	}
},
{ OP_FILES_SET_REASSEMBLY_BUFFER_Vi,
	{
	"Vi",
	"SU", 
	"ZAM::file_mgr_set_reassembly_buffer(frame[z.v1].AsString(), zeek_uint_t(z.v2));\n"	}
},
{ OP_FILES_SET_REASSEMBLY_BUFFER_VVV,
	{
	"VVV",
	"ISU", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_set_reassembly_buffer(frame[z.v2].AsString(), frame[z.v3].AsCount());\n"	}
},
{ OP_FILES_SET_REASSEMBLY_BUFFER_VVi,
	{
	"VVi",
	"ISU", 
	"frame[z.v1].AsIntRef() = ZAM::file_mgr_set_reassembly_buffer(frame[z.v2].AsString(), zeek_uint_t(z.v3));\n"	}
},
{ OP_GET_BYTES_THRESH_VVV,
	{
	"VVV",
	"URI", 
	"frame[z.v1].AsCountRef() = ZAM::conn_size_get_bytes_threshold(frame[z.v2].AsRecord(), frame[z.v3].AsInt());\n"	}
},
{ OP_GET_BYTES_THRESH_VVC,
	{
	"VVC",
	"URI", 
	"frame[z.v1].AsCountRef() = ZAM::conn_size_get_bytes_threshold(frame[z.v2].AsRecord(), z.c.AsInt());\n"	}
},
{ OP_SET_BYTES_THRESH_VVV,
	{
	"VVV",
	"RUI", 
	"SetBytesThresh(frame[z.v1].AsRecord(), frame[z.v2].AsCount(), frame[z.v3].AsInt())\n"	}
},
{ OP_SET_BYTES_THRESH_VVC,
	{
	"VVC",
	"RUI", 
	"SetBytesThresh(frame[z.v1].AsRecord(), frame[z.v2].AsCount(), z.c.AsInt())\n"	}
},
{ OP_SET_BYTES_THRESH_VCV,
	{
	"VCV",
	"RUI", 
	"SetBytesThresh(frame[z.v1].AsRecord(), z.c.AsCount(), frame[z.v2].AsInt())\n"	}
},
{ OP_SET_BYTES_THRESH_VCi,
	{
	"VCi",
	"RUI", 
	"SetBytesThresh(frame[z.v1].AsRecord(), z.c.AsCount(), z.v2)\n"	}
},
{ OP_SET_BYTES_THRESH_VVVV,
	{
	"VVVV",
	"IRUI", 
	"SetBytesThresh(frame[z.v2].AsRecord(), frame[z.v3].AsCount(), frame[z.v4].AsInt())\n	frame[z.v1].AsIntRef() = res;\n"	}
},
{ OP_SET_BYTES_THRESH_VVVC,
	{
	"VVVC",
	"IRUI", 
	"SetBytesThresh(frame[z.v2].AsRecord(), frame[z.v3].AsCount(), z.c.AsInt())\n	frame[z.v1].AsIntRef() = res;\n"	}
},
{ OP_SET_BYTES_THRESH_VVCV,
	{
	"VVCV",
	"IRUI", 
	"SetBytesThresh(frame[z.v2].AsRecord(), z.c.AsCount(), frame[z.v3].AsInt())\n	frame[z.v1].AsIntRef() = res;\n"	}
},
{ OP_SET_BYTES_THRESH_VVCi,
	{
	"VVCi",
	"IRUI", 
	"SetBytesThresh(frame[z.v2].AsRecord(), z.c.AsCount(), z.v3)\n	frame[z.v1].AsIntRef() = res;\n"	}
},
