// Begin of ASN1 (from "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>

extern const char* __hlt_ldap_hlto_scope;

namespace __hlt_ldap::ASN1 {
    struct ASN1BitString;
    struct ASN1Tag;
    struct LengthType;
    struct ASN1Header;
    struct ASN1SubMessages;
    struct ASN1Message;
    struct ASN1Body;
    struct ASN1ObjectIdentifier;
    struct ASN1OctetString;
    struct ASN1String;
    struct ASN1ObjectIdentifierNibble;
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Class, Undef, Universal = 0, Application = 1, ContextSpecific = 2, Private = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Type, Undef, Boolean = 1, Integer = 2, BitString = 3, OctetString = 4, NullVal = 5, ObjectIdentifier = 6, ObjectDescriptor = 7, InstanceOf = 8, Real = 9, Enumerated = 10, EmbeddedPDV = 11, UTF8String = 12, RelativeOID = 13, Sequence = 16, Set = 17, NumericString = 18, PrintableString = 19, TeletextString = 20, VideotextString = 21, IA5String = 22, UTCTime = 23, GeneralizedTime = 24, GraphicString = 25, VisibleString = 26, GeneralString = 27, UniversalString = 28, CharacterString = 29, BMPString = 30, Undef = -1);;
    struct ASN1BitString : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1BitString> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1BitString>::self(this); }
        std::optional<::hilti::rt::Bytes> value_bits{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1BitString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ::hilti::rt::Bool __p_constructed{};
        ASN1BitString();
        ASN1BitString(const ASN1BitString&) = default;
        ASN1BitString(ASN1BitString&&) = default;
        ASN1BitString& operator=(const ASN1BitString&) = default;
        ASN1BitString& operator=(ASN1BitString&&) = default;
        ASN1BitString(std::optional<std::optional<::hilti::rt::Bytes>> value_bits);
        ASN1BitString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed);
        template<typename F> void __visit(F _) const { _("value_bits", value_bits); }
    };

    struct ASN1Tag : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Tag> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Tag>::self(this); }
        std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>> _anon_46{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Tag_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Tag();
        ASN1Tag(const ASN1Tag&) = default;
        ASN1Tag(ASN1Tag&&) = default;
        ASN1Tag& operator=(const ASN1Tag&) = default;
        ASN1Tag& operator=(ASN1Tag&&) = default;
        ASN1Tag(std::optional<std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>> _anon_46);
        template<typename F> void __visit(F _) const { _("<anon>", _anon_46); }
    };

    struct LengthType : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<LengthType> {
        auto __self() { return ::hilti::rt::ValueReference<LengthType>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> len{};
        ::hilti::rt::integer::safe<uint8_t> tag_len{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> data{};
        void __on__anon_44();
        void __on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_152_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__LengthType_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LengthType();
        LengthType(const LengthType&) = default;
        LengthType(LengthType&&) = default;
        LengthType& operator=(const LengthType&) = default;
        LengthType& operator=(LengthType&&) = default;
        LengthType(std::optional<::hilti::rt::integer::safe<uint64_t>> len, std::optional<::hilti::rt::integer::safe<uint8_t>> tag_len, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data);
        template<typename F> void __visit(F _) const { _("len", len); _("tag_len", tag_len); _("data", data); }
    };

    struct ASN1Header : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Header> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Header>::self(this); }
        std::optional<::hilti::rt::ValueReference<ASN1Tag>> tag{};
        std::optional<::hilti::rt::ValueReference<LengthType>> len{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_ASN1__ASN1Header_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Header();
        ASN1Header(const ASN1Header&) = default;
        ASN1Header(ASN1Header&&) = default;
        ASN1Header& operator=(const ASN1Header&) = default;
        ASN1Header& operator=(ASN1Header&&) = default;
        ASN1Header(std::optional<std::optional<::hilti::rt::ValueReference<ASN1Tag>>> tag, std::optional<std::optional<::hilti::rt::ValueReference<LengthType>>> len);
        template<typename F> void __visit(F _) const { _("tag", tag); _("len", len); }
    };

    struct ASN1SubMessages : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1SubMessages> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1SubMessages>::self(this); }
        std::optional<::hilti::rt::Vector<ASN1Message>> submessages{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_submessages_33_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1SubMessages_33_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_msgLen{};
        ASN1SubMessages();
        ASN1SubMessages(const ASN1SubMessages&) = default;
        ASN1SubMessages(ASN1SubMessages&&) = default;
        ASN1SubMessages& operator=(const ASN1SubMessages&) = default;
        ASN1SubMessages& operator=(ASN1SubMessages&&) = default;
        ASN1SubMessages(std::optional<std::optional<::hilti::rt::Vector<ASN1Message>>> submessages);
        ASN1SubMessages(const ::hilti::rt::integer::safe<uint64_t>& __p_msgLen);
        template<typename F> void __visit(F _) const { _("submessages", submessages); }
    };

    struct ASN1Message : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Message> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Message>::self(this); }
        ::hilti::rt::integer::safe<int32_t> application_id{};
        std::optional<::hilti::rt::ValueReference<ASN1Header>> head{};
        std::optional<::hilti::rt::ValueReference<ASN1Body>> body{};
        std::optional<::hilti::rt::Bytes> application_data{};
        void __on_application_data(const ::hilti::rt::Bytes& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_161_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Message_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Message();
        ASN1Message(const ASN1Message&) = default;
        ASN1Message(ASN1Message&&) = default;
        ASN1Message& operator=(const ASN1Message&) = default;
        ASN1Message& operator=(ASN1Message&&) = default;
        ASN1Message(std::optional<::hilti::rt::integer::safe<int32_t>> application_id, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Header>>> head, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Body>>> body, std::optional<std::optional<::hilti::rt::Bytes>> application_data);
        ASN1Message(const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("application_id", application_id); _("head", head); _("body", body); _("application_data", application_data); }
    };

    struct ASN1Body : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Body> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Body>::self(this); }
        std::optional<::hilti::rt::Bool> bool_value{};
        std::optional<::hilti::rt::integer::safe<int64_t>> num_value{};
        std::optional<::hilti::rt::Bytes> null_value{};
        std::optional<::hilti::rt::ValueReference<ASN1BitString>> bitstr_value{};
        std::optional<std::string> str_value{};
        std::optional<::hilti::rt::ValueReference<ASN1SubMessages>> seq{};
        std::optional<::hilti::rt::Bytes> unimplemented_value{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_154_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Body_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ASN1Header> __p_head{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Body();
        ASN1Body(const ASN1Body&) = default;
        ASN1Body(ASN1Body&&) = default;
        ASN1Body& operator=(const ASN1Body&) = default;
        ASN1Body& operator=(ASN1Body&&) = default;
        ASN1Body(std::optional<std::optional<::hilti::rt::Bool>> bool_value, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> num_value, std::optional<std::optional<::hilti::rt::Bytes>> null_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1BitString>>> bitstr_value, std::optional<std::optional<std::string>> str_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1SubMessages>>> seq, std::optional<std::optional<::hilti::rt::Bytes>> unimplemented_value);
        ASN1Body(const ::hilti::rt::ValueReference<ASN1Header>& __p_head, const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("bool_value", bool_value); _("num_value", num_value); _("null_value", null_value); _("bitstr_value", bitstr_value); _("str_value", str_value); _("seq", seq); _("unimplemented_value", unimplemented_value); }
    };

    struct ASN1ObjectIdentifier : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1ObjectIdentifier> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1ObjectIdentifier>::self(this); }
        ::hilti::rt::Bytes oidbytes{};
        ::hilti::rt::integer::safe<uint64_t> temp{};
        std::string oidstring{};
        void __on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> sublist{};
        void __on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop);
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_50{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_49{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_sublist_34_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1ObjectIdentifier_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ASN1ObjectIdentifier();
        ASN1ObjectIdentifier(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier& operator=(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier& operator=(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier(std::optional<::hilti::rt::Bytes> oidbytes, std::optional<::hilti::rt::integer::safe<uint64_t>> temp, std::optional<std::string> oidstring, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>> sublist, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_50, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_49);
        ASN1ObjectIdentifier(const ::hilti::rt::integer::safe<uint64_t>& __p_len);
        template<typename F> void __visit(F _) const { _("oidbytes", oidbytes); _("temp", temp); _("oidstring", oidstring); _("sublist", sublist); _("<anon>", _anon_50); _("<anon>", _anon_49); }
    };

    struct ASN1OctetString : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1OctetString> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1OctetString>::self(this); }
        std::optional<::hilti::rt::Bytes> value{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1OctetString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ::hilti::rt::Bool __p_constructed{};
        ASN1OctetString();
        ASN1OctetString(const ASN1OctetString&) = default;
        ASN1OctetString(ASN1OctetString&&) = default;
        ASN1OctetString& operator=(const ASN1OctetString&) = default;
        ASN1OctetString& operator=(ASN1OctetString&&) = default;
        ASN1OctetString(std::optional<std::optional<::hilti::rt::Bytes>> value);
        ASN1OctetString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed);
        template<typename F> void __visit(F _) const { _("value", value); }
    };

    struct ASN1String : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1String> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1String>::self(this); }
        ::hilti::rt::bytes::Charset encoding{};
        std::optional<std::string> value{};
        void __on_0x25_init();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __convert() -> std::string;
        auto __parse_ASN1__ASN1String_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ASN1Tag> __p_tag{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ASN1String();
        ASN1String(const ASN1String&) = default;
        ASN1String(ASN1String&&) = default;
        ASN1String& operator=(const ASN1String&) = default;
        ASN1String& operator=(ASN1String&&) = default;
        ASN1String(std::optional<::hilti::rt::bytes::Charset> encoding, std::optional<std::optional<std::string>> value);
        ASN1String(const ::hilti::rt::ValueReference<ASN1Tag>& __p_tag, const ::hilti::rt::integer::safe<uint64_t>& __p_len);
        template<typename F> void __visit(F _) const { _("encoding", encoding); _("value", value); }
    };

    struct ASN1ObjectIdentifierNibble : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1ObjectIdentifierNibble> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1ObjectIdentifierNibble>::self(this); }
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> data{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __convert() -> ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>;
        auto __parse_ASN1__ASN1ObjectIdentifierNibble_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1ObjectIdentifierNibble();
        ASN1ObjectIdentifierNibble(const ASN1ObjectIdentifierNibble&) = default;
        ASN1ObjectIdentifierNibble(ASN1ObjectIdentifierNibble&&) = default;
        ASN1ObjectIdentifierNibble& operator=(const ASN1ObjectIdentifierNibble&) = default;
        ASN1ObjectIdentifierNibble& operator=(ASN1ObjectIdentifierNibble&&) = default;
        ASN1ObjectIdentifierNibble(std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data);
        template<typename F> void __visit(F _) const { _("data", data); }
    };

    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1BitString0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Body0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Header0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Message0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifier0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1ObjectIdentifierNibble0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1OctetString0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1String0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1SubMessages0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40ASN1Tag0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25ASN10x400x40LengthType0x25uses_sync_advance = ::hilti::rt::Bool(false);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1BitString& x) -> std::ostream&;
    ASN1BitString::ASN1BitString() {
    }

    ASN1BitString::ASN1BitString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed) : __p_len(std::move(__p_len)), __p_constructed(std::move(__p_constructed)) {
    }

    ASN1BitString::ASN1BitString(std::optional<std::optional<::hilti::rt::Bytes>> value_bits) : ASN1BitString() {
        if ( value_bits ) this->value_bits = std::move(*value_bits);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Class x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Type x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Tag& x) -> std::ostream&;
    ASN1Tag::ASN1Tag() {
    }

    ASN1Tag::ASN1Tag(std::optional<std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>> _anon_46) : ASN1Tag() {
        if ( _anon_46 ) this->_anon_46 = std::move(*_anon_46);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::LengthType& x) -> std::ostream&;
    extern void __hook_LengthType___on__anon_44(::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    extern void __hook_LengthType___on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    LengthType::LengthType() {
    }

    LengthType::LengthType(std::optional<::hilti::rt::integer::safe<uint64_t>> len, std::optional<::hilti::rt::integer::safe<uint8_t>> tag_len, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data) : LengthType() {
        if ( len ) this->len = std::move(*len);
        if ( tag_len ) this->tag_len = std::move(*tag_len);
        if ( data ) this->data = std::move(*data);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Header& x) -> std::ostream&;
    ASN1Header::ASN1Header() {
    }

    ASN1Header::ASN1Header(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Tag>>> tag, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>>> len) : ASN1Header() {
        if ( tag ) this->tag = std::move(*tag);
        if ( len ) this->len = std::move(*len);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1SubMessages& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Message& x) -> std::ostream&;
    ASN1SubMessages::ASN1SubMessages() {
    }

    ASN1SubMessages::ASN1SubMessages(const ::hilti::rt::integer::safe<uint64_t>& __p_msgLen) : __p_msgLen(std::move(__p_msgLen)) {
    }

    ASN1SubMessages::ASN1SubMessages(std::optional<std::optional<::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>>> submessages) : ASN1SubMessages() {
        if ( submessages ) this->submessages = std::move(*submessages);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Body& x) -> std::ostream&;
    extern void __hook_ASN1Message___on_application_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __self);
    ASN1Message::ASN1Message() {
    }

    ASN1Message::ASN1Message(const ::hilti::rt::Bool& __p_recursive) : __p_recursive(std::move(__p_recursive)) {
    }

    ASN1Message::ASN1Message(std::optional<::hilti::rt::integer::safe<int32_t>> application_id, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> head, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>>> body, std::optional<std::optional<::hilti::rt::Bytes>> application_data) : ASN1Message() {
        if ( application_id ) this->application_id = std::move(*application_id);
        if ( head ) this->head = std::move(*head);
        if ( body ) this->body = std::move(*body);
        if ( application_data ) this->application_data = std::move(*application_data);
    }

    
    ASN1Body::ASN1Body() {
    }

    ASN1Body::ASN1Body(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __p_head, const ::hilti::rt::Bool& __p_recursive) : __p_head(std::move(__p_head)), __p_recursive(std::move(__p_recursive)) {
    }

    ASN1Body::ASN1Body(std::optional<std::optional<::hilti::rt::Bool>> bool_value, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> num_value, std::optional<std::optional<::hilti::rt::Bytes>> null_value, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1BitString>>> bitstr_value, std::optional<std::optional<std::string>> str_value, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>>> seq, std::optional<std::optional<::hilti::rt::Bytes>> unimplemented_value) : ASN1Body() {
        if ( bool_value ) this->bool_value = std::move(*bool_value);
        if ( num_value ) this->num_value = std::move(*num_value);
        if ( null_value ) this->null_value = std::move(*null_value);
        if ( bitstr_value ) this->bitstr_value = std::move(*bitstr_value);
        if ( str_value ) this->str_value = std::move(*str_value);
        if ( seq ) this->seq = std::move(*seq);
        if ( unimplemented_value ) this->unimplemented_value = std::move(*unimplemented_value);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifier& x) -> std::ostream&;
    extern void __hook_ASN1ObjectIdentifier___on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    ASN1ObjectIdentifier::ASN1ObjectIdentifier() {
    }

    ASN1ObjectIdentifier::ASN1ObjectIdentifier(const ::hilti::rt::integer::safe<uint64_t>& __p_len) : __p_len(std::move(__p_len)) {
    }

    ASN1ObjectIdentifier::ASN1ObjectIdentifier(std::optional<::hilti::rt::Bytes> oidbytes, std::optional<::hilti::rt::integer::safe<uint64_t>> temp, std::optional<std::string> oidstring, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>> sublist, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_50, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_49) : ASN1ObjectIdentifier() {
        if ( oidbytes ) this->oidbytes = std::move(*oidbytes);
        if ( temp ) this->temp = std::move(*temp);
        if ( oidstring ) this->oidstring = std::move(*oidstring);
        if ( sublist ) this->sublist = std::move(*sublist);
        if ( _anon_50 ) this->_anon_50 = std::move(*_anon_50);
        if ( _anon_49 ) this->_anon_49 = std::move(*_anon_49);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1OctetString& x) -> std::ostream&;
    ASN1OctetString::ASN1OctetString() {
    }

    ASN1OctetString::ASN1OctetString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed) : __p_len(std::move(__p_len)), __p_constructed(std::move(__p_constructed)) {
    }

    ASN1OctetString::ASN1OctetString(std::optional<std::optional<::hilti::rt::Bytes>> value) : ASN1OctetString() {
        if ( value ) this->value = std::move(*value);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1String& x) -> std::ostream&;
    extern void __hook_ASN1String___on_0x25_init(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1String>& __self);
    ASN1String::ASN1String() {
    }

    ASN1String::ASN1String(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Tag>& __p_tag, const ::hilti::rt::integer::safe<uint64_t>& __p_len) : __p_tag(std::move(__p_tag)), __p_len(std::move(__p_len)) {
        encoding = ::hilti::rt::bytes::Charset::Undef;
    }

    ASN1String::ASN1String(std::optional<::hilti::rt::bytes::Charset> encoding, std::optional<std::optional<std::string>> value) : ASN1String() {
        if ( encoding ) this->encoding = std::move(*encoding);
        if ( value ) this->value = std::move(*value);
    }

    
}

namespace hlt_ldap::ASN1::ASN1Body {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_ldap::ASN1::ASN1Header {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::ASN1 {
    extern void __hook_ASN1Message___on_application_data_8bb7(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<ASN1Message>& __self);
    extern void __hook_ASN1Message___on_application_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<ASN1Message>& __self);
    extern void __hook_ASN1Message___on_application_data_8bb7(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<ASN1Message>& __self);
}

namespace hlt_ldap::ASN1::ASN1Message {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::ASN1 {
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done_7fdb(::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done(::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done_7fdb(::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on__anon_48_8b96(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on__anon_48_8b96(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach_4227(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach_4227(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifierNibble& x) -> std::ostream&;
    ASN1ObjectIdentifierNibble::ASN1ObjectIdentifierNibble() {
    }

    ASN1ObjectIdentifierNibble::ASN1ObjectIdentifierNibble(std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data) : ASN1ObjectIdentifierNibble() {
        if ( data ) this->data = std::move(*data);
    }

    
    extern void __hook_ASN1String___on_0x25_init_f039(::hilti::rt::ValueReference<ASN1String>& __self);
    extern void __hook_ASN1String___on_0x25_init(::hilti::rt::ValueReference<ASN1String>& __self);
    extern void __hook_ASN1String___on_0x25_init_f039(::hilti::rt::ValueReference<ASN1String>& __self);
}

namespace hlt_ldap::ASN1::ASN1SubMessages {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::ASN1 {
    extern void __hook_LengthType___on__anon_44_f0b3(::hilti::rt::ValueReference<LengthType>& __self);
    extern void __hook_LengthType___on__anon_44(::hilti::rt::ValueReference<LengthType>& __self);
    extern void __hook_LengthType___on__anon_44_f0b3(::hilti::rt::ValueReference<LengthType>& __self);
    extern void __hook_LengthType___on__anon_45_a0b9(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<LengthType>& __self);
    extern void __hook_LengthType___on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<LengthType>& __self);
    extern void __hook_LengthType___on__anon_45_a0b9(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<LengthType>& __self);
    extern void __register_ASN1_ASN1BitString();
    extern void __register_ASN1_ASN1Body();
    extern void __register_ASN1_ASN1Header();
    extern void __register_ASN1_ASN1Message();
    extern void __register_ASN1_ASN1ObjectIdentifier();
    extern void __register_ASN1_ASN1ObjectIdentifierNibble();
    extern void __register_ASN1_ASN1OctetString();
    extern void __register_ASN1_ASN1String();
    extern void __register_ASN1_ASN1SubMessages();
    extern void __register_ASN1_ASN1Tag();
    extern void __register_ASN1_LengthType();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_ldap::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b = { "ASN1::ASN1BitString", "ASN1::ASN1BitString", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "value_bits", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1BitString, value_bits), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1BitString, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b = { "ASN1::ASN1Class", "ASN1::ASN1Class", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "Universal", 0 }, ::hilti::rt::type_info::enum_::Label{ "Application", 1 }, ::hilti::rt::type_info::enum_::Label{ "ContextSpecific", 2 }, ::hilti::rt::type_info::enum_::Label{ "Private", 3 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b = { "ASN1::ASN1Type", "ASN1::ASN1Type", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "Boolean", 1 }, ::hilti::rt::type_info::enum_::Label{ "Integer", 2 }, ::hilti::rt::type_info::enum_::Label{ "BitString", 3 }, ::hilti::rt::type_info::enum_::Label{ "OctetString", 4 }, ::hilti::rt::type_info::enum_::Label{ "NullVal", 5 }, ::hilti::rt::type_info::enum_::Label{ "ObjectIdentifier", 6 }, ::hilti::rt::type_info::enum_::Label{ "ObjectDescriptor", 7 }, ::hilti::rt::type_info::enum_::Label{ "InstanceOf", 8 }, ::hilti::rt::type_info::enum_::Label{ "Real", 9 }, ::hilti::rt::type_info::enum_::Label{ "Enumerated", 10 }, ::hilti::rt::type_info::enum_::Label{ "EmbeddedPDV", 11 }, ::hilti::rt::type_info::enum_::Label{ "UTF8String", 12 }, ::hilti::rt::type_info::enum_::Label{ "RelativeOID", 13 }, ::hilti::rt::type_info::enum_::Label{ "Sequence", 16 }, ::hilti::rt::type_info::enum_::Label{ "Set", 17 }, ::hilti::rt::type_info::enum_::Label{ "NumericString", 18 }, ::hilti::rt::type_info::enum_::Label{ "PrintableString", 19 }, ::hilti::rt::type_info::enum_::Label{ "TeletextString", 20 }, ::hilti::rt::type_info::enum_::Label{ "VideotextString", 21 }, ::hilti::rt::type_info::enum_::Label{ "IA5String", 22 }, ::hilti::rt::type_info::enum_::Label{ "UTCTime", 23 }, ::hilti::rt::type_info::enum_::Label{ "GeneralizedTime", 24 }, ::hilti::rt::type_info::enum_::Label{ "GraphicString", 25 }, ::hilti::rt::type_info::enum_::Label{ "VisibleString", 26 }, ::hilti::rt::type_info::enum_::Label{ "GeneralString", 27 }, ::hilti::rt::type_info::enum_::Label{ "UniversalString", 28 }, ::hilti::rt::type_info::enum_::Label{ "CharacterString", 29 }, ::hilti::rt::type_info::enum_::Label{ "BMPString", 30 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b = { {}, "bitfield(8) { type_: 0..4 &convert=ASN1Type(__dd); constructed: 5 &convert=cast<bool>(__dd); class: 6..7 &convert=ASN1Class(__dd); }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "type_", &type_info::__ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "constructed", &::hilti::rt::type_info::bool_, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "class", &type_info::__ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 2>() }})) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b = { "ASN1::ASN1Tag", "ASN1::ASN1Tag", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "_anon_46", &type_info::__ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b, offsetof(ASN1::ASN1Tag, _anon_46), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Tag, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__LengthType_namex2aASN1__LengthTypex2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b = { {}, "bitfield(8) { num: 0..6; islong: 7; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "num", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "islong", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }})) };
    const ::hilti::rt::TypeInfo __ti_ASN1__LengthType_namex2aASN1__LengthTypex2b = { "ASN1::LengthType", "ASN1::LengthType", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "len", &::hilti::rt::type_info::uint64, offsetof(ASN1::LengthType, len), false, false }, ::hilti::rt::type_info::struct_::Field{ "tag_len", &::hilti::rt::type_info::uint8, offsetof(ASN1::LengthType, tag_len), false, false }, ::hilti::rt::type_info::struct_::Field{ "data", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b, offsetof(ASN1::LengthType, data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::LengthType, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b = { {}, "value_ref<ASN1Tag>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Tag>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b = { {}, "value_ref<LengthType>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__LengthType_namex2aASN1__LengthTypex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::LengthType>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b = { "ASN1::ASN1Header", "ASN1::ASN1Header", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "tag", &type_info::__ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b, offsetof(ASN1::ASN1Header, tag), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Tag>>() }, ::hilti::rt::type_info::struct_::Field{ "len", &type_info::__ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b, offsetof(ASN1::ASN1Header, len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Header, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b = { {}, "value_ref<ASN1Header>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Header>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b = { {}, "value_ref<ASN1BitString>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1BitString>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b = { {}, "value_ref<ASN1SubMessages>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1SubMessages>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b = { "ASN1::ASN1Body", "ASN1::ASN1Body", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "bool_value", &::hilti::rt::type_info::bool_, offsetof(ASN1::ASN1Body, bool_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bool>() }, ::hilti::rt::type_info::struct_::Field{ "num_value", &::hilti::rt::type_info::int64, offsetof(ASN1::ASN1Body, num_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "null_value", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Body, null_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "bitstr_value", &type_info::__ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b, offsetof(ASN1::ASN1Body, bitstr_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1BitString>>() }, ::hilti::rt::type_info::struct_::Field{ "str_value", &::hilti::rt::type_info::string, offsetof(ASN1::ASN1Body, str_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "seq", &type_info::__ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b, offsetof(ASN1::ASN1Body, seq), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>>() }, ::hilti::rt::type_info::struct_::Field{ "unimplemented_value", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Body, unimplemented_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Body, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b = { {}, "value_ref<ASN1Body>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Body>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b = { "ASN1::ASN1Message", "ASN1::ASN1Message", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "application_id", &::hilti::rt::type_info::int32, offsetof(ASN1::ASN1Message, application_id), false, false }, ::hilti::rt::type_info::struct_::Field{ "head", &type_info::__ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(ASN1::ASN1Message, head), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "body", &type_info::__ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b, offsetof(ASN1::ASN1Message, body), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>>() }, ::hilti::rt::type_info::struct_::Field{ "application_data", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Message, application_data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Message, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b = { {}, "vector<ASN1Message>", new ::hilti::rt::type_info::Vector(&type_info::__ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b, ::hilti::rt::type_info::Vector::accessor<__hlt_ldap::ASN1::ASN1Message>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b = { "ASN1::ASN1SubMessages", "ASN1::ASN1SubMessages", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "submessages", &type_info::__ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b, offsetof(ASN1::ASN1SubMessages, submessages), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1SubMessages, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifier_namex2aASN1__ASN1ObjectIdentifierx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b = { {}, "bitfield(8) { num: 0..6; more: 7; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "num", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "more", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }})) };
    const ::hilti::rt::TypeInfo __ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b = { {}, "vector<bitfield(8) { num: 0..6; more: 7; }>", new ::hilti::rt::type_info::Vector(&type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, ::hilti::rt::type_info::Vector::accessor<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifier_namex2aASN1__ASN1ObjectIdentifierx2b = { "ASN1::ASN1ObjectIdentifier", "ASN1::ASN1ObjectIdentifier", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "oidbytes", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1ObjectIdentifier, oidbytes), false, false }, ::hilti::rt::type_info::struct_::Field{ "temp", &::hilti::rt::type_info::uint64, offsetof(ASN1::ASN1ObjectIdentifier, temp), false, false }, ::hilti::rt::type_info::struct_::Field{ "oidstring", &::hilti::rt::type_info::string, offsetof(ASN1::ASN1ObjectIdentifier, oidstring), false, false }, ::hilti::rt::type_info::struct_::Field{ "sublist", &type_info::__ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b, offsetof(ASN1::ASN1ObjectIdentifier, sublist), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>() }, ::hilti::rt::type_info::struct_::Field{ "_anon_50", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, offsetof(ASN1::ASN1ObjectIdentifier, _anon_50), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "_anon_49", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, offsetof(ASN1::ASN1ObjectIdentifier, _anon_49), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1ObjectIdentifier, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1OctetString_namex2aASN1__ASN1OctetStringx2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1OctetString_namex2aASN1__ASN1OctetStringx2b = { "ASN1::ASN1OctetString", "ASN1::ASN1OctetString", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "value", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1OctetString, value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1OctetString, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1String_namex2aASN1__ASN1Stringx2b;
    extern const ::hilti::rt::TypeInfo __ti_spicy__Charset_namex2aspicy__Charsetx2b;
    const ::hilti::rt::TypeInfo __ti_spicy__Charset_namex2aspicy__Charsetx2b = { "spicy::Charset", "spicy::Charset", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "ASCII", 0 }, ::hilti::rt::type_info::enum_::Label{ "UTF8", 1 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1String_namex2aASN1__ASN1Stringx2b = { "ASN1::ASN1String", "ASN1::ASN1String", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "encoding", &type_info::__ti_spicy__Charset_namex2aspicy__Charsetx2b, offsetof(ASN1::ASN1String, encoding), false, false }, ::hilti::rt::type_info::struct_::Field{ "value", &::hilti::rt::type_info::string, offsetof(ASN1::ASN1String, value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1String, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifierNibble_namex2aASN1__ASN1ObjectIdentifierNibblex2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifierNibble_namex2aASN1__ASN1ObjectIdentifierNibblex2b = { "ASN1::ASN1ObjectIdentifierNibble", "ASN1::ASN1ObjectIdentifierNibble", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "data", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, offsetof(ASN1::ASN1ObjectIdentifierNibble, data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1ObjectIdentifierNibble, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_ldap::ASN1::__register_module)

auto __hlt_ldap::ASN1::ASN1BitString::__parse_ASN1__ASN1BitString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1BitString::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:101:22-109:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::integer::safe<uint8_t> __transient__anon_47;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:102:5-102:9");

    // Begin parsing production: Variable: _anon_47_32 -> uint<8>;
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:102:5-102:9"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(__transient__anon_47, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_47_32 -> uint<8>;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:103:15-103:19");

        // Begin parsing production: Variable: value_bits_32 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).value_bits) = ::spicy::rt::detail::extractBytes(__data, __cur, (__self->__p_len - ::hilti::rt::integer::safe<std::uint64_t>{1U}), ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:103:3-103:36"), (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((__self->__p_len - ::hilti::rt::integer::safe<std::uint64_t>{1U}));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: value_bits_32 -> bytes;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1BitString::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1BitString::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:101:22-109:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1BitString_32_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1Body::__parse_ASN1__ASN1Body_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Body::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:206:3-250:4");

    // Begin parsing production: Switch: switch_154 -> [ASN1Type::Boolean] -> switch_154_case_1 | [ASN1Type::Integer,ASN1Type::Enumerated] -> switch_154_case_2 | [ASN1Type::NullVal] -> switch_154_case_3 | [ASN1Type::BitString] -> switch_154_case_4 | [ASN1Type::OctetString] -> switch_154_case_5 | [ASN1Type::ObjectIdentifier] -> switch_154_case_6 | [ASN1Type::BMPString,ASN1Type::CharacterString,ASN1Type::GeneralizedTime,ASN1Type::GeneralString,ASN1Type::GraphicString,ASN1Type::IA5String,ASN1Type::NumericString,ASN1Type::PrintableString,ASN1Type::TeletextString,ASN1Type::UTCTime,ASN1Type::UTF8String,ASN1Type::VideotextString,ASN1Type::VisibleString,ASN1Type::UniversalString] -> switch_154_case_7 | [ASN1Type::Sequence,ASN1Type::Set] -> switch_154_case_8 | [ASN1Type::ObjectDescriptor,ASN1Type::InstanceOf,ASN1Type::Real,ASN1Type::EmbeddedPDV,ASN1Type::RelativeOID] -> switch_154_case_9 |  | * -> switch_154_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_154_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_154 -> [ASN1Type::Boolean] -> switch_154_case_1 | [ASN1Type::Integer,ASN1Type::Enumerated] -> switch_154_case_2 | [ASN1Type::NullVal] -> switch_154_case_3 | [ASN1Type::BitString] -> switch_154_case_4 | [ASN1Type::OctetString] -> switch_154_case_5 | [ASN1Type::ObjectIdentifier] -> switch_154_case_6 | [ASN1Type::BMPString,ASN1Type::CharacterString,ASN1Type::GeneralizedTime,ASN1Type::GeneralString,ASN1Type::GraphicString,ASN1Type::IA5String,ASN1Type::NumericString,ASN1Type::PrintableString,ASN1Type::TeletextString,ASN1Type::UTCTime,ASN1Type::UTF8String,ASN1Type::VideotextString,ASN1Type::VisibleString,ASN1Type::UniversalString] -> switch_154_case_7 | [ASN1Type::Sequence,ASN1Type::Set] -> switch_154_case_8 | [ASN1Type::ObjectDescriptor,ASN1Type::InstanceOf,ASN1Type::Real,ASN1Type::EmbeddedPDV,ASN1Type::RelativeOID] -> switch_154_case_9 |  | * -> switch_154_default;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1Body::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Body::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1Body_32_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1Body::__parse_switch_154_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Body::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:206:3-250:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:206:3-250:4");
    if ( ASN1::ASN1Type __x = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).tag))._anon_46).value))); __x == ASN1::ASN1Type{ASN1::ASN1Type::Boolean} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:5-208:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:5-208:93");

        // Begin parsing production: Block: switch_154_case_1 -> bool_value_32;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:38-208:42");
            ::hilti::rt::integer::safe<uint8_t> __parsed_bool_value;

            // Begin parsing production: Variable: bool_value_32 -> uint<8>;
            ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:38-208:42"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            std::tie(__parsed_bool_value, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: bool_value_32 -> uint<8>;

            {
                ::hilti::rt::integer::safe<uint8_t> __dd = __parsed_bool_value;
                ::hilti::rt::optional::valueOrInit((*__self).bool_value) = ::hilti::rt::Bool(static_cast<bool>(__dd));
            }

            {
                ::hilti::rt::integer::safe<uint8_t> __dd = __parsed_bool_value;
                ::hilti::rt::Bool __requires = (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len == ::hilti::rt::integer::safe<std::uint64_t>{1U};
                if ( ! (__requires) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:68-208:92");
                    throw ::spicy::rt::ParseError(std::string_view("&requires failed: head.len.len == 1"), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:208:68-208:92");
                }
            }

        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_1 -> bool_value_32;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::Integer} || __x == ASN1::ASN1Type{ASN1::ASN1Type::Enumerated} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:210:5-212:87");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:210:5-212:87");

        // Begin parsing production: Block: switch_154_case_2 -> num_value_32;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:211:40-211:44");
            ::hilti::rt::Bytes __parsed_num_value;

            // Begin parsing production: Variable: num_value_32 -> bytes;
            __parsed_num_value = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:211:29-212:87"), (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: num_value_32 -> bytes;

            {
                ::hilti::rt::Bytes __dd = __parsed_num_value;
                ::hilti::rt::optional::valueOrInit((*__self).num_value) = __dd.toInt(::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Big});
            }

        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_2 -> num_value_32;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::NullVal} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:5-214:77");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:5-214:77");

        // Begin parsing production: Block: switch_154_case_3 -> null_value_32;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:38-214:42");

            // Begin parsing production: Variable: null_value_32 -> bytes;
            ::hilti::rt::optional::valueOrInit((*__self).null_value) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{0U}, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:26-214:77"), (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{0U});
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: null_value_32 -> bytes;

            {
                ::hilti::rt::Bytes __dd = ::hilti::rt::optional::value((*__self).null_value);
                ::hilti::rt::Bool __requires = (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len == ::hilti::rt::integer::safe<std::uint64_t>{0U};
                if ( ! (__requires) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:52-214:76");
                    throw ::spicy::rt::ParseError(std::string_view("&requires failed: head.len.len == 0"), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:214:52-214:76");
                }
            }

        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_3 -> null_value_32;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::BitString} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:216:5-216:91");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:216:5-216:91");

        // Begin parsing production: Block: switch_154_case_4 -> Resolved_622;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:101:22-109:1");

            // Begin parsing production: Unit: ASN1__ASN1BitString_33 -> _anon_47_33 value_bits_33 (field 'bitstr_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));
            ::hilti::rt::optional::valueOrInit((*__self).bitstr_value) = (__hlt_ldap::ASN1::ASN1BitString((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len, (::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).tag))._anon_46).value)))));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).bitstr_value)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__ASN1BitString_33 -> _anon_47_33 value_bits_33 (field 'bitstr_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_4 -> Resolved_622;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::OctetString} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:218:5-219:88");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:218:5-219:88");

        // Begin parsing production: Block: switch_154_case_5 -> Resolved_623;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:114:24-118:1");
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __parsed_str_value;

            // Begin parsing production: Unit: ASN1__ASN1OctetString_34 -> value_34 (field 'str_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));
            __parsed_str_value = (__hlt_ldap::ASN1::ASN1OctetString((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len, (::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).tag))._anon_46).value)))));
            std::tie(__cur, __lah, __lahe, __error) = (*__parsed_str_value).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__ASN1OctetString_34 -> value_34 (field 'str_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));

            {
                ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __dd = __parsed_str_value;
                ::hilti::rt::optional::valueOrInit((*__self).str_value) = ::hilti::rt::optional::value((*__dd).value).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::ASCII}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
            }

        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_5 -> Resolved_623;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::ObjectIdentifier} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:221:5-222:67");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:221:5-222:67");

        // Begin parsing production: Block: switch_154_case_6 -> Resolved_624;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:169:29-193:1");
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier> __parsed_str_value;

            // Begin parsing production: Unit: ASN1__ASN1ObjectIdentifier_35 -> _anon_48_35 sublist_35 (field 'str_value', id n/a, parser, args: (head.len.len));
            __parsed_str_value = (__hlt_ldap::ASN1::ASN1ObjectIdentifier((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len));
            std::tie(__cur, __lah, __lahe, __error) = (*__parsed_str_value).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__ASN1ObjectIdentifier_35 -> _anon_48_35 sublist_35 (field 'str_value', id n/a, parser, args: (head.len.len));

            {
                ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier> __dd = __parsed_str_value;
                ::hilti::rt::optional::valueOrInit((*__self).str_value) = (*__dd).oidstring;
            }

        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_6 -> Resolved_624;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::BMPString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::CharacterString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GeneralizedTime} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GeneralString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GraphicString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::IA5String} || __x == ASN1::ASN1Type{ASN1::ASN1Type::NumericString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::PrintableString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::TeletextString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::UTCTime} || __x == ASN1::ASN1Type{ASN1::ASN1Type::UTF8String} || __x == ASN1::ASN1Type{ASN1::ASN1Type::VideotextString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::VisibleString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::UniversalString} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:224:5-237:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:224:5-237:79");

        // Begin parsing production: Block: switch_154_case_7 -> str_value_32;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("<no location>");

            // Begin parsing production: Enclosure: str_value_32 -> Resolved_626;
            ::hilti::rt::optional::valueOrInit((*__self).str_value) = (std::string());
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:123:19-157:21");
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1String> __parsed__anon_51;

            // Begin parsing production: Unit: ASN1__ASN1String_33 -> Resolved_623 (field '_anon_51', id n/a, parser, args: (head.tag, head.len.len));
            __parsed__anon_51 = (__hlt_ldap::ASN1::ASN1String(::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).tag), (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len));
            std::tie(__cur, __lah, __lahe, __error) = (*__parsed__anon_51).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__ASN1String_33 -> Resolved_623 (field '_anon_51', id n/a, parser, args: (head.tag, head.len.len));

            ::hilti::rt::optional::valueOrInit((*__self).str_value) = (*__parsed__anon_51).__convert();
            // End parsing production: Enclosure: str_value_32 -> Resolved_626;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_7 -> str_value_32;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::Sequence} || __x == ASN1::ASN1Type{ASN1::ASN1Type::Set} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:239:5-239:91");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:239:5-239:91");

        // Begin parsing production: Block: switch_154_case_8 -> Resolved_627;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:255:31-257:14");
            if ( __self->__p_recursive ) {
                // Begin parsing production: Unit: ASN1__ASN1SubMessages_32 -> submessages_32 (field 'seq', id n/a, parser, args: (head.len.len));
                ::hilti::rt::optional::valueOrInit((*__self).seq) = (__hlt_ldap::ASN1::ASN1SubMessages((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len));
                std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).seq)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
                // End parsing production: Unit: ASN1__ASN1SubMessages_32 -> submessages_32 (field 'seq', id n/a, parser, args: (head.len.len));
            }
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_8 -> Resolved_627;
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::ObjectDescriptor} || __x == ASN1::ASN1Type{ASN1::ASN1Type::InstanceOf} || __x == ASN1::ASN1Type{ASN1::ASN1Type::Real} || __x == ASN1::ASN1Type{ASN1::ASN1Type::EmbeddedPDV} || __x == ASN1::ASN1Type{ASN1::ASN1Type::RelativeOID} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:242:5-246:75");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:242:5-246:75");

        // Begin parsing production: Block: switch_154_case_9 -> unimplemented_value_63;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:246:51-246:55");

            // Begin parsing production: Variable: unimplemented_value_63 -> bytes;
            ::hilti::rt::optional::valueOrInit((*__self).unimplemented_value) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:246:30-246:75"), (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: unimplemented_value_63 -> bytes;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_case_9 -> unimplemented_value_63;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:249:5-249:55");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:249:5-249:55");

        // Begin parsing production: Block: switch_154_default -> unimplemented_value_64;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:249:31-249:35");

            // Begin parsing production: Variable: unimplemented_value_64 -> bytes;
            ::hilti::rt::optional::valueOrInit((*__self).unimplemented_value) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:249:10-249:55"), (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance((*::hilti::rt::optional::value((*__self->__p_head.derefAsValue()).len)).len);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: unimplemented_value_64 -> bytes;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_154_default -> unimplemented_value_64;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_ldap::ASN1::ASN1Body::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");

    // Begin parsing production: Unit: ASN1__ASN1Body_32 -> switch_154;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1Body_32 -> switch_154;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_ldap::ASN1::ASN1Header::__parse_ASN1__ASN1Header_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Header::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:90:16-96:1");

        // Begin parsing production: Unit: ASN1__ASN1Tag_36 -> _anon_46_36;
        ::hilti::rt::optional::valueOrInit((*__self).tag) = (__hlt_ldap::ASN1::ASN1Tag());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).tag)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Tag_36 -> _anon_46_36;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:67:19-88:1");

        // Begin parsing production: Unit: ASN1__LengthType_36 -> data_71 switch_153;
        ::hilti::rt::optional::valueOrInit((*__self).len) = (__hlt_ldap::ASN1::LengthType());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).len)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__LengthType_36 -> data_71 switch_153;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1Header::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Header::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1Header_35_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_ldap::ASN1::ASN1Header::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");
    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::ASN1::ASN1Header>((__hlt_ldap::ASN1::ASN1Header()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

    // Begin parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::ASN1::ASN1Header::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

    // Begin parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::ASN1::ASN1Header::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");
    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::ASN1::ASN1Header>((__hlt_ldap::ASN1::ASN1Header()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

    // Begin parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1Header_35 -> Resolved_619 Resolved_620;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_ldap::ASN1::ASN1Message::__on_application_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = ASN1::ASN1Message::__self();
    return __hlt_ldap::ASN1::__hook_ASN1Message___on_application_data(__dd, __self);
}

auto __hlt_ldap::ASN1::ASN1Message::__parse_ASN1__ASN1Message_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_38 -> Resolved_645 Resolved_646;
        ::hilti::rt::optional::valueOrInit((*__self).head) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).head)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_38 -> Resolved_645 Resolved_646;
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:268:3-278:4");

    // Begin parsing production: Switch: switch_161 -> [ASN1Class::Universal] -> switch_161_case_1 | [ASN1Class::Application,ASN1Class::ContextSpecific,ASN1Class::Private] -> switch_161_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_161_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_161 -> [ASN1Class::Universal] -> switch_161_case_1 | [ASN1Class::Application,ASN1Class::ContextSpecific,ASN1Class::Private] -> switch_161_case_2;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1Message::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1Message_34_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1Message::__parse_switch_161_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:268:3-278:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:268:3-278:4");
    if ( ASN1::ASN1Class __x = (::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).head)).tag))._anon_46).value))); __x == ASN1::ASN1Class{ASN1::ASN1Class::Universal} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:270:5-270:65");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:270:5-270:65");

        // Begin parsing production: Block: switch_161_case_1 -> Resolved_647;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");

            // Begin parsing production: Unit: ASN1__ASN1Body_34 -> switch_162 (field 'body', id n/a, parser, args: (self.head, recursive));
            ::hilti::rt::optional::valueOrInit((*__self).body) = (__hlt_ldap::ASN1::ASN1Body(::hilti::rt::optional::value((*__self).head), __self->__p_recursive));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).body)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__ASN1Body_34 -> switch_162 (field 'body', id n/a, parser, args: (self.head, recursive));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_161_case_1 -> Resolved_647;
    }

    else if ( __x == ASN1::ASN1Class{ASN1::ASN1Class::Application} || __x == ASN1::ASN1Class{ASN1::ASN1Class::ContextSpecific} || __x == ASN1::ASN1Class{ASN1::ASN1Class::Private} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:272:5-276:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:272:5-276:5");

        // Begin parsing production: Block: switch_161_case_2 -> application_data_34;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:274:45-274:49");

            // Begin parsing production: Variable: application_data_34 -> bytes;
            ::hilti::rt::optional::valueOrInit((*__self).application_data) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).head)).len)).len, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:274:27-276:5"), (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).head)).len)).len);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: application_data_34 -> bytes;

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:274:27-276:5");
            (*__self).__on_application_data(::hilti::rt::optional::value((*__self).application_data));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_161_case_2 -> application_data_34;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:268:3-278:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("no matching case in switch statement for value '%s'"), (::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).head)).tag))._anon_46).value)))), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:268:3-278:4");
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_ldap::ASN1::ASN1Message::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

    // Begin parsing production: Unit: ASN1__ASN1Message_34 -> Resolved_644 switch_161;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1Message_34 -> Resolved_644 switch_161;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_0x25_done() {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_0x25_done(__self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on__anon_48(__dd, __self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_sublist_foreach(__dd, __stop, __self);
}

auto __hlt_ldap::ASN1::ASN1ObjectIdentifier::__parse_ASN1__ASN1ObjectIdentifier_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1ObjectIdentifier::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:169:29-193:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::integer::safe<uint8_t> __transient__anon_48;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:174:5-174:9");
    if ( __self->__p_len >= ::hilti::rt::integer::safe<std::uint64_t>{1U} ) {
        // Begin parsing production: Variable: _anon_48_34 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:174:5-174:9"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__transient__anon_48, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_48_34 -> uint<8>;

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:174:3-180:3");
        (*__self).__on__anon_48(__transient__anon_48);
        __error = (*__self).__error;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:182:3-188:3");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

        // Begin parsing production: Counter: sublist_34 -> counter(len - 1): _anon_50_34;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_sublist_34_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).sublist));
        // End parsing production: Counter: sublist_34 -> counter(len - 1): _anon_50_34;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:169:29-193:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1ObjectIdentifier::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1ObjectIdentifier::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:169:29-193:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1ObjectIdentifier_34_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1ObjectIdentifier::__parse_sublist_34_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1ObjectIdentifier::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:182:3-188:3");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    for ( ::hilti::rt::integer::safe<uint64_t> __i = __self->__p_len - ::hilti::rt::integer::safe<std::uint64_t>{1U}; ::hilti::rt::Bool(static_cast<bool>(__i));  ) {
        __i--;
        ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>> __elem;
        __location__("<no location>");

        // Begin parsing production: Enclosure: _anon_50_34 -> Resolved_617 (container 'sublist');
        __elem = (::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>());
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:162:35-167:20");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifierNibble> __parsed__anon_49;

        // Begin parsing production: Unit: ASN1__ASN1ObjectIdentifierNibble_35 -> data_70;
        __parsed__anon_49 = (__hlt_ldap::ASN1::ASN1ObjectIdentifierNibble());
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed__anon_49).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1ObjectIdentifierNibble_35 -> data_70;

        __elem = (*__parsed__anon_49).__convert();
        // End parsing production: Enclosure: _anon_50_34 -> Resolved_617 (container 'sublist');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:182:3-188:3");
            (*__self).__on_sublist_foreach(__elem, __stop);
            __error = (*__self).__error;
        }

        if ( ! (__stop) ) {
            __dst.emplace_back(__elem);
        }

        if ( __stop ) {
            break;
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline auto __hlt_ldap::ASN1::ASN1ObjectIdentifierNibble::__convert() -> ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>> {
    auto __self = ASN1::ASN1ObjectIdentifierNibble::__self();
    return ::hilti::rt::optional::value((*__self).data);
}

auto __hlt_ldap::ASN1::ASN1ObjectIdentifierNibble::__parse_ASN1__ASN1ObjectIdentifierNibble_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1ObjectIdentifierNibble::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:162:35-167:20");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:163:10-166:3");

        // Begin parsing production: Variable: data_69 -> bitfield(8) { num: 0..6; more: 7; };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:163:10-166:3"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).data), __cur) = (__x_1 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::integer::bits(std::get<0>(*__x_1), 0, 6, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 7, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_1))), std::get<1>(*__x_1)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: data_69 -> bitfield(8) { num: 0..6; more: 7; };
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1ObjectIdentifierNibble::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1ObjectIdentifierNibble::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:162:35-167:20");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1ObjectIdentifierNibble_34_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1OctetString::__parse_ASN1__ASN1OctetString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1OctetString::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:114:24-118:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_7;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:115:10-115:14");

        // Begin parsing production: Variable: value_32 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).value) = ::spicy::rt::detail::extractBytes(__data, __cur, __self->__p_len, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:115:3-115:27"), (__lhs_7=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(__self->__p_len);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: value_32 -> bytes;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1OctetString::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1OctetString::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:114:24-118:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1OctetString_32_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline auto __hlt_ldap::ASN1::ASN1String::__convert() -> std::string {
    auto __self = ASN1::ASN1String::__self();
    return ::hilti::rt::optional::value((*__self).value);
}

inline void __hlt_ldap::ASN1::ASN1String::__on_0x25_init() {
    auto __self = ASN1::ASN1String::__self();
    return __hlt_ldap::ASN1::__hook_ASN1String___on_0x25_init(__self);
}

auto __hlt_ldap::ASN1::ASN1String::__parse_ASN1__ASN1String_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1String::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:123:19-157:21");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:114:24-118:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __parsed_value;

        // Begin parsing production: Unit: ASN1__ASN1OctetString_33 -> value_33 (field 'value', id n/a, parser, args: (len, tag._anon_46.constructed));
        __parsed_value = (__hlt_ldap::ASN1::ASN1OctetString(__self->__p_len, (::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*__self->__p_tag.derefAsValue())._anon_46).value)))));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_value).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1OctetString_33 -> value_33 (field 'value', id n/a, parser, args: (len, tag._anon_46.constructed));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __dd = __parsed_value;
            ::hilti::rt::optional::valueOrInit((*__self).value) = ::hilti::rt::optional::value((*__dd).value).decode((*__self).encoding, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
        }

    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1String::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1String::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:123:19-157:21");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:123:19-157:21");
        (*__self).__on_0x25_init();
        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1String_32_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1SubMessages::__parse_ASN1__ASN1SubMessages_33_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1SubMessages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:255:31-257:14");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::stream::View __limited = __cur.limit(__self->__p_msgLen);
    ::hilti::rt::stream::View __ncur = __cur.advance(__self->__p_msgLen);

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:256:3-256:40");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

        // Begin parsing production: ForEach: submessages_33 -> foreach: Resolved_633;
        std::tie(__limited, __lah, __lahe, __error) = (*__self).__parse_submessages_33_stage1(__data, __begin, __limited, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).submessages));
        // End parsing production: ForEach: submessages_33 -> foreach: Resolved_633;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    if ( __limited.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:257:3-257:14");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("&size amount not consumed: expected %lu bytes, but got %lu bytes"), __self->__p_msgLen, __limited.offset() - (__ncur.offset() - __self->__p_msgLen)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:257:3-257:14");
    }

    __cur = __ncur;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1SubMessages::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1SubMessages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:255:31-257:14");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1SubMessages_33_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::ASN1SubMessages::__parse_submessages_33_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_8;
    auto __self = ASN1SubMessages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:256:3-256:40");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_8=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_9;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

        // Begin parsing production: Unit: ASN1__ASN1Message_33 -> Resolved_634 switch_158 (field '_anon_52', id n/a, parser, args: (True)) (container 'submessages');
        __elem = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_33 -> Resolved_634 switch_158 (field '_anon_52', id n/a, parser, args: (True)) (container 'submessages');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
        }

        if ( ! (__stop) ) {
            __dst.emplace_back((*__elem));
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_9=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:256:3-256:40");
            throw ::spicy::rt::ParseError(std::string_view("loop body did not change input position, possible infinite loop"), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:256:3-256:40");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_ldap::ASN1::ASN1SubMessages::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:255:31-257:14");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:255:31-257:14");

    // Begin parsing production: Unit: ASN1__ASN1SubMessages_33 -> submessages_33;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: ASN1__ASN1SubMessages_33 -> submessages_33;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_ldap::ASN1::ASN1Tag::__parse_ASN1__ASN1Tag_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_2;
    auto __self = ASN1Tag::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:90:16-96:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:91:4-95:3");

    // Begin parsing production: Variable: _anon_46_35 -> bitfield(8) { type_: 0..4 &convert=ASN1Type(__dd); constructed: 5 &convert=cast<bool>(__dd); class: 6..7 &convert=ASN1Class(__dd); };
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:91:4-95:3"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(::hilti::rt::optional::valueOrInit((*__self)._anon_46), __cur) = (__x_2 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(ASN1::ASN1Type{::hilti::rt::integer::bits(std::get<0>(*__x_2), 0, 4, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0})}, ::hilti::rt::Bool(static_cast<bool>(::hilti::rt::integer::bits(std::get<0>(*__x_2), 5, 5, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}))), ASN1::ASN1Class{::hilti::rt::integer::bits(std::get<0>(*__x_2), 6, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0})}, ::hilti::rt::integer::noop(std::get<0>(*__x_2))), std::get<1>(*__x_2)))).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_46_35 -> bitfield(8) { type_: 0..4 &convert=ASN1Type(__dd); constructed: 5 &convert=cast<bool>(__dd); class: 6..7 &convert=ASN1Class(__dd); };

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::ASN1Tag::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ASN1Tag::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:90:16-96:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__ASN1Tag_35_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_44() {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_44(__self);
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd) {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_45(__dd, __self);
}

auto __hlt_ldap::ASN1::LengthType::__parse_ASN1__LengthType_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LengthType::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:67:19-88:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_3;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:71:10-74:3");

        // Begin parsing production: Variable: data_68 -> bitfield(8) { num: 0..6; islong: 7; };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:71:10-74:3"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).data), __cur) = (__x_3 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::integer::bits(std::get<0>(*__x_3), 0, 6, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_3), 7, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_3))), std::get<1>(*__x_3)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: data_68 -> bitfield(8) { num: 0..6; islong: 7; };
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:77:3-87:4");

    // Begin parsing production: Switch: switch_152 -> [0] -> switch_152_case_1 | [1] -> switch_152_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_152_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_152 -> [0] -> switch_152_case_1 | [1] -> switch_152_case_2;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::ASN1::LengthType::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LengthType::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:67:19-88:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_ASN1__LengthType_35_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::ASN1::LengthType::__parse_switch_152_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LengthType::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:77:3-87:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:77:3-87:4");
    if ( ::hilti::rt::integer::safe<uint8_t> __x = (::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*__self).data).value))); __x == ::hilti::rt::integer::safe<std::uint8_t>{0U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:78:5-81:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:78:5-81:5");

        // Begin parsing production: Block: switch_152_case_1 -> _anon_44_35;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:78:12-78:15");

        // Begin parsing production: Variable: _anon_44_35 -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_44_35 -> void;

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:78:10-81:5");
        (*__self).__on__anon_44();
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:78:5-81:5");
        __error = (*__self).__error;
        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_152_case_1 -> _anon_44_35;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::uint8_t>{1U} ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_10;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:5-86:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:5-86:5");

        // Begin parsing production: Block: switch_152_case_2 -> _anon_45_35;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::integer::safe<uint64_t> __transient__anon_45;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:12-82:16");
        ::hilti::rt::Bytes __parsed__anon_45;

        // Begin parsing production: Variable: _anon_45_35 -> bytes;
        __parsed__anon_45 = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).data).value)))), ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:10-86:5"), (__lhs_10=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).data).value)))));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_45_35 -> bytes;

        {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:5-86:5");
            ::hilti::rt::Bytes __dd = __parsed__anon_45;
            __transient__anon_45 = __dd.toUInt(::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network});
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:10-86:5");
        (*__self).__on__anon_45(__transient__anon_45);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:82:5-86:5");
        __error = (*__self).__error;
        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_152_case_2 -> _anon_45_35;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:77:3-87:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("no matching case in switch statement for value '%s'"), (::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*__self).data).value)))), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:77:3-87:4");
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern void __hlt_ldap::ASN1::__hook_ASN1Message___on_application_data_8bb7(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<ASN1Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:275:7-275:60");
    (*__self).application_id = static_cast<::hilti::rt::integer::safe<int32_t>>((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).head)).tag))._anon_46).value))).value());
}

extern void __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_0x25_done_7fdb(::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:191:5-191:43");
    (*__self).oidstring = (*__self).oidbytes.decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
}

extern void __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on__anon_48_8b96(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:175:5-175:23");
    (*__self).temp = ::hilti::rt::integer::safe<uint64_t>(__dd / ::hilti::rt::integer::safe<std::uint8_t>{40U});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:176:5-176:50");
    (*__self).oidbytes.append(::hilti::rt::Bytes((::hilti::rt::fmt(std::string("%d"), ((*__self).temp))), ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:177:5-177:23");
    (*__self).temp = ::hilti::rt::integer::safe<uint64_t>(__dd % ::hilti::rt::integer::safe<std::uint8_t>{40U});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:178:5-178:51");
    (*__self).oidbytes.append(::hilti::rt::Bytes((::hilti::rt::fmt(std::string(".%d"), ((*__self).temp))), ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:179:5-179:17");
    (*__self).temp = ::hilti::rt::integer::safe<std::uint64_t>{0U};
}

extern void __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_sublist_foreach_4227(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<ASN1ObjectIdentifier>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:183:5-183:41");
    (*__self).temp = ((((*__self).temp << ::hilti::rt::integer::safe<std::uint64_t>{7U})) | ::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<0>(__dd.value)))));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:184:5-187:5");
    if ( (::hilti::rt::optional::value(std::get<1>(__dd.value))) != ::hilti::rt::integer::safe<std::uint8_t>{1U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:185:7-185:53");
        (*__self).oidbytes.append(::hilti::rt::Bytes((::hilti::rt::fmt(std::string(".%d"), ((*__self).temp))), ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:186:7-186:19");
        (*__self).temp = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }
}

extern void __hlt_ldap::ASN1::__hook_ASN1String___on_0x25_init_f039(::hilti::rt::ValueReference<ASN1String>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:127:5-153:5");
    if ( ASN1::ASN1Type __x = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self->__p_tag.derefAsValue())._anon_46).value))); __x == ASN1::ASN1Type{ASN1::ASN1Type::PrintableString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GeneralizedTime} || __x == ASN1::ASN1Type{ASN1::ASN1Type::UTCTime} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:135:9-135:45");
        (*__self).encoding = ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::ASCII};
    }

    else if ( __x == ASN1::ASN1Type{ASN1::ASN1Type::UTF8String} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GeneralString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::CharacterString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::GraphicString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::IA5String} || __x == ASN1::ASN1Type{ASN1::ASN1Type::NumericString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::TeletextString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::VideotextString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::VisibleString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::BMPString} || __x == ASN1::ASN1Type{ASN1::ASN1Type::UniversalString} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:151:9-151:44");
        (*__self).encoding = ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8};
    }

    else  {
        throw ::hilti::rt::UnhandledSwitchCase(::hilti::rt::to_string_for_print(__x), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:127:5-153:5");
    }
}

extern void __hlt_ldap::ASN1::__hook_LengthType___on__anon_44_f0b3(::hilti::rt::ValueReference<LengthType>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:79:7-79:30");
    (*__self).len = ::hilti::rt::integer::safe<uint64_t>((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).data).value))));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:80:7-80:22");
    (*__self).tag_len = ::hilti::rt::integer::safe<std::uint8_t>{1U};
}

extern void __hlt_ldap::ASN1::__hook_LengthType___on__anon_45_a0b9(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<LengthType>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:84:7-84:19");
    (*__self).len = __dd;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:85:7-85:38");
    (*__self).tag_len = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).data).value))) + ::hilti::rt::integer::safe<std::uint8_t>{1U};
}

extern void __hlt_ldap::ASN1::__init_module() {
    __hlt_ldap::ASN1::__register_ASN1_ASN1BitString();
    __hlt_ldap::ASN1::__register_ASN1_ASN1Body();
    __hlt_ldap::ASN1::__register_ASN1_ASN1Header();
    __hlt_ldap::ASN1::__register_ASN1_ASN1Message();
    __hlt_ldap::ASN1::__register_ASN1_ASN1ObjectIdentifier();
    __hlt_ldap::ASN1::__register_ASN1_ASN1ObjectIdentifierNibble();
    __hlt_ldap::ASN1::__register_ASN1_ASN1OctetString();
    __hlt_ldap::ASN1::__register_ASN1_ASN1String();
    __hlt_ldap::ASN1::__register_ASN1_ASN1SubMessages();
    __hlt_ldap::ASN1::__register_ASN1_ASN1Tag();
    __hlt_ldap::ASN1::__register_ASN1_LengthType();
}

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1BitString() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1Body() {
    ::hilti::rt::detail::checkStack();
    ASN1::ASN1Body::__parser = ::spicy::rt::Parser(std::string_view("ASN1::ASN1Body"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::ASN1::ASN1Body::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(ASN1::ASN1Body::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::ASN1::ASN1Body>());
}

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1Header() {
    ::hilti::rt::detail::checkStack();
    ASN1::ASN1Header::__parser = ::spicy::rt::Parser(std::string_view("ASN1::ASN1Header"), ::hilti::rt::Bool(true), hlt_ldap::ASN1::ASN1Header::parse1, hlt_ldap::ASN1::ASN1Header::parse2, hlt_ldap::ASN1::ASN1Header::parse3, ::hilti::rt::Null(), &type_info::__ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(ASN1::ASN1Header::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::ASN1::ASN1Header>());
}

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1Message() {
    ::hilti::rt::detail::checkStack();
    ASN1::ASN1Message::__parser = ::spicy::rt::Parser(std::string_view("ASN1::ASN1Message"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::ASN1::ASN1Message::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(ASN1::ASN1Message::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::ASN1::ASN1Message>());
}

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1ObjectIdentifier() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1ObjectIdentifierNibble() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1OctetString() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1String() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1SubMessages() {
    ::hilti::rt::detail::checkStack();
    ASN1::ASN1SubMessages::__parser = ::spicy::rt::Parser(std::string_view("ASN1::ASN1SubMessages"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::ASN1::ASN1SubMessages::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(ASN1::ASN1SubMessages::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::ASN1::ASN1SubMessages>());
}

extern void __hlt_ldap::ASN1::__register_ASN1_ASN1Tag() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_ASN1_LengthType() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::ASN1::__register_module() { ::hilti::rt::detail::registerModule({ "ASN1", __hlt_ldap_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1BitString& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Class x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Type x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Tag& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::LengthType& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Header& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1SubMessages& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Message& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Body& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifier& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1OctetString& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1String& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::ASN1::operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifierNibble& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Class::Private: return "ASN1Class::Private";
        case __hlt_ldap::ASN1::ASN1Class::ContextSpecific: return "ASN1Class::ContextSpecific";
        case __hlt_ldap::ASN1::ASN1Class::Application: return "ASN1Class::Application";
        case __hlt_ldap::ASN1::ASN1Class::Universal: return "ASN1Class::Universal";
        case __hlt_ldap::ASN1::ASN1Class::Undef: return "ASN1Class::Undef";
        default: return ::hilti::rt::fmt("ASN1Class::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Type::BMPString: return "ASN1Type::BMPString";
        case __hlt_ldap::ASN1::ASN1Type::CharacterString: return "ASN1Type::CharacterString";
        case __hlt_ldap::ASN1::ASN1Type::UniversalString: return "ASN1Type::UniversalString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralString: return "ASN1Type::GeneralString";
        case __hlt_ldap::ASN1::ASN1Type::VisibleString: return "ASN1Type::VisibleString";
        case __hlt_ldap::ASN1::ASN1Type::GraphicString: return "ASN1Type::GraphicString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralizedTime: return "ASN1Type::GeneralizedTime";
        case __hlt_ldap::ASN1::ASN1Type::UTCTime: return "ASN1Type::UTCTime";
        case __hlt_ldap::ASN1::ASN1Type::IA5String: return "ASN1Type::IA5String";
        case __hlt_ldap::ASN1::ASN1Type::VideotextString: return "ASN1Type::VideotextString";
        case __hlt_ldap::ASN1::ASN1Type::TeletextString: return "ASN1Type::TeletextString";
        case __hlt_ldap::ASN1::ASN1Type::PrintableString: return "ASN1Type::PrintableString";
        case __hlt_ldap::ASN1::ASN1Type::NumericString: return "ASN1Type::NumericString";
        case __hlt_ldap::ASN1::ASN1Type::Set: return "ASN1Type::Set";
        case __hlt_ldap::ASN1::ASN1Type::Sequence: return "ASN1Type::Sequence";
        case __hlt_ldap::ASN1::ASN1Type::RelativeOID: return "ASN1Type::RelativeOID";
        case __hlt_ldap::ASN1::ASN1Type::UTF8String: return "ASN1Type::UTF8String";
        case __hlt_ldap::ASN1::ASN1Type::EmbeddedPDV: return "ASN1Type::EmbeddedPDV";
        case __hlt_ldap::ASN1::ASN1Type::Enumerated: return "ASN1Type::Enumerated";
        case __hlt_ldap::ASN1::ASN1Type::Real: return "ASN1Type::Real";
        case __hlt_ldap::ASN1::ASN1Type::InstanceOf: return "ASN1Type::InstanceOf";
        case __hlt_ldap::ASN1::ASN1Type::ObjectDescriptor: return "ASN1Type::ObjectDescriptor";
        case __hlt_ldap::ASN1::ASN1Type::ObjectIdentifier: return "ASN1Type::ObjectIdentifier";
        case __hlt_ldap::ASN1::ASN1Type::NullVal: return "ASN1Type::NullVal";
        case __hlt_ldap::ASN1::ASN1Type::OctetString: return "ASN1Type::OctetString";
        case __hlt_ldap::ASN1::ASN1Type::BitString: return "ASN1Type::BitString";
        case __hlt_ldap::ASN1::ASN1Type::Integer: return "ASN1Type::Integer";
        case __hlt_ldap::ASN1::ASN1Type::Boolean: return "ASN1Type::Boolean";
        case __hlt_ldap::ASN1::ASN1Type::Undef: return "ASN1Type::Undef";
        default: return ::hilti::rt::fmt("ASN1Type::<unknown-%" PRIu64 ">", x.value());
    }
}

extern auto hlt_ldap::ASN1::ASN1Body::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1Body::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::ASN1::ASN1Header::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1Header::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::ASN1::ASN1Header::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1Header::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::ASN1::ASN1Header::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1Header::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::ASN1::ASN1Message::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1Message::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::ASN1::ASN1SubMessages::parse2(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::ASN1::ASN1SubMessages::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

