// Begin of QUIC (from "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_quic_hlto_scope;
extern auto QUIC_decrypt_crypto_payload(const ::hilti::rt::integer::safe<uint32_t>& version, const ::hilti::rt::Bytes& all_data, const ::hilti::rt::Bytes& connection_id, const ::hilti::rt::integer::safe<uint64_t>& encrypted_offset, const ::hilti::rt::integer::safe<uint64_t>& payload_offset, const ::hilti::rt::Bool& from_client) -> ::hilti::rt::Bytes;

namespace __hlt_quic::QUIC {
    struct VariableLengthInteger;
    struct ACKPayload;
    struct CRYPTOPayload;
    struct ZeroRTTPacket;
    struct UnhandledVersion;
    struct RetryPacket;
    struct LongHeaderPacketV2;
    struct LongHeaderPacketV1;
    struct LongHeaderPacket;
    struct InitialPacket;
    struct HandshakePacket;
    struct ConnectionClosePayload;
    struct ConnectionIDInfo;
    struct CryptoBuffer;
    struct EncryptedLongPacketPayload;
    struct Frame;
    struct ShortHeader;
    struct ShortPacketPayload;
    struct Packet;
    struct RequestFrame;
    struct ResponseFrame;
    HILTI_RT_ENUM_WITH_DEFAULT(HeaderForm, Undef, SHORT = 0, LONG = 1, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(FrameType, Undef, PADDING = 0, PING = 1, ACK1 = 2, ACK2 = 3, RESET_STREAM = 4, STOP_SENDING = 5, CRYPTO = 6, NEW_TOKEN = 7, STREAM1 = 8, STREAM2 = 9, STREAM3 = 10, STREAM4 = 11, STREAM5 = 12, STREAM6 = 13, STREAM7 = 14, STREAM8 = 15, MAX_DATA = 16, MAX_STREAM_DATA = 17, MAX_STREAMS1 = 18, MAX_STREAMS2 = 19, DATA_BLOCKED = 20, STREAM_DATA_BLOCKED = 21, STREAMS_BLOCKED1 = 22, STREAMS_BLOCKED2 = 23, NEW_CONNECTION_ID = 24, RETIRE_CONNECTION_ID = 25, PATH_CHALLENGE = 26, PATH_RESPONSE = 27, CONNECTION_CLOSE1 = 28, CONNECTION_CLOSE2 = 29, HANDSHAKE_DONE = 30, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(LongPacketTypeV1, Undef, INITIAL = 0, ZERO_RTT = 1, HANDSHAKE = 2, RETRY = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(LongPacketTypeV2, Undef, INITIAL = 1, ZERO_RTT = 2, HANDSHAKE = 3, RETRY = 0, Undef = -1);;
    struct VariableLengthInteger : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<VariableLengthInteger> {
        auto __self() { return ::hilti::rt::ValueReference<VariableLengthInteger>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> bytes_to_parse{};
        ::hilti::rt::integer::safe<uint64_t> result_{};
        void __on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        void __on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__VariableLengthInteger_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        VariableLengthInteger();
        VariableLengthInteger(const VariableLengthInteger&) = default;
        VariableLengthInteger(VariableLengthInteger&&) = default;
        VariableLengthInteger& operator=(const VariableLengthInteger&) = default;
        VariableLengthInteger& operator=(VariableLengthInteger&&) = default;
        VariableLengthInteger(std::optional<::hilti::rt::integer::safe<uint64_t>> bytes_to_parse, std::optional<::hilti::rt::integer::safe<uint64_t>> result_);
        template<typename F> void __visit(F _) const { _("bytes_to_parse", bytes_to_parse); _("result_", result_); }
    };

    struct ACKPayload : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ACKPayload> {
        auto __self() { return ::hilti::rt::ValueReference<ACKPayload>::self(this); }
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> latest_ack{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> ack_delay{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> ack_range_count{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> first_ack_range{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__ACKPayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ACKPayload();
        ACKPayload(const ACKPayload&) = default;
        ACKPayload(ACKPayload&&) = default;
        ACKPayload& operator=(const ACKPayload&) = default;
        ACKPayload& operator=(ACKPayload&&) = default;
        ACKPayload(std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> latest_ack, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> ack_delay, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> ack_range_count, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> first_ack_range);
        template<typename F> void __visit(F _) const { _("latest_ack", latest_ack); _("ack_delay", ack_delay); _("ack_range_count", ack_range_count); _("first_ack_range", first_ack_range); }
    };

    struct CRYPTOPayload : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<CRYPTOPayload> {
        auto __self() { return ::hilti::rt::ValueReference<CRYPTOPayload>::self(this); }
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> offset{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        std::optional<::hilti::rt::Bytes> cryptodata{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__CRYPTOPayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::Bool __p_from_client{};
        CRYPTOPayload();
        CRYPTOPayload(const CRYPTOPayload&) = default;
        CRYPTOPayload(CRYPTOPayload&&) = default;
        CRYPTOPayload& operator=(const CRYPTOPayload&) = default;
        CRYPTOPayload& operator=(CRYPTOPayload&&) = default;
        CRYPTOPayload(std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> offset, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length, std::optional<std::optional<::hilti::rt::Bytes>> cryptodata);
        CRYPTOPayload(const ::hilti::rt::Bool& __p_from_client);
        template<typename F> void __visit(F _) const { _("offset", offset); _("length", length); _("cryptodata", cryptodata); }
    };

    struct ZeroRTTPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ZeroRTTPacket> {
        auto __self() { return ::hilti::rt::ValueReference<ZeroRTTPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__ZeroRTTPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        ZeroRTTPacket();
        ZeroRTTPacket(const ZeroRTTPacket&) = default;
        ZeroRTTPacket(ZeroRTTPacket&&) = default;
        ZeroRTTPacket& operator=(const ZeroRTTPacket&) = default;
        ZeroRTTPacket& operator=(ZeroRTTPacket&&) = default;
        ZeroRTTPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        ZeroRTTPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("length", length); }
    };

    struct UnhandledVersion : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<UnhandledVersion> {
        auto __self() { return ::hilti::rt::ValueReference<UnhandledVersion>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<UnhandledVersion>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__UnhandledVersion_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        UnhandledVersion();
        UnhandledVersion(const UnhandledVersion&) = default;
        UnhandledVersion(UnhandledVersion&&) = default;
        UnhandledVersion& operator=(const UnhandledVersion&) = default;
        UnhandledVersion& operator=(UnhandledVersion&&) = default;
        UnhandledVersion(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header);
        UnhandledVersion(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); }
    };

    struct RetryPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<RetryPacket> {
        auto __self() { return ::hilti::rt::ValueReference<RetryPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        ::hilti::rt::Bytes retry_token{};
        ::hilti::rt::Bytes integrity_tag{};
        std::optional<::hilti::rt::Bytes> data{};
        void __on_data(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__RetryPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        RetryPacket();
        RetryPacket(const RetryPacket&) = default;
        RetryPacket(RetryPacket&&) = default;
        RetryPacket& operator=(const RetryPacket&) = default;
        RetryPacket& operator=(RetryPacket&&) = default;
        RetryPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<::hilti::rt::Bytes> retry_token, std::optional<::hilti::rt::Bytes> integrity_tag, std::optional<std::optional<::hilti::rt::Bytes>> data);
        RetryPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("retry_token", retry_token); _("integrity_tag", integrity_tag); _("data", data); }
    };

    struct LongHeaderPacketV2 : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<LongHeaderPacketV2> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacketV2>::self(this); }
        std::optional<::hilti::rt::ValueReference<InitialPacket>> initial_hdr{};
        void __on_initial_hdr(const ::hilti::rt::ValueReference<InitialPacket>& __dd);
        std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>> zerortt_hdr{};
        std::optional<::hilti::rt::ValueReference<HandshakePacket>> handshake_hdr{};
        std::optional<::hilti::rt::ValueReference<RetryPacket>> retry_hdr{};
        void __on_retry_hdr(const ::hilti::rt::ValueReference<RetryPacket>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacketV2>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacketV2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_outer{};
        LongHeaderPacketV2();
        LongHeaderPacketV2(const LongHeaderPacketV2&) = default;
        LongHeaderPacketV2(LongHeaderPacketV2&&) = default;
        LongHeaderPacketV2& operator=(const LongHeaderPacketV2&) = default;
        LongHeaderPacketV2& operator=(LongHeaderPacketV2&&) = default;
        LongHeaderPacketV2(std::optional<std::optional<::hilti::rt::ValueReference<InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<RetryPacket>>> retry_hdr);
        LongHeaderPacketV2(::hilti::rt::ValueReference<LongHeaderPacket>& __p_outer);
        template<typename F> void __visit(F _) const { _("initial_hdr", initial_hdr); _("zerortt_hdr", zerortt_hdr); _("handshake_hdr", handshake_hdr); _("retry_hdr", retry_hdr); }
    };

    struct LongHeaderPacketV1 : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<LongHeaderPacketV1> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacketV1>::self(this); }
        std::optional<::hilti::rt::ValueReference<InitialPacket>> initial_hdr{};
        void __on_initial_hdr(const ::hilti::rt::ValueReference<InitialPacket>& __dd);
        std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>> zerortt_hdr{};
        std::optional<::hilti::rt::ValueReference<HandshakePacket>> handshake_hdr{};
        std::optional<::hilti::rt::ValueReference<RetryPacket>> retry_hdr{};
        void __on_retry_hdr(const ::hilti::rt::ValueReference<RetryPacket>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacketV1>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacketV1_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_outer{};
        LongHeaderPacketV1();
        LongHeaderPacketV1(const LongHeaderPacketV1&) = default;
        LongHeaderPacketV1(LongHeaderPacketV1&&) = default;
        LongHeaderPacketV1& operator=(const LongHeaderPacketV1&) = default;
        LongHeaderPacketV1& operator=(LongHeaderPacketV1&&) = default;
        LongHeaderPacketV1(std::optional<std::optional<::hilti::rt::ValueReference<InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<RetryPacket>>> retry_hdr);
        LongHeaderPacketV1(::hilti::rt::ValueReference<LongHeaderPacket>& __p_outer);
        template<typename F> void __visit(F _) const { _("initial_hdr", initial_hdr); _("zerortt_hdr", zerortt_hdr); _("handshake_hdr", handshake_hdr); _("retry_hdr", retry_hdr); }
    };

    struct LongHeaderPacket : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<LongHeaderPacket> {
        auto __self() { return ::hilti::rt::ValueReference<LongHeaderPacket>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> encrypted_offset{};
        ::hilti::rt::integer::safe<uint64_t> payload_length{};
        ::hilti::rt::integer::safe<uint8_t> client_conn_id_length{};
        ::hilti::rt::integer::safe<uint8_t> server_conn_id_length{};
        ::hilti::rt::Bool is_initial{};
        ::hilti::rt::Bool is_retry{};
        std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> first_byte{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> version{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> dest_conn_id_len{};
        void __on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Bytes> dest_conn_id{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> src_conn_id_len{};
        void __on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Bytes> src_conn_id{};
        std::optional<::hilti::rt::ValueReference<LongHeaderPacketV1>> v1{};
        std::optional<::hilti::rt::ValueReference<LongHeaderPacketV2>> v2{};
        std::optional<::hilti::rt::ValueReference<UnhandledVersion>> unknown{};
        void __on_unknown(const ::hilti::rt::ValueReference<UnhandledVersion>& __dd);
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<LongHeaderPacket>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__LongHeaderPacket_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LongHeaderPacket();
        LongHeaderPacket(const LongHeaderPacket&) = default;
        LongHeaderPacket(LongHeaderPacket&&) = default;
        LongHeaderPacket& operator=(const LongHeaderPacket&) = default;
        LongHeaderPacket& operator=(LongHeaderPacket&&) = default;
        LongHeaderPacket(std::optional<::hilti::rt::integer::safe<uint64_t>> encrypted_offset, std::optional<::hilti::rt::integer::safe<uint64_t>> payload_length, std::optional<::hilti::rt::integer::safe<uint8_t>> client_conn_id_length, std::optional<::hilti::rt::integer::safe<uint8_t>> server_conn_id_length, std::optional<::hilti::rt::Bool> is_initial, std::optional<::hilti::rt::Bool> is_retry, std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> version, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> dest_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> dest_conn_id, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> src_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> src_conn_id, std::optional<std::optional<::hilti::rt::ValueReference<LongHeaderPacketV1>>> v1, std::optional<std::optional<::hilti::rt::ValueReference<LongHeaderPacketV2>>> v2, std::optional<std::optional<::hilti::rt::ValueReference<UnhandledVersion>>> unknown);
        template<typename F> void __visit(F _) const { _("encrypted_offset", encrypted_offset); _("payload_length", payload_length); _("client_conn_id_length", client_conn_id_length); _("server_conn_id_length", server_conn_id_length); _("is_initial", is_initial); _("is_retry", is_retry); _("first_byte", first_byte); _("version", version); _("dest_conn_id_len", dest_conn_id_len); _("dest_conn_id", dest_conn_id); _("src_conn_id_len", src_conn_id_len); _("src_conn_id", src_conn_id); _("v1", v1); _("v2", v2); _("unknown", unknown); }
    };

    struct InitialPacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<InitialPacket> {
        auto __self() { return ::hilti::rt::ValueReference<InitialPacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> token_length{};
        std::optional<::hilti::rt::Bytes> token{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__InitialPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        InitialPacket();
        InitialPacket(const InitialPacket&) = default;
        InitialPacket(InitialPacket&&) = default;
        InitialPacket& operator=(const InitialPacket&) = default;
        InitialPacket& operator=(InitialPacket&&) = default;
        InitialPacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> token_length, std::optional<std::optional<::hilti::rt::Bytes>> token, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        InitialPacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("token_length", token_length); _("token", token); _("length", length); }
    };

    struct HandshakePacket : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<HandshakePacket> {
        auto __self() { return ::hilti::rt::ValueReference<HandshakePacket>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> length{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__HandshakePacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        HandshakePacket();
        HandshakePacket(const HandshakePacket&) = default;
        HandshakePacket(HandshakePacket&&) = default;
        HandshakePacket& operator=(const HandshakePacket&) = default;
        HandshakePacket& operator=(HandshakePacket&&) = default;
        HandshakePacket(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> length);
        HandshakePacket(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("length", length); }
    };

    struct ConnectionClosePayload : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ConnectionClosePayload> {
        auto __self() { return ::hilti::rt::ValueReference<ConnectionClosePayload>::self(this); }
        ::hilti::rt::ValueReference<LongHeaderPacket> header{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> error_code{};
        std::optional<::hilti::rt::Bytes> unknown_frame_type{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> frame_type{};
        std::optional<::hilti::rt::ValueReference<VariableLengthInteger>> reason_phrase_length{};
        std::optional<::hilti::rt::Bytes> reason_phrase{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_8_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__ConnectionClosePayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        ConnectionClosePayload();
        ConnectionClosePayload(const ConnectionClosePayload&) = default;
        ConnectionClosePayload(ConnectionClosePayload&&) = default;
        ConnectionClosePayload& operator=(const ConnectionClosePayload&) = default;
        ConnectionClosePayload& operator=(ConnectionClosePayload&&) = default;
        ConnectionClosePayload(std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> error_code, std::optional<std::optional<::hilti::rt::Bytes>> unknown_frame_type, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> frame_type, std::optional<std::optional<::hilti::rt::ValueReference<VariableLengthInteger>>> reason_phrase_length, std::optional<std::optional<::hilti::rt::Bytes>> reason_phrase);
        ConnectionClosePayload(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header);
        template<typename F> void __visit(F _) const { _("header", header); _("error_code", error_code); _("unknown_frame_type", unknown_frame_type); _("frame_type", frame_type); _("reason_phrase_length", reason_phrase_length); _("reason_phrase", reason_phrase); }
    };

    struct ConnectionIDInfo : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ConnectionIDInfo> {
        auto __self() { return ::hilti::rt::ValueReference<ConnectionIDInfo>::self(this); }
        ::hilti::rt::integer::safe<uint8_t> client_cid_len{};
        ::hilti::rt::integer::safe<uint8_t> server_cid_len{};
        ::hilti::rt::Bytes initial_destination_conn_id{};
        ::hilti::rt::Bool client_initial_processed{};
        ::hilti::rt::Bool server_initial_processed{};
        std::optional<::zeek::spicy::rt::ProtocolHandle> ssl_handle{};
        ConnectionIDInfo();
        ConnectionIDInfo(const ConnectionIDInfo&) = default;
        ConnectionIDInfo(ConnectionIDInfo&&) = default;
        ConnectionIDInfo& operator=(const ConnectionIDInfo&) = default;
        ConnectionIDInfo& operator=(ConnectionIDInfo&&) = default;
        ConnectionIDInfo(std::optional<::hilti::rt::integer::safe<uint8_t>> client_cid_len, std::optional<::hilti::rt::integer::safe<uint8_t>> server_cid_len, std::optional<::hilti::rt::Bytes> initial_destination_conn_id, std::optional<::hilti::rt::Bool> client_initial_processed, std::optional<::hilti::rt::Bool> server_initial_processed, std::optional<std::optional<::zeek::spicy::rt::ProtocolHandle>> ssl_handle);
        template<typename F> void __visit(F _) const { _("client_cid_len", client_cid_len); _("server_cid_len", server_cid_len); _("initial_destination_conn_id", initial_destination_conn_id); _("client_initial_processed", client_initial_processed); _("server_initial_processed", server_initial_processed); _("ssl_handle", ssl_handle); }
    };

    struct CryptoBuffer : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<CryptoBuffer> {
        auto __self() { return ::hilti::rt::ValueReference<CryptoBuffer>::self(this); }
        ::hilti::rt::Bytes buffered{};
        void __on__anon_8(const ::hilti::rt::Bytes& __dd);
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<CryptoBuffer>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__CryptoBuffer_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        CryptoBuffer();
        CryptoBuffer(const CryptoBuffer&) = default;
        CryptoBuffer(CryptoBuffer&&) = default;
        CryptoBuffer& operator=(const CryptoBuffer&) = default;
        CryptoBuffer& operator=(CryptoBuffer&&) = default;
        CryptoBuffer(std::optional<::hilti::rt::Bytes> buffered);
        template<typename F> void __visit(F _) const { _("buffered", buffered); }
    };

    struct EncryptedLongPacketPayload : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<EncryptedLongPacketPayload> {
        auto __self() { return ::hilti::rt::ValueReference<EncryptedLongPacketPayload>::self(this); }
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<EncryptedLongPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__EncryptedLongPacketPayload_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        EncryptedLongPacketPayload();
        EncryptedLongPacketPayload(const EncryptedLongPacketPayload&) = default;
        EncryptedLongPacketPayload(EncryptedLongPacketPayload&&) = default;
        EncryptedLongPacketPayload& operator=(const EncryptedLongPacketPayload&) = default;
        EncryptedLongPacketPayload& operator=(EncryptedLongPacketPayload&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct Frame : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Frame> {
        auto __self() { return ::hilti::rt::ValueReference<Frame>::self(this); }
        std::optional<QUIC::FrameType> frame_type{};
        std::optional<::hilti::rt::ValueReference<ACKPayload>> a{};
        std::optional<::hilti::rt::ValueReference<ACKPayload>> b{};
        std::optional<::hilti::rt::ValueReference<CRYPTOPayload>> c{};
        void __on_c(const ::hilti::rt::ValueReference<CRYPTOPayload>& __dd);
        void __on__anon_7();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<Frame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__Frame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<LongHeaderPacket> __p_header{};
        ::hilti::rt::Bool __p_from_client{};
        ::hilti::rt::WeakReference<::spicy::rt::Sink> __p_crypto_sink{};
        Frame();
        Frame(const Frame&) = default;
        Frame(Frame&&) = default;
        Frame& operator=(const Frame&) = default;
        Frame& operator=(Frame&&) = default;
        Frame(std::optional<std::optional<QUIC::FrameType>> frame_type, std::optional<std::optional<::hilti::rt::ValueReference<ACKPayload>>> a, std::optional<std::optional<::hilti::rt::ValueReference<ACKPayload>>> b, std::optional<std::optional<::hilti::rt::ValueReference<CRYPTOPayload>>> c);
        Frame(const ::hilti::rt::ValueReference<LongHeaderPacket>& __p_header, const ::hilti::rt::Bool& __p_from_client, ::hilti::rt::StrongReference<::spicy::rt::Sink> __p_crypto_sink);
        template<typename F> void __visit(F _) const { _("frame_type", frame_type); _("a", a); _("b", b); _("c", c); }
    };

    struct ShortHeader : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ShortHeader> {
        auto __self() { return ::hilti::rt::ValueReference<ShortHeader>::self(this); }
        std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> first_byte{};
        std::optional<::hilti::rt::Bytes> dest_conn_id{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ShortHeader>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__ShortHeader_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint8_t> __p_dest_conn_id_length{};
        ShortHeader();
        ShortHeader(const ShortHeader&) = default;
        ShortHeader(ShortHeader&&) = default;
        ShortHeader& operator=(const ShortHeader&) = default;
        ShortHeader& operator=(ShortHeader&&) = default;
        ShortHeader(std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::Bytes>> dest_conn_id);
        ShortHeader(const ::hilti::rt::integer::safe<uint8_t>& __p_dest_conn_id_length);
        template<typename F> void __visit(F _) const { _("first_byte", first_byte); _("dest_conn_id", dest_conn_id); }
    };

    struct ShortPacketPayload : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ShortPacketPayload> {
        auto __self() { return ::hilti::rt::ValueReference<ShortPacketPayload>::self(this); }
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<ShortPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_QUIC__ShortPacketPayload_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ShortPacketPayload();
        ShortPacketPayload(const ShortPacketPayload&) = default;
        ShortPacketPayload(ShortPacketPayload&&) = default;
        ShortPacketPayload& operator=(const ShortPacketPayload&) = default;
        ShortPacketPayload& operator=(ShortPacketPayload&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct Packet : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Packet> {
        auto __self() { return ::hilti::rt::ValueReference<Packet>::self(this); }
        ::hilti::rt::Bytes decrypted_data{};
        ::hilti::rt::Bytes full_packet{};
        ::hilti::rt::stream::SafeConstIterator start{};
        ::hilti::rt::StrongReference<::spicy::rt::Sink> crypto_sink{};
        ::hilti::rt::StrongReference<CryptoBuffer> crypto_buffer{};
        std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>>> first_byte{};
        void __on__anon_9();
        std::optional<::hilti::rt::ValueReference<ShortHeader>> short_header{};
        std::optional<::hilti::rt::ValueReference<LongHeaderPacket>> long_header{};
        void __on_long_header(const ::hilti::rt::ValueReference<LongHeaderPacket>& __dd);
        std::optional<::hilti::rt::Bytes> all_data{};
        void __on_all_data(const ::hilti::rt::Bytes& __dd);
        std::optional<::hilti::rt::Vector<Frame>> frames{};
        void __on_0x25_init();
        void __on_0x25_done();
        ::hilti::rt::stream::SafeConstIterator __begin{};
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Packet>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_9_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_frames_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<Frame>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_QUIC__Packet_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::Bool __p_from_client{};
        ::hilti::rt::WeakReference<ConnectionIDInfo> __p_context{};
        Packet();
        Packet(const Packet&) = default;
        Packet(Packet&&) = default;
        Packet& operator=(const Packet&) = default;
        Packet& operator=(Packet&&) = default;
        Packet(std::optional<::hilti::rt::Bytes> decrypted_data, std::optional<::hilti::rt::Bytes> full_packet, std::optional<::hilti::rt::stream::SafeConstIterator> start, std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> crypto_sink, std::optional<::hilti::rt::StrongReference<CryptoBuffer>> crypto_buffer, std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::ValueReference<ShortHeader>>> short_header, std::optional<std::optional<::hilti::rt::ValueReference<LongHeaderPacket>>> long_header, std::optional<std::optional<::hilti::rt::Bytes>> all_data, std::optional<std::optional<::hilti::rt::Vector<Frame>>> frames);
        Packet(const ::hilti::rt::Bool& __p_from_client, ::hilti::rt::StrongReference<ConnectionIDInfo> __p_context);
        template<typename F> void __visit(F _) const { _("decrypted_data", decrypted_data); _("full_packet", full_packet); _("start", start); _("crypto_sink", crypto_sink); _("crypto_buffer", crypto_buffer); _("first_byte", first_byte); _("short_header", short_header); _("long_header", long_header); _("all_data", all_data); _("frames", frames); }
    };

    struct RequestFrame : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<RequestFrame> {
        auto __self() { return ::hilti::rt::ValueReference<RequestFrame>::self(this); }
        ::hilti::rt::StrongReference<ConnectionIDInfo> __context{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<RequestFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto context_new() -> ::spicy::rt::UnitContext;
        auto __parse_QUIC__RequestFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        RequestFrame();
        RequestFrame(const RequestFrame&) = default;
        RequestFrame(RequestFrame&&) = default;
        RequestFrame& operator=(const RequestFrame&) = default;
        RequestFrame& operator=(RequestFrame&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct ResponseFrame : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ResponseFrame> {
        auto __self() { return ::hilti::rt::ValueReference<ResponseFrame>::self(this); }
        ::hilti::rt::StrongReference<ConnectionIDInfo> __context{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<ResponseFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto context_new() -> ::spicy::rt::UnitContext;
        auto __parse_QUIC__ResponseFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ResponseFrame();
        ResponseFrame(const ResponseFrame&) = default;
        ResponseFrame(ResponseFrame&&) = default;
        ResponseFrame& operator=(const ResponseFrame&) = default;
        ResponseFrame& operator=(ResponseFrame&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    const ::hilti::rt::Bytes __ctor__bytes = "\000"_b;
    const ::hilti::rt::RegExp __ctor__regexp = ::hilti::rt::RegExp(std::string{"\\x00*"}, {});
    const ::hilti::rt::integer::safe<uint32_t> Version1 = ::hilti::rt::integer::safe<std::uint32_t>{1U};
    const ::hilti::rt::integer::safe<uint32_t> Version2 = ::hilti::rt::integer::safe<std::uint32_t>{1798521807U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft22 = ::hilti::rt::integer::safe<std::uint32_t>{4278190102U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft23 = ::hilti::rt::integer::safe<std::uint32_t>{4278190103U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft24 = ::hilti::rt::integer::safe<std::uint32_t>{4278190104U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft25 = ::hilti::rt::integer::safe<std::uint32_t>{4278190105U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft26 = ::hilti::rt::integer::safe<std::uint32_t>{4278190106U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft27 = ::hilti::rt::integer::safe<std::uint32_t>{4278190107U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft28 = ::hilti::rt::integer::safe<std::uint32_t>{4278190108U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft29 = ::hilti::rt::integer::safe<std::uint32_t>{4278190109U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft30 = ::hilti::rt::integer::safe<std::uint32_t>{4278190110U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft31 = ::hilti::rt::integer::safe<std::uint32_t>{4278190111U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft32 = ::hilti::rt::integer::safe<std::uint32_t>{4278190112U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft33 = ::hilti::rt::integer::safe<std::uint32_t>{4278190113U};
    const ::hilti::rt::integer::safe<uint32_t> VersionDraft34 = ::hilti::rt::integer::safe<std::uint32_t>{4278190114U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace001 = ::hilti::rt::integer::safe<std::uint32_t>{4207849473U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace002 = ::hilti::rt::integer::safe<std::uint32_t>{4207849474U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace00e = ::hilti::rt::integer::safe<std::uint32_t>{4207849486U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace011 = ::hilti::rt::integer::safe<std::uint32_t>{4207849489U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace012 = ::hilti::rt::integer::safe<std::uint32_t>{4207849490U};
    const ::hilti::rt::integer::safe<uint32_t> VersionFace013 = ::hilti::rt::integer::safe<std::uint32_t>{4207849491U};
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ACKPayload0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CRYPTOPayload0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ConnectionClosePayload0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25supports_sinks = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40CryptoBuffer0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40EncryptedLongPacketPayload0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Frame0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40HandshakePacket0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40InitialPacket0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25uses_offset = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacket0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV10x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40LongHeaderPacketV20x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25supports_sinks = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25uses_random_access = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40Packet0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RequestFrame0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ResponseFrame0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40RetryPacket0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortHeader0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ShortPacketPayload0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40UnhandledVersion0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40VariableLengthInteger0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25QUIC0x400x40ZeroRTTPacket0x25uses_sync_advance = ::hilti::rt::Bool(false);
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::VariableLengthInteger& x) -> std::ostream&;
    extern void __hook_VariableLengthInteger___on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>& __self);
    VariableLengthInteger::VariableLengthInteger() {
    }

    VariableLengthInteger::VariableLengthInteger(std::optional<::hilti::rt::integer::safe<uint64_t>> bytes_to_parse, std::optional<::hilti::rt::integer::safe<uint64_t>> result_) : VariableLengthInteger() {
        if ( bytes_to_parse ) this->bytes_to_parse = std::move(*bytes_to_parse);
        if ( result_ ) this->result_ = std::move(*result_);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ACKPayload& x) -> std::ostream&;
    ACKPayload::ACKPayload() {
    }

    ACKPayload::ACKPayload(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> latest_ack, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> ack_delay, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> ack_range_count, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> first_ack_range) : ACKPayload() {
        if ( latest_ack ) this->latest_ack = std::move(*latest_ack);
        if ( ack_delay ) this->ack_delay = std::move(*ack_delay);
        if ( ack_range_count ) this->ack_range_count = std::move(*ack_range_count);
        if ( first_ack_range ) this->first_ack_range = std::move(*first_ack_range);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::CRYPTOPayload& x) -> std::ostream&;
    CRYPTOPayload::CRYPTOPayload() {
    }

    CRYPTOPayload::CRYPTOPayload(const ::hilti::rt::Bool& __p_from_client) : __p_from_client(std::move(__p_from_client)) {
    }

    CRYPTOPayload::CRYPTOPayload(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> offset, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> length, std::optional<std::optional<::hilti::rt::Bytes>> cryptodata) : CRYPTOPayload() {
        if ( offset ) this->offset = std::move(*offset);
        if ( length ) this->length = std::move(*length);
        if ( cryptodata ) this->cryptodata = std::move(*cryptodata);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_quic::QUIC::HeaderForm x, adl::tag) -> std::string;
}

namespace __hlt_quic::QUIC {
    inline auto operator<<(std::ostream& o, HeaderForm x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ZeroRTTPacket& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacket& x) -> std::ostream&;
    extern void __hook_ZeroRTTPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>& __self);
    ZeroRTTPacket::ZeroRTTPacket() {
    }

    ZeroRTTPacket::ZeroRTTPacket(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    ZeroRTTPacket::ZeroRTTPacket(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> length) : ZeroRTTPacket() {
        if ( header ) this->header = std::move(*header);
        if ( length ) this->length = std::move(*length);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV1& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::InitialPacket& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::HandshakePacket& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::RetryPacket& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV2& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::UnhandledVersion& x) -> std::ostream&;
    extern void __hook_UnhandledVersion___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __self);
    UnhandledVersion::UnhandledVersion() {
    }

    UnhandledVersion::UnhandledVersion(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    UnhandledVersion::UnhandledVersion(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header) : UnhandledVersion() {
        if ( header ) this->header = std::move(*header);
    }

    
    extern void __hook_RetryPacket___on_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __self);
    extern void __hook_RetryPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __self);
    RetryPacket::RetryPacket() {
    }

    RetryPacket::RetryPacket(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    RetryPacket::RetryPacket(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header, std::optional<::hilti::rt::Bytes> retry_token, std::optional<::hilti::rt::Bytes> integrity_tag, std::optional<std::optional<::hilti::rt::Bytes>> data) : RetryPacket() {
        if ( header ) this->header = std::move(*header);
        if ( retry_token ) this->retry_token = std::move(*retry_token);
        if ( integrity_tag ) this->integrity_tag = std::move(*integrity_tag);
        if ( data ) this->data = std::move(*data);
    }

    
    extern void __hook_LongHeaderPacketV2___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __self);
    LongHeaderPacketV2::LongHeaderPacketV2() {
    }

    LongHeaderPacketV2::LongHeaderPacketV2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_outer) : __p_outer(std::move(__p_outer)) {
    }

    LongHeaderPacketV2::LongHeaderPacketV2(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>>> retry_hdr) : LongHeaderPacketV2() {
        if ( initial_hdr ) this->initial_hdr = std::move(*initial_hdr);
        if ( zerortt_hdr ) this->zerortt_hdr = std::move(*zerortt_hdr);
        if ( handshake_hdr ) this->handshake_hdr = std::move(*handshake_hdr);
        if ( retry_hdr ) this->retry_hdr = std::move(*retry_hdr);
    }

    
    extern void __hook_LongHeaderPacketV1___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __self);
    LongHeaderPacketV1::LongHeaderPacketV1() {
    }

    LongHeaderPacketV1::LongHeaderPacketV1(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_outer) : __p_outer(std::move(__p_outer)) {
    }

    LongHeaderPacketV1::LongHeaderPacketV1(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>>> initial_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>>> zerortt_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>>> handshake_hdr, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>>> retry_hdr) : LongHeaderPacketV1() {
        if ( initial_hdr ) this->initial_hdr = std::move(*initial_hdr);
        if ( zerortt_hdr ) this->zerortt_hdr = std::move(*zerortt_hdr);
        if ( handshake_hdr ) this->handshake_hdr = std::move(*handshake_hdr);
        if ( retry_hdr ) this->retry_hdr = std::move(*retry_hdr);
    }

    
    extern void __hook_LongHeaderPacket___on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_unknown(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __self);
    LongHeaderPacket::LongHeaderPacket() {
    }

    LongHeaderPacket::LongHeaderPacket(std::optional<::hilti::rt::integer::safe<uint64_t>> encrypted_offset, std::optional<::hilti::rt::integer::safe<uint64_t>> payload_length, std::optional<::hilti::rt::integer::safe<uint8_t>> client_conn_id_length, std::optional<::hilti::rt::integer::safe<uint8_t>> server_conn_id_length, std::optional<::hilti::rt::Bool> is_initial, std::optional<::hilti::rt::Bool> is_retry, std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> version, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> dest_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> dest_conn_id, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> src_conn_id_len, std::optional<std::optional<::hilti::rt::Bytes>> src_conn_id, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>>> v1, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>>> v2, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>>> unknown) : LongHeaderPacket() {
        if ( encrypted_offset ) this->encrypted_offset = std::move(*encrypted_offset);
        if ( payload_length ) this->payload_length = std::move(*payload_length);
        if ( client_conn_id_length ) this->client_conn_id_length = std::move(*client_conn_id_length);
        if ( server_conn_id_length ) this->server_conn_id_length = std::move(*server_conn_id_length);
        if ( is_initial ) this->is_initial = std::move(*is_initial);
        if ( is_retry ) this->is_retry = std::move(*is_retry);
        if ( first_byte ) this->first_byte = std::move(*first_byte);
        if ( version ) this->version = std::move(*version);
        if ( dest_conn_id_len ) this->dest_conn_id_len = std::move(*dest_conn_id_len);
        if ( dest_conn_id ) this->dest_conn_id = std::move(*dest_conn_id);
        if ( src_conn_id_len ) this->src_conn_id_len = std::move(*src_conn_id_len);
        if ( src_conn_id ) this->src_conn_id = std::move(*src_conn_id);
        if ( v1 ) this->v1 = std::move(*v1);
        if ( v2 ) this->v2 = std::move(*v2);
        if ( unknown ) this->unknown = std::move(*unknown);
    }

    
    extern void __hook_InitialPacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __self);
    InitialPacket::InitialPacket() {
    }

    InitialPacket::InitialPacket(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    InitialPacket::InitialPacket(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> token_length, std::optional<std::optional<::hilti::rt::Bytes>> token, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> length) : InitialPacket() {
        if ( header ) this->header = std::move(*header);
        if ( token_length ) this->token_length = std::move(*token_length);
        if ( token ) this->token = std::move(*token);
        if ( length ) this->length = std::move(*length);
    }

    
    extern void __hook_HandshakePacket___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>& __self);
    HandshakePacket::HandshakePacket() {
    }

    HandshakePacket::HandshakePacket(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    HandshakePacket::HandshakePacket(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> length) : HandshakePacket() {
        if ( header ) this->header = std::move(*header);
        if ( length ) this->length = std::move(*length);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ConnectionClosePayload& x) -> std::ostream&;
    extern void __hook_ConnectionClosePayload___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::ConnectionClosePayload>& __self);
    ConnectionClosePayload::ConnectionClosePayload() {
    }

    ConnectionClosePayload::ConnectionClosePayload(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header) : __p_header(std::move(__p_header)) {
        header = __self()->__p_header.derefAsValue();
    }

    ConnectionClosePayload::ConnectionClosePayload(std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>> header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> error_code, std::optional<std::optional<::hilti::rt::Bytes>> unknown_frame_type, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> frame_type, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>> reason_phrase_length, std::optional<std::optional<::hilti::rt::Bytes>> reason_phrase) : ConnectionClosePayload() {
        if ( header ) this->header = std::move(*header);
        if ( error_code ) this->error_code = std::move(*error_code);
        if ( unknown_frame_type ) this->unknown_frame_type = std::move(*unknown_frame_type);
        if ( frame_type ) this->frame_type = std::move(*frame_type);
        if ( reason_phrase_length ) this->reason_phrase_length = std::move(*reason_phrase_length);
        if ( reason_phrase ) this->reason_phrase = std::move(*reason_phrase);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ConnectionIDInfo& x) -> std::ostream&;
    ConnectionIDInfo::ConnectionIDInfo() {
    }

    ConnectionIDInfo::ConnectionIDInfo(std::optional<::hilti::rt::integer::safe<uint8_t>> client_cid_len, std::optional<::hilti::rt::integer::safe<uint8_t>> server_cid_len, std::optional<::hilti::rt::Bytes> initial_destination_conn_id, std::optional<::hilti::rt::Bool> client_initial_processed, std::optional<::hilti::rt::Bool> server_initial_processed, std::optional<std::optional<::zeek::spicy::rt::ProtocolHandle>> ssl_handle) : ConnectionIDInfo() {
        if ( client_cid_len ) this->client_cid_len = std::move(*client_cid_len);
        if ( server_cid_len ) this->server_cid_len = std::move(*server_cid_len);
        if ( initial_destination_conn_id ) this->initial_destination_conn_id = std::move(*initial_destination_conn_id);
        if ( client_initial_processed ) this->client_initial_processed = std::move(*client_initial_processed);
        if ( server_initial_processed ) this->server_initial_processed = std::move(*server_initial_processed);
        if ( ssl_handle ) this->ssl_handle = std::move(*ssl_handle);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::CryptoBuffer& x) -> std::ostream&;
    extern void __hook_CryptoBuffer___on__anon_8(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer>& __self);
    CryptoBuffer::CryptoBuffer() {
    }

    CryptoBuffer::CryptoBuffer(std::optional<::hilti::rt::Bytes> buffered) : CryptoBuffer() {
        if ( buffered ) this->buffered = std::move(*buffered);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::EncryptedLongPacketPayload& x) -> std::ostream&;
    EncryptedLongPacketPayload::EncryptedLongPacketPayload() {
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_quic::QUIC::FrameType x, adl::tag) -> std::string;
}

namespace __hlt_quic::QUIC {
    inline auto operator<<(std::ostream& o, FrameType x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::Frame& x) -> std::ostream&;
    extern void __hook_Frame___on_c(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame>& __self);
    extern void __hook_Frame___on__anon_7(::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame>& __self);
    Frame::Frame() {
    }

    Frame::Frame(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __p_header, const ::hilti::rt::Bool& __p_from_client, ::hilti::rt::StrongReference<::spicy::rt::Sink> __p_crypto_sink) : __p_header(std::move(__p_header)), __p_from_client(std::move(__p_from_client)), __p_crypto_sink(std::move(__p_crypto_sink)) {
    }

    Frame::Frame(std::optional<std::optional<QUIC::FrameType>> frame_type, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ACKPayload>>> a, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ACKPayload>>> b, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>>> c) : Frame() {
        if ( frame_type ) this->frame_type = std::move(*frame_type);
        if ( a ) this->a = std::move(*a);
        if ( b ) this->b = std::move(*b);
        if ( c ) this->c = std::move(*c);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_quic::QUIC::LongPacketTypeV1 x, adl::tag) -> std::string;
}

namespace __hlt_quic::QUIC {
    inline auto operator<<(std::ostream& o, LongPacketTypeV1 x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_quic::QUIC::LongPacketTypeV2 x, adl::tag) -> std::string;
}

namespace __hlt_quic::QUIC {
    inline auto operator<<(std::ostream& o, LongPacketTypeV2 x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ShortHeader& x) -> std::ostream&;
    ShortHeader::ShortHeader() {
    }

    ShortHeader::ShortHeader(const ::hilti::rt::integer::safe<uint8_t>& __p_dest_conn_id_length) : __p_dest_conn_id_length(std::move(__p_dest_conn_id_length)) {
    }

    ShortHeader::ShortHeader(std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::Bytes>> dest_conn_id) : ShortHeader() {
        if ( first_byte ) this->first_byte = std::move(*first_byte);
        if ( dest_conn_id ) this->dest_conn_id = std::move(*dest_conn_id);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ShortPacketPayload& x) -> std::ostream&;
    ShortPacketPayload::ShortPacketPayload() {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::Packet& x) -> std::ostream&;
    extern void __hook_Packet___on__anon_9(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __self);
    extern void __hook_Packet___on_long_header(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __self);
    extern void __hook_Packet___on_all_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __self);
    extern void __hook_Packet___on_0x25_init(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __self);
    extern void __hook_Packet___on_0x25_done(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __self);
    Packet::Packet() {
    }

    Packet::Packet(const ::hilti::rt::Bool& __p_from_client, ::hilti::rt::StrongReference<__hlt_quic::QUIC::ConnectionIDInfo> __p_context) : __p_from_client(std::move(__p_from_client)), __p_context(std::move(__p_context)) {
        crypto_sink = ::hilti::rt::reference::make_strong<::spicy::rt::Sink>();
    }

    Packet::Packet(std::optional<::hilti::rt::Bytes> decrypted_data, std::optional<::hilti::rt::Bytes> full_packet, std::optional<::hilti::rt::stream::SafeConstIterator> start, std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> crypto_sink, std::optional<::hilti::rt::StrongReference<__hlt_quic::QUIC::CryptoBuffer>> crypto_buffer, std::optional<std::optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>>>> first_byte, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortHeader>>> short_header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>>> long_header, std::optional<std::optional<::hilti::rt::Bytes>> all_data, std::optional<std::optional<::hilti::rt::Vector<__hlt_quic::QUIC::Frame>>> frames) : Packet() {
        if ( decrypted_data ) this->decrypted_data = std::move(*decrypted_data);
        if ( full_packet ) this->full_packet = std::move(*full_packet);
        if ( start ) this->start = std::move(*start);
        if ( crypto_sink ) this->crypto_sink = std::move(*crypto_sink);
        if ( crypto_buffer ) this->crypto_buffer = std::move(*crypto_buffer);
        if ( first_byte ) this->first_byte = std::move(*first_byte);
        if ( short_header ) this->short_header = std::move(*short_header);
        if ( long_header ) this->long_header = std::move(*long_header);
        if ( all_data ) this->all_data = std::move(*all_data);
        if ( frames ) this->frames = std::move(*frames);
    }

    
    extern void __hook_CryptoBuffer___on__anon_8_64ca(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CryptoBuffer>& __self);
    extern void __hook_CryptoBuffer___on__anon_8(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CryptoBuffer>& __self);
    extern void __hook_CryptoBuffer___on__anon_8_64ca(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CryptoBuffer>& __self);
}

namespace hlt_quic::QUIC::CryptoBuffer {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_quic::QUIC::EncryptedLongPacketPayload {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_Frame___on__anon_7_27b5(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_7(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on__anon_7_27b5(::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on_c_904e(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd, ::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on_c(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd, ::hilti::rt::ValueReference<Frame>& __self);
    extern void __hook_Frame___on_c_904e(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd, ::hilti::rt::ValueReference<Frame>& __self);
}

namespace hlt_quic::QUIC::Frame {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_LongHeaderPacket___on_dest_conn_id_len_f78d(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_dest_conn_id_len_f78d(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_src_conn_id_len_ef9e(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_src_conn_id_len_ef9e(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_unknown_1ace(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_unknown(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
    extern void __hook_LongHeaderPacket___on_unknown_1ace(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self);
}

namespace hlt_quic::QUIC::LongHeaderPacket {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_LongHeaderPacketV1___on_initial_hdr_e7eb(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_initial_hdr_e7eb(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_retry_hdr_86a4(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
    extern void __hook_LongHeaderPacketV1___on_retry_hdr_86a4(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self);
}

namespace hlt_quic::QUIC::LongHeaderPacketV1 {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_LongHeaderPacketV2___on_initial_hdr_694d(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_initial_hdr_694d(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_retry_hdr_6b61(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
    extern void __hook_LongHeaderPacketV2___on_retry_hdr_6b61(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self);
}

namespace hlt_quic::QUIC::LongHeaderPacketV2 {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace spicy::rt {
    extern void accept_input();
}

namespace zeek::spicy::rt {
    extern void protocol_data_in(const ::hilti::rt::Bool& is_orig, const ::hilti::rt::Bytes& data, const ::zeek::spicy::rt::ProtocolHandle& h);
}

namespace __hlt_quic::QUIC {
    extern void __hook_Packet___on_0x25_done_faf0(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_0x25_done(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_0x25_done_faf0(::hilti::rt::ValueReference<Packet>& __self);
}

namespace zeek::spicy::rt {
    extern auto protocol_handle_get_or_create(const std::string& analyzer, const ::hilti::rt::Protocol& protocol) -> ::zeek::spicy::rt::ProtocolHandle;
}

namespace __hlt_quic::QUIC {
    extern void __hook_Packet___on_0x25_init_8604(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_0x25_init(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_0x25_init_8604(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on__anon_9_1a25(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on__anon_9(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on__anon_9_1a25(::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_all_data_d2ea(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_all_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_all_data_d2ea(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Packet>& __self);
}

namespace zeek::spicy::rt {
    extern void protocol_handle_close(const ::zeek::spicy::rt::ProtocolHandle& handle);
}

namespace __hlt_quic::QUIC {
    extern void __hook_Packet___on_long_header_5d3b(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd, ::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_long_header(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd, ::hilti::rt::ValueReference<Packet>& __self);
    extern void __hook_Packet___on_long_header_5d3b(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd, ::hilti::rt::ValueReference<Packet>& __self);
    static auto can_decrypt(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& long_header, const __hlt_quic::QUIC::ConnectionIDInfo& context, const ::hilti::rt::Bool& is_client) -> ::hilti::rt::Bool;
}

namespace hlt_quic::QUIC::Packet {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::RequestFrame& x) -> std::ostream&;
    RequestFrame::RequestFrame() {
    }

    
}

namespace hlt_quic::QUIC::RequestFrame {
    extern auto context_new() -> ::spicy::rt::UnitContext;
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::RequestFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern auto operator<<(std::ostream& o, const __hlt_quic::QUIC::ResponseFrame& x) -> std::ostream&;
    ResponseFrame::ResponseFrame() {
    }

    
}

namespace hlt_quic::QUIC::ResponseFrame {
    extern auto context_new() -> ::spicy::rt::UnitContext;
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ResponseFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_RetryPacket___on_data_17c1(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<RetryPacket>& __self);
    extern void __hook_RetryPacket___on_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<RetryPacket>& __self);
    extern void __hook_RetryPacket___on_data_17c1(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<RetryPacket>& __self);
}

namespace hlt_quic::QUIC::ShortHeader {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortHeader>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_quic::QUIC::ShortPacketPayload {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_quic::QUIC::UnhandledVersion {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_quic::QUIC {
    extern void __hook_VariableLengthInteger___on__anon_84a8(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_84a8(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_3_foreach_228a(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __hook_VariableLengthInteger___on__anon_3_foreach_228a(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<VariableLengthInteger>& __self);
    extern void __register_QUIC_ACKPayload();
    extern void __register_QUIC_CRYPTOPayload();
    extern void __register_QUIC_ConnectionClosePayload();
    extern void __register_QUIC_CryptoBuffer();
    extern void __register_QUIC_EncryptedLongPacketPayload();
    extern void __register_QUIC_Frame();
    extern void __register_QUIC_HandshakePacket();
    extern void __register_QUIC_InitialPacket();
    extern void __register_QUIC_LongHeaderPacket();
    extern void __register_QUIC_LongHeaderPacketV1();
    extern void __register_QUIC_LongHeaderPacketV2();
    extern void __register_QUIC_Packet();
    extern void __register_QUIC_RequestFrame();
    extern void __register_QUIC_ResponseFrame();
    extern void __register_QUIC_RetryPacket();
    extern void __register_QUIC_ShortHeader();
    extern void __register_QUIC_ShortPacketPayload();
    extern void __register_QUIC_UnhandledVersion();
    extern void __register_QUIC_VariableLengthInteger();
    extern void __register_QUIC_ZeroRTTPacket();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_quic::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_QUIC__VariableLengthInteger_namex2aQUIC__VariableLengthIntegerx2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__VariableLengthInteger_namex2aQUIC__VariableLengthIntegerx2b = { "QUIC::VariableLengthInteger", "QUIC::VariableLengthInteger", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "bytes_to_parse", &::hilti::rt::type_info::uint64, offsetof(QUIC::VariableLengthInteger, bytes_to_parse), false, false }, ::hilti::rt::type_info::struct_::Field{ "result_", &::hilti::rt::type_info::uint64, offsetof(QUIC::VariableLengthInteger, result_), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::VariableLengthInteger, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ACKPayload_namex2aQUIC__ACKPayloadx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b = { {}, "value_ref<VariableLengthInteger>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__VariableLengthInteger_namex2aQUIC__VariableLengthIntegerx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::VariableLengthInteger>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__ACKPayload_namex2aQUIC__ACKPayloadx2b = { "QUIC::ACKPayload", "QUIC::ACKPayload", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "latest_ack", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ACKPayload, latest_ack), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "ack_delay", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ACKPayload, ack_delay), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "ack_range_count", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ACKPayload, ack_range_count), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "first_ack_range", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ACKPayload, first_ack_range), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ACKPayload, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__CRYPTOPayload_namex2aQUIC__CRYPTOPayloadx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__CRYPTOPayload_namex2aQUIC__CRYPTOPayloadx2b = { "QUIC::CRYPTOPayload", "QUIC::CRYPTOPayload", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "offset", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::CRYPTOPayload, offset), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::CRYPTOPayload, length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "cryptodata", &::hilti::rt::type_info::bytes, offsetof(QUIC::CRYPTOPayload, cryptodata), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::CRYPTOPayload, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__HeaderForm_namex2aQUIC__HeaderFormx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__HeaderForm_namex2aQUIC__HeaderFormx2b = { "QUIC::HeaderForm", "QUIC::HeaderForm", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "SHORT", 0 }, ::hilti::rt::type_info::enum_::Label{ "LONG", 1 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ZeroRTTPacket_namex2aQUIC__ZeroRTTPacketx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacket_namex2aQUIC__LongHeaderPacketx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_packet_type__4__5x3e_type_specific_bits__0__3_x28convertx31cast_uint_8__x2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_packet_type_4_5_type_specific_bits_0_3_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_packet_type__4__5x3e_type_specific_bits__0__3_x28convertx31cast_uint_8__x2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_packet_type_4_5_type_specific_bits_0_3_x2b = { {}, "bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; packet_type: 4..5; type_specific_bits: 0..3 &convert=cast<uint<8>>(__dd); }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "header_form", &type_info::__ti_QUIC__HeaderForm_namex2aQUIC__HeaderFormx2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "fixed_bit", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "packet_type", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 2>() }, ::hilti::rt::type_info::bitfield::Bits{ "type_specific_bits", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 3>() }})) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacketV1__value_refx2anamex2aQUIC__LongHeaderPacketV1x2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacketV1_namex2aQUIC__LongHeaderPacketV1x2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_InitialPacket__value_refx2anamex2aQUIC__InitialPacketx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__InitialPacket_namex2aQUIC__InitialPacketx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__InitialPacket_namex2aQUIC__InitialPacketx2b = { "QUIC::InitialPacket", "QUIC::InitialPacket", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::InitialPacket, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "token_length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::InitialPacket, token_length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "token", &::hilti::rt::type_info::bytes, offsetof(QUIC::InitialPacket, token), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::InitialPacket, length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::InitialPacket, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_InitialPacket__value_refx2anamex2aQUIC__InitialPacketx2bx2b = { {}, "value_ref<InitialPacket>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__InitialPacket_namex2aQUIC__InitialPacketx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::InitialPacket>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ZeroRTTPacket__value_refx2anamex2aQUIC__ZeroRTTPacketx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ZeroRTTPacket__value_refx2anamex2aQUIC__ZeroRTTPacketx2bx2b = { {}, "value_ref<ZeroRTTPacket>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__ZeroRTTPacket_namex2aQUIC__ZeroRTTPacketx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::ZeroRTTPacket>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_HandshakePacket__value_refx2anamex2aQUIC__HandshakePacketx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__HandshakePacket_namex2aQUIC__HandshakePacketx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__HandshakePacket_namex2aQUIC__HandshakePacketx2b = { "QUIC::HandshakePacket", "QUIC::HandshakePacket", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::HandshakePacket, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::HandshakePacket, length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::HandshakePacket, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_HandshakePacket__value_refx2anamex2aQUIC__HandshakePacketx2bx2b = { {}, "value_ref<HandshakePacket>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__HandshakePacket_namex2aQUIC__HandshakePacketx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::HandshakePacket>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_RetryPacket__value_refx2anamex2aQUIC__RetryPacketx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__RetryPacket_namex2aQUIC__RetryPacketx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__RetryPacket_namex2aQUIC__RetryPacketx2b = { "QUIC::RetryPacket", "QUIC::RetryPacket", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::RetryPacket, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "retry_token", &::hilti::rt::type_info::bytes, offsetof(QUIC::RetryPacket, retry_token), false, false }, ::hilti::rt::type_info::struct_::Field{ "integrity_tag", &::hilti::rt::type_info::bytes, offsetof(QUIC::RetryPacket, integrity_tag), false, false }, ::hilti::rt::type_info::struct_::Field{ "data", &::hilti::rt::type_info::bytes, offsetof(QUIC::RetryPacket, data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::RetryPacket, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_RetryPacket__value_refx2anamex2aQUIC__RetryPacketx2bx2b = { {}, "value_ref<RetryPacket>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__RetryPacket_namex2aQUIC__RetryPacketx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::RetryPacket>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacketV1_namex2aQUIC__LongHeaderPacketV1x2b = { "QUIC::LongHeaderPacketV1", "QUIC::LongHeaderPacketV1", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "initial_hdr", &type_info::__ti_value_ref_InitialPacket__value_refx2anamex2aQUIC__InitialPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV1, initial_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "zerortt_hdr", &type_info::__ti_value_ref_ZeroRTTPacket__value_refx2anamex2aQUIC__ZeroRTTPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV1, zerortt_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "handshake_hdr", &type_info::__ti_value_ref_HandshakePacket__value_refx2anamex2aQUIC__HandshakePacketx2bx2b, offsetof(QUIC::LongHeaderPacketV1, handshake_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>>() }, ::hilti::rt::type_info::struct_::Field{ "retry_hdr", &type_info::__ti_value_ref_RetryPacket__value_refx2anamex2aQUIC__RetryPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV1, retry_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::LongHeaderPacketV1, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacketV1__value_refx2anamex2aQUIC__LongHeaderPacketV1x2bx2b = { {}, "value_ref<LongHeaderPacketV1>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__LongHeaderPacketV1_namex2aQUIC__LongHeaderPacketV1x2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::LongHeaderPacketV1>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacketV2__value_refx2anamex2aQUIC__LongHeaderPacketV2x2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacketV2_namex2aQUIC__LongHeaderPacketV2x2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacketV2_namex2aQUIC__LongHeaderPacketV2x2b = { "QUIC::LongHeaderPacketV2", "QUIC::LongHeaderPacketV2", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "initial_hdr", &type_info::__ti_value_ref_InitialPacket__value_refx2anamex2aQUIC__InitialPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV2, initial_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "zerortt_hdr", &type_info::__ti_value_ref_ZeroRTTPacket__value_refx2anamex2aQUIC__ZeroRTTPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV2, zerortt_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ZeroRTTPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "handshake_hdr", &type_info::__ti_value_ref_HandshakePacket__value_refx2anamex2aQUIC__HandshakePacketx2bx2b, offsetof(QUIC::LongHeaderPacketV2, handshake_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::HandshakePacket>>() }, ::hilti::rt::type_info::struct_::Field{ "retry_hdr", &type_info::__ti_value_ref_RetryPacket__value_refx2anamex2aQUIC__RetryPacketx2bx2b, offsetof(QUIC::LongHeaderPacketV2, retry_hdr), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::LongHeaderPacketV2, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacketV2__value_refx2anamex2aQUIC__LongHeaderPacketV2x2bx2b = { {}, "value_ref<LongHeaderPacketV2>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__LongHeaderPacketV2_namex2aQUIC__LongHeaderPacketV2x2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::LongHeaderPacketV2>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_UnhandledVersion__value_refx2anamex2aQUIC__UnhandledVersionx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_QUIC__UnhandledVersion_namex2aQUIC__UnhandledVersionx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__UnhandledVersion_namex2aQUIC__UnhandledVersionx2b = { "QUIC::UnhandledVersion", "QUIC::UnhandledVersion", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::UnhandledVersion, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::UnhandledVersion, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_UnhandledVersion__value_refx2anamex2aQUIC__UnhandledVersionx2bx2b = { {}, "value_ref<UnhandledVersion>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__UnhandledVersion_namex2aQUIC__UnhandledVersionx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::UnhandledVersion>()) };
    extern const ::hilti::rt::TypeInfo __ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b;
    const ::hilti::rt::TypeInfo __ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b = { {}, "optional<iterator<stream>>", new ::hilti::rt::type_info::Optional(&::hilti::rt::type_info::stream_iterator, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::stream::SafeConstIterator>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__LongHeaderPacket_namex2aQUIC__LongHeaderPacketx2b = { "QUIC::LongHeaderPacket", "QUIC::LongHeaderPacket", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "encrypted_offset", &::hilti::rt::type_info::uint64, offsetof(QUIC::LongHeaderPacket, encrypted_offset), false, false }, ::hilti::rt::type_info::struct_::Field{ "payload_length", &::hilti::rt::type_info::uint64, offsetof(QUIC::LongHeaderPacket, payload_length), false, false }, ::hilti::rt::type_info::struct_::Field{ "client_conn_id_length", &::hilti::rt::type_info::uint8, offsetof(QUIC::LongHeaderPacket, client_conn_id_length), false, false }, ::hilti::rt::type_info::struct_::Field{ "server_conn_id_length", &::hilti::rt::type_info::uint8, offsetof(QUIC::LongHeaderPacket, server_conn_id_length), false, false }, ::hilti::rt::type_info::struct_::Field{ "is_initial", &::hilti::rt::type_info::bool_, offsetof(QUIC::LongHeaderPacket, is_initial), false, false }, ::hilti::rt::type_info::struct_::Field{ "is_retry", &::hilti::rt::type_info::bool_, offsetof(QUIC::LongHeaderPacket, is_retry), false, false }, ::hilti::rt::type_info::struct_::Field{ "first_byte", &type_info::__ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_packet_type__4__5x3e_type_specific_bits__0__3_x28convertx31cast_uint_8__x2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_packet_type_4_5_type_specific_bits_0_3_x2b, offsetof(QUIC::LongHeaderPacket, first_byte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "version", &::hilti::rt::type_info::uint32, offsetof(QUIC::LongHeaderPacket, version), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint32_t>>() }, ::hilti::rt::type_info::struct_::Field{ "dest_conn_id_len", &::hilti::rt::type_info::uint8, offsetof(QUIC::LongHeaderPacket, dest_conn_id_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "dest_conn_id", &::hilti::rt::type_info::bytes, offsetof(QUIC::LongHeaderPacket, dest_conn_id), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "src_conn_id_len", &::hilti::rt::type_info::uint8, offsetof(QUIC::LongHeaderPacket, src_conn_id_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "src_conn_id", &::hilti::rt::type_info::bytes, offsetof(QUIC::LongHeaderPacket, src_conn_id), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "v1", &type_info::__ti_value_ref_LongHeaderPacketV1__value_refx2anamex2aQUIC__LongHeaderPacketV1x2bx2b, offsetof(QUIC::LongHeaderPacket, v1), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>>() }, ::hilti::rt::type_info::struct_::Field{ "v2", &type_info::__ti_value_ref_LongHeaderPacketV2__value_refx2anamex2aQUIC__LongHeaderPacketV2x2bx2b, offsetof(QUIC::LongHeaderPacket, v2), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>>() }, ::hilti::rt::type_info::struct_::Field{ "unknown", &type_info::__ti_value_ref_UnhandledVersion__value_refx2anamex2aQUIC__UnhandledVersionx2bx2b, offsetof(QUIC::LongHeaderPacket, unknown), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>>() }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(QUIC::LongHeaderPacket, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__offset", &::hilti::rt::type_info::uint64, offsetof(QUIC::LongHeaderPacket, __offset), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::LongHeaderPacket, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b = { {}, "value_ref<LongHeaderPacket>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__LongHeaderPacket_namex2aQUIC__LongHeaderPacketx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::LongHeaderPacket>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__ZeroRTTPacket_namex2aQUIC__ZeroRTTPacketx2b = { "QUIC::ZeroRTTPacket", "QUIC::ZeroRTTPacket", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::ZeroRTTPacket, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ZeroRTTPacket, length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ZeroRTTPacket, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ConnectionClosePayload_namex2aQUIC__ConnectionClosePayloadx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__ConnectionClosePayload_namex2aQUIC__ConnectionClosePayloadx2b = { "QUIC::ConnectionClosePayload", "QUIC::ConnectionClosePayload", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::ConnectionClosePayload, header), false, false }, ::hilti::rt::type_info::struct_::Field{ "error_code", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ConnectionClosePayload, error_code), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "unknown_frame_type", &::hilti::rt::type_info::bytes, offsetof(QUIC::ConnectionClosePayload, unknown_frame_type), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "frame_type", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ConnectionClosePayload, frame_type), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "reason_phrase_length", &type_info::__ti_value_ref_VariableLengthInteger__value_refx2anamex2aQUIC__VariableLengthIntegerx2bx2b, offsetof(QUIC::ConnectionClosePayload, reason_phrase_length), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger>>() }, ::hilti::rt::type_info::struct_::Field{ "reason_phrase", &::hilti::rt::type_info::bytes, offsetof(QUIC::ConnectionClosePayload, reason_phrase), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ConnectionClosePayload, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b;
    extern const ::hilti::rt::TypeInfo __ti_zeek__ProtocolHandle_libraryx2azeek__spicy__rt__ProtocolHandlex2b;
    const ::hilti::rt::TypeInfo __ti_zeek__ProtocolHandle_libraryx2azeek__spicy__rt__ProtocolHandlex2b = { "zeek::ProtocolHandle", "zeek::ProtocolHandle", new ::hilti::rt::type_info::Library() };
    const ::hilti::rt::TypeInfo __ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b = { "QUIC::ConnectionIDInfo", "QUIC::ConnectionIDInfo", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "client_cid_len", &::hilti::rt::type_info::uint8, offsetof(QUIC::ConnectionIDInfo, client_cid_len), false, false }, ::hilti::rt::type_info::struct_::Field{ "server_cid_len", &::hilti::rt::type_info::uint8, offsetof(QUIC::ConnectionIDInfo, server_cid_len), false, false }, ::hilti::rt::type_info::struct_::Field{ "initial_destination_conn_id", &::hilti::rt::type_info::bytes, offsetof(QUIC::ConnectionIDInfo, initial_destination_conn_id), false, false }, ::hilti::rt::type_info::struct_::Field{ "client_initial_processed", &::hilti::rt::type_info::bool_, offsetof(QUIC::ConnectionIDInfo, client_initial_processed), false, false }, ::hilti::rt::type_info::struct_::Field{ "server_initial_processed", &::hilti::rt::type_info::bool_, offsetof(QUIC::ConnectionIDInfo, server_initial_processed), false, false }, ::hilti::rt::type_info::struct_::Field{ "ssl_handle", &type_info::__ti_zeek__ProtocolHandle_libraryx2azeek__spicy__rt__ProtocolHandlex2b, offsetof(QUIC::ConnectionIDInfo, ssl_handle), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::zeek::spicy::rt::ProtocolHandle>() }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__CryptoBuffer_namex2aQUIC__CryptoBufferx2b;
    extern const ::hilti::rt::TypeInfo __ti_spicy_rt__SinkState_libraryx2aspicy__rt__sink__detail__Statex2cx2b;
    const ::hilti::rt::TypeInfo __ti_spicy_rt__SinkState_libraryx2aspicy__rt__sink__detail__Statex2cx2b = { "spicy_rt::SinkState", "spicy_rt::SinkState", new ::hilti::rt::type_info::Library() };
    const ::hilti::rt::TypeInfo __ti_QUIC__CryptoBuffer_namex2aQUIC__CryptoBufferx2b = { "QUIC::CryptoBuffer", "QUIC::CryptoBuffer", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "buffered", &::hilti::rt::type_info::bytes, offsetof(QUIC::CryptoBuffer, buffered), false, false }, ::hilti::rt::type_info::struct_::Field{ "__sink", &type_info::__ti_spicy_rt__SinkState_libraryx2aspicy__rt__sink__detail__Statex2cx2b, offsetof(QUIC::CryptoBuffer, __sink), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::CryptoBuffer, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__EncryptedLongPacketPayload_namex2aQUIC__EncryptedLongPacketPayloadx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__EncryptedLongPacketPayload_namex2aQUIC__EncryptedLongPacketPayloadx2b = { "QUIC::EncryptedLongPacketPayload", "QUIC::EncryptedLongPacketPayload", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::EncryptedLongPacketPayload, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__FrameType_namex2aQUIC__FrameTypex2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__FrameType_namex2aQUIC__FrameTypex2b = { "QUIC::FrameType", "QUIC::FrameType", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "PADDING", 0 }, ::hilti::rt::type_info::enum_::Label{ "PING", 1 }, ::hilti::rt::type_info::enum_::Label{ "ACK1", 2 }, ::hilti::rt::type_info::enum_::Label{ "ACK2", 3 }, ::hilti::rt::type_info::enum_::Label{ "RESET_STREAM", 4 }, ::hilti::rt::type_info::enum_::Label{ "STOP_SENDING", 5 }, ::hilti::rt::type_info::enum_::Label{ "CRYPTO", 6 }, ::hilti::rt::type_info::enum_::Label{ "NEW_TOKEN", 7 }, ::hilti::rt::type_info::enum_::Label{ "STREAM1", 8 }, ::hilti::rt::type_info::enum_::Label{ "STREAM2", 9 }, ::hilti::rt::type_info::enum_::Label{ "STREAM3", 10 }, ::hilti::rt::type_info::enum_::Label{ "STREAM4", 11 }, ::hilti::rt::type_info::enum_::Label{ "STREAM5", 12 }, ::hilti::rt::type_info::enum_::Label{ "STREAM6", 13 }, ::hilti::rt::type_info::enum_::Label{ "STREAM7", 14 }, ::hilti::rt::type_info::enum_::Label{ "STREAM8", 15 }, ::hilti::rt::type_info::enum_::Label{ "MAX_DATA", 16 }, ::hilti::rt::type_info::enum_::Label{ "MAX_STREAM_DATA", 17 }, ::hilti::rt::type_info::enum_::Label{ "MAX_STREAMS1", 18 }, ::hilti::rt::type_info::enum_::Label{ "MAX_STREAMS2", 19 }, ::hilti::rt::type_info::enum_::Label{ "DATA_BLOCKED", 20 }, ::hilti::rt::type_info::enum_::Label{ "STREAM_DATA_BLOCKED", 21 }, ::hilti::rt::type_info::enum_::Label{ "STREAMS_BLOCKED1", 22 }, ::hilti::rt::type_info::enum_::Label{ "STREAMS_BLOCKED2", 23 }, ::hilti::rt::type_info::enum_::Label{ "NEW_CONNECTION_ID", 24 }, ::hilti::rt::type_info::enum_::Label{ "RETIRE_CONNECTION_ID", 25 }, ::hilti::rt::type_info::enum_::Label{ "PATH_CHALLENGE", 26 }, ::hilti::rt::type_info::enum_::Label{ "PATH_RESPONSE", 27 }, ::hilti::rt::type_info::enum_::Label{ "CONNECTION_CLOSE1", 28 }, ::hilti::rt::type_info::enum_::Label{ "CONNECTION_CLOSE2", 29 }, ::hilti::rt::type_info::enum_::Label{ "HANDSHAKE_DONE", 30 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__Frame_namex2aQUIC__Framex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ACKPayload__value_refx2anamex2aQUIC__ACKPayloadx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ACKPayload__value_refx2anamex2aQUIC__ACKPayloadx2bx2b = { {}, "value_ref<ACKPayload>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__ACKPayload_namex2aQUIC__ACKPayloadx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::ACKPayload>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_CRYPTOPayload__value_refx2anamex2aQUIC__CRYPTOPayloadx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_CRYPTOPayload__value_refx2anamex2aQUIC__CRYPTOPayloadx2bx2b = { {}, "value_ref<CRYPTOPayload>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__CRYPTOPayload_namex2aQUIC__CRYPTOPayloadx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::CRYPTOPayload>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__Frame_namex2aQUIC__Framex2b = { "QUIC::Frame", "QUIC::Frame", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "frame_type", &type_info::__ti_QUIC__FrameType_namex2aQUIC__FrameTypex2b, offsetof(QUIC::Frame, frame_type), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<QUIC::FrameType>() }, ::hilti::rt::type_info::struct_::Field{ "a", &type_info::__ti_value_ref_ACKPayload__value_refx2anamex2aQUIC__ACKPayloadx2bx2b, offsetof(QUIC::Frame, a), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ACKPayload>>() }, ::hilti::rt::type_info::struct_::Field{ "b", &type_info::__ti_value_ref_ACKPayload__value_refx2anamex2aQUIC__ACKPayloadx2bx2b, offsetof(QUIC::Frame, b), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ACKPayload>>() }, ::hilti::rt::type_info::struct_::Field{ "c", &type_info::__ti_value_ref_CRYPTOPayload__value_refx2anamex2aQUIC__CRYPTOPayloadx2bx2b, offsetof(QUIC::Frame, c), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::Frame, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__LongPacketTypeV1_namex2aQUIC__LongPacketTypeV1x2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__LongPacketTypeV1_namex2aQUIC__LongPacketTypeV1x2b = { "QUIC::LongPacketTypeV1", "QUIC::LongPacketTypeV1", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "INITIAL", 0 }, ::hilti::rt::type_info::enum_::Label{ "ZERO_RTT", 1 }, ::hilti::rt::type_info::enum_::Label{ "HANDSHAKE", 2 }, ::hilti::rt::type_info::enum_::Label{ "RETRY", 3 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__LongPacketTypeV2_namex2aQUIC__LongPacketTypeV2x2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__LongPacketTypeV2_namex2aQUIC__LongPacketTypeV2x2b = { "QUIC::LongPacketTypeV2", "QUIC::LongPacketTypeV2", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "INITIAL", 1 }, ::hilti::rt::type_info::enum_::Label{ "ZERO_RTT", 2 }, ::hilti::rt::type_info::enum_::Label{ "HANDSHAKE", 3 }, ::hilti::rt::type_info::enum_::Label{ "RETRY", 0 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ShortHeader_namex2aQUIC__ShortHeaderx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_spin_bit__5x3e_todo__0__4x3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_spin_bit_5_5_todo_0_4_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_spin_bit__5x3e_todo__0__4x3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_spin_bit_5_5_todo_0_4_x2b = { {}, "bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; spin_bit: 5; todo: 0..4; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "header_form", &type_info::__ti_QUIC__HeaderForm_namex2aQUIC__HeaderFormx2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "fixed_bit", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "spin_bit", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 2>() }, ::hilti::rt::type_info::bitfield::Bits{ "todo", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 3>() }})) };
    const ::hilti::rt::TypeInfo __ti_QUIC__ShortHeader_namex2aQUIC__ShortHeaderx2b = { "QUIC::ShortHeader", "QUIC::ShortHeader", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "first_byte", &type_info::__ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31cast_QUIC__HeaderForm_x2acast_uint_8__x2a__ddx2bx2bx3e_fixed_bit__6x3e_spin_bit__5x3e_todo__0__4x3e_x75_bitfieldx2a8_header_form_7_7_fixed_bit_6_6_spin_bit_5_5_todo_0_4_x2b, offsetof(QUIC::ShortHeader, first_byte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "dest_conn_id", &::hilti::rt::type_info::bytes, offsetof(QUIC::ShortHeader, dest_conn_id), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ShortHeader, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ShortPacketPayload_namex2aQUIC__ShortPacketPayloadx2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__ShortPacketPayload_namex2aQUIC__ShortPacketPayloadx2b = { "QUIC::ShortPacketPayload", "QUIC::ShortPacketPayload", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ShortPacketPayload, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__Packet_namex2aQUIC__Packetx2b;
    extern const ::hilti::rt::TypeInfo __ti_strong_ref_spicy_rt__Sink__strong_refx2anamex2aspicy_rt__Sinkx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_spicy_rt__Sink_namex2aspicy_rt__Sinkx2b;
    const ::hilti::rt::TypeInfo __ti_spicy_rt__Sink_namex2aspicy_rt__Sinkx2b = { "spicy_rt::Sink", "spicy_rt::Sink", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({})) };
    const ::hilti::rt::TypeInfo __ti_strong_ref_spicy_rt__Sink__strong_refx2anamex2aspicy_rt__Sinkx2bx2b = { {}, "strong_ref<spicy_rt::Sink>", new ::hilti::rt::type_info::StrongReference(&type_info::__ti_spicy_rt__Sink_namex2aspicy_rt__Sinkx2b, ::hilti::rt::type_info::StrongReference::accessor<::spicy::rt::Sink>()) };
    extern const ::hilti::rt::TypeInfo __ti_strong_ref_CryptoBuffer__strong_refx2anamex2aQUIC__CryptoBufferx2bx2b;
    const ::hilti::rt::TypeInfo __ti_strong_ref_CryptoBuffer__strong_refx2anamex2aQUIC__CryptoBufferx2bx2b = { {}, "strong_ref<CryptoBuffer>", new ::hilti::rt::type_info::StrongReference(&type_info::__ti_QUIC__CryptoBuffer_namex2aQUIC__CryptoBufferx2b, ::hilti::rt::type_info::StrongReference::accessor<__hlt_quic::QUIC::CryptoBuffer>()) };
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31HeaderFormx2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31HeaderFormx2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_x2b = { {}, "bitfield(8) { header_form: 7 &convert=HeaderForm(__dd); }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "header_form", &type_info::__ti_QUIC__HeaderForm_namex2aQUIC__HeaderFormx2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>>, 0>() }})) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ShortHeader__value_refx2anamex2aQUIC__ShortHeaderx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ShortHeader__value_refx2anamex2aQUIC__ShortHeaderx2bx2b = { {}, "value_ref<ShortHeader>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_QUIC__ShortHeader_namex2aQUIC__ShortHeaderx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_quic::QUIC::ShortHeader>()) };
    extern const ::hilti::rt::TypeInfo __ti_vector_Frame__vectorx2anamex2aQUIC__Framex2bx2b;
    const ::hilti::rt::TypeInfo __ti_vector_Frame__vectorx2anamex2aQUIC__Framex2bx2b = { {}, "vector<Frame>", new ::hilti::rt::type_info::Vector(&type_info::__ti_QUIC__Frame_namex2aQUIC__Framex2b, ::hilti::rt::type_info::Vector::accessor<__hlt_quic::QUIC::Frame>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__Packet_namex2aQUIC__Packetx2b = { "QUIC::Packet", "QUIC::Packet", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "decrypted_data", &::hilti::rt::type_info::bytes, offsetof(QUIC::Packet, decrypted_data), false, false }, ::hilti::rt::type_info::struct_::Field{ "full_packet", &::hilti::rt::type_info::bytes, offsetof(QUIC::Packet, full_packet), false, false }, ::hilti::rt::type_info::struct_::Field{ "start", &::hilti::rt::type_info::stream_iterator, offsetof(QUIC::Packet, start), false, false }, ::hilti::rt::type_info::struct_::Field{ "crypto_sink", &type_info::__ti_strong_ref_spicy_rt__Sink__strong_refx2anamex2aspicy_rt__Sinkx2bx2b, offsetof(QUIC::Packet, crypto_sink), true, false }, ::hilti::rt::type_info::struct_::Field{ "crypto_buffer", &type_info::__ti_strong_ref_CryptoBuffer__strong_refx2anamex2aQUIC__CryptoBufferx2bx2b, offsetof(QUIC::Packet, crypto_buffer), false, false }, ::hilti::rt::type_info::struct_::Field{ "first_byte", &type_info::__ti_bitfieldx2a8x2b_x73_header_form__7_x28convertx31HeaderFormx2a__ddx2bx3e_x75_bitfieldx2a8_header_form_7_7_x2b, offsetof(QUIC::Packet, first_byte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<QUIC::HeaderForm, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "short_header", &type_info::__ti_value_ref_ShortHeader__value_refx2anamex2aQUIC__ShortHeaderx2bx2b, offsetof(QUIC::Packet, short_header), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortHeader>>() }, ::hilti::rt::type_info::struct_::Field{ "long_header", &type_info::__ti_value_ref_LongHeaderPacket__value_refx2anamex2aQUIC__LongHeaderPacketx2bx2b, offsetof(QUIC::Packet, long_header), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>>() }, ::hilti::rt::type_info::struct_::Field{ "all_data", &::hilti::rt::type_info::bytes, offsetof(QUIC::Packet, all_data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "frames", &type_info::__ti_vector_Frame__vectorx2anamex2aQUIC__Framex2bx2b, offsetof(QUIC::Packet, frames), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<__hlt_quic::QUIC::Frame>>() }, ::hilti::rt::type_info::struct_::Field{ "__begin", &::hilti::rt::type_info::stream_iterator, offsetof(QUIC::Packet, __begin), true, false }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(QUIC::Packet, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__sink", &type_info::__ti_spicy_rt__SinkState_libraryx2aspicy__rt__sink__detail__Statex2cx2b, offsetof(QUIC::Packet, __sink), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::Packet, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__RequestFrame_namex2aQUIC__RequestFramex2b;
    extern const ::hilti::rt::TypeInfo __ti_strong_ref_QUIC__ConnectionIDInfo__strong_refx2anamex2aQUIC__ConnectionIDInfox2bx2b;
    const ::hilti::rt::TypeInfo __ti_strong_ref_QUIC__ConnectionIDInfo__strong_refx2anamex2aQUIC__ConnectionIDInfox2bx2b = { {}, "strong_ref<QUIC::ConnectionIDInfo>", new ::hilti::rt::type_info::StrongReference(&type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b, ::hilti::rt::type_info::StrongReference::accessor<__hlt_quic::QUIC::ConnectionIDInfo>()) };
    const ::hilti::rt::TypeInfo __ti_QUIC__RequestFrame_namex2aQUIC__RequestFramex2b = { "QUIC::RequestFrame", "QUIC::RequestFrame", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__context", &type_info::__ti_strong_ref_QUIC__ConnectionIDInfo__strong_refx2anamex2aQUIC__ConnectionIDInfox2bx2b, offsetof(QUIC::RequestFrame, __context), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::RequestFrame, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_QUIC__ResponseFrame_namex2aQUIC__ResponseFramex2b;
    const ::hilti::rt::TypeInfo __ti_QUIC__ResponseFrame_namex2aQUIC__ResponseFramex2b = { "QUIC::ResponseFrame", "QUIC::ResponseFrame", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__context", &type_info::__ti_strong_ref_QUIC__ConnectionIDInfo__strong_refx2anamex2aQUIC__ConnectionIDInfox2bx2b, offsetof(QUIC::ResponseFrame, __context), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(QUIC::ResponseFrame, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_quic::QUIC::__register_module)

auto __hlt_quic::QUIC::ACKPayload::__parse_QUIC__ACKPayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ACKPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:301:19-306:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
        ::hilti::rt::optional::valueOrInit((*__self).latest_ack) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).latest_ack)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
        ::hilti::rt::optional::valueOrInit((*__self).ack_delay) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).ack_delay)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
        ::hilti::rt::optional::valueOrInit((*__self).ack_range_count) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).ack_range_count)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
        ::hilti::rt::optional::valueOrInit((*__self).first_ack_range) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).first_ack_range)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_7 -> _anon_9 _anon_3_7;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ACKPayload::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ACKPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:301:19-306:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ACKPayload_2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::CRYPTOPayload::__parse_QUIC__CRYPTOPayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CRYPTOPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:295:22-299:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_6 -> _anon_8 _anon_3_6;
        ::hilti::rt::optional::valueOrInit((*__self).offset) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).offset)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_6 -> _anon_8 _anon_3_6;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_6 -> _anon_8 _anon_3_6;
        ::hilti::rt::optional::valueOrInit((*__self).length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_6 -> _anon_8 _anon_3_6;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:298:15-298:19");

        // Begin parsing production: Variable: cryptodata_2 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).cryptodata) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self).length)).result_, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:298:3-298:46"), (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((*::hilti::rt::optional::value((*__self).length)).result_);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: cryptodata_2 -> bytes;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::CRYPTOPayload::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CRYPTOPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:295:22-299:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__CRYPTOPayload_2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_quic::QUIC::ConnectionClosePayload::__on_0x25_done() {
    auto __self = QUIC::ConnectionClosePayload::__self();
    return __hlt_quic::QUIC::__hook_ConnectionClosePayload___on_0x25_done(__self);
}

auto __hlt_quic::QUIC::ConnectionClosePayload::__parse_QUIC__ConnectionClosePayload_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ConnectionClosePayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:308:31-317:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
        ::hilti::rt::optional::valueOrInit((*__self).error_code) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).error_code)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:313:5-313:41");

    // Begin parsing production: LookAhead: switch_8_lha_2 -> {Ctor: unknown_frame_type_2 -> b"\x00" (const bytes) (id 1)}: switch_8_case_1 | {Variable: _anon_10 -> uint<8> (not a literal)}: switch_8_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_8_lha_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: LookAhead: switch_8_lha_2 -> {Ctor: unknown_frame_type_2 -> b"\x00" (const bytes) (id 1)}: switch_8_case_1 | {Variable: _anon_10 -> uint<8> (not a literal)}: switch_8_case_2;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
        ::hilti::rt::optional::valueOrInit((*__self).reason_phrase_length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).reason_phrase_length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:316:18-316:22");

        // Begin parsing production: Variable: reason_phrase_2 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).reason_phrase) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self).reason_phrase_length)).result_, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:316:3-316:63"), (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((*::hilti::rt::optional::value((*__self).reason_phrase_length)).result_);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: reason_phrase_2 -> bytes;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:308:31-317:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ConnectionClosePayload::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ConnectionClosePayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:308:31-317:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ConnectionClosePayload_2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::ConnectionClosePayload::__parse_switch_8_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ConnectionClosePayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:313:5-313:41");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
            ::hilti::rt::stream::SafeConstIterator __literal = ((::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) && (__cur.startsWith(__hlt_quic::QUIC::__ctor__bytes)) ? __cur.begin() + ::hilti::rt::integer::safe<std::uint64_t>{1U} : __cur.begin());
            if ( __literal != __cur.begin() ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{1};
                __lahe = __literal;
            }

            ::spicy::rt::detail::printParserState(std::string_view("QUIC::ConnectionClosePayload"), __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, std::string_view("default"), __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{1} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:5-312:35");

        // Begin parsing production: Block: switch_8_case_1 -> unknown_frame_type_2;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34");

            // Begin parsing production: Ctor: unknown_frame_type_2 -> b"\x00" (const bytes);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{1} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34");
                    throw ::spicy::rt::ParseError(std::string_view("unexpected token to consume"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34");
                }

                if ( __cur.sub(__cur.begin(), __lahe) != __hlt_quic::QUIC::__ctor__bytes ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34");
                    throw ::spicy::rt::ParseError(std::string_view("unexpected data when consuming token"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34");
                }

                ::hilti::rt::optional::valueOrInit((*__self).unknown_frame_type) = __hlt_quic::QUIC::__ctor__bytes;
                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
                ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_quic::QUIC::__ctor__bytes, std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:312:28-312:34"), (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                ::hilti::rt::optional::valueOrInit((*__self).unknown_frame_type) = __hlt_quic::QUIC::__ctor__bytes;
                __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{1U});
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }

            // End parsing production: Ctor: unknown_frame_type_2 -> b"\x00" (const bytes);
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_8_case_1 -> unknown_frame_type_2;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:313:5-313:41");
        throw ::spicy::rt::ParseError(std::string_view("expected look-ahead token, but reached end-of-data"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:313:5-313:41");
    }

    else  {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:313:5-313:41");

        // Begin parsing production: Block: switch_8_case_2 -> Resolved_34;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

            // Begin parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
            ::hilti::rt::optional::valueOrInit((*__self).frame_type) = (__hlt_quic::QUIC::VariableLengthInteger());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).frame_type)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__VariableLengthInteger_8 -> _anon_10 _anon_3_8;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_8_case_2 -> Resolved_34;
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline void __hlt_quic::QUIC::CryptoBuffer::__on__anon_8(const ::hilti::rt::Bytes& __dd) {
    auto __self = QUIC::CryptoBuffer::__self();
    return __hlt_quic::QUIC::__hook_CryptoBuffer___on__anon_8(__dd, __self);
}

auto __hlt_quic::QUIC::CryptoBuffer::__parse_QUIC__CryptoBuffer_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CryptoBuffer::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient__anon_8;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:407:5-407:9");

    // Begin parsing production: Variable: _anon_8_2 -> bytes;
    while ( ::hilti::rt::Bool(true) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
        ::hilti::rt::Bool more_data = ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        if ( ::hilti::rt::Bool(static_cast<bool>(__cur.size())) ) {
            __transient__anon_8 = __cur.data();
            __cur = __cur.advance(__cur.size());
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:407:3-410:3");
            (*__self).__on__anon_8(__transient__anon_8);
            __error = (*__self).__error;
        }

        if ( ! (more_data) ) {
            break;
        }
    }

    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_8_2 -> bytes;

    ;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::CryptoBuffer::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CryptoBuffer::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__CryptoBuffer_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {
        ;
        throw;
    }

    return __result;
}

extern auto __hlt_quic::QUIC::CryptoBuffer::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::CryptoBuffer>((__hlt_quic::QUIC::CryptoBuffer()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");

    // Begin parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::CryptoBuffer::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");

    // Begin parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::CryptoBuffer::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::CryptoBuffer>((__hlt_quic::QUIC::CryptoBuffer()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__CryptoBuffer_namex2aQUIC__CryptoBufferx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:403:21-411:1");

    // Begin parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__CryptoBuffer -> _anon_8_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_quic::QUIC::EncryptedLongPacketPayload::__parse_QUIC__EncryptedLongPacketPayload_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = EncryptedLongPacketPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient_payload;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_7;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:398:3-398:27");

        // Begin parsing production: Skip: payload_16 -> skip: payload;
        while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_7=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __cur = __cur.advance(__cur.size());
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }

        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Skip: payload_16 -> skip: payload;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::EncryptedLongPacketPayload::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = EncryptedLongPacketPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__EncryptedLongPacketPayload_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_quic::QUIC::EncryptedLongPacketPayload::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::EncryptedLongPacketPayload>((__hlt_quic::QUIC::EncryptedLongPacketPayload()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");

    // Begin parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::EncryptedLongPacketPayload::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");

    // Begin parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::EncryptedLongPacketPayload::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::EncryptedLongPacketPayload>((__hlt_quic::QUIC::EncryptedLongPacketPayload()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__EncryptedLongPacketPayload_namex2aQUIC__EncryptedLongPacketPayloadx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");

    // Begin parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__EncryptedLongPacketPayload -> payload_16;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::Frame::__on__anon_7() {
    auto __self = QUIC::Frame::__self();
    return __hlt_quic::QUIC::__hook_Frame___on__anon_7(__self);
}

inline void __hlt_quic::QUIC::Frame::__on_c(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd) {
    auto __self = QUIC::Frame::__self();
    return __hlt_quic::QUIC::__hook_Frame___on_c(__dd, __self);
}

auto __hlt_quic::QUIC::Frame::__parse_QUIC__Frame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:275:21-293:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:276:16-276:20");
        ::hilti::rt::integer::safe<uint8_t> __parsed_frame_type;

        // Begin parsing production: Variable: frame_type -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:276:16-276:20"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__parsed_frame_type, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: frame_type -> uint<8>;

        {
            ::hilti::rt::integer::safe<uint8_t> __dd = __parsed_frame_type;
            ::hilti::rt::optional::valueOrInit((*__self).frame_type) = ::hilti::rt::enum_::from_uint<QUIC::FrameType>(__dd);
        }

    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:279:3-292:4");

    // Begin parsing production: Switch: switch_6 -> [FrameType::ACK1] -> switch_6_case_1 | [FrameType::ACK2] -> switch_6_case_2 | [FrameType::CRYPTO] -> switch_6_case_3 | [FrameType::CONNECTION_CLOSE1] -> switch_6_case_4 | [FrameType::PADDING] -> switch_6_case_5 | [FrameType::PING] -> switch_6_case_6 |  | * -> switch_6_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_6_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_6 -> [FrameType::ACK1] -> switch_6_case_1 | [FrameType::ACK2] -> switch_6_case_2 | [FrameType::CRYPTO] -> switch_6_case_3 | [FrameType::CONNECTION_CLOSE1] -> switch_6_case_4 | [FrameType::PADDING] -> switch_6_case_5 | [FrameType::PING] -> switch_6_case_6 |  | * -> switch_6_default;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::Frame::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:275:21-293:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__Frame_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::Frame::__parse_switch_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Frame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:279:3-292:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:279:3-292:4");
    if ( QUIC::FrameType __x = ::hilti::rt::optional::value((*__self).frame_type); __x == QUIC::FrameType{QUIC::FrameType::ACK1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:280:5-280:37");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:280:5-280:37");

        // Begin parsing production: Block: switch_6_case_1 -> Resolved_25;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:301:19-306:1");

            // Begin parsing production: Unit: QUIC__ACKPayload -> Resolved_26 Resolved_26 Resolved_26 Resolved_26;
            ::hilti::rt::optional::valueOrInit((*__self).a) = (__hlt_quic::QUIC::ACKPayload());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).a)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__ACKPayload -> Resolved_26 Resolved_26 Resolved_26 Resolved_26;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_1 -> Resolved_25;
    }

    else if ( __x == QUIC::FrameType{QUIC::FrameType::ACK2} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:281:5-281:37");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:281:5-281:37");

        // Begin parsing production: Block: switch_6_case_2 -> Resolved_25;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:301:19-306:1");

            // Begin parsing production: Unit: QUIC__ACKPayload -> Resolved_26 Resolved_26 Resolved_26 Resolved_26;
            ::hilti::rt::optional::valueOrInit((*__self).b) = (__hlt_quic::QUIC::ACKPayload());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).b)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__ACKPayload -> Resolved_26 Resolved_26 Resolved_26 Resolved_26;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_2 -> Resolved_25;
    }

    else if ( __x == QUIC::FrameType{QUIC::FrameType::CRYPTO} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:282:5-285:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:282:5-285:5");

        // Begin parsing production: Block: switch_6_case_3 -> Resolved_27;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:295:22-299:1");

            // Begin parsing production: Unit: QUIC__CRYPTOPayload -> Resolved_26 Resolved_26 cryptodata (field 'c', id n/a, parser, args: (from_client));
            ::hilti::rt::optional::valueOrInit((*__self).c) = (__hlt_quic::QUIC::CRYPTOPayload(__self->__p_from_client));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).c)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__CRYPTOPayload -> Resolved_26 Resolved_26 cryptodata (field 'c', id n/a, parser, args: (from_client));

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:282:26-285:5");
            (*__self).__on_c(::hilti::rt::optional::value((*__self).c));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_3 -> Resolved_27;
    }

    else if ( __x == QUIC::FrameType{QUIC::FrameType::CONNECTION_CLOSE1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:286:5-286:69");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:286:5-286:69");

        // Begin parsing production: Block: switch_6_case_4 -> Resolved_28;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::ValueReference<__hlt_quic::QUIC::ConnectionClosePayload> __transient__anon_4;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:308:31-317:1");

        // Begin parsing production: Unit: QUIC__ConnectionClosePayload -> Resolved_26 switch_7_lha_2 Resolved_26 reason_phrase (field '_anon_4', id n/a, parser, args: (header));
        __transient__anon_4 = (__hlt_quic::QUIC::ConnectionClosePayload(__self->__p_header.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_4).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__ConnectionClosePayload -> Resolved_26 switch_7_lha_2 Resolved_26 reason_phrase (field '_anon_4', id n/a, parser, args: (header));

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_4 -> Resolved_28;
    }

    else if ( __x == QUIC::FrameType{QUIC::FrameType::PADDING} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:5-287:41");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:5-287:41");

        // Begin parsing production: Block: switch_6_case_5 -> _anon_5_3;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::Bytes __transient__anon_5;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:27-287:41");
        ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

        // Begin parsing production: Skip: _anon_5_3 -> skip:            Ctor: _anon_5_2 -> /\x00*/ (regexp);
        ::hilti::rt::stream::View __ncur = __cur;
        for ( ::hilti::rt::regexp::MatchState ms = __hlt_quic::QUIC::__ctor__regexp.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
            ::hilti::rt::integer::safe<int32_t> __rc;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:34-287:40");
            std::tie(__rc, __ncur) = ms.advance(__ncur);
            if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_8;
                // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
                ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_8=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                continue;
            }

            else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:34-287:40");
                throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:287:34-287:40");
            }

            else  {
                __cur = __ncur;
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }

                break;
            }
        }

        // End parsing production: Skip: _anon_5_3 -> skip:            Ctor: _anon_5_2 -> /\x00*/ (regexp);

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_5 -> _anon_5_3;
    }

    else if ( __x == QUIC::FrameType{QUIC::FrameType::PING} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:288:5-288:30");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:288:5-288:30");

        // Begin parsing production: Block: switch_6_case_6 -> _anon_6_2;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:288:26-288:29");

        // Begin parsing production: Variable: _anon_6_2 -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_6_2 -> void;

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_case_6 -> _anon_6_2;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:289:5-291:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:289:5-291:5");

        // Begin parsing production: Block: switch_6_default -> _anon_7_2;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:289:12-289:15");

        // Begin parsing production: Variable: _anon_7_2 -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_7_2 -> void;

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:289:10-291:5");
        (*__self).__on__anon_7();
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:289:5-291:5");
        __error = (*__self).__error;
        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_6_default -> _anon_7_2;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_quic::QUIC::Frame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:275:21-293:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:275:21-293:1");

    // Begin parsing production: Unit: QUIC__Frame -> frame_type switch_6;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__Frame -> frame_type switch_6;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::HandshakePacket::__on_0x25_done() {
    auto __self = QUIC::HandshakePacket::__self();
    return __hlt_quic::QUIC::__hook_HandshakePacket___on_0x25_done(__self);
}

auto __hlt_quic::QUIC::HandshakePacket::__parse_QUIC__HandshakePacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = HandshakePacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:354:24-358:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_11 -> _anon_13 _anon_3_11;
        ::hilti::rt::optional::valueOrInit((*__self).length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_11 -> _anon_13 _anon_3_11;
    }

    ::hilti::rt::Bytes __transient_payload;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:357:3-357:48");

        // Begin parsing production: Skip: payload_14 -> skip: payload;
        ::hilti::rt::stream::View __limited_ = __cur.limit((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::stream::View __ncur = __cur.advance((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::integer::safe<uint64_t> __skip = (*::hilti::rt::optional::value((*__self).length)).result_;
        while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
            ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("not enough bytes for skipping"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:357:3-357:48"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
            __limited_ = __limited_.advance(__consume);
            if ( __trim ) {
                (*__data).trim(__limited_.begin());
            }

            __skip = __skip - __consume;
        }

        if ( __limited_.offset() < __ncur.offset() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:357:23-357:47");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("&size amount not consumed: expected %lu bytes, but got %lu bytes"), (*::hilti::rt::optional::value((*__self).length)).result_, __limited_.offset() - (__ncur.offset() - (*::hilti::rt::optional::value((*__self).length)).result_)), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:357:23-357:47");
        }

        // End parsing production: Skip: payload_14 -> skip: payload;

        __cur = __ncur;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:354:24-358:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::HandshakePacket::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = HandshakePacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:354:24-358:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__HandshakePacket_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_quic::QUIC::InitialPacket::__on_0x25_done() {
    auto __self = QUIC::InitialPacket::__self();
    return __hlt_quic::QUIC::__hook_InitialPacket___on_0x25_done(__self);
}

auto __hlt_quic::QUIC::InitialPacket::__parse_QUIC__InitialPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = InitialPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:326:22-346:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_9 -> _anon_11 _anon_3_9;
        ::hilti::rt::optional::valueOrInit((*__self).token_length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).token_length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_9 -> _anon_11 _anon_3_9;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_9;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:329:10-329:14");

        // Begin parsing production: Variable: token_4 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).token) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*__self).token_length)).result_, ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:329:3-329:47"), (__lhs_9=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((*::hilti::rt::optional::value((*__self).token_length)).result_);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: token_4 -> bytes;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_9 -> _anon_11 _anon_3_9;
        ::hilti::rt::optional::valueOrInit((*__self).length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_9 -> _anon_11 _anon_3_9;

        {
            ::hilti::rt::ValueReference<__hlt_quic::QUIC::VariableLengthInteger> __dd = ::hilti::rt::optional::value((*__self).length);
            ::hilti::rt::Bool __requires = (*::hilti::rt::optional::value((*__self).length)).result_ >= ::hilti::rt::integer::safe<std::uint64_t>{20U};
            if ( ! (__requires) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:339:33-339:67");
                throw ::spicy::rt::ParseError(std::string_view("&requires failed: self.length.result_ >= 20"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:339:33-339:67");
            }
        }

    }

    ::hilti::rt::Bytes __transient_payload;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:345:3-345:48");

        // Begin parsing production: Skip: payload_12 -> skip: payload;
        ::hilti::rt::stream::View __limited_ = __cur.limit((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::stream::View __ncur = __cur.advance((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::integer::safe<uint64_t> __skip = (*::hilti::rt::optional::value((*__self).length)).result_;
        while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
            ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("not enough bytes for skipping"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:345:3-345:48"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
            __limited_ = __limited_.advance(__consume);
            if ( __trim ) {
                (*__data).trim(__limited_.begin());
            }

            __skip = __skip - __consume;
        }

        if ( __limited_.offset() < __ncur.offset() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:345:23-345:47");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("&size amount not consumed: expected %lu bytes, but got %lu bytes"), (*::hilti::rt::optional::value((*__self).length)).result_, __limited_.offset() - (__ncur.offset() - (*::hilti::rt::optional::value((*__self).length)).result_)), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:345:23-345:47");
        }

        // End parsing production: Skip: payload_12 -> skip: payload;

        __cur = __ncur;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:326:22-346:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::InitialPacket::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = InitialPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:326:22-346:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__InitialPacket_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_dest_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_dest_conn_id_len(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_src_conn_id_len(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_src_conn_id_len(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacket::__on_unknown(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd) {
    auto __self = QUIC::LongHeaderPacket::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacket___on_unknown(__dd, __self);
}

auto __hlt_quic::QUIC::LongHeaderPacket::__parse_QUIC__LongHeaderPacket_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:233:15-238:3");

        // Begin parsing production: Variable: first_byte -> bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; packet_type: 4..5; type_specific_bits: 0..3 &convert=cast<uint<8>>(__dd); };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:233:15-238:3"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).first_byte), __cur) = (__x_1 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::enum_::from_uint<QUIC::HeaderForm>(::hilti::rt::integer::bits(std::get<0>(*__x_1), 7, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0})), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 6, 6, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 4, 5, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 0, 3, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_1))), std::get<1>(*__x_1)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: first_byte -> bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; packet_type: 4..5; type_specific_bits: 0..3 &convert=cast<uint<8>>(__dd); };

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:240:12-240:17");

        // Begin parsing production: Variable: version -> uint<32>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{4U}, std::string_view("expecting 4 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:240:12-240:17"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).version), __cur) = ::hilti::rt::integer::unpack<uint32_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: version -> uint<32>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:241:21-241:25");

        // Begin parsing production: Variable: dest_conn_id_len -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:241:21-241:25"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).dest_conn_id_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: dest_conn_id_len -> uint<8>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:241:3-241:62");
        (*__self).__on_dest_conn_id_len(::hilti::rt::optional::value((*__self).dest_conn_id_len));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_10;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:242:17-242:21");

        // Begin parsing production: Variable: dest_conn_id -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).dest_conn_id) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>((*__self).server_conn_id_length), ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:242:3-242:55"), (__lhs_10=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>((*__self).server_conn_id_length));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: dest_conn_id -> bytes;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:243:20-243:24");

        // Begin parsing production: Variable: src_conn_id_len -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:243:20-243:24"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).src_conn_id_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: src_conn_id_len -> uint<8>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:243:3-243:61");
        (*__self).__on_src_conn_id_len(::hilti::rt::optional::value((*__self).src_conn_id_len));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_11;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:244:16-244:20");

        // Begin parsing production: Variable: src_conn_id -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).src_conn_id) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>((*__self).client_conn_id_length), ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:244:3-244:54"), (__lhs_11=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>((*__self).client_conn_id_length));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: src_conn_id -> bytes;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:246:3-271:4");

    // Begin parsing production: Switch: switch_3 -> [VersionDraft22,VersionDraft23,VersionDraft24,VersionDraft25,VersionDraft26,VersionDraft27,VersionDraft28,VersionDraft29,VersionDraft30,VersionDraft31,VersionDraft32,VersionDraft33,VersionDraft34,VersionFace001,VersionFace002,VersionFace00e,VersionFace011,VersionFace012,VersionFace013,Version1] -> switch_3_case_1 | [Version2] -> switch_3_case_2 |  | * -> switch_3_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_3_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_3 -> [VersionDraft22,VersionDraft23,VersionDraft24,VersionDraft25,VersionDraft26,VersionDraft27,VersionDraft28,VersionDraft29,VersionDraft30,VersionDraft31,VersionDraft32,VersionDraft33,VersionDraft34,VersionFace001,VersionFace002,VersionFace00e,VersionFace011,VersionFace012,VersionFace013,Version1] -> switch_3_case_1 | [Version2] -> switch_3_case_2 |  | * -> switch_3_default;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacket::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__LongHeaderPacket_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacket::__parse_switch_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:246:3-271:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:246:3-271:4");
    if ( ::hilti::rt::integer::safe<uint32_t> __x = ::hilti::rt::optional::value((*__self).version); __x == __hlt_quic::QUIC::VersionDraft22 || __x == __hlt_quic::QUIC::VersionDraft23 || __x == __hlt_quic::QUIC::VersionDraft24 || __x == __hlt_quic::QUIC::VersionDraft25 || __x == __hlt_quic::QUIC::VersionDraft26 || __x == __hlt_quic::QUIC::VersionDraft27 || __x == __hlt_quic::QUIC::VersionDraft28 || __x == __hlt_quic::QUIC::VersionDraft29 || __x == __hlt_quic::QUIC::VersionDraft30 || __x == __hlt_quic::QUIC::VersionDraft31 || __x == __hlt_quic::QUIC::VersionDraft32 || __x == __hlt_quic::QUIC::VersionDraft33 || __x == __hlt_quic::QUIC::VersionDraft34 || __x == __hlt_quic::QUIC::VersionFace001 || __x == __hlt_quic::QUIC::VersionFace002 || __x == __hlt_quic::QUIC::VersionFace00e || __x == __hlt_quic::QUIC::VersionFace011 || __x == __hlt_quic::QUIC::VersionFace012 || __x == __hlt_quic::QUIC::VersionFace013 || __x == __hlt_quic::QUIC::Version1 ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:247:5-266:45");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:247:5-266:45");

        // Begin parsing production: Block: switch_3_case_1 -> Resolved_16;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:181:34-198:1");

            // Begin parsing production: Unit: QUIC__LongHeaderPacketV1_2 -> switch_4 (field 'v1', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).v1) = (__hlt_quic::QUIC::LongHeaderPacketV1(__self));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).v1)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__LongHeaderPacketV1_2 -> switch_4 (field 'v1', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_3_case_1 -> Resolved_16;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

    }

    else if ( __x == __hlt_quic::QUIC::Version2 ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:267:5-267:45");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:267:5-267:45");

        // Begin parsing production: Block: switch_3_case_2 -> Resolved_22;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:200:34-217:1");

            // Begin parsing production: Unit: QUIC__LongHeaderPacketV2_2 -> switch_5 (field 'v2', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).v2) = (__hlt_quic::QUIC::LongHeaderPacketV2(__self));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).v2)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__LongHeaderPacketV2_2 -> switch_5 (field 'v2', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_3_case_2 -> Resolved_22;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:268:5-270:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:268:5-270:5");

        // Begin parsing production: Block: switch_3_default -> Resolved_23;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");

            // Begin parsing production: Unit: QUIC__UnhandledVersion_2 -> payload_11 (field 'unknown', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).unknown) = (__hlt_quic::QUIC::UnhandledVersion(__self));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).unknown)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__UnhandledVersion_2 -> payload_11 (field 'unknown', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:268:10-270:5");
            (*__self).__on_unknown(::hilti::rt::optional::value((*__self).unknown));

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_3_default -> Resolved_23;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_quic::QUIC::LongHeaderPacket::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::LongHeaderPacket>((__hlt_quic::QUIC::LongHeaderPacket()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");

    // Begin parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;

        (*__unit).__offset = __ncur.begin().offset() - __ncur.begin().offset();

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::LongHeaderPacket::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");

    // Begin parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;

        (*__unit).__offset = __ncur.begin().offset() - __ncur.begin().offset();

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::LongHeaderPacket::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::LongHeaderPacket>((__hlt_quic::QUIC::LongHeaderPacket()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__LongHeaderPacket_namex2aQUIC__LongHeaderPacketx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");

    // Begin parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__LongHeaderPacket -> first_byte version dest_conn_id_len dest_conn_id src_conn_id_len src_conn_id switch_3;

        (*__unit).__offset = __ncur.begin().offset() - __ncur.begin().offset();

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::LongHeaderPacketV1::__on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV1::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_initial_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV1::__on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV1::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_retry_hdr(__dd, __self);
}

auto __hlt_quic::QUIC::LongHeaderPacketV1::__parse_QUIC__LongHeaderPacketV1_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV1::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:181:34-198:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:182:3-197:4");

    // Begin parsing production: Switch: switch -> [LongPacketTypeV1::INITIAL] -> switch_case_1 | [LongPacketTypeV1::ZERO_RTT] -> switch_case_2 | [LongPacketTypeV1::HANDSHAKE] -> switch_case_3 | [LongPacketTypeV1::RETRY] -> switch_case_4;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch -> [LongPacketTypeV1::INITIAL] -> switch_case_1 | [LongPacketTypeV1::ZERO_RTT] -> switch_case_2 | [LongPacketTypeV1::HANDSHAKE] -> switch_case_3 | [LongPacketTypeV1::RETRY] -> switch_case_4;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacketV1::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV1::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:181:34-198:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__LongHeaderPacketV1_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacketV1::__parse_switch_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV1::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:182:3-197:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:182:3-197:4");
    if ( QUIC::LongPacketTypeV1 __x = QUIC::LongPacketTypeV1{(::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self->__p_outer.derefAsValue()).first_byte).value)))}; __x == QUIC::LongPacketTypeV1{QUIC::LongPacketTypeV1::INITIAL} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:183:5-190:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:183:5-190:5");

        // Begin parsing production: Block: switch_case_1 -> Resolved_3;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:326:22-346:1");

            // Begin parsing production: Unit: QUIC__InitialPacket -> Resolved_4 token Resolved_4 payload (field 'initial_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).initial_hdr) = (__hlt_quic::QUIC::InitialPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).initial_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__InitialPacket -> Resolved_4 token Resolved_4 payload (field 'initial_hdr', id n/a, parser, args: (outer));

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:183:34-190:5");
            (*__self).__on_initial_hdr(::hilti::rt::optional::value((*__self).initial_hdr));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_1 -> Resolved_3;
    }

    else if ( __x == QUIC::LongPacketTypeV1{QUIC::LongPacketTypeV1::ZERO_RTT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:192:5-192:69");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:192:5-192:69");

        // Begin parsing production: Block: switch_case_2 -> Resolved_5;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:348:22-352:1");

            // Begin parsing production: Unit: QUIC__ZeroRTTPacket -> Resolved_4 payload_2 (field 'zerortt_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).zerortt_hdr) = (__hlt_quic::QUIC::ZeroRTTPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).zerortt_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__ZeroRTTPacket -> Resolved_4 payload_2 (field 'zerortt_hdr', id n/a, parser, args: (outer));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_2 -> Resolved_5;
    }

    else if ( __x == QUIC::LongPacketTypeV1{QUIC::LongPacketTypeV1::HANDSHAKE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:193:5-193:74");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:193:5-193:74");

        // Begin parsing production: Block: switch_case_3 -> Resolved_6;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:354:24-358:1");

            // Begin parsing production: Unit: QUIC__HandshakePacket -> Resolved_4 payload_3 (field 'handshake_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).handshake_hdr) = (__hlt_quic::QUIC::HandshakePacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).handshake_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__HandshakePacket -> Resolved_4 payload_3 (field 'handshake_hdr', id n/a, parser, args: (outer));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_3 -> Resolved_6;
    }

    else if ( __x == QUIC::LongPacketTypeV1{QUIC::LongPacketTypeV1::RETRY} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:194:5-196:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:194:5-196:5");

        // Begin parsing production: Block: switch_case_4 -> Resolved_7;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:361:20-374:1");

            // Begin parsing production: Unit: QUIC__RetryPacket -> data (field 'retry_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).retry_hdr) = (__hlt_quic::QUIC::RetryPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).retry_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__RetryPacket -> data (field 'retry_hdr', id n/a, parser, args: (outer));

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:194:32-196:5");
            (*__self).__on_retry_hdr(::hilti::rt::optional::value((*__self).retry_hdr));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_4 -> Resolved_7;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:182:3-197:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("no matching case in switch statement for value '%s'"), QUIC::LongPacketTypeV1{(::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self->__p_outer.derefAsValue()).first_byte).value)))}), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:182:3-197:4");
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_quic::QUIC::LongHeaderPacketV1::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:181:34-198:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:181:34-198:1");

    // Begin parsing production: Unit: QUIC__LongHeaderPacketV1 -> switch;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__LongHeaderPacketV1 -> switch;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::LongHeaderPacketV2::__on_initial_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV2::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_initial_hdr(__dd, __self);
}

inline void __hlt_quic::QUIC::LongHeaderPacketV2::__on_retry_hdr(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd) {
    auto __self = QUIC::LongHeaderPacketV2::__self();
    return __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_retry_hdr(__dd, __self);
}

auto __hlt_quic::QUIC::LongHeaderPacketV2::__parse_QUIC__LongHeaderPacketV2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV2::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:200:34-217:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:201:3-216:4");

    // Begin parsing production: Switch: switch_2 -> [LongPacketTypeV2::INITIAL] -> switch_2_case_1 | [LongPacketTypeV2::ZERO_RTT] -> switch_2_case_2 | [LongPacketTypeV2::HANDSHAKE] -> switch_2_case_3 | [LongPacketTypeV2::RETRY] -> switch_2_case_4;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_2 -> [LongPacketTypeV2::INITIAL] -> switch_2_case_1 | [LongPacketTypeV2::ZERO_RTT] -> switch_2_case_2 | [LongPacketTypeV2::HANDSHAKE] -> switch_2_case_3 | [LongPacketTypeV2::RETRY] -> switch_2_case_4;

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacketV2::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV2::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:200:34-217:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__LongHeaderPacketV2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::LongHeaderPacketV2::__parse_switch_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = LongHeaderPacketV2::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:201:3-216:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:201:3-216:4");
    if ( QUIC::LongPacketTypeV2 __x = QUIC::LongPacketTypeV2{(::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self->__p_outer.derefAsValue()).first_byte).value)))}; __x == QUIC::LongPacketTypeV2{QUIC::LongPacketTypeV2::INITIAL} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:202:5-209:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:202:5-209:5");

        // Begin parsing production: Block: switch_2_case_1 -> Resolved_9;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:326:22-346:1");

            // Begin parsing production: Unit: QUIC__InitialPacket_2 -> Resolved_10 token_2 Resolved_10 payload_4 (field 'initial_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).initial_hdr) = (__hlt_quic::QUIC::InitialPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).initial_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__InitialPacket_2 -> Resolved_10 token_2 Resolved_10 payload_4 (field 'initial_hdr', id n/a, parser, args: (outer));

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:202:34-209:5");
            (*__self).__on_initial_hdr(::hilti::rt::optional::value((*__self).initial_hdr));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_2_case_1 -> Resolved_9;
    }

    else if ( __x == QUIC::LongPacketTypeV2{QUIC::LongPacketTypeV2::ZERO_RTT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:211:5-211:69");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:211:5-211:69");

        // Begin parsing production: Block: switch_2_case_2 -> Resolved_11;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:348:22-352:1");

            // Begin parsing production: Unit: QUIC__ZeroRTTPacket_2 -> Resolved_10 payload_5 (field 'zerortt_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).zerortt_hdr) = (__hlt_quic::QUIC::ZeroRTTPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).zerortt_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__ZeroRTTPacket_2 -> Resolved_10 payload_5 (field 'zerortt_hdr', id n/a, parser, args: (outer));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_2_case_2 -> Resolved_11;
    }

    else if ( __x == QUIC::LongPacketTypeV2{QUIC::LongPacketTypeV2::HANDSHAKE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:212:5-212:74");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:212:5-212:74");

        // Begin parsing production: Block: switch_2_case_3 -> Resolved_12;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:354:24-358:1");

            // Begin parsing production: Unit: QUIC__HandshakePacket_2 -> Resolved_10 payload_6 (field 'handshake_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).handshake_hdr) = (__hlt_quic::QUIC::HandshakePacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).handshake_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__HandshakePacket_2 -> Resolved_10 payload_6 (field 'handshake_hdr', id n/a, parser, args: (outer));
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_2_case_3 -> Resolved_12;
    }

    else if ( __x == QUIC::LongPacketTypeV2{QUIC::LongPacketTypeV2::RETRY} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:213:5-215:5");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:213:5-215:5");

        // Begin parsing production: Block: switch_2_case_4 -> Resolved_13;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:361:20-374:1");

            // Begin parsing production: Unit: QUIC__RetryPacket_2 -> data_2 (field 'retry_hdr', id n/a, parser, args: (outer));
            ::hilti::rt::optional::valueOrInit((*__self).retry_hdr) = (__hlt_quic::QUIC::RetryPacket(__self->__p_outer.derefAsValue()));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).retry_hdr)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__RetryPacket_2 -> data_2 (field 'retry_hdr', id n/a, parser, args: (outer));

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:213:32-215:5");
            (*__self).__on_retry_hdr(::hilti::rt::optional::value((*__self).retry_hdr));
            __error = (*__self).__error;
        }

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_2_case_4 -> Resolved_13;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:201:3-216:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("no matching case in switch statement for value '%s'"), QUIC::LongPacketTypeV2{(::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self->__p_outer.derefAsValue()).first_byte).value)))}), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:201:3-216:4");
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_quic::QUIC::LongHeaderPacketV2::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:200:34-217:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:200:34-217:1");

    // Begin parsing production: Unit: QUIC__LongHeaderPacketV2 -> switch_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__LongHeaderPacketV2 -> switch_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::Packet::__on_0x25_done() {
    auto __self = QUIC::Packet::__self();
    return __hlt_quic::QUIC::__hook_Packet___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::Packet::__on_0x25_init() {
    auto __self = QUIC::Packet::__self();
    return __hlt_quic::QUIC::__hook_Packet___on_0x25_init(__self);
}

inline void __hlt_quic::QUIC::Packet::__on__anon_9() {
    auto __self = QUIC::Packet::__self();
    return __hlt_quic::QUIC::__hook_Packet___on__anon_9(__self);
}

inline void __hlt_quic::QUIC::Packet::__on_all_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = QUIC::Packet::__self();
    return __hlt_quic::QUIC::__hook_Packet___on_all_data(__dd, __self);
}

inline void __hlt_quic::QUIC::Packet::__on_long_header(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd) {
    auto __self = QUIC::Packet::__self();
    return __hlt_quic::QUIC::__hook_Packet___on_long_header(__dd, __self);
}

auto __hlt_quic::QUIC::Packet::__parse_QUIC__Packet_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Packet::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_2;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:436:15-438:3");

        // Begin parsing production: Variable: first_byte_3 -> bitfield(8) { header_form: 7 &convert=HeaderForm(__dd); };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:436:15-438:3"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).first_byte), __cur) = (__x_2 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(QUIC::HeaderForm{::hilti::rt::integer::bits(std::get<0>(*__x_2), 7, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0})}, ::hilti::rt::integer::noop(std::get<0>(*__x_2))), std::get<1>(*__x_2)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: first_byte_3 -> bitfield(8) { header_form: 7 &convert=HeaderForm(__dd); };

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__begin = __begin;

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:442:5-442:8");

    // Begin parsing production: Variable: _anon_9_2 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_9_2 -> void;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:442:3-444:3");
    (*__self).__on__anon_9();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__begin = __begin;

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:448:3-465:4");

    // Begin parsing production: Switch: switch_9 -> [HeaderForm::SHORT] -> switch_9_case_1 | [HeaderForm::LONG] -> switch_9_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_9_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_9 -> [HeaderForm::SHORT] -> switch_9_case_1 | [HeaderForm::LONG] -> switch_9_case_2;

        (*__self).__begin = __begin;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:468:13-468:17");
        if ( ((*__self).long_header.has_value()) && (can_decrypt(::hilti::rt::optional::value((*__self).long_header), (*__self->__p_context.derefAsValue()), __self->__p_from_client)) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_12;
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__self).start;
            ::hilti::rt::stream::View __parse_cur = __cur.advance(__parse_begin);

            // Begin parsing production: Variable: all_data -> bytes;
            ::spicy::rt::detail::waitForEod(__data, __parse_cur, (__lhs_12=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            ::hilti::rt::optional::valueOrInit((*__self).all_data) = __parse_cur.data();
            __parse_cur = __parse_cur.advance(__parse_cur.size());
            // End parsing production: Variable: all_data -> bytes;

                (*__self).__begin = __begin;

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:468:3-512:3");
            (*__self).__on_all_data(::hilti::rt::optional::value((*__self).all_data));

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }
    }

        (*__self).__begin = __begin;

    ::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload> __transient__anon_10;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    if ( (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).first_byte).value))) == QUIC::HeaderForm{QUIC::HeaderForm::SHORT} ) {
        // Begin parsing production: Unit: QUIC__ShortPacketPayload_2 -> payload_21;
        __transient__anon_10 = (__hlt_quic::QUIC::ShortPacketPayload());
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_10).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__ShortPacketPayload_2 -> payload_21;
    }

        (*__self).__begin = __begin;

    ::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload> __transient__anon_11;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:397:42-399:1");
    if ( ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).first_byte).value))) == QUIC::HeaderForm{QUIC::HeaderForm::LONG}) && ((*__self).decrypted_data.size() == ::hilti::rt::integer::safe<std::uint64_t>{0U}) ) {
        // Begin parsing production: Unit: QUIC__EncryptedLongPacketPayload_2 -> payload_22;
        __transient__anon_11 = (__hlt_quic::QUIC::EncryptedLongPacketPayload());
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_11).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__EncryptedLongPacketPayload_2 -> payload_22;
    }

        (*__self).__begin = __begin;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:521:3-521:181");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};
        if ( ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).first_byte).value))) == QUIC::HeaderForm{QUIC::HeaderForm::LONG}) && ((*__self).decrypted_data.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U}) ) {
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).decrypted_data);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: ForEach: frames -> foreach: Resolved_59;
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*__self).__parse_frames_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).frames));
            // End parsing production: ForEach: frames -> foreach: Resolved_59;

            ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};

                (*__self).__begin = __begin;

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }
    }

        (*__self).__begin = __begin;

        (*__self).__begin = __begin;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
    (*__self).__on_0x25_done();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

    {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
        (*(*__self).crypto_sink).close();
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::Packet::__parse_frames_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_quic::QUIC::Frame>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_13;
    auto __self = Packet::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:521:3-521:181");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_13=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_14;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame> __elem;

            (*__self).__begin = __begin;

        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:275:21-293:1");

        // Begin parsing production: Unit: QUIC__Frame_2 -> frame_type_2 switch_13 (field '_anon_12', id n/a, parser, args: (self.long_header, from_client, self.crypto_sink)) (container 'frames');
        __elem = (__hlt_quic::QUIC::Frame(::hilti::rt::optional::value((*__self).long_header), __self->__p_from_client, (*__self).crypto_sink));
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__Frame_2 -> frame_type_2 switch_13 (field '_anon_12', id n/a, parser, args: (self.long_header, from_client, self.crypto_sink)) (container 'frames');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

        if ( ! (__stop) ) {
            __dst.emplace_back((*__elem));
        }

            (*__self).__begin = __begin;

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_14=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:521:3-521:181");
            throw ::spicy::rt::ParseError(std::string_view("loop body did not change input position, possible infinite loop"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:521:3-521:181");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::Packet::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Packet::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {

            __trim = ::hilti::rt::Bool(false);

        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__begin = __begin;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
        (*__self).__on_0x25_init();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__Packet_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__begin = __begin;

        {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
            (*(*__self).crypto_sink).close();
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

auto __hlt_quic::QUIC::Packet::__parse_switch_9_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Packet::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:448:3-465:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent(std::string_view("spicy"));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:448:3-465:4");
    if ( QUIC::HeaderForm __x = (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).first_byte).value))); __x == QUIC::HeaderForm{QUIC::HeaderForm::SHORT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:449:5-449:75");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:449:5-449:75");

        // Begin parsing production: Block: switch_9_case_1 -> Resolved_47;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:381:27-389:1");

            // Begin parsing production: Unit: QUIC__ShortHeader_2 -> first_byte_4 dest_conn_id_3 (field 'short_header', id n/a, parser, args: ((*context).client_cid_len));
            ::hilti::rt::optional::valueOrInit((*__self).short_header) = (__hlt_quic::QUIC::ShortHeader((*__self->__p_context.derefAsValue()).client_cid_len));
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).short_header)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__ShortHeader_2 -> first_byte_4 dest_conn_id_3 (field 'short_header', id n/a, parser, args: ((*context).client_cid_len));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__begin = __begin;

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_9_case_1 -> Resolved_47;

            (*__self).__begin = __begin;

    }

    else if ( __x == QUIC::HeaderForm{QUIC::HeaderForm::LONG} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:450:5-464:6");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:450:5-464:6");

        // Begin parsing production: Block: switch_9_case_2 -> Resolved_48;
        ::hilti::rt::debug::indent(std::string_view("spicy"));

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:225:32-272:1");

            // Begin parsing production: Unit: QUIC__LongHeaderPacket_2 -> first_byte_5 version_2 dest_conn_id_len_2 dest_conn_id_4 src_conn_id_len_2 src_conn_id_2 switch_10;
            ::hilti::rt::optional::valueOrInit((*__self).long_header) = (__hlt_quic::QUIC::LongHeaderPacket());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).long_header)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: QUIC__LongHeaderPacket_2 -> first_byte_5 version_2 dest_conn_id_len_2 dest_conn_id_4 src_conn_id_len_2 src_conn_id_2 switch_10;

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:450:25-464:6");
            (*__self).__on_long_header(::hilti::rt::optional::value((*__self).long_header));

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__begin = __begin;

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_9_case_2 -> Resolved_48;

            (*__self).__begin = __begin;

    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:448:3-465:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("no matching case in switch statement for value '%s'"), (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self).first_byte).value)))), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:448:3-465:4");
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_quic::QUIC::Packet::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");

    // Begin parsing production: Unit: QUIC__Packet -> first_byte_3 _anon_9_2 switch_9 all_data Resolved_57 Resolved_58 frames;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__Packet -> first_byte_3 _anon_9_2 switch_9 all_data Resolved_57 Resolved_58 frames;

        (*__unit).__begin = __ncur.begin();

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_quic::QUIC::RequestFrame::__parse_QUIC__RequestFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = RequestFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet> __transient__anon_13;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");

    // Begin parsing production: Unit: QUIC__Packet_2 -> first_byte_6 _anon_9_3 switch_15 all_data_2 Resolved_75 Resolved_76 frames_2 (field '_anon_13', id n/a, parser, args: (True, self.context()));
    __transient__anon_13 = (__hlt_quic::QUIC::Packet(::hilti::rt::Bool(true), (*__self).__context));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_13).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: QUIC__Packet_2 -> first_byte_6 _anon_9_3 switch_15 all_data_2 Resolved_75 Resolved_76 frames_2 (field '_anon_13', id n/a, parser, args: (True, self.context()));

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::RequestFrame::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = RequestFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__RequestFrame_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {
        (*__self).__context = ::hilti::rt::StrongReference<__hlt_quic::QUIC::ConnectionIDInfo>();
        throw;
    }

    (*__self).__context = ::hilti::rt::StrongReference<__hlt_quic::QUIC::ConnectionIDInfo>();
    return __result;
}

extern auto __hlt_quic::QUIC::RequestFrame::context_new() -> ::spicy::rt::UnitContext {
    ::hilti::rt::detail::checkStack();
    return ::spicy::rt::detail::createContext(::hilti::rt::reference::make_strong<__hlt_quic::QUIC::ConnectionIDInfo>(), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
}

extern auto __hlt_quic::QUIC::RequestFrame::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::RequestFrame> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::RequestFrame>((__hlt_quic::QUIC::RequestFrame()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");

    // Begin parsing production: Unit: QUIC__RequestFrame -> Resolved_64;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__RequestFrame -> Resolved_64;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::RequestFrame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::RequestFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");

    // Begin parsing production: Unit: QUIC__RequestFrame -> Resolved_64;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__RequestFrame -> Resolved_64;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::RequestFrame::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::RequestFrame> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::RequestFrame>((__hlt_quic::QUIC::RequestFrame()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__RequestFrame_namex2aQUIC__RequestFramex2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:556:28-559:1");

    // Begin parsing production: Unit: QUIC__RequestFrame -> Resolved_64;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__RequestFrame -> Resolved_64;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_quic::QUIC::ResponseFrame::__parse_QUIC__ResponseFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ResponseFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet> __transient__anon_14;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:418:15-551:1");

    // Begin parsing production: Unit: QUIC__Packet_3 -> first_byte_9 _anon_9_4 switch_21 all_data_3 Resolved_93 Resolved_94 frames_3 (field '_anon_14', id n/a, parser, args: (False, self.context()));
    __transient__anon_14 = (__hlt_quic::QUIC::Packet(::hilti::rt::Bool(false), (*__self).__context));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_14).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: QUIC__Packet_3 -> first_byte_9 _anon_9_4 switch_21 all_data_3 Resolved_93 Resolved_94 frames_3 (field '_anon_14', id n/a, parser, args: (False, self.context()));

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ResponseFrame::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ResponseFrame::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ResponseFrame_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {
        (*__self).__context = ::hilti::rt::StrongReference<__hlt_quic::QUIC::ConnectionIDInfo>();
        throw;
    }

    (*__self).__context = ::hilti::rt::StrongReference<__hlt_quic::QUIC::ConnectionIDInfo>();
    return __result;
}

extern auto __hlt_quic::QUIC::ResponseFrame::context_new() -> ::spicy::rt::UnitContext {
    ::hilti::rt::detail::checkStack();
    return ::spicy::rt::detail::createContext(::hilti::rt::reference::make_strong<__hlt_quic::QUIC::ConnectionIDInfo>(), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
}

extern auto __hlt_quic::QUIC::ResponseFrame::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::ResponseFrame> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::ResponseFrame>((__hlt_quic::QUIC::ResponseFrame()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");

    // Begin parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::ResponseFrame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ResponseFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");

    // Begin parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::ResponseFrame::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::ResponseFrame> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::ResponseFrame>((__hlt_quic::QUIC::ResponseFrame()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__ResponseFrame_namex2aQUIC__ResponseFramex2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_QUIC__ConnectionIDInfo_namex2aQUIC__ConnectionIDInfox2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:561:29-564:1");

    // Begin parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ResponseFrame -> Resolved_82;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::RetryPacket::__on_0x25_done() {
    auto __self = QUIC::RetryPacket::__self();
    return __hlt_quic::QUIC::__hook_RetryPacket___on_0x25_done(__self);
}

inline void __hlt_quic::QUIC::RetryPacket::__on_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = QUIC::RetryPacket::__self();
    return __hlt_quic::QUIC::__hook_RetryPacket___on_data(__dd, __self);
}

auto __hlt_quic::QUIC::RetryPacket::__parse_QUIC__RetryPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = RetryPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:361:20-374:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_15;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:370:9-370:13");

        // Begin parsing production: Variable: data_4 -> bytes;
        ::spicy::rt::detail::waitForEod(__data, __cur, (__lhs_15=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        ::hilti::rt::optional::valueOrInit((*__self).data) = __cur.data();
        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: data_4 -> bytes;

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:370:3-373:3");
        (*__self).__on_data(::hilti::rt::optional::value((*__self).data));
        __error = (*__self).__error;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:361:20-374:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::RetryPacket::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = RetryPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:361:20-374:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__RetryPacket_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_quic::QUIC::ShortHeader::__parse_QUIC__ShortHeader_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ShortHeader::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:381:27-389:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_3;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:382:16-387:5");

        // Begin parsing production: Variable: first_byte_2 -> bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; spin_bit: 5; todo: 0..4; };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:382:16-387:5"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).first_byte), __cur) = (__x_3 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::enum_::from_uint<QUIC::HeaderForm>(::hilti::rt::integer::bits(std::get<0>(*__x_3), 7, 7, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0})), ::hilti::rt::integer::bits(std::get<0>(*__x_3), 6, 6, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_3), 5, 5, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_3), 0, 4, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_3))), std::get<1>(*__x_3)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: first_byte_2 -> bitfield(8) { header_form: 7 &convert=cast<QUIC::HeaderForm>(cast<uint<8>>(__dd)); fixed_bit: 6; spin_bit: 5; todo: 0..4; };
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_16;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:388:19-388:23");

        // Begin parsing production: Variable: dest_conn_id_2 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).dest_conn_id) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>(__self->__p_dest_conn_id_length), ::hilti::rt::Bool(false), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:388:5-388:50"), (__lhs_16=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(__self->__p_dest_conn_id_length));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: dest_conn_id_2 -> bytes;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ShortHeader::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ShortHeader::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:381:27-389:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ShortHeader_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_quic::QUIC::ShortHeader::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortHeader>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:381:27-389:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:381:27-389:1");

    // Begin parsing production: Unit: QUIC__ShortHeader -> first_byte_2 dest_conn_id_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ShortHeader -> first_byte_2 dest_conn_id_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_quic::QUIC::ShortPacketPayload::__parse_QUIC__ShortPacketPayload_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ShortPacketPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient_payload;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_17;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:393:3-393:27");

        // Begin parsing production: Skip: payload_15 -> skip: payload;
        while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_17=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __cur = __cur.advance(__cur.size());
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }

        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Skip: payload_15 -> skip: payload;
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ShortPacketPayload::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ShortPacketPayload::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ShortPacketPayload_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_quic::QUIC::ShortPacketPayload::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::ShortPacketPayload>((__hlt_quic::QUIC::ShortPacketPayload()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");

    // Begin parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::ShortPacketPayload::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");

    // Begin parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_quic::QUIC::ShortPacketPayload::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");
    ::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload> __unit = ::hilti::rt::reference::make_value<__hlt_quic::QUIC::ShortPacketPayload>((__hlt_quic::QUIC::ShortPacketPayload()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_QUIC__ShortPacketPayload_namex2aQUIC__ShortPacketPayloadx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:392:34-394:1");

    // Begin parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__ShortPacketPayload -> payload_15;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::UnhandledVersion::__on_0x25_done() {
    auto __self = QUIC::UnhandledVersion::__self();
    return __hlt_quic::QUIC::__hook_UnhandledVersion___on_0x25_done(__self);
}

auto __hlt_quic::QUIC::UnhandledVersion::__parse_QUIC__UnhandledVersion_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = UnhandledVersion::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient_payload;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_18;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:222:3-222:27");

        // Begin parsing production: Skip: payload_7 -> skip: payload;
        while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_18=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __cur = __cur.advance(__cur.size());
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }

        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Skip: payload_7 -> skip: payload;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::UnhandledVersion::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = UnhandledVersion::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__UnhandledVersion_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_quic::QUIC::UnhandledVersion::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:220:32-223:1");

    // Begin parsing production: Unit: QUIC__UnhandledVersion -> payload_7;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: QUIC__UnhandledVersion -> payload_7;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_quic::QUIC::VariableLengthInteger::__on__anon(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = QUIC::VariableLengthInteger::__self();
    return __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon(__dd, __self);
}

inline void __hlt_quic::QUIC::VariableLengthInteger::__on__anon_3_foreach(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = QUIC::VariableLengthInteger::__self();
    return __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon_3_foreach(__dd, __stop, __self);
}

auto __hlt_quic::QUIC::VariableLengthInteger::__parse_QUIC__VariableLengthInteger_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = VariableLengthInteger::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::integer::safe<uint8_t> __transient__anon;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:167:5-167:9");

    // Begin parsing production: Variable: _anon -> uint<8>;
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:167:5-167:9"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(__transient__anon, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon -> uint<8>;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:167:3-170:3");
    (*__self).__on__anon(__transient__anon);
    __error = (*__self).__error;
    ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>> __transient__anon_3;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:172:3-174:3");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    if ( (*__self).bytes_to_parse > ::hilti::rt::integer::safe<std::uint64_t>{1U} ) {
        // Begin parsing production: Counter: _anon_3 -> counter(self.bytes_to_parse - 1): _anon_2;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse__anon_3_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, __transient__anon_3);
        // End parsing production: Counter: _anon_3 -> counter(self.bytes_to_parse - 1): _anon_2;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::VariableLengthInteger::__parse__anon_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = VariableLengthInteger::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:172:3-174:3");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    for ( ::hilti::rt::integer::safe<uint64_t> __i = (*__self).bytes_to_parse - ::hilti::rt::integer::safe<std::uint64_t>{1U}; ::hilti::rt::Bool(static_cast<bool>(__i));  ) {
        __i--;
        ::hilti::rt::integer::safe<uint8_t> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:172:5-172:9");

        // Begin parsing production: Variable: _anon_2 -> uint<8> (container '_anon_3');
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("expecting 1 bytes for unpacking value"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:172:5-172:9"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__elem, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_2 -> uint<8> (container '_anon_3');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:172:3-174:3");
            (*__self).__on__anon_3_foreach(__elem, __stop);
            __error = (*__self).__error;
        }

        if ( __stop ) {
            break;
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::VariableLengthInteger::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = VariableLengthInteger::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__VariableLengthInteger_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_quic::QUIC::ZeroRTTPacket::__on_0x25_done() {
    auto __self = QUIC::ZeroRTTPacket::__self();
    return __hlt_quic::QUIC::__hook_ZeroRTTPacket___on_0x25_done(__self);
}

auto __hlt_quic::QUIC::ZeroRTTPacket::__parse_QUIC__ZeroRTTPacket_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ZeroRTTPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:348:22-352:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:158:30-175:1");

        // Begin parsing production: Unit: QUIC__VariableLengthInteger_10 -> _anon_12 _anon_3_10;
        ::hilti::rt::optional::valueOrInit((*__self).length) = (__hlt_quic::QUIC::VariableLengthInteger());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).length)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: QUIC__VariableLengthInteger_10 -> _anon_12 _anon_3_10;
    }

    ::hilti::rt::Bytes __transient_payload;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:351:3-351:48");

        // Begin parsing production: Skip: payload_13 -> skip: payload;
        ::hilti::rt::stream::View __limited_ = __cur.limit((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::stream::View __ncur = __cur.advance((*::hilti::rt::optional::value((*__self).length)).result_);
        ::hilti::rt::integer::safe<uint64_t> __skip = (*::hilti::rt::optional::value((*__self).length)).result_;
        while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
            ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, std::string_view("not enough bytes for skipping"), std::string_view("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:351:3-351:48"), ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
            __limited_ = __limited_.advance(__consume);
            if ( __trim ) {
                (*__data).trim(__limited_.begin());
            }

            __skip = __skip - __consume;
        }

        if ( __limited_.offset() < __ncur.offset() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:351:23-351:47");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("&size amount not consumed: expected %lu bytes, but got %lu bytes"), (*::hilti::rt::optional::value((*__self).length)).result_, __limited_.offset() - (__ncur.offset() - (*::hilti::rt::optional::value((*__self).length)).result_)), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:351:23-351:47");
        }

        // End parsing production: Skip: payload_13 -> skip: payload;

        __cur = __ncur;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:348:22-352:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_quic::QUIC::ZeroRTTPacket::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ZeroRTTPacket::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:348:22-352:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_QUIC__ZeroRTTPacket_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern void __hlt_quic::QUIC::__hook_CryptoBuffer___on__anon_8_64ca(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<CryptoBuffer>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:408:5-408:23");
    (*__self).buffered.append(__dd);
}

extern void __hlt_quic::QUIC::__hook_Frame___on__anon_7_27b5(::hilti::rt::ValueReference<Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:290:7-290:95");
    throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string("unhandled frame type %s in %s"), ::hilti::rt::optional::value((*__self).frame_type), (::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self->__p_header.derefAsValue()).first_byte).value)))), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:290:7-290:95");
}

extern void __hlt_quic::QUIC::__hook_Frame___on_c_904e(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::CRYPTOPayload>& __dd, ::hilti::rt::ValueReference<Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:284:7-284:65");
    (*__self->__p_crypto_sink.derefAsValue()).write(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).c)).cryptodata), std::optional<::hilti::rt::integer::safe<uint64_t>>((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).c)).offset)).result_), std::optional<::hilti::rt::integer::safe<uint64_t>>());
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_initial_hdr_e7eb(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:184:7-184:29");
    (*__self->__p_outer.derefAsValue()).is_initial = ::hilti::rt::Bool(true);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:185:7-188:68");
    (*__self->__p_outer.derefAsValue()).encrypted_offset = (*__self->__p_outer.derefAsValue()).__offset + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).length)).bytes_to_parse + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).token_length)).bytes_to_parse + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).token_length)).result_;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:189:7-189:60");
    (*__self->__p_outer.derefAsValue()).payload_length = (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).length)).result_;
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacketV1___on_retry_hdr_86a4(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV1>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:195:9-195:29");
    (*__self->__p_outer.derefAsValue()).is_retry = ::hilti::rt::Bool(true);
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_initial_hdr_694d(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::InitialPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:203:7-203:29");
    (*__self->__p_outer.derefAsValue()).is_initial = ::hilti::rt::Bool(true);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:204:7-207:69");
    (*__self->__p_outer.derefAsValue()).encrypted_offset = (*__self->__p_outer.derefAsValue()).__offset + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).length)).bytes_to_parse + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).token_length)).bytes_to_parse + (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).token_length)).result_;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:208:7-208:60");
    (*__self->__p_outer.derefAsValue()).payload_length = (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).initial_hdr)).length)).result_;
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacketV2___on_retry_hdr_6b61(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::RetryPacket>& __dd, ::hilti::rt::ValueReference<LongHeaderPacketV2>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:214:9-214:29");
    (*__self->__p_outer.derefAsValue()).is_retry = ::hilti::rt::Bool(true);
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacket___on_dest_conn_id_len_f78d(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:241:29-241:59");
    (*__self).server_conn_id_length = __dd;
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacket___on_src_conn_id_len_ef9e(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:243:28-243:58");
    (*__self).client_conn_id_length = __dd;
}

extern void __hlt_quic::QUIC::__hook_LongHeaderPacket___on_unknown_1ace(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __dd, ::hilti::rt::ValueReference<LongHeaderPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:269:7-269:57");
    throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string("unhandled QUIC version 0x%x"), ::hilti::rt::optional::value((*__self).version)), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:269:7-269:57");
}

extern void __hlt_quic::QUIC::__hook_Packet___on_0x25_done_faf0(::hilti::rt::ValueReference<Packet>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:528:5-549:5");
    if ( ((*__self).crypto_buffer != ::hilti::rt::StrongReference<__hlt_quic::QUIC::CryptoBuffer>()) && ((*(*__self).crypto_buffer).buffered.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:529:7-529:57");
        ::hilti::rt::Bytes handshake_data = (*(*__self).crypto_buffer).buffered;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:533:7-533:87");
        ::hilti::rt::Bytes length_bytes = ::hilti::rt::integer::pack<uint16_t>(static_cast<::hilti::rt::integer::safe<uint16_t>>(handshake_data.size()), ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Big});
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:534:7-538:7");
        ::zeek::spicy::rt::protocol_data_in(__self->__p_from_client, "\026\003\003"_b + length_bytes + handshake_data, ::hilti::rt::optional::value((*__self->__p_context.derefAsValue()).ssl_handle));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:542:7-545:48");
        if ( __self->__p_from_client ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:543:9-543:47");
            (*__self->__p_context.derefAsValue()).client_initial_processed = ::hilti::rt::Bool(true);
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:545:9-545:47");
            (*__self->__p_context.derefAsValue()).server_initial_processed = ::hilti::rt::Bool(true);
        }

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:548:7-548:27");
        ::spicy::rt::accept_input();
    }
}

extern void __hlt_quic::QUIC::__hook_Packet___on_0x25_init_8604(::hilti::rt::ValueReference<Packet>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:428:5-430:5");
    if ( ! ((*__self->__p_context.derefAsValue()).ssl_handle.has_value()) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:429:7-429:69");
        ::hilti::rt::optional::valueOrInit((*__self->__p_context.derefAsValue()).ssl_handle) = ::zeek::spicy::rt::protocol_handle_get_or_create(std::string("SSL"), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:432:5-432:29");
    (*__self).start = (*__self).__begin;
}

extern void __hlt_quic::QUIC::__hook_Packet___on__anon_9_1a25(::hilti::rt::ValueReference<Packet>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:443:5-443:30");
    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>((*__self).start);
}

extern void __hlt_quic::QUIC::__hook_Packet___on_all_data_d2ea(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<Packet>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:469:5-469:43");
    (*__self).crypto_buffer = ::hilti::rt::reference::make_strong<__hlt_quic::QUIC::CryptoBuffer>();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:470:5-470:48");
    (*(*__self).crypto_sink).connect((*__self).crypto_buffer);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:472:5-505:5");
    if ( __self->__p_from_client ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:473:7-473:64");
        (*__self->__p_context.derefAsValue()).server_cid_len = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).dest_conn_id_len);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:474:7-474:63");
        (*__self->__p_context.derefAsValue()).client_cid_len = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).src_conn_id_len);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:478:7-485:7");
        (*__self).decrypted_data = ::QUIC_decrypt_crypto_payload(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).version), ::hilti::rt::optional::value((*__self).all_data), ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).dest_conn_id), (*::hilti::rt::optional::value((*__self).long_header)).encrypted_offset, (*::hilti::rt::optional::value((*__self).long_header)).payload_length, __self->__p_from_client);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:489:7-491:7");
        if ( (*__self->__p_context.derefAsValue()).initial_destination_conn_id.size() == ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:490:9-490:75");
            (*__self->__p_context.derefAsValue()).initial_destination_conn_id = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).dest_conn_id);
        }
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:494:7-494:63");
        (*__self->__p_context.derefAsValue()).server_cid_len = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).src_conn_id_len);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:495:7-495:64");
        (*__self->__p_context.derefAsValue()).client_cid_len = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).dest_conn_id_len);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:497:7-504:7");
        (*__self).decrypted_data = ::QUIC_decrypt_crypto_payload(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).long_header)).version), ::hilti::rt::optional::value((*__self).all_data), (*__self->__p_context.derefAsValue()).initial_destination_conn_id, (*::hilti::rt::optional::value((*__self).long_header)).encrypted_offset, (*::hilti::rt::optional::value((*__self).long_header)).payload_length, __self->__p_from_client);
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:510:5-511:32");
    if ( (*__self).decrypted_data.size() == ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:511:7-511:32");
        throw ::spicy::rt::ParseError(std::string("decryption failed"), "/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:511:7-511:32");
    }
}

extern void __hlt_quic::QUIC::__hook_Packet___on_long_header_5d3b(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __dd, ::hilti::rt::ValueReference<Packet>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:455:9-463:9");
    if ( (*::hilti::rt::optional::value((*__self).long_header)).is_retry ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:456:11-456:50");
        (*__self->__p_context.derefAsValue()).client_initial_processed = ::hilti::rt::Bool(false);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:457:11-457:50");
        (*__self->__p_context.derefAsValue()).server_initial_processed = ::hilti::rt::Bool(false);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:458:11-458:51");
        (*__self->__p_context.derefAsValue()).initial_destination_conn_id = ""_b;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:461:11-461:57");
        ::zeek::spicy::rt::protocol_handle_close(::hilti::rt::optional::value((*__self->__p_context.derefAsValue()).ssl_handle));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:462:11-462:35");
        (*__self->__p_context.derefAsValue()).ssl_handle.reset();
    }
}

extern void __hlt_quic::QUIC::__hook_RetryPacket___on_data_17c1(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<RetryPacket>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:371:5-371:57");
    (*__self).retry_token = ::hilti::rt::optional::value((*__self).data).sub(::hilti::rt::integer::safe<std::uint64_t>{0U}, ::hilti::rt::optional::value((*__self).data).size() - ::hilti::rt::integer::safe<std::uint64_t>{16U});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:372:5-372:69");
    (*__self).integrity_tag = ::hilti::rt::optional::value((*__self).data).sub(::hilti::rt::optional::value((*__self).data).size() - ::hilti::rt::integer::safe<std::uint64_t>{16U}, ::hilti::rt::optional::value((*__self).data).size());
}

extern void __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon_3_foreach_228a(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<VariableLengthInteger>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:173:5-173:43");
    (*__self).result_ = ((((*__self).result_ << ::hilti::rt::integer::safe<std::uint64_t>{8U})) | ::hilti::rt::integer::safe<uint64_t>(__dd));
}

extern void __hlt_quic::QUIC::__hook_VariableLengthInteger___on__anon_84a8(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<VariableLengthInteger>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:168:5-168:47");
    (*__self).bytes_to_parse = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::pow(::hilti::rt::integer::safe<std::uint8_t>{2U}, ((((::hilti::rt::integer::safe<std::uint8_t>{192U} & __dd)) >> ::hilti::rt::integer::safe<std::uint64_t>{6U}))));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:169:5-169:28");
    (*__self).result_ = ::hilti::rt::integer::safe<uint64_t>((__dd & ::hilti::rt::integer::safe<std::uint8_t>{63U}));
}

extern void __hlt_quic::QUIC::__init_module() {
    __hlt_quic::QUIC::__register_QUIC_ACKPayload();
    __hlt_quic::QUIC::__register_QUIC_CRYPTOPayload();
    __hlt_quic::QUIC::__register_QUIC_ConnectionClosePayload();
    __hlt_quic::QUIC::__register_QUIC_CryptoBuffer();
    __hlt_quic::QUIC::__register_QUIC_EncryptedLongPacketPayload();
    __hlt_quic::QUIC::__register_QUIC_Frame();
    __hlt_quic::QUIC::__register_QUIC_HandshakePacket();
    __hlt_quic::QUIC::__register_QUIC_InitialPacket();
    __hlt_quic::QUIC::__register_QUIC_LongHeaderPacket();
    __hlt_quic::QUIC::__register_QUIC_LongHeaderPacketV1();
    __hlt_quic::QUIC::__register_QUIC_LongHeaderPacketV2();
    __hlt_quic::QUIC::__register_QUIC_Packet();
    __hlt_quic::QUIC::__register_QUIC_RequestFrame();
    __hlt_quic::QUIC::__register_QUIC_ResponseFrame();
    __hlt_quic::QUIC::__register_QUIC_RetryPacket();
    __hlt_quic::QUIC::__register_QUIC_ShortHeader();
    __hlt_quic::QUIC::__register_QUIC_ShortPacketPayload();
    __hlt_quic::QUIC::__register_QUIC_UnhandledVersion();
    __hlt_quic::QUIC::__register_QUIC_VariableLengthInteger();
    __hlt_quic::QUIC::__register_QUIC_ZeroRTTPacket();
}

extern void __hlt_quic::QUIC::__register_QUIC_ACKPayload() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_CRYPTOPayload() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_ConnectionClosePayload() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_CryptoBuffer() {
    ::hilti::rt::detail::checkStack();

    {
        QUIC::CryptoBuffer::__parser = ::spicy::rt::Parser(std::string_view("QUIC::CryptoBuffer"), ::hilti::rt::Bool(false), hlt_quic::QUIC::CryptoBuffer::parse1, hlt_quic::QUIC::CryptoBuffer::parse2, hlt_quic::QUIC::CryptoBuffer::parse3, ::hilti::rt::Null(), &type_info::__ti_QUIC__CryptoBuffer_namex2aQUIC__CryptoBufferx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
        ::spicy::rt::detail::registerParser(QUIC::CryptoBuffer::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::CryptoBuffer>());
    }

}

extern void __hlt_quic::QUIC::__register_QUIC_EncryptedLongPacketPayload() {
    ::hilti::rt::detail::checkStack();
    QUIC::EncryptedLongPacketPayload::__parser = ::spicy::rt::Parser(std::string_view("QUIC::EncryptedLongPacketPayload"), ::hilti::rt::Bool(true), hlt_quic::QUIC::EncryptedLongPacketPayload::parse1, hlt_quic::QUIC::EncryptedLongPacketPayload::parse2, hlt_quic::QUIC::EncryptedLongPacketPayload::parse3, ::hilti::rt::Null(), &type_info::__ti_QUIC__EncryptedLongPacketPayload_namex2aQUIC__EncryptedLongPacketPayloadx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::EncryptedLongPacketPayload::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::EncryptedLongPacketPayload>());
}

extern void __hlt_quic::QUIC::__register_QUIC_Frame() {
    ::hilti::rt::detail::checkStack();
    QUIC::Frame::__parser = ::spicy::rt::Parser(std::string_view("QUIC::Frame"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_quic::QUIC::Frame::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__Frame_namex2aQUIC__Framex2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::Frame::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::Frame>());
}

extern void __hlt_quic::QUIC::__register_QUIC_HandshakePacket() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_InitialPacket() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_LongHeaderPacket() {
    ::hilti::rt::detail::checkStack();
    QUIC::LongHeaderPacket::__parser = ::spicy::rt::Parser(std::string_view("QUIC::LongHeaderPacket"), ::hilti::rt::Bool(true), hlt_quic::QUIC::LongHeaderPacket::parse1, hlt_quic::QUIC::LongHeaderPacket::parse2, hlt_quic::QUIC::LongHeaderPacket::parse3, ::hilti::rt::Null(), &type_info::__ti_QUIC__LongHeaderPacket_namex2aQUIC__LongHeaderPacketx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::LongHeaderPacket::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::LongHeaderPacket>());
}

extern void __hlt_quic::QUIC::__register_QUIC_LongHeaderPacketV1() {
    ::hilti::rt::detail::checkStack();
    QUIC::LongHeaderPacketV1::__parser = ::spicy::rt::Parser(std::string_view("QUIC::LongHeaderPacketV1"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_quic::QUIC::LongHeaderPacketV1::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__LongHeaderPacketV1_namex2aQUIC__LongHeaderPacketV1x2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::LongHeaderPacketV1::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::LongHeaderPacketV1>());
}

extern void __hlt_quic::QUIC::__register_QUIC_LongHeaderPacketV2() {
    ::hilti::rt::detail::checkStack();
    QUIC::LongHeaderPacketV2::__parser = ::spicy::rt::Parser(std::string_view("QUIC::LongHeaderPacketV2"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_quic::QUIC::LongHeaderPacketV2::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__LongHeaderPacketV2_namex2aQUIC__LongHeaderPacketV2x2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::LongHeaderPacketV2::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::LongHeaderPacketV2>());
}

extern void __hlt_quic::QUIC::__register_QUIC_Packet() {
    ::hilti::rt::detail::checkStack();

    {
        QUIC::Packet::__parser = ::spicy::rt::Parser(std::string_view("QUIC::Packet"), ::hilti::rt::Bool(false), ::hilti::rt::Null(), hlt_quic::QUIC::Packet::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__Packet_namex2aQUIC__Packetx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
        ::spicy::rt::detail::registerParser(QUIC::Packet::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::Packet>());
    }

}

extern void __hlt_quic::QUIC::__register_QUIC_RequestFrame() {
    ::hilti::rt::detail::checkStack();
    QUIC::RequestFrame::__parser = ::spicy::rt::Parser(std::string_view("QUIC::RequestFrame"), ::hilti::rt::Bool(true), hlt_quic::QUIC::RequestFrame::parse1, hlt_quic::QUIC::RequestFrame::parse2, hlt_quic::QUIC::RequestFrame::parse3, hlt_quic::QUIC::RequestFrame::context_new, &type_info::__ti_QUIC__RequestFrame_namex2aQUIC__RequestFramex2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::RequestFrame::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::RequestFrame>());
}

extern void __hlt_quic::QUIC::__register_QUIC_ResponseFrame() {
    ::hilti::rt::detail::checkStack();
    QUIC::ResponseFrame::__parser = ::spicy::rt::Parser(std::string_view("QUIC::ResponseFrame"), ::hilti::rt::Bool(true), hlt_quic::QUIC::ResponseFrame::parse1, hlt_quic::QUIC::ResponseFrame::parse2, hlt_quic::QUIC::ResponseFrame::parse3, hlt_quic::QUIC::ResponseFrame::context_new, &type_info::__ti_QUIC__ResponseFrame_namex2aQUIC__ResponseFramex2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::ResponseFrame::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::ResponseFrame>());
}

extern void __hlt_quic::QUIC::__register_QUIC_RetryPacket() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_ShortHeader() {
    ::hilti::rt::detail::checkStack();
    QUIC::ShortHeader::__parser = ::spicy::rt::Parser(std::string_view("QUIC::ShortHeader"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_quic::QUIC::ShortHeader::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__ShortHeader_namex2aQUIC__ShortHeaderx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::ShortHeader::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::ShortHeader>());
}

extern void __hlt_quic::QUIC::__register_QUIC_ShortPacketPayload() {
    ::hilti::rt::detail::checkStack();
    QUIC::ShortPacketPayload::__parser = ::spicy::rt::Parser(std::string_view("QUIC::ShortPacketPayload"), ::hilti::rt::Bool(true), hlt_quic::QUIC::ShortPacketPayload::parse1, hlt_quic::QUIC::ShortPacketPayload::parse2, hlt_quic::QUIC::ShortPacketPayload::parse3, ::hilti::rt::Null(), &type_info::__ti_QUIC__ShortPacketPayload_namex2aQUIC__ShortPacketPayloadx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::ShortPacketPayload::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::ShortPacketPayload>());
}

extern void __hlt_quic::QUIC::__register_QUIC_UnhandledVersion() {
    ::hilti::rt::detail::checkStack();
    QUIC::UnhandledVersion::__parser = ::spicy::rt::Parser(std::string_view("QUIC::UnhandledVersion"), ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_quic::QUIC::UnhandledVersion::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_QUIC__UnhandledVersion_namex2aQUIC__UnhandledVersionx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(QUIC::UnhandledVersion::__parser, std::string(__hlt_quic_hlto_scope), ::hilti::rt::StrongReference<__hlt_quic::QUIC::UnhandledVersion>());
}

extern void __hlt_quic::QUIC::__register_QUIC_VariableLengthInteger() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_QUIC_ZeroRTTPacket() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_quic::QUIC::__register_module() { ::hilti::rt::detail::registerModule({ "QUIC", __hlt_quic_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

static auto __hlt_quic::QUIC::can_decrypt(const ::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& long_header, const __hlt_quic::QUIC::ConnectionIDInfo& context, const ::hilti::rt::Bool& is_client) -> ::hilti::rt::Bool {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:27:3-28:17");
    if ( ! ((*long_header).is_initial) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:28:5-28:17");
        return ::hilti::rt::Bool(false);
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:30:3-31:46");
    if ( is_client ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:31:5-31:46");
        return ! (context.client_initial_processed);
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/quic/QUIC.spicy:35:3-37:48");
    return ((context.client_initial_processed) && (context.initial_destination_conn_id.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U})) && (! (context.server_initial_processed));
}

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::VariableLengthInteger& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ACKPayload& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::CRYPTOPayload& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_quic::QUIC::operator<<(std::ostream& o, HeaderForm x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ZeroRTTPacket& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacket& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV1& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::InitialPacket& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::HandshakePacket& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::RetryPacket& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::LongHeaderPacketV2& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::UnhandledVersion& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ConnectionClosePayload& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ConnectionIDInfo& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::CryptoBuffer& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::EncryptedLongPacketPayload& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_quic::QUIC::operator<<(std::ostream& o, FrameType x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::Frame& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_quic::QUIC::operator<<(std::ostream& o, LongPacketTypeV1 x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_quic::QUIC::operator<<(std::ostream& o, LongPacketTypeV2 x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ShortHeader& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ShortPacketPayload& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::Packet& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::RequestFrame& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_quic::QUIC::operator<<(std::ostream& o, const __hlt_quic::QUIC::ResponseFrame& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto hilti::rt::detail::adl::to_string(__hlt_quic::QUIC::HeaderForm x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_quic::QUIC::HeaderForm::LONG: return "HeaderForm::LONG";
        case __hlt_quic::QUIC::HeaderForm::SHORT: return "HeaderForm::SHORT";
        case __hlt_quic::QUIC::HeaderForm::Undef: return "HeaderForm::Undef";
        default: return ::hilti::rt::fmt("HeaderForm::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_quic::QUIC::FrameType x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_quic::QUIC::FrameType::HANDSHAKE_DONE: return "FrameType::HANDSHAKE_DONE";
        case __hlt_quic::QUIC::FrameType::CONNECTION_CLOSE2: return "FrameType::CONNECTION_CLOSE2";
        case __hlt_quic::QUIC::FrameType::CONNECTION_CLOSE1: return "FrameType::CONNECTION_CLOSE1";
        case __hlt_quic::QUIC::FrameType::PATH_RESPONSE: return "FrameType::PATH_RESPONSE";
        case __hlt_quic::QUIC::FrameType::PATH_CHALLENGE: return "FrameType::PATH_CHALLENGE";
        case __hlt_quic::QUIC::FrameType::RETIRE_CONNECTION_ID: return "FrameType::RETIRE_CONNECTION_ID";
        case __hlt_quic::QUIC::FrameType::NEW_CONNECTION_ID: return "FrameType::NEW_CONNECTION_ID";
        case __hlt_quic::QUIC::FrameType::STREAMS_BLOCKED2: return "FrameType::STREAMS_BLOCKED2";
        case __hlt_quic::QUIC::FrameType::STREAMS_BLOCKED1: return "FrameType::STREAMS_BLOCKED1";
        case __hlt_quic::QUIC::FrameType::STREAM_DATA_BLOCKED: return "FrameType::STREAM_DATA_BLOCKED";
        case __hlt_quic::QUIC::FrameType::DATA_BLOCKED: return "FrameType::DATA_BLOCKED";
        case __hlt_quic::QUIC::FrameType::MAX_STREAMS2: return "FrameType::MAX_STREAMS2";
        case __hlt_quic::QUIC::FrameType::MAX_STREAMS1: return "FrameType::MAX_STREAMS1";
        case __hlt_quic::QUIC::FrameType::MAX_STREAM_DATA: return "FrameType::MAX_STREAM_DATA";
        case __hlt_quic::QUIC::FrameType::MAX_DATA: return "FrameType::MAX_DATA";
        case __hlt_quic::QUIC::FrameType::STREAM8: return "FrameType::STREAM8";
        case __hlt_quic::QUIC::FrameType::STREAM7: return "FrameType::STREAM7";
        case __hlt_quic::QUIC::FrameType::STREAM6: return "FrameType::STREAM6";
        case __hlt_quic::QUIC::FrameType::STREAM5: return "FrameType::STREAM5";
        case __hlt_quic::QUIC::FrameType::STREAM4: return "FrameType::STREAM4";
        case __hlt_quic::QUIC::FrameType::STREAM3: return "FrameType::STREAM3";
        case __hlt_quic::QUIC::FrameType::STREAM2: return "FrameType::STREAM2";
        case __hlt_quic::QUIC::FrameType::STREAM1: return "FrameType::STREAM1";
        case __hlt_quic::QUIC::FrameType::NEW_TOKEN: return "FrameType::NEW_TOKEN";
        case __hlt_quic::QUIC::FrameType::CRYPTO: return "FrameType::CRYPTO";
        case __hlt_quic::QUIC::FrameType::STOP_SENDING: return "FrameType::STOP_SENDING";
        case __hlt_quic::QUIC::FrameType::RESET_STREAM: return "FrameType::RESET_STREAM";
        case __hlt_quic::QUIC::FrameType::ACK2: return "FrameType::ACK2";
        case __hlt_quic::QUIC::FrameType::ACK1: return "FrameType::ACK1";
        case __hlt_quic::QUIC::FrameType::PING: return "FrameType::PING";
        case __hlt_quic::QUIC::FrameType::PADDING: return "FrameType::PADDING";
        case __hlt_quic::QUIC::FrameType::Undef: return "FrameType::Undef";
        default: return ::hilti::rt::fmt("FrameType::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_quic::QUIC::LongPacketTypeV1 x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_quic::QUIC::LongPacketTypeV1::RETRY: return "LongPacketTypeV1::RETRY";
        case __hlt_quic::QUIC::LongPacketTypeV1::HANDSHAKE: return "LongPacketTypeV1::HANDSHAKE";
        case __hlt_quic::QUIC::LongPacketTypeV1::ZERO_RTT: return "LongPacketTypeV1::ZERO_RTT";
        case __hlt_quic::QUIC::LongPacketTypeV1::INITIAL: return "LongPacketTypeV1::INITIAL";
        case __hlt_quic::QUIC::LongPacketTypeV1::Undef: return "LongPacketTypeV1::Undef";
        default: return ::hilti::rt::fmt("LongPacketTypeV1::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_quic::QUIC::LongPacketTypeV2 x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_quic::QUIC::LongPacketTypeV2::HANDSHAKE: return "LongPacketTypeV2::HANDSHAKE";
        case __hlt_quic::QUIC::LongPacketTypeV2::ZERO_RTT: return "LongPacketTypeV2::ZERO_RTT";
        case __hlt_quic::QUIC::LongPacketTypeV2::INITIAL: return "LongPacketTypeV2::INITIAL";
        case __hlt_quic::QUIC::LongPacketTypeV2::RETRY: return "LongPacketTypeV2::RETRY";
        case __hlt_quic::QUIC::LongPacketTypeV2::Undef: return "LongPacketTypeV2::Undef";
        default: return ::hilti::rt::fmt("LongPacketTypeV2::<unknown-%" PRIu64 ">", x.value());
    }
}

extern auto hlt_quic::QUIC::CryptoBuffer::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::CryptoBuffer::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::CryptoBuffer::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::CryptoBuffer>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::CryptoBuffer::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::CryptoBuffer::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::CryptoBuffer::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::EncryptedLongPacketPayload::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::EncryptedLongPacketPayload::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::EncryptedLongPacketPayload::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::EncryptedLongPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::EncryptedLongPacketPayload::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::EncryptedLongPacketPayload::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::EncryptedLongPacketPayload::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::Frame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Frame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::Frame::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::LongHeaderPacket::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::LongHeaderPacket::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::LongHeaderPacket::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacket>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::LongHeaderPacket::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::LongHeaderPacket::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::LongHeaderPacket::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::LongHeaderPacketV1::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV1>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::LongHeaderPacketV1::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::LongHeaderPacketV2::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::LongHeaderPacketV2>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::LongHeaderPacketV2::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::Packet::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::Packet>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::Packet::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::RequestFrame::context_new() -> ::spicy::rt::UnitContext { return __hlt_quic::QUIC::RequestFrame::context_new(); }

extern auto hlt_quic::QUIC::RequestFrame::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::RequestFrame::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::RequestFrame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::RequestFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::RequestFrame::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::RequestFrame::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::RequestFrame::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ResponseFrame::context_new() -> ::spicy::rt::UnitContext { return __hlt_quic::QUIC::ResponseFrame::context_new(); }

extern auto hlt_quic::QUIC::ResponseFrame::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ResponseFrame::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ResponseFrame::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ResponseFrame>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ResponseFrame::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ResponseFrame::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ResponseFrame::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ShortHeader::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortHeader>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ShortHeader::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ShortPacketPayload::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ShortPacketPayload::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ShortPacketPayload::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::ShortPacketPayload>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ShortPacketPayload::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::ShortPacketPayload::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::ShortPacketPayload::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_quic::QUIC::UnhandledVersion::parse2(::hilti::rt::ValueReference<__hlt_quic::QUIC::UnhandledVersion>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_quic::QUIC::UnhandledVersion::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

