/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "/build/zeek/src/zeek/src/parse.y"

// See the file "COPYING" in the main distribution directory for copyright.
#line 84 "/build/zeek/src/zeek/src/parse.y"

#include <cstdlib>
#include <cstring>
#include <cassert>

#include <set>
#include <string>

#include "zeek/input.h"
#include "zeek/ZeekList.h"
#include "zeek/Desc.h"
#include "zeek/Expr.h"
#include "zeek/Func.h"
#include "zeek/Stmt.h"
#include "zeek/Val.h"
#include "zeek/Var.h"
#include "zeek/RE.h"
#include "zeek/Scope.h"
#include "zeek/Reporter.h"
#include "zeek/ScriptCoverageManager.h"
#include "zeek/ScriptValidation.h"
#include "zeek/zeekygen/Manager.h"
#include "zeek/module_util.h"
#include "zeek/IntrusivePtr.h"

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

extern int conditional_epoch; // let's us track embedded conditionals

// Whether the file we're currently parsing includes @if conditionals.
extern bool current_file_has_conditionals;

extern YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int zeeklex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

using namespace zeek;
using namespace zeek::detail;

// Part of the module facility: while parsing, keep track of which
// module to put things in.
std::string zeek::detail::current_module = GLOBAL_MODULE_NAME;

bool is_export = false; // true if in an export {} block

// Used to temporarily turn off "is_export". A stack because the need
// to do so can nest.
std::vector<bool> hold_is_export;

// When parsing an expression for the debugger, where to put the result
// (obviously not reentrant).
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

extern int in_when_cond;

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
static int in_record_redef = 0;
static int in_enum_redef = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;
static int expr_list_has_opt_comma = 0;

std::vector<std::set<const ID*>> locals_at_this_scope;
static std::unordered_set<const ID*> out_of_scope_locals;

static Location func_hdr_location;
static int func_hdr_cond_epoch = 0;
EnumType* cur_enum_type = nullptr;
static ID* cur_decl_type_id = nullptr;

static void parse_new_enum(void)
	{
	// Starting a new enum definition.
	assert(cur_enum_type == nullptr);

	if ( cur_decl_type_id )
		{
		auto name = make_full_var_name(current_module.c_str(), cur_decl_type_id->Name());
		cur_enum_type = new EnumType(name);
		}
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parse_redef_enum(ID* id)
	{
	// Redef an enum. id points to the enum to be redefined.
	// Let cur_enum_type point to it.
	assert(cur_enum_type == nullptr);

	// abort on errors; enums need to be accessible to continue parsing
	if ( ! id->GetType() )
		reporter->FatalError("unknown enum identifier \"%s\"", id->Name());
	else
		{
		if ( ! id->GetType() || id->GetType()->Tag() != TYPE_ENUM )
			reporter->FatalError("identifier \"%s\" is not an enum", id->Name());
		cur_enum_type = id->GetType()->AsEnumType();
		}
	}

static void parse_redef_record_field(ID* id, const char* field, InitClass ic,
                                     std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	if ( ! id->GetType() )
		{
		reporter->FatalError("unknown record identifier \"%s\"", id->Name());
		return;
		}

	auto t = id->GetType();
	if ( ! t || t->Tag() != TYPE_RECORD )
		{
		reporter->FatalError("identifier \"%s\" has type \"%s\", expected \"record\"",
		                     id->Name(), type_name(t->Tag()));
		return;
		}

	auto rt = t->AsRecordType();
	auto idx = rt->FieldOffset(field);
	if ( idx < 0 )
		{
		reporter->FatalError("field \"%s\" not in record \"%s\"", field, id->Name());
		return;
		}

	auto decl = rt->FieldDecl(idx);
	if ( ! decl->attrs )
		if ( ic == INIT_EXTRA )
			decl->attrs = make_intrusive<detail::Attributes>(decl->type,
			                                                 true /* in_record */,
			                                                 false /* is_global */);

	for ( const auto& attr : *attrs )
		{
		// At this point, only support &log redef'ing.
		if ( attr->Tag() != ATTR_LOG )
			{
				reporter->FatalError("Can only redef \"&log\" attributes of record fields");
				return;
			}

		if ( ic == INIT_EXTRA )
			decl->attrs->AddAttr(attr, true /* is_redef */);
		else
			// Removing attributes is a noop if they don't exist.
			if ( decl->attrs )
				decl->attrs->RemoveAttr(attr->Tag());
		}
	}

static void extend_record(ID* id, std::unique_ptr<type_decl_list> fields,
                          std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	const auto& types = Type::Aliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	bool add_log_attr = false;

	if ( attrs )
		for ( const auto& at : *attrs )
			if ( at->Tag() == ATTR_LOG )
				{
				add_log_attr = true;
				break;
				}

	for ( const auto& t : types )
		{
		auto error = t->AsRecordType()->AddFields(*fields, add_log_attr);

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static AttributesPtr
make_attributes(std::vector<AttrPtr>* attrs,
                TypePtr t, bool in_record, bool is_global)
	{
	if ( ! attrs )
		return nullptr;

	auto rval = make_intrusive<Attributes>(std::move(*attrs), std::move(t),
	                                       in_record, is_global);
	delete attrs;
	return rval;
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	const auto& type = expr->GetType();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->GetType()->IsTable();

	return false;
	}

static void check_loop_var(const IDPtr& var)
	{
	if ( var->IsGlobal() )
 		var->Error("global variable used in 'for' loop");

 	if ( var->IsConst() )
 		var->Error("constant used in 'for' loop");
	}

static void build_global(ID* id, Type* t, InitClass ic, Expr* e,
                         std::vector<AttrPtr>* attrs, DeclType dt)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	add_global(id_ptr, std::move(t_ptr), ic, e_ptr, std::move(attrs_ptr), dt);

	if ( dt == VAR_REDEF )
		zeekygen_mgr->Redef(id, ::filename, ic, std::move(e_ptr));
	else
		zeekygen_mgr->Identifier(std::move(id_ptr));
	}

static StmtPtr build_local(ID* id, Type* t, InitClass ic, Expr* e,
                           std::vector<AttrPtr>* attrs, DeclType dt,
                           bool do_coverage)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	auto init = add_local(std::move(id_ptr), std::move(t_ptr), ic,
	                      e_ptr, std::move(attrs_ptr), dt);

	if ( do_coverage )
		script_coverage_mgr.AddStmt(init.get());

	return init;
	}

static void refine_location(zeek::detail::ID* id)
	{
	if ( *id->GetLocationInfo() == zeek::detail::no_location )
		id->SetLocationInfo(&detail::start_location, &detail::end_location);
	}


#line 351 "/build/zeek/src/zeek/build/src/p.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "zeekparse.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ADD = 3,                    /* TOK_ADD  */
  YYSYMBOL_TOK_ADD_TO = 4,                 /* TOK_ADD_TO  */
  YYSYMBOL_TOK_ADDR = 5,                   /* TOK_ADDR  */
  YYSYMBOL_TOK_ANY = 6,                    /* TOK_ANY  */
  YYSYMBOL_TOK_ASSERT = 7,                 /* TOK_ASSERT  */
  YYSYMBOL_TOK_ATENDIF = 8,                /* TOK_ATENDIF  */
  YYSYMBOL_TOK_ATELSE = 9,                 /* TOK_ATELSE  */
  YYSYMBOL_TOK_ATIF = 10,                  /* TOK_ATIF  */
  YYSYMBOL_TOK_ATIFDEF = 11,               /* TOK_ATIFDEF  */
  YYSYMBOL_TOK_ATIFNDEF = 12,              /* TOK_ATIFNDEF  */
  YYSYMBOL_TOK_BOOL = 13,                  /* TOK_BOOL  */
  YYSYMBOL_TOK_BREAK = 14,                 /* TOK_BREAK  */
  YYSYMBOL_TOK_CASE = 15,                  /* TOK_CASE  */
  YYSYMBOL_TOK_OPTION = 16,                /* TOK_OPTION  */
  YYSYMBOL_TOK_CONST = 17,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CONSTANT = 18,              /* TOK_CONSTANT  */
  YYSYMBOL_TOK_COPY = 19,                  /* TOK_COPY  */
  YYSYMBOL_TOK_COUNT = 20,                 /* TOK_COUNT  */
  YYSYMBOL_TOK_DEFAULT = 21,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_DELETE = 22,                /* TOK_DELETE  */
  YYSYMBOL_TOK_DOUBLE = 23,                /* TOK_DOUBLE  */
  YYSYMBOL_TOK_ELSE = 24,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_ENUM = 25,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_EVENT = 26,                 /* TOK_EVENT  */
  YYSYMBOL_TOK_EXPORT = 27,                /* TOK_EXPORT  */
  YYSYMBOL_TOK_FALLTHROUGH = 28,           /* TOK_FALLTHROUGH  */
  YYSYMBOL_TOK_FILE = 29,                  /* TOK_FILE  */
  YYSYMBOL_TOK_FOR = 30,                   /* TOK_FOR  */
  YYSYMBOL_TOK_FUNCTION = 31,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_GLOBAL = 32,                /* TOK_GLOBAL  */
  YYSYMBOL_TOK_HOOK = 33,                  /* TOK_HOOK  */
  YYSYMBOL_TOK_ID = 34,                    /* TOK_ID  */
  YYSYMBOL_TOK_IF = 35,                    /* TOK_IF  */
  YYSYMBOL_TOK_INT = 36,                   /* TOK_INT  */
  YYSYMBOL_TOK_INTERVAL = 37,              /* TOK_INTERVAL  */
  YYSYMBOL_TOK_LIST = 38,                  /* TOK_LIST  */
  YYSYMBOL_TOK_MODULE = 39,                /* TOK_MODULE  */
  YYSYMBOL_TOK_LOCAL = 40,                 /* TOK_LOCAL  */
  YYSYMBOL_TOK_WHEN_LOCAL = 41,            /* TOK_WHEN_LOCAL  */
  YYSYMBOL_TOK_NEXT = 42,                  /* TOK_NEXT  */
  YYSYMBOL_TOK_OF = 43,                    /* TOK_OF  */
  YYSYMBOL_TOK_OPAQUE = 44,                /* TOK_OPAQUE  */
  YYSYMBOL_TOK_PATTERN = 45,               /* TOK_PATTERN  */
  YYSYMBOL_TOK_PATTERN_END = 46,           /* TOK_PATTERN_END  */
  YYSYMBOL_TOK_PATTERN_TEXT = 47,          /* TOK_PATTERN_TEXT  */
  YYSYMBOL_TOK_PORT = 48,                  /* TOK_PORT  */
  YYSYMBOL_TOK_PRINT = 49,                 /* TOK_PRINT  */
  YYSYMBOL_TOK_RECORD = 50,                /* TOK_RECORD  */
  YYSYMBOL_TOK_REDEF = 51,                 /* TOK_REDEF  */
  YYSYMBOL_TOK_REMOVE_FROM = 52,           /* TOK_REMOVE_FROM  */
  YYSYMBOL_TOK_RETURN = 53,                /* TOK_RETURN  */
  YYSYMBOL_TOK_SCHEDULE = 54,              /* TOK_SCHEDULE  */
  YYSYMBOL_TOK_SET = 55,                   /* TOK_SET  */
  YYSYMBOL_TOK_STRING = 56,                /* TOK_STRING  */
  YYSYMBOL_TOK_SUBNET = 57,                /* TOK_SUBNET  */
  YYSYMBOL_TOK_SWITCH = 58,                /* TOK_SWITCH  */
  YYSYMBOL_TOK_TABLE = 59,                 /* TOK_TABLE  */
  YYSYMBOL_TOK_TIME = 60,                  /* TOK_TIME  */
  YYSYMBOL_TOK_TIMEOUT = 61,               /* TOK_TIMEOUT  */
  YYSYMBOL_TOK_TYPE = 62,                  /* TOK_TYPE  */
  YYSYMBOL_TOK_VECTOR = 63,                /* TOK_VECTOR  */
  YYSYMBOL_TOK_WHEN = 64,                  /* TOK_WHEN  */
  YYSYMBOL_TOK_WHILE = 65,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_AS = 66,                    /* TOK_AS  */
  YYSYMBOL_TOK_IS = 67,                    /* TOK_IS  */
  YYSYMBOL_TOK_GLOBAL_ID = 68,             /* TOK_GLOBAL_ID  */
  YYSYMBOL_TOK_ATTR_ADD_FUNC = 69,         /* TOK_ATTR_ADD_FUNC  */
  YYSYMBOL_TOK_ATTR_DEFAULT = 70,          /* TOK_ATTR_DEFAULT  */
  YYSYMBOL_TOK_ATTR_DEFAULT_INSERT = 71,   /* TOK_ATTR_DEFAULT_INSERT  */
  YYSYMBOL_TOK_ATTR_OPTIONAL = 72,         /* TOK_ATTR_OPTIONAL  */
  YYSYMBOL_TOK_ATTR_REDEF = 73,            /* TOK_ATTR_REDEF  */
  YYSYMBOL_TOK_ATTR_DEL_FUNC = 74,         /* TOK_ATTR_DEL_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_FUNC = 75,      /* TOK_ATTR_EXPIRE_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_CREATE = 76,    /* TOK_ATTR_EXPIRE_CREATE  */
  YYSYMBOL_TOK_ATTR_EXPIRE_READ = 77,      /* TOK_ATTR_EXPIRE_READ  */
  YYSYMBOL_TOK_ATTR_EXPIRE_WRITE = 78,     /* TOK_ATTR_EXPIRE_WRITE  */
  YYSYMBOL_TOK_ATTR_RAW_OUTPUT = 79,       /* TOK_ATTR_RAW_OUTPUT  */
  YYSYMBOL_TOK_ATTR_ON_CHANGE = 80,        /* TOK_ATTR_ON_CHANGE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE = 81,     /* TOK_ATTR_BROKER_STORE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX = 82, /* TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
  YYSYMBOL_TOK_ATTR_BACKEND = 83,          /* TOK_ATTR_BACKEND  */
  YYSYMBOL_TOK_ATTR_PRIORITY = 84,         /* TOK_ATTR_PRIORITY  */
  YYSYMBOL_TOK_ATTR_LOG = 85,              /* TOK_ATTR_LOG  */
  YYSYMBOL_TOK_ATTR_ERROR_HANDLER = 86,    /* TOK_ATTR_ERROR_HANDLER  */
  YYSYMBOL_TOK_ATTR_GROUP = 87,            /* TOK_ATTR_GROUP  */
  YYSYMBOL_TOK_ATTR_TYPE_COLUMN = 88,      /* TOK_ATTR_TYPE_COLUMN  */
  YYSYMBOL_TOK_ATTR_DEPRECATED = 89,       /* TOK_ATTR_DEPRECATED  */
  YYSYMBOL_TOK_ATTR_IS_ASSIGNED = 90,      /* TOK_ATTR_IS_ASSIGNED  */
  YYSYMBOL_TOK_ATTR_IS_USED = 91,          /* TOK_ATTR_IS_USED  */
  YYSYMBOL_TOK_ATTR_ORDERED = 92,          /* TOK_ATTR_ORDERED  */
  YYSYMBOL_TOK_DEBUG = 93,                 /* TOK_DEBUG  */
  YYSYMBOL_TOK_NO_TEST = 94,               /* TOK_NO_TEST  */
  YYSYMBOL_95_ = 95,                       /* ','  */
  YYSYMBOL_96_ = 96,                       /* '='  */
  YYSYMBOL_97_ = 97,                       /* '?'  */
  YYSYMBOL_98_ = 98,                       /* ':'  */
  YYSYMBOL_TOK_OR_OR = 99,                 /* TOK_OR_OR  */
  YYSYMBOL_TOK_AND_AND = 100,              /* TOK_AND_AND  */
  YYSYMBOL_101_ = 101,                     /* '<'  */
  YYSYMBOL_102_ = 102,                     /* '>'  */
  YYSYMBOL_TOK_LE = 103,                   /* TOK_LE  */
  YYSYMBOL_TOK_GE = 104,                   /* TOK_GE  */
  YYSYMBOL_TOK_EQ = 105,                   /* TOK_EQ  */
  YYSYMBOL_TOK_NE = 106,                   /* TOK_NE  */
  YYSYMBOL_TOK_IN = 107,                   /* TOK_IN  */
  YYSYMBOL_TOK_NOT_IN = 108,               /* TOK_NOT_IN  */
  YYSYMBOL_109_ = 109,                     /* '|'  */
  YYSYMBOL_110_ = 110,                     /* '^'  */
  YYSYMBOL_111_ = 111,                     /* '&'  */
  YYSYMBOL_TOK_LSHIFT = 112,               /* TOK_LSHIFT  */
  YYSYMBOL_TOK_RSHIFT = 113,               /* TOK_RSHIFT  */
  YYSYMBOL_114_ = 114,                     /* '+'  */
  YYSYMBOL_115_ = 115,                     /* '-'  */
  YYSYMBOL_116_ = 116,                     /* '*'  */
  YYSYMBOL_117_ = 117,                     /* '/'  */
  YYSYMBOL_118_ = 118,                     /* '%'  */
  YYSYMBOL_TOK_INCR = 119,                 /* TOK_INCR  */
  YYSYMBOL_TOK_DECR = 120,                 /* TOK_DECR  */
  YYSYMBOL_121_ = 121,                     /* '!'  */
  YYSYMBOL_122_ = 122,                     /* '~'  */
  YYSYMBOL_123_ = 123,                     /* '$'  */
  YYSYMBOL_124_ = 124,                     /* '['  */
  YYSYMBOL_125_ = 125,                     /* ']'  */
  YYSYMBOL_126_ = 126,                     /* '('  */
  YYSYMBOL_127_ = 127,                     /* ')'  */
  YYSYMBOL_TOK_HAS_FIELD = 128,            /* TOK_HAS_FIELD  */
  YYSYMBOL_TOK_HAS_ATTR = 129,             /* TOK_HAS_ATTR  */
  YYSYMBOL_130_ = 130,                     /* '{'  */
  YYSYMBOL_131_ = 131,                     /* '}'  */
  YYSYMBOL_132_ = 132,                     /* ';'  */
  YYSYMBOL_YYACCEPT = 133,                 /* $accept  */
  YYSYMBOL_zeek = 134,                     /* zeek  */
  YYSYMBOL_135_1 = 135,                    /* $@1  */
  YYSYMBOL_136_2 = 136,                    /* $@2  */
  YYSYMBOL_decl_list = 137,                /* decl_list  */
  YYSYMBOL_opt_expr = 138,                 /* opt_expr  */
  YYSYMBOL_when_clause = 139,              /* when_clause  */
  YYSYMBOL_when_head = 140,                /* when_head  */
  YYSYMBOL_when_start = 141,               /* when_start  */
  YYSYMBOL_when_flavor = 142,              /* when_flavor  */
  YYSYMBOL_when_captures = 143,            /* when_captures  */
  YYSYMBOL_when_condition = 144,           /* when_condition  */
  YYSYMBOL_145_3 = 145,                    /* $@3  */
  YYSYMBOL_146_4 = 146,                    /* $@4  */
  YYSYMBOL_expr = 147,                     /* expr  */
  YYSYMBOL_148_5 = 148,                    /* $@5  */
  YYSYMBOL_149_6 = 149,                    /* $@6  */
  YYSYMBOL_150_7 = 150,                    /* $@7  */
  YYSYMBOL_151_8 = 151,                    /* $@8  */
  YYSYMBOL_152_9 = 152,                    /* $@9  */
  YYSYMBOL_153_10 = 153,                   /* $@10  */
  YYSYMBOL_154_11 = 154,                   /* $@11  */
  YYSYMBOL_155_12 = 155,                   /* $@12  */
  YYSYMBOL_rhs = 156,                      /* rhs  */
  YYSYMBOL_157_13 = 157,                   /* $@13  */
  YYSYMBOL_rhs_expr_list = 158,            /* rhs_expr_list  */
  YYSYMBOL_expr_list = 159,                /* expr_list  */
  YYSYMBOL_opt_expr_list = 160,            /* opt_expr_list  */
  YYSYMBOL_enum_body = 161,                /* enum_body  */
  YYSYMBOL_enum_body_list = 162,           /* enum_body_list  */
  YYSYMBOL_enum_body_elem = 163,           /* enum_body_elem  */
  YYSYMBOL_type = 164,                     /* type  */
  YYSYMBOL_165_14 = 165,                   /* $@14  */
  YYSYMBOL_166_15 = 166,                   /* $@15  */
  YYSYMBOL_167_16 = 167,                   /* $@16  */
  YYSYMBOL_type_list = 168,                /* type_list  */
  YYSYMBOL_type_decl_list = 169,           /* type_decl_list  */
  YYSYMBOL_type_decl = 170,                /* type_decl  */
  YYSYMBOL_formal_args = 171,              /* formal_args  */
  YYSYMBOL_formal_args_decl_list = 172,    /* formal_args_decl_list  */
  YYSYMBOL_formal_args_decl = 173,         /* formal_args_decl  */
  YYSYMBOL_decl = 174,                     /* decl  */
  YYSYMBOL_175_17 = 175,                   /* $@17  */
  YYSYMBOL_176_18 = 176,                   /* $@18  */
  YYSYMBOL_177_19 = 177,                   /* $@19  */
  YYSYMBOL_178_20 = 178,                   /* $@20  */
  YYSYMBOL_179_21 = 179,                   /* $@21  */
  YYSYMBOL_180_22 = 180,                   /* $@22  */
  YYSYMBOL_181_23 = 181,                   /* $@23  */
  YYSYMBOL_182_24 = 182,                   /* $@24  */
  YYSYMBOL_183_25 = 183,                   /* $@25  */
  YYSYMBOL_184_26 = 184,                   /* $@26  */
  YYSYMBOL_conditional_list = 185,         /* conditional_list  */
  YYSYMBOL_conditional = 186,              /* conditional  */
  YYSYMBOL_func_hdr = 187,                 /* func_hdr  */
  YYSYMBOL_func_body = 188,                /* func_body  */
  YYSYMBOL_189_27 = 189,                   /* $@27  */
  YYSYMBOL_190_28 = 190,                   /* $@28  */
  YYSYMBOL_lambda_body = 191,              /* lambda_body  */
  YYSYMBOL_192_29 = 192,                   /* $@29  */
  YYSYMBOL_193_30 = 193,                   /* $@30  */
  YYSYMBOL_anonymous_function = 194,       /* anonymous_function  */
  YYSYMBOL_195_31 = 195,                   /* $@31  */
  YYSYMBOL_begin_lambda = 196,             /* begin_lambda  */
  YYSYMBOL_opt_captures = 197,             /* opt_captures  */
  YYSYMBOL_capture_list = 198,             /* capture_list  */
  YYSYMBOL_capture = 199,                  /* capture  */
  YYSYMBOL_opt_deep = 200,                 /* opt_deep  */
  YYSYMBOL_func_params = 201,              /* func_params  */
  YYSYMBOL_opt_type = 202,                 /* opt_type  */
  YYSYMBOL_init_class = 203,               /* init_class  */
  YYSYMBOL_opt_init = 204,                 /* opt_init  */
  YYSYMBOL_205_32 = 205,                   /* $@32  */
  YYSYMBOL_206_33 = 206,                   /* $@33  */
  YYSYMBOL_index_slice = 207,              /* index_slice  */
  YYSYMBOL_opt_attr = 208,                 /* opt_attr  */
  YYSYMBOL_attr_list = 209,                /* attr_list  */
  YYSYMBOL_attr = 210,                     /* attr  */
  YYSYMBOL_stmt = 211,                     /* stmt  */
  YYSYMBOL_212_34 = 212,                   /* $@34  */
  YYSYMBOL_stmt_list = 213,                /* stmt_list  */
  YYSYMBOL_event = 214,                    /* event  */
  YYSYMBOL_case_list = 215,                /* case_list  */
  YYSYMBOL_case = 216,                     /* case  */
  YYSYMBOL_case_type_list = 217,           /* case_type_list  */
  YYSYMBOL_case_type = 218,                /* case_type  */
  YYSYMBOL_for_head = 219,                 /* for_head  */
  YYSYMBOL_local_id_list = 220,            /* local_id_list  */
  YYSYMBOL_local_id = 221,                 /* local_id  */
  YYSYMBOL_global_id = 222,                /* global_id  */
  YYSYMBOL_223_35 = 223,                   /* $@35  */
  YYSYMBOL_def_global_id = 224,            /* def_global_id  */
  YYSYMBOL_225_36 = 225,                   /* $@36  */
  YYSYMBOL_226_37 = 226,                   /* $@37  */
  YYSYMBOL_event_id = 227,                 /* event_id  */
  YYSYMBOL_228_38 = 228,                   /* $@38  */
  YYSYMBOL_global_or_event_id = 229,       /* global_or_event_id  */
  YYSYMBOL_resolve_id = 230,               /* resolve_id  */
  YYSYMBOL_lookup_identifier = 231,        /* lookup_identifier  */
  YYSYMBOL_opt_assert_msg = 232,           /* opt_assert_msg  */
  YYSYMBOL_opt_no_test = 233,              /* opt_no_test  */
  YYSYMBOL_opt_no_test_block = 234,        /* opt_no_test_block  */
  YYSYMBOL_opt_deprecated = 235,           /* opt_deprecated  */
  YYSYMBOL_expr_list_opt_comma = 236       /* expr_list_opt_comma  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3393

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  133
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  297
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  787

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   363


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by zeeklex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by zeeklex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,     2,   123,   118,   111,     2,
     126,   127,   116,   114,    95,   115,     2,   117,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    98,   132,
     101,    96,   102,    97,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   124,     2,   125,   110,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   130,   109,   131,   122,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      99,   100,   103,   104,   105,   106,   107,   108,   112,   113,
     119,   120,   128,   129
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   398,   398,   397,   427,   427,   434,   435,   439,   442,
     446,   454,   458,   466,   472,   480,   483,   488,   490,   494,
     494,   494,   499,   505,   511,   517,   523,   529,   535,   541,
     547,   583,   589,   595,   619,   625,   646,   652,   661,   667,
     673,   679,   685,   691,   697,   703,   709,   715,   721,   727,
     733,   739,   745,   752,   751,   772,   781,   790,   792,   798,
     805,   804,   814,   820,   828,   854,   860,   860,   860,   868,
     875,   882,   888,   881,   931,   931,   944,   950,   952,   958,
    1023,  1029,  1029,  1046,  1053,  1059,  1066,  1066,  1071,  1074,
    1076,  1080,  1086,  1095,  1097,  1101,  1107,  1115,  1117,  1126,
    1139,  1147,  1157,  1162,  1167,  1172,  1177,  1182,  1187,  1192,
    1197,  1202,  1207,  1212,  1217,  1223,  1230,  1232,  1229,  1239,
    1239,  1246,  1254,  1262,  1268,  1274,  1280,  1286,  1292,  1298,
    1304,  1324,  1326,  1334,  1339,  1345,  1358,  1360,  1363,  1367,
    1369,  1371,  1376,  1385,  1392,  1392,  1395,  1400,  1408,  1413,
    1413,  1432,  1431,  1440,  1439,  1447,  1446,  1454,  1456,  1458,
    1453,  1471,  1470,  1482,  1481,  1488,  1491,  1492,  1496,  1498,
    1500,  1502,  1504,  1509,  1518,  1525,  1534,  1545,  1554,  1544,
    1574,  1580,  1573,  1607,  1606,  1627,  1646,  1649,  1653,  1658,
    1667,  1691,  1694,  1698,  1700,  1705,  1708,  1712,  1713,  1714,
    1715,  1719,  1719,  1719,  1722,  1726,  1750,  1752,  1756,  1758,
    1766,  1768,  1770,  1772,  1774,  1776,  1778,  1780,  1782,  1784,
    1786,  1788,  1790,  1792,  1794,  1796,  1798,  1800,  1802,  1804,
    1806,  1808,  1810,  1812,  1828,  1834,  1833,  1850,  1855,  1863,
    1871,  1879,  1888,  1895,  1902,  1909,  1917,  1925,  1933,  1941,
    1949,  1957,  1964,  1971,  1981,  1989,  1996,  2001,  2008,  2012,
    2038,  2041,  2045,  2048,  2051,  2056,  2059,  2067,  2073,  2090,
    2114,  2119,  2146,  2164,  2166,  2174,  2200,  2200,  2205,  2205,
    2205,  2210,  2210,  2215,  2254,  2268,  2270,  2282,  2285,  2289,
    2292,  2296,  2299,  2303,  2306,  2320,  2323,  2324
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ADD",
  "TOK_ADD_TO", "TOK_ADDR", "TOK_ANY", "TOK_ASSERT", "TOK_ATENDIF",
  "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF", "TOK_ATIFNDEF", "TOK_BOOL",
  "TOK_BREAK", "TOK_CASE", "TOK_OPTION", "TOK_CONST", "TOK_CONSTANT",
  "TOK_COPY", "TOK_COUNT", "TOK_DEFAULT", "TOK_DELETE", "TOK_DOUBLE",
  "TOK_ELSE", "TOK_ENUM", "TOK_EVENT", "TOK_EXPORT", "TOK_FALLTHROUGH",
  "TOK_FILE", "TOK_FOR", "TOK_FUNCTION", "TOK_GLOBAL", "TOK_HOOK",
  "TOK_ID", "TOK_IF", "TOK_INT", "TOK_INTERVAL", "TOK_LIST", "TOK_MODULE",
  "TOK_LOCAL", "TOK_WHEN_LOCAL", "TOK_NEXT", "TOK_OF", "TOK_OPAQUE",
  "TOK_PATTERN", "TOK_PATTERN_END", "TOK_PATTERN_TEXT", "TOK_PORT",
  "TOK_PRINT", "TOK_RECORD", "TOK_REDEF", "TOK_REMOVE_FROM", "TOK_RETURN",
  "TOK_SCHEDULE", "TOK_SET", "TOK_STRING", "TOK_SUBNET", "TOK_SWITCH",
  "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT", "TOK_TYPE", "TOK_VECTOR",
  "TOK_WHEN", "TOK_WHILE", "TOK_AS", "TOK_IS", "TOK_GLOBAL_ID",
  "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT", "TOK_ATTR_DEFAULT_INSERT",
  "TOK_ATTR_OPTIONAL", "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC",
  "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_ON_CHANGE",
  "TOK_ATTR_BROKER_STORE", "TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX",
  "TOK_ATTR_BACKEND", "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG",
  "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_GROUP", "TOK_ATTR_TYPE_COLUMN",
  "TOK_ATTR_DEPRECATED", "TOK_ATTR_IS_ASSIGNED", "TOK_ATTR_IS_USED",
  "TOK_ATTR_ORDERED", "TOK_DEBUG", "TOK_NO_TEST", "','", "'='", "'?'",
  "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'", "TOK_LE", "TOK_GE",
  "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'", "'^'", "'&'",
  "TOK_LSHIFT", "TOK_RSHIFT", "'+'", "'-'", "'*'", "'/'", "'%'",
  "TOK_INCR", "TOK_DECR", "'!'", "'~'", "'$'", "'['", "']'", "'('", "')'",
  "TOK_HAS_FIELD", "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "zeek",
  "$@1", "$@2", "decl_list", "opt_expr", "when_clause", "when_head",
  "when_start", "when_flavor", "when_captures", "when_condition", "$@3",
  "$@4", "expr", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "rhs", "$@13", "rhs_expr_list", "expr_list", "opt_expr_list",
  "enum_body", "enum_body_list", "enum_body_elem", "type", "$@14", "$@15",
  "$@16", "type_list", "type_decl_list", "type_decl", "formal_args",
  "formal_args_decl_list", "formal_args_decl", "decl", "$@17", "$@18",
  "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "$@25", "$@26",
  "conditional_list", "conditional", "func_hdr", "func_body", "$@27",
  "$@28", "lambda_body", "$@29", "$@30", "anonymous_function", "$@31",
  "begin_lambda", "opt_captures", "capture_list", "capture", "opt_deep",
  "func_params", "opt_type", "init_class", "opt_init", "$@32", "$@33",
  "index_slice", "opt_attr", "attr_list", "attr", "stmt", "$@34",
  "stmt_list", "event", "case_list", "case", "case_type_list", "case_type",
  "for_head", "local_id_list", "local_id", "global_id", "$@35",
  "def_global_id", "$@36", "$@37", "event_id", "$@38",
  "global_or_event_id", "resolve_id", "lookup_identifier",
  "opt_assert_msg", "opt_no_test", "opt_no_test_block", "opt_deprecated",
  "expr_list_opt_comma", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-550)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-205)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -17,  -550,    52,  3331,  2663,  -550,  -550,  -550,   -33,    13,
      21,  -550,  -550,  -550,   -35,  -550,  -550,  -550,   126,   119,
    -550,  -550,  -550,  -550,  -550,  2663,  -550,    27,  2663,  -550,
    -550,  -550,   144,    55,  2663,    62,    64,    65,  -550,  2663,
    2663,  2663,  -550,  2663,  2663,  2663,  2663,   148,  2663,  2663,
    2374,  -550,  -550,  -550,  2663,   158,   159,    51,  -550,    51,
      77,    23,  -550,    77,    51,    77,    72,  -550,  -550,  -550,
    -550,    23,   107,  1045,  -550,  2374,  2663,  2374,    82,  2663,
    -550,   111,  2663,  1302,  2663,  -550,  2663,  2441,   283,   283,
     162,   283,   283,   283,   283,    31,  2374,   131,    85,  1503,
    1160,  1160,  2899,  2899,  -550,  2757,  2663,  2663,  2663,  2663,
    2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,
    2663,  2663,  2663,  2663,  2663,  2663,   187,  2757,  -550,   194,
    1570,   105,   110,  2899,    88,  -550,    88,   204,  1640,  -550,
    -550,  -550,  1640,    88,  1640,  -550,   235,    77,   120,    51,
    -550,  -550,  2663,   112,   144,    23,   113,   121,   123,   144,
     124,  2663,   481,  2663,  -550,   127,  -550,  -550,  -550,   197,
    1045,    46,   899,  -550,   165,  -550,  1045,    50,  1637,   236,
    -550,    77,  3101,  1160,   -79,    23,   141,  2663,   142,  2796,
     225,  2663,   177,  2663,  -550,  -550,  -550,  -550,  2374,  -550,
    -550,  -550,  -550,  -550,  -550,  -550,   145,   151,   231,    77,
     152,  -550,  -550,   237,   238,  -550,  -550,   153,   160,  -550,
    -550,   161,  -550,   239,  -550,  -550,  -550,  -550,  1160,  1704,
    2995,  3101,  3129,  3129,  3129,  3129,  3129,  3129,   623,   623,
    2641,  1397,   277,   365,   365,   185,   185,   283,   283,   283,
    -550,   189,  1771,   -70,  2663,  -550,  -550,  -550,  -550,  -550,
    -550,  -550,  -550,   807,  -550,   807,   190,   163,   -69,  -550,
     193,   195,   196,  -550,  -550,   198,   208,   209,   216,   218,
    -550,   219,   220,  -550,   221,   223,  -550,  -550,   227,   228,
     230,  -550,  -550,  -550,  -550,  1640,  -550,   203,  -550,   807,
    -550,   156,  1640,   259,   295,    88,  2899,  1838,   233,    51,
     199,   206,   233,     9,  2663,    51,   233,   -62,  -550,   233,
    1025,  1369,  2663,   243,  2663,  -550,    47,  -550,   233,  2663,
    -550,  -550,  -550,  -550,  -550,  -550,   -41,  -550,   287,    78,
    -550,  -550,  2663,  -550,   202,  1640,   213,  -550,  -550,  2374,
    -550,  2374,  2663,  -550,   204,  2899,  -550,   204,  2899,   308,
    -550,  2899,  2899,  2899,  -550,  2663,  2663,  -550,  -550,  1640,
    1160,  1640,  2899,   253,   204,   204,  2663,  2663,  2663,  2663,
    2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,
     311,  -550,  -550,  1640,  -550,  -550,   304,   234,   807,  1640,
    2663,   226,  -550,  -550,    88,   233,  2663,  -550,    34,   144,
    1905,    88,  -550,   233,  -550,   233,  -550,  1972,  -550,  -550,
    1436,   240,   264,   270,  2663,  -550,  1140,  -550,   236,  -550,
    -550,  -550,  -550,  -550,  -550,  -550,   268,   232,   131,   326,
     272,  -550,   281,  -550,  -550,  -550,  -550,   -31,   -27,  -550,
    2913,   245,  2374,   285,   286,  -550,   297,  1640,  2899,  -550,
    -550,  2374,  2374,  2374,  2374,  2374,  2374,  2374,  2374,  2374,
    2374,  2374,  2374,  2374,  2374,  -550,   303,   326,   400,   361,
    -550,  1640,   305,  2374,  -550,   807,  -550,   288,   383,  2663,
     -26,  -550,  1045,   807,  -550,  -550,     7,  1045,   793,   243,
     301,  -550,  2374,   233,  1045,  -550,  -550,  1640,  -550,  -550,
    -550,   -77,   307,   339,  -550,  -550,  -550,   309,  2899,  -550,
     396,  -550,  -550,  -550,  -550,  -550,  -550,  -550,  -550,   310,
     312,   313,  -550,   315,  -550,  1640,  -550,   337,  2039,   144,
      36,   421,  1640,  2624,   350,  -550,  -550,  -550,  -550,  -550,
    -550,  -550,  -550,   318,  1045,  -550,   354,    11,  -550,  -550,
     326,   322,   188,  -550,  2899,   323,  1640,  1640,   325,  -550,
     327,  2663,  -550,  -550,   420,  2663,  1045,   328,  2940,    56,
      76,  -550,  -550,   919,   330,  -550,   331,   443,   374,   448,
    -550,  -550,   370,  -550,  -550,  -550,  2507,  3055,   338,   233,
    2106,   367,  2173,  -550,   233,   406,  -550,   413,  -550,  1045,
    -550,  -550,  -550,  -550,  -550,  -550,  2899,   344,   345,  1640,
    -550,  -550,  2663,  -550,  -550,   452,  1045,  -550,  1045,  1640,
    -550,  -550,   360,  2240,  -550,   362,  -550,  -550,  -550,  2757,
    2757,  -550,   144,   369,   371,  2757,  2757,  2757,  2757,  2757,
    2757,   462,  1270,  1270,  2940,  2940,  -550,  2757,  2757,  2757,
    2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,
    2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,  2508,   455,
     375,   459,   380,   463,  2757,  2508,  2508,  2757,   409,  2663,
    -550,   302,   302,   302,   302,   302,   302,    38,  2508,  1270,
    2307,  3048,  3182,  3210,  3210,  3210,  3210,  3210,  3210,  1232,
    1232,  2774,  1464,  1530,   460,   460,   229,   229,   302,   302,
     302,  2940,   204,  2940,  2899,  2940,  2508,  3182,  1270,   382,
    2663,  2757,  2757,   384,    41,  1707,   386,  2508,  2966,  -550,
     464,   414,   422,   424,   425,   427,   428,   429,   432,   433,
     436,   437,   438,   442,   445,  1707,  -550,  2940,  2757,  2757,
    2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,  2757,
    2757,  2757,  1707,  2508,  2508,  2508,  2508,  2508,  2508,  2508,
    2508,  2508,  2508,  2508,  2508,  2508,  2508
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       7,     4,     0,     2,     0,     1,   171,   172,     0,     0,
       0,   278,   278,   281,     0,   278,   278,   278,     0,   276,
     278,   258,     6,   165,   163,     0,    80,     0,     0,   183,
      74,   285,     0,     0,     0,     0,     0,     0,   286,     0,
       0,     0,    81,     0,     0,     0,     0,     0,    94,     0,
       5,    77,    57,    79,     0,     0,     0,   196,   276,   196,
       0,     0,   144,     0,   196,     0,     0,   276,   281,   276,
     149,     0,     0,     3,   166,    24,     0,    25,   187,     0,
     275,     0,     0,     0,    94,    66,    94,     0,    31,    30,
       0,    26,    27,    28,    29,   187,    92,   297,     0,     0,
       0,     0,     0,     0,    53,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    71,     0,
       0,     0,     0,     0,   197,   279,   197,   138,   207,   282,
     283,     7,   207,   197,   207,   143,     0,     0,   157,   196,
     277,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,     0,   235,   255,   252,    11,
       0,     0,     0,   256,    57,   257,     0,     0,     0,   192,
     166,     0,    75,     0,     0,     0,     0,    94,     0,    83,
       0,     0,     0,   296,    93,    64,    22,    86,    88,    33,
      35,   111,   113,   102,   104,   105,     0,     0,   128,     0,
       0,   103,   107,   121,     0,   109,   110,     0,     0,   108,
     112,     0,   106,     0,    84,   130,   284,    85,     0,     0,
      45,    44,    48,    50,    49,    51,    46,    47,    62,    63,
      40,    41,    39,    42,    43,    32,    34,    36,    37,    38,
      58,     0,    92,     0,    94,    76,   168,   169,   170,   195,
     199,   200,   198,   201,   280,   201,     0,     0,   136,   141,
       0,     0,     0,   212,   213,     0,     0,     0,     0,     0,
     226,     0,     0,   220,     0,     0,   230,   231,     0,     0,
     232,   214,   215,   234,   174,   206,   209,     0,   173,   201,
     175,     0,   207,     0,     0,   197,     0,   288,   290,   196,
       0,     0,   290,     0,     0,   196,   290,     0,    15,   290,
       0,     0,     0,   292,     0,    12,    18,    19,   290,     0,
     243,   177,   167,   164,    23,   191,     0,   189,     0,     0,
     185,    55,     0,    65,     0,   207,     0,    70,    82,    59,
      60,    91,    90,   119,   138,     0,   124,   138,     0,     0,
     116,     0,     0,     0,    54,     0,     9,    56,    72,   207,
       0,   207,     0,   194,     0,   137,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   145,   207,   151,   176,   153,     0,   201,   207,
       0,     0,   289,   246,   197,   290,    94,   247,     0,     0,
       0,   197,   245,   290,   248,   290,   261,     0,   291,   258,
       0,     0,    17,     0,     0,   254,     0,   258,   192,   186,
     190,   180,   184,    78,    69,    67,     0,     0,   297,     0,
       0,   127,     0,   122,   129,   134,   132,     0,     0,   123,
      52,     0,     8,     0,     0,   202,     0,   207,     0,   140,
     139,   216,   210,   211,   217,   222,   223,   224,   225,   218,
     219,   221,   227,   228,   229,   233,     0,     0,     0,     0,
     158,   207,     0,   287,   237,   201,   239,     0,     0,     0,
       0,   274,     0,   201,   238,   249,     0,     0,     0,   292,
       0,    14,    20,   290,   178,   188,   258,   207,    61,    87,
      89,   295,     0,    95,    97,   125,   126,   166,     0,   115,
       0,   205,    73,   147,   203,   148,   142,   193,   146,     0,
       0,     0,   134,     0,   162,   207,   259,     0,     0,     0,
       0,   240,   207,     0,     0,   242,   260,   244,   236,   258,
      19,    21,   253,     0,   181,    68,   293,     0,   101,   120,
      96,     0,     0,   131,     0,     0,     0,     0,   166,   150,
       0,     0,   269,   273,     0,     0,     0,     0,     0,     0,
       0,   266,   258,     0,     0,   179,     0,     0,   295,     0,
      98,   118,     0,   133,   114,   152,     0,     0,     0,   290,
       0,     0,     0,   241,   290,   267,   258,     0,   258,   264,
      10,    13,   182,   294,    99,   100,     0,     0,     0,   207,
     251,   271,     0,   270,   250,     0,   262,   265,   263,   207,
     154,   156,     0,     0,   268,     0,   160,   272,   135,     0,
       0,    74,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    92,   128,
       0,   121,     0,     0,     0,    24,    25,     0,     0,    94,
      66,    31,    30,    26,    27,    28,    29,   187,    88,     0,
       0,    45,    44,    48,    50,    49,    51,    46,    47,    62,
      63,    40,    41,    39,    42,    43,    32,    34,    36,    37,
      38,     0,   138,     0,     0,     0,    91,    75,     0,     0,
      94,     0,     0,     0,     0,   207,     0,    59,    52,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   206,    67,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   207,   216,   210,   211,   217,   222,   223,   224,
     225,   218,   219,   221,   227,   228,   229
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -550,  -550,  -550,  -550,   376,   150,  -550,  -550,  -550,  -550,
    -550,    -8,  -550,  -550,    -4,  -113,  -550,  -144,  -209,  -550,
    -550,   -91,  -550,  -100,  -550,  -550,   -76,   -52,    74,  -550,
      -6,   115,  -550,  -550,  -550,  -353,    20,  -550,  -334,  -550,
    -199,  -550,  -550,  -550,  -550,  -550,  -550,  -550,  -550,  -550,
    -550,  -550,   -43,     0,  -550,  -550,  -550,  -550,   125,  -550,
    -550,  -550,  -550,   477,  -550,   242,   128,  -550,    14,   -49,
    -132,  -252,  -550,  -550,   -46,   -71,  -549,  -290,  -162,  -550,
    -381,   372,  -550,  -550,  -550,   -48,  -550,  -550,  -152,    98,
    -550,   247,  -550,  -550,   492,  -550,   493,  -550,    61,  -550,
    -263,    66,   -22,   132
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,    21,     4,     3,   251,   168,   169,   170,   171,
     421,   423,   424,   551,   172,   228,   436,   187,   507,   254,
     453,    79,    90,   199,   352,   437,    97,    98,   512,   513,
     514,   446,   445,   561,   439,   447,   517,   593,   267,   268,
     269,    22,   141,   149,   477,   478,   479,   304,   532,   598,
     306,    74,   562,   173,    24,   333,   427,   553,   432,   506,
     586,    51,    78,   192,   181,   336,   337,   338,   356,   134,
     263,   369,   370,   524,    52,   434,   295,   296,   175,   323,
      73,   310,   496,   546,   580,   581,   176,   490,    81,    70,
      71,    57,    58,   264,    60,    61,   139,   225,    53,   401,
     403,   419,   558,   194
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      50,   200,   309,    23,   265,   391,   184,   315,   325,   448,
     136,   299,   556,   371,   330,   143,   342,   596,   597,   557,
     440,    75,   543,   442,    77,   342,   374,   174,   544,   588,
      83,   177,   186,   342,   188,    87,    88,    89,   498,    91,
      92,    93,    94,   408,    96,    99,   504,   393,   343,   407,
     130,   253,     5,   412,   428,   367,   414,    31,     6,     7,
       8,     9,    10,   375,   518,   425,   335,   294,   518,   539,
     413,   298,   178,   300,   138,   182,     1,   142,    96,   144,
      96,  -192,    96,   341,   429,   317,     6,     7,     8,     9,
      10,    38,   260,    54,   519,    62,   198,   198,   520,   540,
     305,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   140,   252,   174,   554,   589,   191,   364,   488,
     174,   574,   140,   409,   731,   346,   518,   339,   545,    55,
     261,   489,   486,   575,    67,    68,   481,    56,   307,   133,
     494,   684,   495,    76,   606,   179,   135,    96,   320,   321,
      66,   302,   179,   226,   226,   146,   740,   148,   583,    69,
     326,   607,   327,   398,   608,   459,   460,   332,    80,   198,
     331,    82,    95,    96,   262,   240,   755,   349,    84,   351,
      85,    86,   131,   132,   226,   340,     6,     7,     8,     9,
      10,   609,   368,   137,   145,   151,   179,   183,   431,   190,
     195,     6,     7,     8,     9,    10,   311,   224,   227,    11,
      12,   250,   592,   755,   198,   626,   193,   628,   255,    13,
      14,   395,   257,   535,    15,    16,    17,   258,   266,   301,
     552,   542,    18,   303,   308,   312,   311,   313,   259,   314,
      96,   102,   103,   322,    19,   335,   316,   491,   324,    59,
     404,   329,    63,    64,    65,    20,   411,    72,   345,   347,
     455,   348,   485,   350,   355,   353,   438,   354,   357,   493,
     358,   359,   363,   360,   361,   362,   394,   366,   372,   376,
     373,   377,   378,   396,   379,   654,   655,    23,   454,   397,
     456,   123,   124,   125,   380,   381,   391,   391,   126,   127,
     410,   128,   382,   129,   383,   384,   385,   386,   417,   387,
     420,   430,   476,   388,   389,   426,   390,   402,   482,   475,
     541,   405,   406,   433,   392,   547,   620,   418,   351,   332,
     435,   624,   444,   102,   103,   675,   676,   677,    96,   102,
     103,   458,   126,   127,   487,   128,  -155,   129,   484,   428,
     511,   450,   452,   509,   480,   500,   198,   226,   654,   655,
     521,   734,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   526,   573,   733,   119,
     120,   121,   122,   123,   124,   125,   483,   501,   431,   515,
     126,   127,    96,   128,   530,   129,   126,   127,   516,   128,
     533,   129,   522,   531,   603,   536,   226,   537,   523,   226,
     502,   399,   226,   226,   226,   126,   127,   550,   128,   525,
     129,   102,   103,   226,   560,   528,   555,   534,   559,   564,
    -117,   565,   566,   567,   571,   576,   174,   569,   582,   585,
     587,   174,   174,   591,   601,   595,  -159,   611,   174,   599,
     604,   613,   612,   556,   570,   391,   615,   579,   616,   619,
     441,   577,   625,   443,   622,   578,   630,   631,   449,   121,
     122,   123,   124,   125,    25,   538,   634,   457,   126,   127,
     688,   128,   636,   129,   638,   689,   697,   690,   721,    26,
      27,   722,   723,    28,   724,   728,   725,   757,   174,   735,
     758,   739,    29,   756,    30,    31,   451,   297,   759,   226,
     760,   761,    32,   762,   763,   764,   654,   655,   765,   766,
     174,    33,   767,   768,   769,    34,    35,   174,   770,   678,
      36,   771,   584,   699,    37,   318,   730,   772,   632,    38,
     687,   529,   568,   200,   590,   180,   505,   344,   635,   627,
     147,   508,   332,   174,   150,   549,   614,   600,   422,     0,
     510,   602,     0,   527,   673,   674,   675,   676,   677,   226,
     174,     0,   174,   126,   127,     0,   128,     0,   129,     0,
      39,     0,     0,     0,     0,    40,    41,     0,    42,   364,
      43,    44,    45,    46,    47,    48,     0,    49,     0,     0,
       0,     0,     0,   319,     0,     0,     0,     0,   633,     0,
       0,     0,     0,     0,     0,   226,     0,     0,   341,     0,
       0,     0,     0,   563,     0,   685,   686,   729,     0,   226,
       0,   691,   692,   693,   694,   695,   696,     0,   698,   698,
       0,     0,     0,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,     0,     0,     0,   226,   736,   594,
     726,     0,     0,   727,     0,    96,     0,     0,     0,   102,
     103,     0,     0,   605,     0,   698,     0,     0,     0,     0,
       0,   555,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   226,   226,     0,     0,     0,
       0,     0,     0,     0,   698,     0,    96,   737,   738,     0,
       0,   629,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,     0,     0,     0,     0,   126,   127,     0,   128,
       0,   129,     0,     0,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,     0,   224,
     227,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   226,     0,   226,   226,   226,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    25,     0,     0,     0,
     152,     6,     7,     8,     9,    10,     0,   153,     0,     0,
     154,    26,    27,     0,     0,    28,     0,     0,   226,   155,
       0,   156,     0,   157,    29,     0,    30,    31,   158,     0,
       0,     0,     0,   159,    32,   160,   441,     0,   443,     0,
     449,     0,   161,    33,     0,     0,   162,    34,    35,     0,
       0,   163,    36,     0,     0,     0,    37,   164,   165,     0,
       0,    38,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   594,     0,     0,     0,  -204,  -204,  -204,  -204,
    -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,
    -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,  -204,
       0,     0,    39,   100,     0,     0,     0,    40,    41,     0,
      42,     0,    43,    44,    45,    46,    47,    48,     0,    49,
       0,     0,    25,   166,   548,   167,   152,     6,     7,     8,
       9,    10,     0,   153,     0,     0,   154,    26,    27,  -204,
       0,    28,     0,     0,     0,   155,     0,   156,     0,   157,
      29,   101,    30,    31,   158,     0,     0,     0,     0,   159,
      32,   160,     0,     0,     0,   102,   103,     0,   161,    33,
       0,     0,   162,    34,    35,     0,     0,   163,    36,     0,
       0,     0,    37,   164,   165,     0,     0,    38,     0,     0,
       0,     0,     0,     0,     0,   104,   105,     0,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,     0,     0,
       0,     0,   126,   127,     0,   128,     0,   129,    39,   100,
       0,   328,     0,    40,    41,     0,    42,     0,    43,    44,
      45,    46,    47,    48,     0,    49,     0,     0,    25,   166,
     610,   167,   152,     6,     7,     8,     9,    10,     0,   153,
       0,     0,   154,    26,    27,     0,     0,    28,     0,     0,
       0,   155,     0,   156,     0,   157,    29,   101,    30,    31,
     158,     0,     0,     0,     0,   159,    32,   160,     0,     0,
       0,   102,   103,     0,   161,    33,     0,     0,   162,    34,
      35,     0,     0,   163,    36,     0,     0,     0,    37,   164,
     165,     0,     0,    38,     0,     0,     0,     0,     0,     0,
       0,   104,   105,     0,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   100,     0,     0,     0,   126,   127,
       0,   128,     0,   129,    39,     0,     0,   415,     0,    40,
      41,     0,    42,    25,    43,    44,    45,    46,    47,    48,
       0,    49,     0,     0,     0,   166,     0,   167,    26,    27,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,    29,   101,    30,    31,     0,     0,     0,     0,     0,
       0,    32,     0,     0,     0,     0,   102,   103,     0,     0,
      33,     0,     0,     0,    34,    35,     0,     0,     0,    36,
       0,     0,     0,    37,     0,     0,     0,     0,    38,     0,
       0,     0,     0,     0,     0,     0,   104,   105,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,     0,
       0,     0,     0,   126,   127,     0,   128,     0,   129,    39,
       0,     0,   503,   639,    40,    41,     0,    42,     0,    43,
      44,    45,    46,    47,    48,     0,    49,     0,    26,    27,
     197,     0,   640,     0,     0,     0,     0,     0,   654,   655,
       0,    29,     0,   641,    31,     0,   100,     0,     0,     0,
       0,   642,     0,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,    34,   643,     0,     0,     0,   644,
       0,     0,     0,    37,     0,     0,     0,     0,    38,     0,
       0,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,     0,     0,     0,   101,   126,   127,     0,   128,     0,
     129,     0,     0,     0,     0,     0,     0,     0,   102,   103,
       0,     0,     0,   100,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,   645,   646,     0,    42,     0,   647,
     648,   649,   650,   651,    48,     0,    49,     0,   104,   105,
     197,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   101,     0,     0,     0,   126,   127,     0,   128,     0,
     129,     0,   185,     0,     0,   102,   103,     0,     0,     0,
     100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   102,   103,   104,   105,     0,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   101,     0,
       0,     0,   126,   127,     0,   128,     0,   129,     0,   416,
       0,     0,   102,   103,     0,     0,     0,   100,   118,   119,
     120,   121,   122,   123,   124,   125,     0,     0,     0,     0,
     126,   127,     0,   128,     0,   129,     0,     0,     0,     0,
     654,   655,   104,   105,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   101,     0,     0,     0,   126,
     127,     0,   128,     0,   129,     0,   499,     0,     0,   102,
     103,     0,     0,     0,   100,   670,   671,   672,   673,   674,
     675,   676,   677,     0,     0,     0,     0,   126,   127,     0,
     128,     0,   129,     0,     0,     0,   654,   655,     0,   104,
     105,     0,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   101,     0,     0,     0,   126,   127,     0,   128,
     196,   129,     0,     0,     0,     0,   102,   103,     0,     0,
       0,   100,   671,   672,   673,   674,   675,   676,   677,     0,
       0,     0,     0,   126,   127,     0,   128,     0,   129,     0,
       0,     0,     0,     0,     0,     0,   104,   105,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   101,
       0,     0,     0,   126,   127,     0,   128,   256,   129,     0,
       0,     0,     0,   102,   103,     0,     0,     0,   652,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   104,   105,     0,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   653,     0,     0,     0,
     126,   127,     0,   128,   334,   129,     0,     0,     0,     0,
     654,   655,     0,     0,     0,   652,   741,   742,   743,   273,
     274,   744,   745,   746,   747,   748,   280,   749,   750,   283,
     751,   752,   286,   287,   753,   754,   290,   291,   292,   293,
     656,   657,   365,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   653,     0,     0,     0,   126,   127,     0,
     128,     0,   129,     0,     0,     0,     0,   654,   655,     0,
       0,     0,   100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   656,   657,    -8,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     101,     0,     0,     0,   126,   127,     0,   128,     0,   129,
       0,     0,     0,     0,   102,   103,     0,     0,     0,   100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   400,   104,   105,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   101,     0,     0,
       0,   126,   127,     0,   128,     0,   129,     0,     0,     0,
       0,   102,   103,     0,     0,     0,   100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,     0,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   101,     0,     0,     0,   126,   127,
       0,   128,   492,   129,     0,     0,     0,     0,   102,   103,
       0,     0,     0,   100,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
       0,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   101,     0,     0,     0,   126,   127,     0,   128,   497,
     129,     0,     0,     0,     0,   102,   103,     0,     0,     0,
     100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,     0,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   101,     0,
       0,     0,   126,   127,     0,   128,   572,   129,     0,     0,
       0,     0,   102,   103,     0,     0,     0,   100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   101,     0,     0,     0,   126,
     127,     0,   128,   621,   129,     0,     0,     0,     0,   102,
     103,     0,     0,     0,   100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,     0,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   101,     0,     0,     0,   126,   127,     0,   128,
     623,   129,     0,     0,     0,     0,   102,   103,     0,     0,
       0,   652,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   653,
       0,     0,     0,   126,   127,     0,   128,   637,   129,     0,
       0,     0,     0,   654,   655,     0,     0,     0,   100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   656,   657,   732,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   101,     0,     0,     0,
     126,   127,     0,   128,     0,   129,     0,     0,     0,     0,
     102,   103,     0,     0,     0,   100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,     0,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   101,     0,     0,     0,   126,   127,     0,
     128,     0,   129,     0,     0,     0,     0,   102,   103,     0,
       0,     0,   652,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,     0,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     189,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     653,     0,     0,     0,   126,   127,     0,   128,     0,   129,
       0,     0,     0,     0,   654,   655,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,     0,     0,   656,   657,     0,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   639,     0,     0,
       0,   126,   127,     0,   128,     0,   129,     0,   617,     0,
       0,     0,    26,    27,     0,     0,   640,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,   641,    31,     0,
       0,     0,     0,     0,     0,   642,    25,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,    34,   643,
       0,    26,    27,   644,     0,    28,   578,    37,     0,     0,
       0,     0,    38,     0,    29,     0,    30,    31,     0,     0,
       0,     0,     0,     0,    32,     0,     0,   102,   103,     0,
       0,     0,     0,    33,     0,     0,     0,    34,    35,     0,
       0,     0,    36,     0,     0,     0,    37,     0,     0,     0,
       0,    38,     0,    39,     0,     0,     0,     0,   645,   646,
       0,    42,     0,   647,   648,   649,   650,   651,    48,     0,
      49,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     639,     0,     0,     0,   126,   127,     0,   128,     0,   129,
       0,     0,    39,     0,     0,    26,    27,    40,    41,   640,
      42,     0,    43,    44,    45,    46,    47,    48,    29,    49,
     641,    31,     0,     0,     0,     0,     0,     0,   642,    25,
       0,     0,     0,     0,     0,     0,     0,    33,     0,     0,
       0,    34,   643,     0,    26,    27,   644,     0,    28,     0,
      37,     0,     0,     0,     0,    38,     0,    29,     0,    30,
      31,     0,     0,     0,     0,     0,     0,    32,     0,     0,
     654,   655,     0,     0,     0,     0,    33,     0,     0,     0,
      34,    35,     0,     0,     0,    36,     0,     0,     0,    37,
       0,     0,     0,     0,    38,     0,    39,     0,     0,     0,
       0,   645,   646,     0,    42,     0,   647,   648,   649,   650,
     651,    48,     0,    49,   669,   670,   671,   672,   673,   674,
     675,   676,   677,     0,     0,     0,     0,   126,   127,     0,
     128,     0,   129,     0,   201,   202,     0,     0,     0,     0,
       0,     0,   203,     0,     0,    43,    44,    45,    46,   204,
       0,     0,   205,     0,   206,   207,     0,     0,   208,     0,
     209,     0,   210,    31,     0,   211,   212,   213,     0,     0,
       0,     0,     0,   214,   215,   201,   202,   216,     0,   217,
       0,     0,     0,   203,   218,   219,   220,     0,   221,   222,
     204,     0,   223,   205,     0,   206,   207,    38,     0,   679,
       0,   680,     0,   210,    31,     0,   211,   212,   681,   102,
     103,     0,     0,     0,   214,   215,     0,     0,   216,     0,
     217,     0,     0,     0,     0,   218,   219,   220,     0,   682,
     222,     0,     0,   683,     0,     0,     0,     0,    38,     0,
     105,     0,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   654,   655,     0,     0,   126,   127,     0,   128,
       0,   129,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   102,   103,   657,     0,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,     0,     0,     0,     0,   126,
     127,     0,   128,     0,   129,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   654,   655,     0,     0,   126,   127,
       0,   128,     0,   129,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   102,   103,     0,
       0,   126,   127,     0,   128,     0,   129,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   618,     0,     0,     0,
       0,     0,     0,     0,     0,   102,   103,     0,     0,     0,
       0,     0,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
       0,     0,     0,     0,   126,   127,     0,   128,     0,   129,
    -205,  -205,  -205,  -205,  -205,  -205,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   654,   655,
       0,     0,   126,   127,     0,   128,     0,   129,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   654,   655,     0,     0,
       0,     0,     0,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,     0,     0,     0,     0,   126,   127,     0,   128,     0,
     129,  -205,  -205,  -205,  -205,  -205,  -205,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,     0,
       0,     0,     0,   126,   127,     0,   128,     0,   129,     6,
       7,     8,     9,    10,     0,     0,     0,    11,    12,     0,
       0,     0,     0,     0,     0,     0,     0,    13,    14,     0,
       0,     0,    15,    16,    17,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20
};

static const yytype_int16 yycheck[] =
{
       4,   101,   154,     3,   136,   295,    82,   159,   170,   362,
      59,   143,    89,   265,   176,    64,    95,   566,   567,    96,
     354,    25,    15,   357,    28,    95,    95,    73,    21,    18,
      34,    74,    84,    95,    86,    39,    40,    41,   419,    43,
      44,    45,    46,    34,    48,    49,   427,   299,   127,   312,
      54,   127,     0,   316,    95,   125,   319,    34,     8,     9,
      10,    11,    12,   132,    95,   328,    19,   138,    95,    95,
     132,   142,    76,   144,    60,    79,    93,    63,    82,    65,
      84,    34,    86,   183,   125,   161,     8,     9,    10,    11,
      12,    68,     4,   126,   125,   130,   100,   101,   125,   125,
     149,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    61,   127,   170,   506,   115,    96,   228,    95,
     176,    95,    71,   124,    96,   187,    95,   180,   131,   126,
      52,   107,   405,   107,    25,    26,   398,   126,   152,    98,
     413,    95,   415,   126,    98,   124,    58,   161,   162,   163,
      34,   147,   124,   102,   103,    67,   125,    69,   549,    50,
     124,    95,   126,   305,    98,   374,   375,   177,    34,   183,
     130,   126,    34,   187,    96,   189,   735,   191,   126,   193,
     126,   126,    34,    34,   133,   181,     8,     9,    10,    11,
      12,   582,   254,   126,   132,    98,   124,    96,   130,    47,
     125,     8,     9,    10,    11,    12,   155,   102,   103,    16,
      17,    34,    34,   772,   228,   606,    95,   608,    34,    26,
      27,   302,   127,   485,    31,    32,    33,   127,    34,     4,
     503,   493,    39,   123,   132,   132,   185,   126,   133,   126,
     254,    66,    67,   126,    51,    19,   132,   409,    61,    12,
     309,    96,    15,    16,    17,    62,   315,    20,   127,   127,
     370,    46,   404,    96,    43,   130,   352,   126,   126,   411,
      43,    43,    43,   130,   124,   124,   130,    98,    98,    96,
     127,    96,    96,    34,    96,    66,    67,   297,   369,     4,
     371,   116,   117,   118,    96,    96,   596,   597,   123,   124,
     314,   126,    96,   128,    96,    96,    96,    96,   322,    96,
     324,    34,   393,    96,    96,   329,    96,    94,   399,    18,
     492,   132,   126,   131,   131,   497,   599,    94,   342,   339,
     127,   604,    34,    66,    67,   116,   117,   118,   352,    66,
      67,    98,   123,   124,   406,   126,    52,   128,   132,    95,
      34,   365,   366,   131,   130,   125,   370,   306,    66,    67,
     125,   724,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   457,   539,   722,   112,
     113,   114,   115,   116,   117,   118,   400,   127,   130,   127,
     123,   124,   406,   126,     4,   128,   123,   124,   127,   126,
     481,   128,   127,    52,   576,   127,   355,    34,   132,   358,
     424,   306,   361,   362,   363,   123,   124,   126,   126,   132,
     128,    66,    67,   372,    95,   132,   507,   132,   131,    43,
     131,   131,   130,   130,   107,    24,   492,   132,    98,   131,
      96,   497,   498,   131,    34,   132,   131,   127,   504,   132,
     132,    18,   131,    89,   535,   755,    18,   543,    98,   131,
     355,   542,    66,   358,   107,    62,   132,   132,   363,   114,
     115,   116,   117,   118,     3,   489,    34,   372,   123,   124,
     642,   126,   132,   128,   132,   126,    34,   126,    43,    18,
      19,   126,    43,    22,   124,    96,    43,    43,   554,   127,
      96,   127,    31,   127,    33,    34,   366,   141,    96,   458,
      96,    96,    41,    96,    96,    96,    66,    67,    96,    96,
     576,    50,    96,    96,    96,    54,    55,   583,    96,   543,
      59,    96,   550,   656,    63,    64,   690,   756,   619,    68,
     641,   477,   532,   653,   560,    78,   428,   185,   629,   607,
      68,   436,   562,   609,    71,   499,   588,   571,   326,    -1,
     438,   575,    -1,   458,   114,   115,   116,   117,   118,   518,
     626,    -1,   628,   123,   124,    -1,   126,    -1,   128,    -1,
     109,    -1,    -1,    -1,    -1,   114,   115,    -1,   117,   699,
     119,   120,   121,   122,   123,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,   622,    -1,
      -1,    -1,    -1,    -1,    -1,   564,    -1,    -1,   728,    -1,
      -1,    -1,    -1,   518,    -1,   639,   640,   689,    -1,   578,
      -1,   645,   646,   647,   648,   649,   650,    -1,   652,   653,
      -1,    -1,    -1,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,    -1,    -1,    -1,   616,   730,   564,
     684,    -1,    -1,   687,    -1,   689,    -1,    -1,    -1,    66,
      67,    -1,    -1,   578,    -1,   699,    -1,    -1,    -1,    -1,
      -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   654,   655,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   728,    -1,   730,   731,   732,    -1,
      -1,   616,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,    -1,    -1,    -1,   123,   124,    -1,   126,
      -1,   128,    -1,    -1,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,    -1,   654,
     655,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   721,    -1,   723,   724,   725,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
       7,     8,     9,    10,    11,    12,    -1,    14,    -1,    -1,
      17,    18,    19,    -1,    -1,    22,    -1,    -1,   757,    26,
      -1,    28,    -1,    30,    31,    -1,    33,    34,    35,    -1,
      -1,    -1,    -1,    40,    41,    42,   721,    -1,   723,    -1,
     725,    -1,    49,    50,    -1,    -1,    53,    54,    55,    -1,
      -1,    58,    59,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   757,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,   109,     4,    -1,    -1,    -1,   114,   115,    -1,
     117,    -1,   119,   120,   121,   122,   123,   124,    -1,   126,
      -1,    -1,     3,   130,   131,   132,     7,     8,     9,    10,
      11,    12,    -1,    14,    -1,    -1,    17,    18,    19,   132,
      -1,    22,    -1,    -1,    -1,    26,    -1,    28,    -1,    30,
      31,    52,    33,    34,    35,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    -1,    -1,    66,    67,    -1,    49,    50,
      -1,    -1,    53,    54,    55,    -1,    -1,    58,    59,    -1,
      -1,    -1,    63,    64,    65,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,    -1,
      -1,    -1,   123,   124,    -1,   126,    -1,   128,   109,     4,
      -1,   132,    -1,   114,   115,    -1,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,    -1,    -1,     3,   130,
     131,   132,     7,     8,     9,    10,    11,    12,    -1,    14,
      -1,    -1,    17,    18,    19,    -1,    -1,    22,    -1,    -1,
      -1,    26,    -1,    28,    -1,    30,    31,    52,    33,    34,
      35,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    -1,
      -1,    66,    67,    -1,    49,    50,    -1,    -1,    53,    54,
      55,    -1,    -1,    58,    59,    -1,    -1,    -1,    63,    64,
      65,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,     4,    -1,    -1,    -1,   123,   124,
      -1,   126,    -1,   128,   109,    -1,    -1,   132,    -1,   114,
     115,    -1,   117,     3,   119,   120,   121,   122,   123,   124,
      -1,   126,    -1,    -1,    -1,   130,    -1,   132,    18,    19,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    52,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      50,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,   109,
      -1,    -1,   132,     3,   114,   115,    -1,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,    -1,    18,    19,
     130,    -1,    22,    -1,    -1,    -1,    -1,    -1,    66,    67,
      -1,    31,    -1,    33,    34,    -1,     4,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,    -1,    -1,    52,   123,   124,    -1,   126,    -1,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,    -1,    -1,   114,   115,    -1,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,    -1,    96,    97,
     130,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,
     128,    -1,   130,    -1,    -1,    66,    67,    -1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    52,    -1,
      -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,   130,
      -1,    -1,    66,    67,    -1,    -1,    -1,     4,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,    -1,
      66,    67,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    52,    -1,    -1,    -1,   123,
     124,    -1,   126,    -1,   128,    -1,   130,    -1,    -1,    66,
      67,    -1,    -1,    -1,     4,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    66,    67,    -1,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,
     127,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,     4,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    52,
      -1,    -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,
      -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    52,    -1,    -1,    -1,
     123,   124,    -1,   126,   127,   128,    -1,    -1,    -1,    -1,
      66,    67,    -1,    -1,    -1,     4,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      52,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    52,    -1,    -1,
      -1,   123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,
      -1,    66,    67,    -1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    52,    -1,    -1,    -1,   123,   124,
      -1,   126,   127,   128,    -1,    -1,    -1,    -1,    66,    67,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,   127,
     128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    52,    -1,
      -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    52,    -1,    -1,    -1,   123,
     124,    -1,   126,   127,   128,    -1,    -1,    -1,    -1,    66,
      67,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,
     127,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    52,
      -1,    -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,
      -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    52,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,    -1,
      66,    67,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      52,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,    -1,    -1,    66,    67,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,     3,    -1,    -1,
      -1,   123,   124,    -1,   126,    -1,   128,    -1,   131,    -1,
      -1,    -1,    18,    19,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    54,    55,
      -1,    18,    19,    59,    -1,    22,    62,    63,    -1,    -1,
      -1,    -1,    68,    -1,    31,    -1,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    -1,    54,    55,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    63,    -1,    -1,    -1,
      -1,    68,    -1,   109,    -1,    -1,    -1,    -1,   114,   115,
      -1,   117,    -1,   119,   120,   121,   122,   123,   124,    -1,
     126,   110,   111,   112,   113,   114,   115,   116,   117,   118,
       3,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,   109,    -1,    -1,    18,    19,   114,   115,    22,
     117,    -1,   119,   120,   121,   122,   123,   124,    31,   126,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      -1,    54,    55,    -1,    18,    19,    59,    -1,    22,    -1,
      63,    -1,    -1,    -1,    -1,    68,    -1,    31,    -1,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      66,    67,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      54,    55,    -1,    -1,    -1,    59,    -1,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    68,    -1,   109,    -1,    -1,    -1,
      -1,   114,   115,    -1,   117,    -1,   119,   120,   121,   122,
     123,   124,    -1,   126,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    -1,    -1,   119,   120,   121,   122,    20,
      -1,    -1,    23,    -1,    25,    26,    -1,    -1,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    -1,    -1,
      -1,    -1,    -1,    44,    45,     5,     6,    48,    -1,    50,
      -1,    -1,    -1,    13,    55,    56,    57,    -1,    59,    60,
      20,    -1,    63,    23,    -1,    25,    26,    68,    -1,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    66,
      67,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    -1,
      50,    -1,    -1,    -1,    -1,    55,    56,    57,    -1,    59,
      60,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    66,    67,    -1,    -1,   123,   124,    -1,   126,
      -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,   123,
     124,    -1,   126,    -1,   128,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    66,    67,    -1,    -1,   123,   124,
      -1,   126,    -1,   128,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    66,    67,    -1,
      -1,   123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    66,    67,
      -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,
     128,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    27,    -1,
      -1,    -1,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    93,   134,   137,   136,     0,     8,     9,    10,    11,
      12,    16,    17,    26,    27,    31,    32,    33,    39,    51,
      62,   135,   174,   186,   187,     3,    18,    19,    22,    31,
      33,    34,    41,    50,    54,    55,    59,    63,    68,   109,
     114,   115,   117,   119,   120,   121,   122,   123,   124,   126,
     147,   194,   207,   231,   126,   126,   126,   224,   225,   224,
     227,   228,   130,   224,   224,   224,    34,    25,    26,    50,
     222,   223,   224,   213,   184,   147,   126,   147,   195,   154,
      34,   221,   126,   147,   126,   126,   126,   147,   147,   147,
     155,   147,   147,   147,   147,    34,   147,   159,   160,   147,
       4,    52,    66,    67,    96,    97,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   123,   124,   126,   128,
     147,    34,    34,    98,   202,   222,   202,   126,   201,   229,
     231,   175,   201,   202,   201,   132,   222,   227,   222,   176,
     229,    98,     7,    14,    17,    26,    28,    30,    35,    40,
      42,    49,    53,    58,    64,    65,   130,   132,   139,   140,
     141,   142,   147,   186,   207,   211,   219,   185,   147,   124,
     196,   197,   147,    96,   159,   130,   160,   150,   160,   109,
      47,    96,   196,    95,   236,   125,   127,   130,   147,   156,
     156,     5,     6,    13,    20,    23,    25,    26,    29,    31,
      33,    36,    37,    38,    44,    45,    48,    50,    55,    56,
      57,    59,    60,    63,   164,   230,   231,   164,   148,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
      34,   138,   147,   159,   152,    34,   127,   127,   127,   164,
       4,    52,    96,   203,   226,   203,    34,   171,   172,   173,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,   208,   209,   210,   137,   208,   203,
     208,     4,   201,   123,   180,   202,   183,   147,   132,   221,
     214,   231,   132,   126,   126,   221,   132,   159,    64,   132,
     147,   147,   126,   212,    61,   211,   124,   126,   132,    96,
     211,   130,   186,   188,   127,    19,   198,   199,   200,   185,
     201,   156,    95,   127,   214,   127,   160,   127,    46,   147,
      96,   147,   157,   130,   126,    43,   201,   126,    43,    43,
     130,   124,   124,    43,   156,    98,    98,   125,   160,   204,
     205,   204,    98,   127,    95,   132,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,   210,   131,   204,   130,   208,    34,     4,   203,   164,
      95,   232,    94,   233,   202,   132,   126,   233,    34,   124,
     147,   202,   233,   132,   233,   132,   130,   147,    94,   234,
     147,   143,   198,   144,   145,   233,   147,   189,    95,   125,
      34,   130,   191,   131,   208,   127,   149,   158,   159,   167,
     171,   164,   171,   164,    34,   165,   164,   168,   168,   164,
     147,   138,   147,   153,   208,   156,   208,   164,    98,   173,
     173,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,    18,   208,   177,   178,   179,
     130,   204,   208,   147,   132,   203,   233,   160,    95,   107,
     220,   221,   127,   203,   233,   233,   215,   127,   213,   130,
     125,   127,   147,   132,   213,   199,   192,   151,   191,   131,
     236,    34,   161,   162,   163,   127,   127,   169,    95,   125,
     125,   125,   127,   132,   206,   132,   208,   164,   132,   161,
       4,    52,   181,   208,   132,   204,   127,    34,   147,    95,
     125,   211,   204,    15,    21,   131,   216,   211,   131,   234,
     126,   146,   233,   190,   213,   208,    89,    96,   235,   131,
      95,   166,   185,   164,    43,   131,   130,   130,   169,   132,
     208,   107,   127,   221,    95,   107,    24,   208,    62,   159,
     217,   218,    98,   213,   144,   131,   193,    96,    18,   115,
     163,   131,    34,   170,   164,   132,   209,   209,   182,   132,
     147,    34,   147,   211,   132,   164,    98,    95,    98,   213,
     131,   127,   131,    18,   235,    18,    98,   131,   131,   131,
     233,   127,   107,   127,   233,    66,   213,   218,   213,   164,
     132,   132,   208,   147,    34,   208,   132,   127,   132,     3,
      22,    33,    41,    55,    59,   114,   115,   119,   120,   121,
     122,   123,     4,    52,    66,    67,    96,    97,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   147,    29,
      31,    38,    59,    63,    95,   147,   147,   154,   221,   126,
     126,   147,   147,   147,   147,   147,   147,    34,   147,   148,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,    43,   126,    43,   124,    43,   147,   147,    96,   160,
     150,    96,    98,   171,   168,   127,   160,   147,   147,   127,
     125,    69,    70,    71,    74,    75,    76,    77,    78,    80,
      81,    83,    84,    87,    88,   209,   127,    43,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,    96,   151,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   133,   135,   134,   136,   134,   137,   137,   138,   138,
     139,   139,   140,   141,   141,   142,   142,   143,   143,   145,
     146,   144,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   148,   147,   147,   147,   147,   147,   147,
     149,   147,   147,   147,   147,   147,   150,   151,   147,   147,
     147,   152,   153,   147,   154,   147,   147,   147,   147,   147,
     147,   155,   147,   147,   147,   147,   157,   156,   156,   158,
     158,   159,   159,   160,   160,   161,   161,   162,   162,   163,
     163,   163,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   165,   166,   164,   167,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   168,   168,   169,   169,   170,   171,   171,   171,   172,
     172,   172,   173,   174,   175,   174,   174,   174,   174,   176,
     174,   177,   174,   178,   174,   179,   174,   180,   181,   182,
     174,   183,   174,   184,   174,   174,   185,   185,   186,   186,
     186,   186,   186,   187,   187,   187,   187,   189,   190,   188,
     192,   193,   191,   195,   194,   196,   197,   197,   198,   198,
     199,   200,   200,   201,   201,   202,   202,   203,   203,   203,
     203,   205,   206,   204,   204,   207,   208,   208,   209,   209,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   212,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   213,   213,   214,
     215,   215,   216,   216,   216,   217,   217,   218,   218,   219,
     219,   219,   219,   220,   220,   221,   223,   222,   225,   226,
     224,   228,   227,   229,   230,   231,   231,   232,   232,   233,
     233,   234,   234,   235,   235,   235,   236,   236
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     3,     2,     0,     1,     0,
       7,     1,     2,     7,     4,     2,     1,     1,     0,     0,
       0,     3,     3,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     0,     4,     4,     4,     1,     3,     4,
       0,     6,     3,     3,     3,     4,     0,     0,     7,     5,
       4,     0,     0,     6,     0,     3,     3,     1,     5,     1,
       1,     0,     4,     3,     3,     3,     0,     4,     1,     2,
       0,     3,     1,     2,     0,     1,     2,     1,     3,     4,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     0,     0,     6,     0,
       5,     1,     3,     3,     2,     4,     4,     3,     1,     3,
       1,     3,     1,     3,     0,     5,     1,     2,     0,     3,
       3,     1,     4,     3,     0,     5,     7,     7,     7,     0,
       8,     0,     9,     0,    11,     0,    11,     0,     0,     0,
      12,     0,     7,     0,     4,     1,     0,     2,     4,     4,
       4,     1,     1,     4,     4,     4,     5,     0,     0,     5,
       0,     0,     5,     0,     5,     2,     3,     0,     3,     1,
       2,     1,     0,     5,     3,     2,     0,     0,     1,     1,
       1,     0,     0,     3,     0,     6,     1,     0,     2,     1,
       3,     3,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     1,     3,     3,     3,
       1,     1,     1,     3,     1,     0,     5,     4,     4,     4,
       5,     7,     5,     2,     5,     3,     3,     3,     3,     4,
       8,     8,     1,     5,     3,     1,     1,     2,     0,     4,
       2,     0,     4,     4,     3,     3,     1,     2,     4,     6,
       8,     8,    10,     3,     1,     1,     0,     2,     0,     0,
       3,     0,     2,     1,     1,     1,     1,     2,     0,     1,
       0,     1,     0,     1,     3,     0,     1,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = zeeklex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 398 "/build/zeek/src/zeek/src/parse.y"
                        {
			// Without the following, in some scenarios the
			// location associated with global statements gets
			// associated with the last @load'd file rather than
			// the script that includes the global statements.
			auto loc = zeek::detail::GetCurrentLocation();
			if ( loc.filename )
				set_location(loc);
			}
#line 2759 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 3: /* zeek: decl_list $@1 stmt_list  */
#line 408 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back({AdoptRef{}, (yyvsp[0].stmt)});
			else
				stmts = (yyvsp[0].stmt);

			// Do some further validation on the parsed AST unless
			// we already know there were errors.
			if ( zeek::reporter->Errors() == 0 )
				zeek::detail::script_validation();

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2779 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 4: /* $@2: %empty  */
#line 427 "/build/zeek/src/zeek/src/parse.y"
                          { in_debug = true; }
#line 2785 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 5: /* zeek: TOK_DEBUG $@2 expr  */
#line 428 "/build/zeek/src/zeek/src/parse.y"
                        {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2793 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 8: /* opt_expr: expr  */
#line 440 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 2799 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 9: /* opt_expr: %empty  */
#line 442 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = 0; }
#line 2805 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 10: /* when_clause: when_head TOK_TIMEOUT expr '{' opt_no_test_block stmt_list '}'  */
#line 447 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyvsp[-6].when_clause)->AddTimeout({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-1].stmt)});
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 2816 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 12: /* when_head: when_start stmt  */
#line 459 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].when_clause)->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 2825 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 13: /* when_start: when_flavor '[' when_captures ']' '(' when_condition ')'  */
#line 467 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, (yyvsp[-4].captures), (yyvsp[-6].b));
			}
#line 2834 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 14: /* when_start: when_flavor '(' when_condition ')'  */
#line 473 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, nullptr, (yyvsp[-3].b));
			}
#line 2843 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 15: /* when_flavor: TOK_RETURN TOK_WHEN  */
#line 481 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 2849 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 16: /* when_flavor: TOK_WHEN  */
#line 484 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 2855 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 18: /* when_captures: %empty  */
#line 490 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.captures) = new zeek::FuncType::CaptureList; }
#line 2861 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 19: /* $@3: %empty  */
#line 494 "/build/zeek/src/zeek/src/parse.y"
                { ++in_when_cond; }
#line 2867 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 20: /* $@4: %empty  */
#line 494 "/build/zeek/src/zeek/src/parse.y"
                                         { --in_when_cond; }
#line 2873 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 21: /* when_condition: $@3 expr $@4  */
#line 495 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 2879 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 22: /* expr: '(' expr ')'  */
#line 500 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2888 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 23: /* expr: TOK_COPY '(' expr ')'  */
#line 506 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr({AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 2897 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 24: /* expr: TOK_ADD expr  */
#line 512 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new AggrAddExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2906 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 25: /* expr: TOK_DELETE expr  */
#line 518 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new AggrDelExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2915 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 26: /* expr: TOK_INCR expr  */
#line 524 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2924 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 27: /* expr: TOK_DECR expr  */
#line 530 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2933 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 28: /* expr: '!' expr  */
#line 536 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2942 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 29: /* expr: '~' expr  */
#line 542 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2951 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 30: /* expr: '-' expr  */
#line 548 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr({AdoptRef{}, (yyvsp[0].expr)});

			if ( ! (yyval.expr)->IsError() && (yyvsp[0].expr)->IsConst() )
				{
				auto v = (yyvsp[0].expr)->ExprVal();
				auto tag = v->GetType()->Tag();

				if ( tag == TYPE_COUNT )
					{
					auto c = v->AsCount();
					uint64_t int_max = static_cast<uint64_t>(INT64_MAX) + 1;

					if ( c <= int_max )
						{
						auto ce = new ConstExpr(val_mgr->Int(-c));
						Unref((yyval.expr));
						(yyval.expr) = ce;
						}
					else
						{
						(yyval.expr)->Error("literal is outside range of 'int' values");
						(yyval.expr)->SetError();
						}
					}
				else
					{
					auto ce = new ConstExpr((yyval.expr)->Eval(nullptr));
					Unref((yyval.expr));
					(yyval.expr) = ce;
					}
				}
			}
#line 2990 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 31: /* expr: '+' expr  */
#line 584 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2999 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 32: /* expr: expr '+' expr  */
#line 590 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3008 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 33: /* expr: expr TOK_ADD_TO rhs  */
#line 596 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			ExprPtr lhs = {AdoptRef{}, (yyvsp[-2].expr)};
			ExprPtr rhs = {AdoptRef{}, (yyvsp[0].expr)};
			auto tag1 = (yyvsp[-2].expr)->GetType()->Tag();

			if ( IsArithmetic((yyvsp[-2].expr)->GetType()->Tag()) )
				{
				// Script optimization assumes that each AST
				// node is distinct, hence the call to
				// Duplicate() here.
				ExprPtr sum = make_intrusive<AddExpr>(lhs->Duplicate(), rhs);

				if ( sum->GetType()->Tag() != tag1 )
					sum = make_intrusive<ArithCoerceExpr>(sum, tag1);

				(yyval.expr) = new AssignExpr(lhs, sum, false);
				}
			else
				(yyval.expr) = new AddToExpr(lhs, rhs);
			}
#line 3035 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 34: /* expr: expr '-' expr  */
#line 620 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3044 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 35: /* expr: expr TOK_REMOVE_FROM rhs  */
#line 626 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			ExprPtr lhs = {AdoptRef{}, (yyvsp[-2].expr)};
			ExprPtr rhs = {AdoptRef{}, (yyvsp[0].expr)};
			auto tag1 = (yyvsp[-2].expr)->GetType()->Tag();

			if ( IsArithmetic(tag1) )
				{
				ExprPtr sum = make_intrusive<SubExpr>(lhs, rhs);

				if ( sum->GetType()->Tag() != tag1 )
					sum = make_intrusive<ArithCoerceExpr>(sum, tag1);

				(yyval.expr) = new AssignExpr(lhs, sum, false);
				}
			else
				(yyval.expr) = new RemoveFromExpr(lhs, rhs);
			}
#line 3068 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 36: /* expr: expr '*' expr  */
#line 647 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3077 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 37: /* expr: expr '/' expr  */
#line 653 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( (yyvsp[-2].expr)->GetType()->Tag() == TYPE_ADDR )
				(yyval.expr) = new MaskExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			else
				(yyval.expr) = new DivideExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3089 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 38: /* expr: expr '%' expr  */
#line 662 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3098 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 39: /* expr: expr '&' expr  */
#line 668 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3107 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 40: /* expr: expr '|' expr  */
#line 674 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3116 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 41: /* expr: expr '^' expr  */
#line 680 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3125 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 42: /* expr: expr TOK_LSHIFT expr  */
#line 686 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_LSHIFT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3134 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 43: /* expr: expr TOK_RSHIFT expr  */
#line 692 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_RSHIFT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3143 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 44: /* expr: expr TOK_AND_AND expr  */
#line 698 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3152 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 45: /* expr: expr TOK_OR_OR expr  */
#line 704 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3161 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 46: /* expr: expr TOK_EQ expr  */
#line 710 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3170 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 47: /* expr: expr TOK_NE expr  */
#line 716 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3179 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 48: /* expr: expr '<' expr  */
#line 722 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3188 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 49: /* expr: expr TOK_LE expr  */
#line 728 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3197 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 50: /* expr: expr '>' expr  */
#line 734 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3206 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 51: /* expr: expr TOK_GE expr  */
#line 740 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3215 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 52: /* expr: expr '?' expr ':' expr  */
#line 746 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3224 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 53: /* $@5: %empty  */
#line 752 "/build/zeek/src/zeek/src/parse.y"
                        {
			// Prevent usage of trailing commas on the left-hand
			// side of list expressions (e.g. in table inits).
			if ( (yyvsp[-1].expr)->Tag() == EXPR_LIST && expr_list_has_opt_comma )
				(yyvsp[-1].expr)->Error("incorrect syntax for list expression "
				          "on left-hand side of assignment: "
				          "trailing comma not allowed");
			}
#line 3237 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 54: /* expr: expr '=' $@5 rhs  */
#line 761 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));

			if ( (yyvsp[-3].expr)->Tag() == EXPR_INDEX && (yyvsp[-3].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                      " in arbitrary expression contexts, only"
				                      " as a statement");

			(yyval.expr) = get_assign_expr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[0].expr)}, in_init).release();
			}
#line 3252 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 55: /* expr: TOK_WHEN_LOCAL local_id '=' rhs  */
#line 773 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-2].id));
			(yyval.expr) = add_and_assign_local({AdoptRef{}, (yyvsp[-2].id)}, {AdoptRef{}, (yyvsp[0].expr)},
			                                        val_mgr->True()).release();
			}
#line 3264 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 56: /* expr: expr '[' expr_list ']'  */
#line 782 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			if ( in_when_cond > 0 )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3276 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 58: /* expr: expr '$' TOK_ID  */
#line 793 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3285 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 59: /* expr: '$' TOK_ID '=' expr  */
#line 799 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3294 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 60: /* $@6: %empty  */
#line 805 "/build/zeek/src/zeek/src/parse.y"
                        {
			func_hdr_location = (yylsp[-3]);
			(yyvsp[-1].id)->SetInferReturnType(true);
			}
#line 3303 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 61: /* expr: '$' TOK_ID begin_lambda '=' $@6 lambda_body  */
#line 810 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), IntrusivePtr{AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3311 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 62: /* expr: expr TOK_IN expr  */
#line 815 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3320 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 63: /* expr: expr TOK_NOT_IN expr  */
#line 821 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(make_intrusive<InExpr>(
			        ExprPtr{AdoptRef{}, (yyvsp[-2].expr)},
			        ExprPtr{AdoptRef{}, (yyvsp[0].expr)}));
			}
#line 3331 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 64: /* expr: '[' opt_expr_list ']'  */
#line 829 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer. Interpret no expressions
			// as an empty record constructor.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3360 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 65: /* expr: TOK_RECORD '(' expr_list ')'  */
#line 855 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3369 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 66: /* $@7: %empty  */
#line 860 "/build/zeek/src/zeek/src/parse.y"
                              { ++in_init; }
#line 3375 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 67: /* $@8: %empty  */
#line 860 "/build/zeek/src/zeek/src/parse.y"
                                                               { --in_init; }
#line 3381 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 68: /* expr: TOK_TABLE '(' $@7 opt_expr_list ')' $@8 opt_attr  */
#line 862 "/build/zeek/src/zeek/src/parse.y"
                        { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-3].list)}, std::move(attrs));
			}
#line 3391 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 69: /* expr: TOK_SET '(' opt_expr_list ')' opt_attr  */
#line 869 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, std::move(attrs));
			}
#line 3401 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 70: /* expr: TOK_VECTOR '(' opt_expr_list ')'  */
#line 876 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3410 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 71: /* $@9: %empty  */
#line 882 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3419 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 72: /* $@10: %empty  */
#line 888 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3428 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 73: /* expr: expr '(' $@9 opt_expr_list $@10 ')'  */
#line 894 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME && (yyvsp[-5].expr)->AsNameExpr()->Id()->IsType() )
				{
				const auto& ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->GetType();

				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					{
					auto rt = cast_intrusive<RecordType>(ctor_type);
					(yyval.expr) = new RecordConstructorExpr(rt, ListExprPtr{AdoptRef{}, (yyvsp[-2].list)});
					}
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr({AdoptRef{}, (yyvsp[-5].expr)}, {AdoptRef{}, (yyvsp[-2].list)}, in_hook > 0, in_when_cond);
			}
#line 3469 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 74: /* $@11: %empty  */
#line 931 "/build/zeek/src/zeek/src/parse.y"
                         { ++in_hook; }
#line 3475 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 75: /* expr: TOK_HOOK $@11 expr  */
#line 932 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			else if ( (yyvsp[0].expr)->AsCallExpr()->Func()->GetType()->AsFuncType()->Flavor() != FUNC_FLAVOR_HOOK )
				(yyvsp[0].expr)->Error("hook keyword should only be used to call hooks");

			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3491 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 76: /* expr: expr TOK_HAS_FIELD TOK_ID  */
#line 945 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3500 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 78: /* expr: TOK_SCHEDULE expr '{' event '}'  */
#line 953 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].event_expr)});
			}
#line 3509 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 79: /* expr: lookup_identifier  */
#line 959 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							        false, is_export);
*/

					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( id->IsDeprecated() )
					reporter->Deprecation(id->GetDeprecationWarning());

				if ( id->IsBlank() )
					{
					(yyval.expr) = new NameExpr(std::move(id));
					(yyval.expr)->SetError("blank identifier used in expression");
					}
				else if ( ! id->GetType() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(std::move(id));
					}

				else if ( id->IsEnumConst() )
					{
					if ( IsErrorType(id->GetType()->Tag()) )
						{
						// The most-relevant error message should already be reported, so
						// just bail out.
						YYERROR;
						}

					EnumType* t = id->GetType()->AsEnumType();
					auto intval = t->Lookup(id->ModuleName(), id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetEnumVal(intval));
					}
				else
					{
					if ( out_of_scope_locals.count(id.get()) > 0 )
						id->Error("use of out-of-scope local; move declaration to outer scope");

					(yyval.expr) = new NameExpr(std::move(id));
					}
				}
			}
#line 3577 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 80: /* expr: TOK_CONSTANT  */
#line 1024 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			}
#line 3586 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 81: /* $@12: %empty  */
#line 1029 "/build/zeek/src/zeek/src/parse.y"
                    { begin_RE(); }
#line 3592 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 82: /* expr: '/' $@12 TOK_PATTERN_TEXT TOK_PATTERN_END  */
#line 1030 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]));

			auto* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].re_modes).ignore_case )
				re->MakeCaseInsensitive();

			if ( (yyvsp[0].re_modes).single_line )
				re->MakeSingleLine();

			re->Compile();
			(yyval.expr) = new ConstExpr(make_intrusive<PatternVal>(re));
			}
#line 3612 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 83: /* expr: '|' expr '|'  */
#line 1047 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			ExprPtr e{AdoptRef{}, (yyvsp[-1].expr)};
			(yyval.expr) = new SizeExpr(std::move(e));
			}
#line 3622 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 84: /* expr: expr TOK_AS type  */
#line 1054 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3631 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 85: /* expr: expr TOK_IS type  */
#line 1060 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3640 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 86: /* $@13: %empty  */
#line 1066 "/build/zeek/src/zeek/src/parse.y"
                    { ++in_init; }
#line 3646 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 87: /* rhs: '{' $@13 rhs_expr_list '}'  */
#line 1067 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_init;
			(yyval.expr) = (yyvsp[-1].list);
			}
#line 3655 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 90: /* rhs_expr_list: %empty  */
#line 1076 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.list) = new ListExpr(); }
#line 3661 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 91: /* expr_list: expr_list ',' expr  */
#line 1081 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3670 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 92: /* expr_list: expr  */
#line 1087 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			expr_list_has_opt_comma = 0;
			(yyval.list) = new ListExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3680 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 94: /* opt_expr_list: %empty  */
#line 1097 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.list) = new ListExpr(); }
#line 3686 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 95: /* enum_body: enum_body_list  */
#line 1102 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3695 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 96: /* enum_body: enum_body_list ','  */
#line 1108 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3704 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 99: /* enum_body_elem: TOK_ID '=' TOK_CONSTANT opt_deprecated  */
#line 1127 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->GetType()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr),
				                       in_enum_redef != 0);
			}
#line 3720 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 100: /* enum_body_elem: TOK_ID '=' '-' TOK_CONSTANT  */
#line 1140 "/build/zeek/src/zeek/src/parse.y"
                        {
			// We only accept counts as enumerator, but we want to return a nice
			// error message if users try to use a negative integer (will also
			// catch other cases, but that's fine.)
			reporter->Error("enumerator is not a count constant");
			}
#line 3731 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 101: /* enum_body_elem: TOK_ID opt_deprecated  */
#line 1148 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr),
			                       in_enum_redef != 0);
			}
#line 3742 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 102: /* type: TOK_BOOL  */
#line 1157 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL)->Ref();
				}
#line 3751 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 103: /* type: TOK_INT  */
#line 1162 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT)->Ref();
				}
#line 3760 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 104: /* type: TOK_COUNT  */
#line 1167 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT)->Ref();
				}
#line 3769 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 105: /* type: TOK_DOUBLE  */
#line 1172 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE)->Ref();
				}
#line 3778 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 106: /* type: TOK_TIME  */
#line 1177 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME)->Ref();
				}
#line 3787 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 107: /* type: TOK_INTERVAL  */
#line 1182 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL)->Ref();
				}
#line 3796 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 108: /* type: TOK_STRING  */
#line 1187 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING)->Ref();
				}
#line 3805 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 109: /* type: TOK_PATTERN  */
#line 1192 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN)->Ref();
				}
#line 3814 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 110: /* type: TOK_PORT  */
#line 1197 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT)->Ref();
				}
#line 3823 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 111: /* type: TOK_ADDR  */
#line 1202 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR)->Ref();
				}
#line 3832 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 112: /* type: TOK_SUBNET  */
#line 1207 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET)->Ref();
				}
#line 3841 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 113: /* type: TOK_ANY  */
#line 1212 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY)->Ref();
				}
#line 3850 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 114: /* type: TOK_TABLE '[' type_list ']' TOK_OF type  */
#line 1218 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType({AdoptRef{}, (yyvsp[-3].type_l)}, {AdoptRef{}, (yyvsp[0].type)});
				}
#line 3859 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 115: /* type: TOK_SET '[' type_list ']'  */
#line 1224 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType({AdoptRef{}, (yyvsp[-1].type_l)}, nullptr);
				}
#line 3868 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 116: /* $@14: %empty  */
#line 1230 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_record; }
#line 3874 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 117: /* $@15: %empty  */
#line 1232 "/build/zeek/src/zeek/src/parse.y"
                        { --in_record; }
#line 3880 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 118: /* type: TOK_RECORD '{' $@14 type_decl_list $@15 '}'  */
#line 1234 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3889 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 119: /* $@16: %empty  */
#line 1239 "/build/zeek/src/zeek/src/parse.y"
                             { set_location((yylsp[-1])); parse_new_enum(); }
#line 3895 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 120: /* type: TOK_ENUM '{' $@16 enum_body '}'  */
#line 1240 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3905 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 121: /* type: TOK_LIST  */
#line 1247 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3916 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 122: /* type: TOK_LIST TOK_OF type  */
#line 1255 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3927 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 123: /* type: TOK_VECTOR TOK_OF type  */
#line 1263 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3936 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 124: /* type: TOK_FUNCTION func_params  */
#line 1269 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3945 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 125: /* type: TOK_EVENT '(' formal_args ')'  */
#line 1275 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, nullptr, FUNC_FLAVOR_EVENT);
				}
#line 3954 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 126: /* type: TOK_HOOK '(' formal_args ')'  */
#line 1281 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3963 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 127: /* type: TOK_FILE TOK_OF type  */
#line 1287 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3972 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 128: /* type: TOK_FILE  */
#line 1293 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3981 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 129: /* type: TOK_OPAQUE TOK_OF TOK_ID  */
#line 1299 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3990 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 130: /* type: resolve_id  */
#line 1305 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->IsType() ? (yyvsp[0].id)->GetType().get() : nullptr) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type()->Ref();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Deprecation((yyvsp[0].id)->GetDeprecationWarning());
				}
			}
#line 4011 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 131: /* type_list: type_list ',' type  */
#line 1325 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_l)->AppendEvenIfNotPure({AdoptRef{}, (yyvsp[0].type)}); }
#line 4017 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 132: /* type_list: type  */
#line 1327 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type_l) = new TypeList({NewRef{}, (yyvsp[0].type)});
			(yyval.type_l)->Append({AdoptRef{}, (yyvsp[0].type)});
			}
#line 4026 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 133: /* type_decl_list: type_decl_list conditional_list type_decl  */
#line 1335 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 4034 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 134: /* type_decl_list: %empty  */
#line 1339 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 4042 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 135: /* type_decl: TOK_ID ':' type opt_attr ';'  */
#line 1346 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			auto attrs = make_attributes((yyvsp[-1].attr_l), {NewRef{}, (yyvsp[-2].type)}, in_record > 0, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-4].str), {AdoptRef{}, (yyvsp[-2].type)}, std::move(attrs));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename,
				                                        in_record_redef != 0);
			}
#line 4056 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 136: /* formal_args: formal_args_decl_list  */
#line 1359 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 4062 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 137: /* formal_args: formal_args_decl_list ';'  */
#line 1361 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 4068 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 138: /* formal_args: %empty  */
#line 1363 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType(new type_decl_list()); }
#line 4074 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 139: /* formal_args_decl_list: formal_args_decl_list ';' formal_args_decl  */
#line 1368 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4080 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 140: /* formal_args_decl_list: formal_args_decl_list ',' formal_args_decl  */
#line 1370 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4086 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 141: /* formal_args_decl_list: formal_args_decl  */
#line 1372 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4092 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 142: /* formal_args_decl: TOK_ID ':' type opt_attr  */
#line 1377 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			auto attrs = make_attributes((yyvsp[0].attr_l), {NewRef{}, (yyvsp[-1].type)}, true, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].type)}, std::move(attrs));
			}
#line 4102 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 143: /* decl: TOK_MODULE TOK_ID ';'  */
#line 1386 "/build/zeek/src/zeek/src/parse.y"
                        {
			current_module = (yyvsp[-1].str);
			zeek::detail::add_module((yyvsp[-1].str));
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 4112 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 144: /* $@17: %empty  */
#line 1392 "/build/zeek/src/zeek/src/parse.y"
                               { is_export = true; }
#line 4118 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 145: /* decl: TOK_EXPORT '{' $@17 decl_list '}'  */
#line 1393 "/build/zeek/src/zeek/src/parse.y"
                        { is_export = false; }
#line 4124 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 146: /* decl: TOK_GLOBAL def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1396 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			}
#line 4132 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 147: /* decl: TOK_OPTION def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1401 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( (yyvsp[-5].id)->IsBlank() )
				(yyvsp[-5].id)->Error("blank identifier used as option");
			else
				build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			}
#line 4143 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 148: /* decl: TOK_CONST def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1409 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			}
#line 4151 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 149: /* $@18: %empty  */
#line 1413 "/build/zeek/src/zeek/src/parse.y"
                                    {
			if ( (yyvsp[0].id)->IsType() )
				{
				auto tag = (yyvsp[0].id)->GetType()->Tag();
				auto tstr = type_name(tag);
				if ( tag == TYPE_RECORD || tag == TYPE_ENUM )
					yyerror(zeek::util::fmt("redef of %s type %s is missing %s keyword",
								tstr, (yyvsp[0].id)->Name(), tstr));
				else
					yyerror(zeek::util::fmt("can not redef %s type %s", tstr, (yyvsp[0].id)->Name()));

				YYERROR;  // bail
				}
		}
#line 4170 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 150: /* decl: TOK_REDEF global_id $@18 opt_type init_class opt_init opt_attr ';'  */
#line 1427 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-6].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			}
#line 4178 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 151: /* $@19: %empty  */
#line 1432 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_enum_redef; parse_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 4184 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 152: /* decl: TOK_REDEF TOK_ENUM global_id TOK_ADD_TO '{' $@19 enum_body '}' ';'  */
#line 1434 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_enum_redef;
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 4193 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 153: /* $@20: %empty  */
#line 1440 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-2].id); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename, INIT_EXTRA); }
#line 4199 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 154: /* decl: TOK_REDEF TOK_RECORD global_id '$' TOK_ID $@20 TOK_ADD_TO '{' attr_list '}' ';'  */
#line 1442 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			parse_redef_record_field((yyvsp[-8].id), (yyvsp[-6].str), INIT_EXTRA, std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-2].attr_l)));
			}
#line 4208 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 155: /* $@21: %empty  */
#line 1447 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-2].id); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename, INIT_REMOVE); }
#line 4214 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 156: /* decl: TOK_REDEF TOK_RECORD global_id '$' TOK_ID $@21 TOK_REMOVE_FROM '{' attr_list '}' ';'  */
#line 1449 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			parse_redef_record_field((yyvsp[-8].id), (yyvsp[-6].str), INIT_REMOVE, std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-2].attr_l)));
			}
#line 4223 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 157: /* $@22: %empty  */
#line 1454 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 4229 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 158: /* $@23: %empty  */
#line 1456 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_record; ++in_record_redef; }
#line 4235 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 159: /* $@24: %empty  */
#line 1458 "/build/zeek/src/zeek/src/parse.y"
                        { --in_record; --in_record_redef; }
#line 4241 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 160: /* decl: TOK_REDEF TOK_RECORD global_id $@22 TOK_ADD_TO '{' $@23 type_decl_list $@24 '}' opt_attr ';'  */
#line 1460 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->GetType() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), std::unique_ptr<type_decl_list>((yyvsp[-4].type_decl_l)),
				              std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-1].attr_l)));
			}
#line 4255 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 161: /* $@25: %empty  */
#line 1471 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType({NewRef{}, (yyvsp[-1].id)});  }
#line 4261 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 162: /* decl: TOK_TYPE def_global_id ':' $@25 type opt_attr ';'  */
#line 1473 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			IntrusivePtr id{AdoptRef{}, (yyvsp[-5].id)};
			add_type(id.get(), {AdoptRef{}, (yyvsp[-2].type)},
			                       std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[-1].attr_l)});
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4273 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 163: /* $@26: %empty  */
#line 1482 "/build/zeek/src/zeek/src/parse.y"
                        {
			func_hdr_location = (yylsp[0]);
			func_hdr_cond_epoch = conditional_epoch;
			}
#line 4282 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 168: /* conditional: TOK_ATIF '(' expr ')'  */
#line 1497 "/build/zeek/src/zeek/src/parse.y"
                        { do_atif((yyvsp[-1].expr)); }
#line 4288 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 169: /* conditional: TOK_ATIFDEF '(' TOK_ID ')'  */
#line 1499 "/build/zeek/src/zeek/src/parse.y"
                        { do_atifdef((yyvsp[-1].str)); }
#line 4294 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 170: /* conditional: TOK_ATIFNDEF '(' TOK_ID ')'  */
#line 1501 "/build/zeek/src/zeek/src/parse.y"
                        { do_atifndef((yyvsp[-1].str)); }
#line 4300 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 171: /* conditional: TOK_ATENDIF  */
#line 1503 "/build/zeek/src/zeek/src/parse.y"
                        { do_atendif(); }
#line 4306 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 172: /* conditional: TOK_ATELSE  */
#line 1505 "/build/zeek/src/zeek/src/parse.y"
                        { do_atelse(); }
#line 4312 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 173: /* func_hdr: TOK_FUNCTION def_global_id func_params opt_attr  */
#line 1510 "/build/zeek/src/zeek/src/parse.y"
                        {
			IntrusivePtr id{AdoptRef{}, (yyvsp[-2].id)};
			begin_func(id, current_module.c_str(),
				                     FUNC_FLAVOR_FUNCTION, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4325 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 174: /* func_hdr: TOK_EVENT event_id func_params opt_attr  */
#line 1519 "/build/zeek/src/zeek/src/parse.y"
                        {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4336 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 175: /* func_hdr: TOK_HOOK def_global_id func_params opt_attr  */
#line 1526 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_HOOK, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4349 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 176: /* func_hdr: TOK_REDEF TOK_EVENT event_id func_params opt_attr  */
#line 1535 "/build/zeek/src/zeek/src/parse.y"
                        {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, true, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4360 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 177: /* $@27: %empty  */
#line 1545 "/build/zeek/src/zeek/src/parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;

			locals_at_this_scope.clear();
			out_of_scope_locals.clear();
			}
#line 4372 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 178: /* $@28: %empty  */
#line 1554 "/build/zeek/src/zeek/src/parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4381 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 179: /* func_body: '{' $@27 stmt_list $@28 '}'  */
#line 1560 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location(func_hdr_location, (yylsp[0]));

			bool free_of_conditionals = true;
			if ( current_file_has_conditionals ||
			     conditional_epoch > func_hdr_cond_epoch )
				free_of_conditionals = false;

			end_func({AdoptRef{}, (yyvsp[-2].stmt)}, current_module.c_str(), free_of_conditionals);
			}
#line 4396 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 180: /* $@29: %empty  */
#line 1574 "/build/zeek/src/zeek/src/parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 4405 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 181: /* $@30: %empty  */
#line 1580 "/build/zeek/src/zeek/src/parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4414 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 182: /* lambda_body: '{' $@29 stmt_list $@30 '}'  */
#line 1586 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));

			// Code duplication here is sad but needed.
			// end_func actually instantiates the function
			// and associates it with an ID. We perform that
			// association later and need to return a lambda
			// expression.

			// Gather the ingredients for a Func from the
			// current scope.
			auto ingredients = std::make_shared<FunctionIngredients>(
				current_scope(), IntrusivePtr{AdoptRef{}, (yyvsp[-2].stmt)}, current_module.c_str());
			auto outer_ids = gather_outer_ids(pop_scope(), ingredients->Body());

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4436 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 183: /* $@31: %empty  */
#line 1607 "/build/zeek/src/zeek/src/parse.y"
                        {
			// "is_export" is used in some contexts to determine
			// whether a given newly seen identifier is a global.
			// We're about parse a lambda body, for which all of
			// the new identifiers should be locals, not globals,
			// so we need to turn off "is_export" here.  We use
			// a stack because lambdas can have additional lambdas
			// inside their bodies.
			hold_is_export.push_back(is_export);
			is_export = false;
			}
#line 4452 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 184: /* anonymous_function: TOK_FUNCTION $@31 begin_lambda conditional_list lambda_body  */
#line 1619 "/build/zeek/src/zeek/src/parse.y"
                        {
			is_export = hold_is_export.back();
			hold_is_export.pop_back();
			(yyval.expr) = (yyvsp[0].expr);
			}
#line 4462 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 185: /* begin_lambda: opt_captures func_params  */
#line 1628 "/build/zeek/src/zeek/src/parse.y"
                        {
			auto id = current_scope()->GenerateTemporary("anonymous-function");
			begin_func(id, current_module.c_str(), FUNC_FLAVOR_FUNCTION, false, {AdoptRef{}, (yyvsp[0].func_type)});

			std::optional<FuncType::CaptureList> captures;

			if ( (yyvsp[-1].captures) )
				{
				captures = *(yyvsp[-1].captures);
				delete (yyvsp[-1].captures);
				}

			(yyvsp[0].func_type)->SetCaptures(std::move(captures));
			(yyval.id) = id.release();
			}
#line 4482 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 186: /* opt_captures: '[' capture_list ']'  */
#line 1647 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.captures) = (yyvsp[-1].captures); }
#line 4488 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 187: /* opt_captures: %empty  */
#line 1649 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.captures) = nullptr; }
#line 4494 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 188: /* capture_list: capture_list ',' capture  */
#line 1654 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-2].captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4503 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 189: /* capture_list: capture  */
#line 1659 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.captures) = new zeek::FuncType::CaptureList;
			(yyval.captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4513 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 190: /* capture: opt_deep TOK_ID  */
#line 1668 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				reporter->Error("no such local identifier: %s", (yyvsp[0].str));
			else if ( id->IsType() )
				{
				reporter->Error("cannot specify type in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}
			else if ( id->IsGlobal() )
				{
				reporter->Error("cannot specify global in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}

			delete [] (yyvsp[0].str);

			(yyval.capture) = new FuncType::Capture(id, (yyvsp[-1].b));
			}
#line 4539 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 191: /* opt_deep: TOK_COPY  */
#line 1692 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 4545 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 192: /* opt_deep: %empty  */
#line 1694 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 4551 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 193: /* func_params: '(' formal_args ')' ':' type  */
#line 1699 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-3].record)}, {AdoptRef{}, (yyvsp[0].type)}, FUNC_FLAVOR_FUNCTION); }
#line 4557 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 194: /* func_params: '(' formal_args ')'  */
#line 1701 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4563 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 195: /* opt_type: ':' type  */
#line 1706 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type) = (yyvsp[0].type); }
#line 4569 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 196: /* opt_type: %empty  */
#line 1708 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type) = 0; }
#line 4575 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 197: /* init_class: %empty  */
#line 1712 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_NONE; }
#line 4581 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 198: /* init_class: '='  */
#line 1713 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_FULL; }
#line 4587 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 199: /* init_class: TOK_ADD_TO  */
#line 1714 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_EXTRA; }
#line 4593 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 200: /* init_class: TOK_REMOVE_FROM  */
#line 1715 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_REMOVE; }
#line 4599 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 201: /* $@32: %empty  */
#line 1719 "/build/zeek/src/zeek/src/parse.y"
                { ++in_init; }
#line 4605 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 202: /* $@33: %empty  */
#line 1719 "/build/zeek/src/zeek/src/parse.y"
                                   { --in_init; }
#line 4611 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 203: /* opt_init: $@32 rhs $@33  */
#line 1720 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 4617 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 204: /* opt_init: %empty  */
#line 1722 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = 0; }
#line 4623 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 205: /* index_slice: expr '[' opt_expr ':' opt_expr ']'  */
#line 1727 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			auto low = (yyvsp[-3].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-3].expr)} :
			                make_intrusive<ConstExpr>(val_mgr->Count(0));

			auto high = (yyvsp[-1].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-1].expr)} :
			                 make_intrusive<SizeExpr>(
			                     ExprPtr{NewRef{}, (yyvsp[-5].expr)});

			if ( ! IsIntegral(low->GetType()->Tag()) || ! IsIntegral(high->GetType()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			auto le = make_intrusive<ListExpr>(std::move(low));
			le->Append(std::move(high));

			if ( in_when_cond > 0  )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			}
#line 4649 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 207: /* opt_attr: %empty  */
#line 1752 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr_l) = nullptr; }
#line 4655 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 208: /* attr_list: attr_list attr  */
#line 1757 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-1].attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr)); }
#line 4661 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 209: /* attr_list: attr  */
#line 1759 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.attr_l) = new std::vector<AttrPtr>;
			(yyval.attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr));
			}
#line 4670 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 210: /* attr: TOK_ATTR_DEFAULT '=' expr  */
#line 1767 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEFAULT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4676 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 211: /* attr: TOK_ATTR_DEFAULT_INSERT '=' expr  */
#line 1769 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEFAULT_INSERT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4682 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 212: /* attr: TOK_ATTR_OPTIONAL  */
#line 1771 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4688 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 213: /* attr: TOK_ATTR_REDEF  */
#line 1773 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4694 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 214: /* attr: TOK_ATTR_IS_ASSIGNED  */
#line 1775 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_ASSIGNED); }
#line 4700 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 215: /* attr: TOK_ATTR_IS_USED  */
#line 1777 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_USED); }
#line 4706 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 216: /* attr: TOK_ATTR_ADD_FUNC '=' expr  */
#line 1779 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ADD_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4712 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 217: /* attr: TOK_ATTR_DEL_FUNC '=' expr  */
#line 1781 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEL_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4718 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 218: /* attr: TOK_ATTR_ON_CHANGE '=' expr  */
#line 1783 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ON_CHANGE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4724 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 219: /* attr: TOK_ATTR_BROKER_STORE '=' expr  */
#line 1785 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4730 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 220: /* attr: TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
#line 1787 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE_ALLOW_COMPLEX); }
#line 4736 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 221: /* attr: TOK_ATTR_BACKEND '=' expr  */
#line 1789 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BACKEND, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4742 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 222: /* attr: TOK_ATTR_EXPIRE_FUNC '=' expr  */
#line 1791 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4748 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 223: /* attr: TOK_ATTR_EXPIRE_CREATE '=' expr  */
#line 1793 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4754 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 224: /* attr: TOK_ATTR_EXPIRE_READ '=' expr  */
#line 1795 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4760 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 225: /* attr: TOK_ATTR_EXPIRE_WRITE '=' expr  */
#line 1797 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4766 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 226: /* attr: TOK_ATTR_RAW_OUTPUT  */
#line 1799 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4772 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 227: /* attr: TOK_ATTR_PRIORITY '=' expr  */
#line 1801 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_PRIORITY, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4778 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 228: /* attr: TOK_ATTR_GROUP '=' expr  */
#line 1803 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_GROUP, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4784 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 229: /* attr: TOK_ATTR_TYPE_COLUMN '=' expr  */
#line 1805 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4790 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 230: /* attr: TOK_ATTR_LOG  */
#line 1807 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4796 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 231: /* attr: TOK_ATTR_ERROR_HANDLER  */
#line 1809 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4802 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 232: /* attr: TOK_ATTR_DEPRECATED  */
#line 1811 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4808 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 233: /* attr: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 1813 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.attr) = new Attr(
					ATTR_DEPRECATED,
					make_intrusive<ConstExpr>(IntrusivePtr{AdoptRef{}, (yyvsp[0].val)}));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				Unref((yyvsp[0].val));
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4828 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 234: /* attr: TOK_ATTR_ORDERED  */
#line 1829 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ORDERED); }
#line 4834 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 235: /* $@34: %empty  */
#line 1834 "/build/zeek/src/zeek/src/parse.y"
                        {
			std::set<const ID*> id_set;
			locals_at_this_scope.emplace_back(id_set);
			}
#line 4843 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 236: /* stmt: '{' $@34 opt_no_test_block stmt_list '}'  */
#line 1839 "/build/zeek/src/zeek/src/parse.y"
                        {
			auto& scope_locals = locals_at_this_scope.back();
			out_of_scope_locals.insert(scope_locals.begin(), scope_locals.end());
			locals_at_this_scope.pop_back();

			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4858 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 237: /* stmt: TOK_ASSERT expr opt_assert_msg ';'  */
#line 1851 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.stmt) = new AssertStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4866 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 238: /* stmt: TOK_PRINT expr_list ';' opt_no_test  */
#line 1856 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].list)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4877 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 239: /* stmt: TOK_EVENT event ';' opt_no_test  */
#line 1864 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt({AdoptRef{}, (yyvsp[-2].event_expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4888 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 240: /* stmt: TOK_IF '(' expr ')' stmt  */
#line 1872 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, make_intrusive<NullStmt>());
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4899 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 241: /* stmt: TOK_IF '(' expr ')' stmt TOK_ELSE stmt  */
#line 1880 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[-2].stmt));
			reject_directive((yyvsp[0].stmt));
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].stmt)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4911 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 242: /* stmt: TOK_SWITCH expr '{' case_list '}'  */
#line 1889 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt({AdoptRef{}, (yyvsp[-3].expr)}, (yyvsp[-1].case_l));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4921 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 243: /* stmt: for_head stmt  */
#line 1896 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->AsForStmt()->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyvsp[-1].stmt));
			}
#line 4931 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 244: /* stmt: TOK_WHILE '(' expr ')' stmt  */
#line 1903 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			(yyval.stmt) = new WhileStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4941 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 245: /* stmt: TOK_NEXT ';' opt_no_test  */
#line 1910 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4952 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 246: /* stmt: TOK_BREAK ';' opt_no_test  */
#line 1918 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4963 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 247: /* stmt: TOK_FALLTHROUGH ';' opt_no_test  */
#line 1926 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4974 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 248: /* stmt: TOK_RETURN ';' opt_no_test  */
#line 1934 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4985 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 249: /* stmt: TOK_RETURN expr ';' opt_no_test  */
#line 1942 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4996 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 250: /* stmt: TOK_LOCAL local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1950 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-1]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-6].id));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR, ! (yyvsp[0].b)).release();
			}
#line 5007 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 251: /* stmt: TOK_CONST local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1958 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-2]));

			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST, ! (yyvsp[0].b)).release();
			}
#line 5017 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 252: /* stmt: when_clause  */
#line 1965 "/build/zeek/src/zeek/src/parse.y"
                        {
			std::shared_ptr<WhenInfo> wi((yyvsp[0].when_clause));
			(yyval.stmt) = new WhenStmt(std::move(wi));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5027 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 253: /* stmt: index_slice '=' expr ';' opt_no_test  */
#line 1972 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr({AdoptRef{}, (yyvsp[-4].expr)},
			                                  {AdoptRef{}, (yyvsp[-2].expr)}, in_init));

			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5040 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 254: /* stmt: expr ';' opt_no_test  */
#line 1982 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5051 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 255: /* stmt: ';'  */
#line 1990 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5061 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 256: /* stmt: conditional  */
#line 1997 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.stmt) = new NullStmt(true /* is_directive */); }
#line 5067 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 257: /* stmt_list: stmt_list stmt  */
#line 2002 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back({AdoptRef{}, (yyvsp[0].stmt)});
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 5077 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 258: /* stmt_list: %empty  */
#line 2008 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.stmt) = new StmtList(); }
#line 5083 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 259: /* event: lookup_identifier '(' opt_expr_list ')'  */
#line 2013 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			const auto& id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(util::fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}

				if ( id->IsDeprecated() )
					reporter->Deprecation(id->GetDeprecationWarning());

				(yyval.event_expr) = new EventExpr(id->Name(), {AdoptRef{}, (yyvsp[-1].list)});
				}
			else
				{
				(yyval.event_expr) = new EventExpr((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].list)});
				}
			}
#line 5110 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 260: /* case_list: case_list case  */
#line 2039 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 5116 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 261: /* case_list: %empty  */
#line 2041 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.case_l) = new case_list; }
#line 5122 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 262: /* case: TOK_CASE expr_list ':' stmt_list  */
#line 2046 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case({AdoptRef{}, (yyvsp[-2].list)}, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5128 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 263: /* case: TOK_CASE case_type_list ':' stmt_list  */
#line 2049 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case(nullptr, (yyvsp[-2].id_l), {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5134 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 264: /* case: TOK_DEFAULT ':' stmt_list  */
#line 2052 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case(nullptr, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5140 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 265: /* case_type_list: case_type_list ',' case_type  */
#line 2057 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 5146 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 266: /* case_type_list: case_type  */
#line 2060 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5155 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 267: /* case_type: TOK_TYPE type  */
#line 2068 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, false);
			(yyval.id)->SetType({AdoptRef{}, (yyvsp[0].type)});
			}
#line 5164 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 268: /* case_type: TOK_TYPE type TOK_AS TOK_ID  */
#line 2074 "/build/zeek/src/zeek/src/parse.y"
                        {
			const char* name = (yyvsp[0].str);
			TypePtr type{AdoptRef{}, (yyvsp[-2].type)};
			auto case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, std::move(type), INIT_NONE, nullptr, nullptr,
			                        VAR_REGULAR);
			(yyval.id) = case_var.release();
			}
#line 5183 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 269: /* for_head: TOK_FOR '(' TOK_ID TOK_IN expr ')'  */
#line 2091 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			auto loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				check_loop_var(loop_var);
			else
				{
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
				                                    false, false);
				}

			auto* loop_vars = new IDPList;
			loop_vars->push_back(loop_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 5210 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 270: /* for_head: TOK_FOR '(' '[' local_id_list ']' TOK_IN expr ')'  */
#line 2115 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 5218 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 271: /* for_head: TOK_FOR '(' TOK_ID ',' TOK_ID TOK_IN expr ')'  */
#line 2120 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			auto key_var = lookup_ID((yyvsp[-5].str), module);
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				check_loop_var(key_var);
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				check_loop_var(val_var);
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			auto* loop_vars = new IDPList;
			loop_vars->push_back(key_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 5248 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 272: /* for_head: TOK_FOR '(' '[' local_id_list ']' ',' TOK_ID TOK_IN expr ')'  */
#line 2147 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				check_loop_var(val_var);
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 5267 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 273: /* local_id_list: local_id_list ',' local_id  */
#line 2165 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 5273 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 274: /* local_id_list: local_id  */
#line 2167 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5282 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 275: /* local_id: TOK_ID  */
#line 2175 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() && ! (yyval.id)->IsBlank() )
					(yyval.id)->Error("already a global identifier");

				if ( (yyval.id)->IsConst() && ! (yyval.id)->IsBlank() )
 					(yyval.id)->Error("already a const identifier");

				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
				                              false, is_export).release();
				}
			}
#line 5309 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 276: /* $@35: %empty  */
#line 2200 "/build/zeek/src/zeek/src/parse.y"
        { resolving_global_ID = true; }
#line 5315 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 277: /* global_id: $@35 global_or_event_id  */
#line 2201 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 5321 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 278: /* $@36: %empty  */
#line 2205 "/build/zeek/src/zeek/src/parse.y"
        { defining_global_ID = true; }
#line 5327 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 279: /* $@37: %empty  */
#line 2205 "/build/zeek/src/zeek/src/parse.y"
                                                 { defining_global_ID = false; }
#line 5333 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 280: /* def_global_id: $@36 global_id $@37  */
#line 2206 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[-1].id); }
#line 5339 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 281: /* $@38: %empty  */
#line 2210 "/build/zeek/src/zeek/src/parse.y"
        { resolving_global_ID = false; }
#line 5345 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 282: /* event_id: $@38 global_or_event_id  */
#line 2211 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 5351 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 283: /* global_or_event_id: lookup_identifier  */
#line 2216 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str(), false,
			                    defining_global_ID);
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					const auto& t = (yyval.id)->GetType();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Deprecation((yyval.id)->GetDeprecationWarning());
					}

				refine_location((yyval.id));
				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
				                              true, is_export).release();
				}
			}
#line 5390 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 284: /* resolve_id: lookup_identifier  */
#line 2255 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 5405 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 286: /* lookup_identifier: TOK_GLOBAL_ID  */
#line 2271 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( is_export )
				{
				reporter->Error("cannot use :: prefix in export section: %s", (yyvsp[0].str));
				YYERROR;
				}
			}
#line 5417 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 287: /* opt_assert_msg: ',' expr  */
#line 2283 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 5423 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 288: /* opt_assert_msg: %empty  */
#line 2285 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = nullptr; }
#line 5429 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 289: /* opt_no_test: TOK_NO_TEST  */
#line 2290 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 5435 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 290: /* opt_no_test: %empty  */
#line 2292 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 5441 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 291: /* opt_no_test_block: TOK_NO_TEST  */
#line 2297 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; script_coverage_mgr.IncIgnoreDepth(); }
#line 5447 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 292: /* opt_no_test_block: %empty  */
#line 2299 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 5453 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 293: /* opt_deprecated: TOK_ATTR_DEPRECATED  */
#line 2304 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = new ConstExpr(make_intrusive<StringVal>("")); }
#line 5459 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 294: /* opt_deprecated: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 2307 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.expr) = new ConstExpr(make_intrusive<StringVal>(""));
				}
			}
#line 5476 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 295: /* opt_deprecated: %empty  */
#line 2320 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = nullptr; }
#line 5482 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 296: /* expr_list_opt_comma: ','  */
#line 2323 "/build/zeek/src/zeek/src/parse.y"
                         { expr_list_has_opt_comma = 1; }
#line 5488 "/build/zeek/src/zeek/build/src/p.cc"
    break;


#line 5492 "/build/zeek/src/zeek/build/src/p.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2327 "/build/zeek/src/zeek/src/parse.y"


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = util::copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! util::streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                      msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
